      SUBROUTINE KINCOP
C     *****************
C  COPYING UTIL INTO UTIL4 AND UTIL8
      IMPLICIT LOGICAL(A-H,O-Z)
      COMMON / UTIL  /  QP(4), QM(4), PH(4)
      REAL*8            QP   , QM   , PH
      COMMON / UTIL8 / DQP(4),DQM(4),DPH(4)
      REAL*8           DQP   ,DQM   ,DPH
      COMMON / UTIL4 / AQP(4),AQM(4),APH(4)
      REAL*4           AQP   ,AQM   ,APH
      COMMON / ENERG / ENE,AEL2,AMF2,AMF,ALGEL,ALGMF,BETI,BT1,ATH2
      REAL*8           ENE,AEL2,AMF2,AMF,ALGEL,ALGMF,BETI,BT1,ATH2
      DO 30 I=1,4
      DQP(I)=QP(I)*ENE
      DQM(I)=QM(I)*ENE
      DPH(I)=PH(I)*ENE
      AQP(I)=QP(I)*ENE
      AQM(I)=QM(I)*ENE
 30   APH(I)=PH(I)*ENE
      RETURN
      END
      SUBROUTINE TRALO4(KTO,AP,BP,AM)
C     *******************************
      COMMON / CMSLAB / GAMLAB
C REAL*4 VERSION OF TRALOR plus boost to lab
      REAL*4 AP(4),BP(4),AM
      REAL*8 DP(4),AMAST
      DO 30 I=1,4
  30  DP(I)=AP(I)
      CALL TRALOR(KTO,DP)
      DO 31 I=1,4
  31  AP(I)=DP(I)
      AM=AMAST(DP)
C additional boost from (CMS) to LAB system
      CALL BOSTR3(GAMLAB,AP,AP)
      RETURN
      END
      SUBROUTINE DUMPB4
C     ****************
C PRINTS FINAL STATE TAU AND PHOTON   MOMENTA
C CALLED OPTIONALY BY THE USER
      COMMON / UTIL4  / QP(4),QM(4),PH(4)
      COMMON / INOUT / NINP,NOUT
      DIMENSION SUM(4)
      DATA ICONT/0/
      ICONT=ICONT+1
      DO 30 I=1,4
  30  SUM(I)=QP(I)+QM(I)+PH(I)
      WRITE(NOUT,1100) ICONT
      AQP=     QP(4)**2-QP(3)**2-QP(2)**2-QP(1)**2
      AQM=     QM(4)**2-QM(3)**2-QM(2)**2-QM(1)**2
      APH=     PH(4)**2-PH(3)**2-PH(2)**2-PH(1)**2
      IF(AQP.GT.0.) AQP=SQRT(AQP)
      IF(AQM.GT.0.) AQM=SQRT(AQM)
      WRITE(NOUT,1501) (QP(I),I=1,4),AQP
      WRITE(NOUT,1502) (QM(I),I=1,4),AQM
      WRITE(NOUT,1503) (PH(I),I=1,4),APH
      WRITE(NOUT,1600) ( SUM(I),I=1,4)
 1100 FORMAT(///20X,'MOMENTA FROM KORAL,     EVENT NO.  ',I5/
     &40X,'  P(1)',7X,'  P(2)',7X,'  P(3)',7X,'  P(4)',7X,'  MASS')
 1501 FORMAT(20X,'QP  ',9X,5(1X,F12.5))
 1502 FORMAT(20X,'QM  ',9X,5(1X,F12.5))
 1503 FORMAT(20X,'PH  ',9X,5(1X,F12.5))
 1600 FORMAT(20X,'SUM ',9X,5(1X,F12.5),/)
      RETURN
      END
      SUBROUTINE KORAL(E1,E2)
C     ***********************
C=======================================================================
C==================COMPUT. PHYS. COMMUN. PART ==========================
C=======================================================================
C THIS IS PART OF KORALB ALMOST IDENTICAL TO THAT PUBLISHED
C IN COMPUTER PHYSICS COMMUNICATIONS 36, (1985) 191,
C BY S. JADACH AND Z. WAS
C CORRECTIONS WITH RESPECT TO CPC VERSION MARKED WITH C;; (SJ)
C CORRECTIONS WITH RESPECT TO CPC VERSION MARKED WITH *$  (ZW)
C     ****************************************************************
C     *  THIS IS CENTRAL MENAGER    ROUTINE FOR TAUPAIR PRODUCTION   *
C     *  PROCESS IT CALLS OTHER ROUTINES CALCULATES THE SPIN WEIGHT  *
C     *  WHICH IS NEXT USED TO DECIDE WHETHER EVENT IS ACCEPTED OR   *
C     *  REJECTED. THIS WEIGHING AND REJECTING PROCEDURE INTRODUCES  *
C     *  CORRELATION IN THE DECAYS OF TWO TAUS AND OTHER SPIN        *
C     *  EFFECTS. E1 AND E2 ARE POLARISATION VECTORS OF E+ AND E-    *
C     ****************************************************************
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON / UTIL1 / XK,C1,S1,C2,S2,CF,SF,CG,SG,V
      COMMON / CONTRL/ SWT(6),ISPIN
      DIMENSION E1(3),E2(3),SA(4),SB(4),H1(4),H2(4)
      COMPLEX*16 T1(4,4),T2(4,4),S(4,4),E(4,4)
      COMPLEX*16 ZERO,ROT,TOT
      REAL*4 RRR
      LOGICAL LSOF,LHAR
      DATA INIT /0/
      COMMON /REINIT/ IFINI
C     number of generations to calculate maximal weight. 
      DATA NUMSTA /500/
      ZERO=DCMPLX(0.D0,0.D0)
      IF (IFINI.EQ.0) INIT=0 
C-----IF ELECTRONS ARE UNPOLARIZED WE TAKE EASIER PATH
      SUM=0.
      DO 30 I=1,3
   30 SUM=SUM+E1(I)**2+E2(I)**2
C-----
C-----
      IF (INIT.EQ.0) THEN
      INIT=1
      XLSP=1.05
      DO KKK=1,NUMSTA
      CALL EVENTB
      KTO=1
      CALL DEKAY(KTO,H1)
      KTO=2
      CALL DEKAY(KTO,H2)
      H1(4)=1.
      H2(4)=1.
      CALL SPIN(E,H1,H2)
C-----ROTATION OF THE INITIAL POLARIZATION TO THE DYNAMIC COORDINATES
      SA(1)= CG*E1(1)+SG*E1(2)
      SA(2)=-SG*E1(1)+CG*E1(2)
      SA(3)=E1(3)
      SA(4)=1.
      SB(1)= CG*E2(1)+SG*E2(2)
      SB(2)=-SG*E2(1)+CG*E2(2)
      SB(3)=E2(3)
      SB(4)=1.
      CALL SPIN(S,SA,SB)
C---- CALCULATION OF THE SPIN WEIGHT FOR POLARIZED ELECTRONS
      LSOF= XK.EQ.0.
      LHAR= .NOT.LSOF
      TOT=ZERO
      CALL AMPLIT(0,T1,T2)
      DO 210 I=1,4
      DO 210 J=1,4
      IF(LSOF) TOT=TOT+DCONJG(T1(I,J))*T2(I,J)+DCONJG(T2(I,J))*T1(I,J)
      IF(LHAR) TOT=TOT+DCONJG(T1(I,J))*T1(I,J)+DCONJG(T2(I,J))*T2(I,J)
 210  CONTINUE
      ROT=ZERO
      CALL AMPLIT(1,T1,T2)
      DO 200 I=1,4
      DO 200 J=1,4
      DO 200 K=1,4
      DO 200 L=1,4
      IF(LSOF) ROT=ROT+
     +S(K,L)*(DCONJG(T1(K,I))*T2(L,J)+DCONJG(T2(K,I))*T1(L,J))*E(J,I)
      IF(LHAR) ROT=ROT+
     +S(K,L)*(DCONJG(T1(K,I))*T1(L,J)+DCONJG(T2(K,I))*T2(L,J))*E(J,I)
  200 CONTINUE
      WT=DREAL(ROT/TOT)
      XLSP=MAX(XLSP,1.2*WT)
      ENDDO

      ENDIF
C ---
C     GENERATION
C ---
   50 CALL EVENTB
      KTO=1
      CALL DEKAY(KTO,H1)
      KTO=2
      CALL DEKAY(KTO,H2)
      H1(4)=1.
      H2(4)=1.
      CALL SPIN(E,H1,H2)
C-----ROTATION OF THE INITIAL POLARIZATION TO THE DYNAMIC COORDINATES
      SA(1)= CG*E1(1)+SG*E1(2)
      SA(2)=-SG*E1(1)+CG*E1(2)
      SA(3)=E1(3)
      SA(4)=1.
      SB(1)= CG*E2(1)+SG*E2(2)
      SB(2)=-SG*E2(1)+CG*E2(2)
      SB(3)=E2(3)
      SB(4)=1.
      CALL SPIN(S,SA,SB)
C---- CALCULATION OF THE SPIN WEIGHT FOR POLARIZED ELECTRONS
      LSOF= XK.EQ.0.
      LHAR= .NOT.LSOF
      TOT=ZERO
      CALL AMPLIT(0,T1,T2)
      DO 110 I=1,4
      DO 110 J=1,4
      IF(LSOF) TOT=TOT+DCONJG(T1(I,J))*T2(I,J)+DCONJG(T2(I,J))*T1(I,J)
      IF(LHAR) TOT=TOT+DCONJG(T1(I,J))*T1(I,J)+DCONJG(T2(I,J))*T2(I,J)
 110  CONTINUE
      ROT=ZERO
      CALL AMPLIT(1,T1,T2)
      DO 100 I=1,4
      DO 100 J=1,4
      DO 100 K=1,4
      DO 100 L=1,4
      IF(LSOF) ROT=ROT+
     +S(K,L)*(DCONJG(T1(K,I))*T2(L,J)+DCONJG(T2(K,I))*T1(L,J))*E(J,I)
      IF(LHAR) ROT=ROT+
     +S(K,L)*(DCONJG(T1(K,I))*T1(L,J)+DCONJG(T2(K,I))*T2(L,J))*E(J,I)
  100 CONTINUE
      WT=DREAL(ROT/TOT)
      SWT(4)=SWT(4)+1.
      SWT(5)=SWT(5)+WT
      SWT(6)=SWT(6)+WT*WT
      CALL RANMAR(RRR,1)
      R=XLSP*RRR
      IF(R.GT.WT) GOTO 50
      RETURN
      END
      SUBROUTINE AMPLIT(MODE,T1,T2)
C********************************************************************
C  IN THIS ROUTINE THE COMPLEX SPIN AMPLITUDES FOR THE TAU          *
C  PRODUCTION PROCESS ARE CALCULATED                                *
C********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
C
      COMMON / CONST / PI,ALFA,ALF1,QE2,QF2,QEF
      COMMON / WEAK  / QCE,QCF,CVE,CVF,CAE,CAF,ZPROP
      COMMON / UTIL1 / XK,C1,S1,C2,S2,CF,SF,CG,SG,V
      COMMON / BOXY  / Z1,Z2,Z3
      COMMON / ENERG / ENE,AEL2,AMF2,AMF,ALGEL,ALGMF,BETI,BT1,ATH2
      COMMON / SIGMA / SIG0,SIG0CM,SOFT,SOF1,F2RE,BRM,BOX
      COMMON / NEWZET/ IFZET,ITRANS
      COMPLEX*16 T1(4,4),T2(4,4),ZERO,FAC,TCI(4,4),TCF(4,4)
      COMPLEX*16 ONEC,IMAG,F2,ZH,Z1,Z2,Z3,ZFAC
      ZERO=DCMPLX(0.D0,0.D0)
      IMAG=DCMPLX(0.D0,1.D0)
      ONEC=DCMPLX(1.D0,0.D0)
C
      IF(XK.GT.0.) GOTO 300
C  ********************************************
C  *                                          *
C  *       SOFT PHOTON CASE                   *
C  *                                          *
C  ********************************************
      C=C1
      S=S1
      DO 10 I=1,4
      DO 10 IJ=1,4
 10   T1(I,IJ)=ZERO
C-----BORN AMPLITUDE
      T1(1,1)=       ONEC
      T1(2,2)=     C*ONEC
      T1(2,4)= AMF*S*IMAG
C     TERMS PROPORTIONAL TO BORN
      A=ALF1*QEF
      FAC=(1.+SOF1+A*BRM)*ONEC
      DO 20 I=1,4
      DO 20 J=1,4
 20   T2(I,J)=T1(I,J)*FAC
C-----BOX CONTRIBUTIONS
      T2(1,1)=T2(1,1)+A*Z1
      T2(2,2)=T2(2,2)+A*Z2
      T2(2,4)=T2(2,4)+A*Z3*IMAG*AMF
C-----FINAL FERMION F2-VERTEX CONTRIBUTION
      F2IM=-QF2*ALF1*PI*AMF2/(4.*BT1)
      F2=DCMPLX(F2RE,F2IM)
      T2(1,1)=T2(1,1)+2.*F2
      T2(2,2)=T2(2,2)+2.*C*F2
      T2(2,4)=T2(2,4)+2.*S/AMF*IMAG*F2
C---- NEW Z IMPLEMENTATION.
      IF(IFZET.EQ.1.AND.MODE.EQ.1) THEN
      CALL ZNEW(ZFAC,ENE)
      ZFAC=ZFAC/QCE/QCF
      T1(1,1)=T1(1,1)+ZFAC*(CVE*CVF+C*CAE*CAF)*ONEC
      T1(1,2)=T1(1,2)+ZFAC*(CVE*CAF+C*CAE*CVF)*ONEC
      T1(2,1)=T1(2,1)+ZFAC*(CAE*CVF+C*CVE*CAF)*ONEC
      T1(2,2)=T1(2,2)+ZFAC*(CAE*CAF+C*CVE*CVF)*ONEC
C
      T2(1,1)=T2(1,1)+ZFAC*(CVE*CVF+C*CAE*CAF)*ONEC
      T2(1,2)=T2(1,2)+ZFAC*(CVE*CAF+C*CAE*CVF)*ONEC
      T2(2,1)=T2(2,1)+ZFAC*(CAE*CVF+C*CVE*CAF)*ONEC
      T2(2,2)=T2(2,2)+ZFAC*(CAE*CAF+C*CVE*CVF)*ONEC
      ENDIF 
C-----WEAK BOSON Z0 CONTRIBUTION GIVES GAMMA-Z0 INTERFERENCE
C-----THIS CAN BE REASONABLE FOR ENE .LE. 20 GEV
      IF (QEF.EQ.0.) RETURN
      IF(IFZET.EQ.0.AND.MODE.EQ.1) THEN
      CALL ZNEW(ZFAC,ENE)
      ZFAC=ZFAC/QCE/QCF
      T2(1,1)=T2(1,1)+ZFAC*(CVE*CVF+C*CAE*CAF)*ONEC
      T2(1,2)=T2(1,2)+ZFAC*(CVE*CAF+C*CAE*CVF)*ONEC
      T2(2,1)=T2(2,1)+ZFAC*(CAE*CVF+C*CVE*CAF)*ONEC
      T2(2,2)=T2(2,2)+ZFAC*(CAE*CAF+C*CVE*CVF)*ONEC
      ENDIF 
      RETURN
  300 CONTINUE
C  *******************************************
C  *                                         *
C  *       HARD PHOTON CASE                  *
C  *                                         *
C  *******************************************
      Y=SQRT(1.-XK)
      BB=.5*XK/Y
      GB=(1.-.5*XK)/Y
      AM=AMF/Y
      HINI= QCE/Y/BB/(AEL2+S1**2)
      HFIN= QCF/BB/(AM**2+V**2*S2**2)
C-----
      TCI(1,1)= (-BB*SF                              )*HINI*ONEC
      TCI(1,2)= ( BB*C2*CF                           )*HINI*IMAG
      TCI(1,3)=                                             ZERO
      TCI(1,4)= ( AM*BB*S2*CF                        )*HINI*ONEC
      TCI(2,1)= ( BB*C1*CF                           )*HINI*IMAG
      TCI(2,2)= (-BB*C1*C2*SF                        )*HINI*ONEC
      TCI(2,3)=                                             ZERO
      TCI(2,4)= ( AM*BB*C1*S2*SF                     )*HINI*IMAG
      TCI(3,1)= (-GB*CF                              )*HINI*ONEC
      TCI(3,2)= (-GB*C2*SF                           )*HINI*IMAG
      TCI(3,3)=                                             ZERO
      TCI(3,4)= (-AM*GB*S2*SF                        )*HINI*ONEC
      TCI(4,1)= (-GB*C1*SF                           )*HINI*IMAG
      TCI(4,2)= (-GB*C1*C2*CF+S1*S2                  )*HINI*ONEC
      TCI(4,3)=                                             ZERO
      TCI(4,4)= ( AM*(GB*C1*S2*CF+S1*C2)             )*HINI*IMAG
C-----
      TCF(1,1)= (-BB*V*S2*SF                         )*HFIN*ONEC
      TCF(1,2)= ( BB*V*S2*C2*CF                      )*HFIN*IMAG
      TCF(1,3)= ( AM*BB*SF                           )*HFIN*IMAG
      TCF(1,4)= (-AM*BB*V*C2*C2*CF                   )*HFIN*ONEC
      TCF(2,1)= ( BB*V*S2*C1*CF                      )*HFIN*IMAG
      TCF(2,2)= (-BB*V*S2*C2*C1*SF                   )*HFIN*ONEC
      TCF(2,3)= ( AM*BB*C1*CF                        )*HFIN*ONEC
      TCF(2,4)= (-AM*BB*V*C2*C2*C1*SF                )*HFIN*IMAG
      TCF(3,1)= (-GB*V*S2*CF                         )*HFIN*ONEC
      TCF(3,2)= (-GB*V*S2*C2*SF                      )*HFIN*IMAG
      TCF(3,3)= ( AM*BB*CF                           )*HFIN*IMAG
      TCF(3,4)= (-AM*V*(GB*S2*S2-BB)*SF              )*HFIN*ONEC
      TCF(4,1)= (-GB*V*S2*C1*SF                      )*HFIN*IMAG
      TCF(4,2)= (-V*S2*(GB*C1*C2*CF-S1*S2)           )*HFIN*ONEC
      TCF(4,3)= (-AM*BB*C1*SF                        )*HFIN*ONEC
      TCF(4,4)= ( AM*V*((GB*S2*S2-BB)*C1*CF+S2*C2*S1))*HFIN*IMAG
      DO 140 K=1,4
      DO 140 I=1,2
      ZH=TCF(I,K)
      TCF(I  ,K)=    ZH*CF-TCF(I+2,K)*SF
  140 TCF(I+2,K)=    ZH*SF+TCF(I+2,K)*CF

C-----
*$ CORRECTION 16 11 87 Z.W.
      SGX=C1*SQRT(AEL2)
*$ CORRECTION 16 11 87 Z.W.
      SGX1= SGX*BB/GB
      DO 150 K=1,4
      T1(1,K)= S1*TCI(1,K)+TCF(1,K)
      T1(2,K)=(S1*TCI(2,K)+TCF(2,K))*IMAG
*$ CORRECTION 16 11 87 Z.W.
      T1(3,K)=-SGX*TCI(1,K)*IMAG*C1
      T1(4,K)=-SGX*TCI(2,K)
C-----
      T2(1,K)= S1*TCI(3,K)+TCF(3,K)
      T2(2,K)=(S1*TCI(4,K)+TCF(4,K))*IMAG
*$ CORRECTION 16 11 87 Z.W.
      T2(3,K)=-SGX1*TCI(3,K)*IMAG*C1
 150  T2(4,K)=-SGX1*TCI(4,K)
      RETURN
      END
      SUBROUTINE ZNEW(ZPROP,ENE)
      IMPLICIT REAL*8 (A-H,O-Z)
      common /znowy/ amz,gamz
       COMPLEX*16 ZPROP
       S   =4D0*ENE**2
       ZPROP=S/DCMPLX(S-AMZ**2,GAMZ*S/AMZ)
      END
      SUBROUTINE SPIN(V,E1,F1)
C     modified routine SPIN(....
C     **********************                                    
      IMPLICIT REAL*8(A-H,O-Z)                                  
      COMPLEX*16 V(4,4)                                         
      DIMENSION E(4),F(4),E1(4),F1(4)
      COMMON / NEWZET/ IFZET,ITRANS
      COMMON / CONTRL/ SWT(6),ISPIN
      DATA ZER/0./                                              
      DATA init/0/
      COMMON /REINIT/ IFINI      
C      DATA itrans/0/
      IF (IFINI.EQ.0) INIT=0 
C 
      if (init.eq.0) then
       init=1
       write(6,*) "SPIN: itrans=",itrans,"   *****"
      endif
      if (itrans.eq.0) then
       do 7 k=1,4
        E(K)=E1(K)
        F(K)=F1(K)
 7     continue 
        E(1)=0.0
        F(1)=0.0
        E(2)=0.0
        F(2)=0.0
        IF (ISPIN.EQ.0) THEN
          E(3)=0.0
          F(3)=0.0
        ENDIF 
       V(1,1)=DCMPLX( E(4)*F(4) -E(1)*F(1) +E(2)*F(2) +E(3)*F(3),  ZER)  KOR06450
       V(2,2)=DCMPLX( E(4)*F(4) +E(1)*F(1) -E(2)*F(2) +E(3)*F(3),  ZER)  KOR06460
       V(3,3)=DCMPLX( E(4)*F(4) -E(1)*F(1) -E(2)*F(2) -E(3)*F(3),  ZER)  KOR06470
       V(4,4)=DCMPLX( E(4)*F(4) +E(1)*F(1) +E(2)*F(2) -E(3)*F(3),  ZER)  KOR06480
       V(1,2)=DCMPLX( E(3)*F(4) +E(4)*F(3), E(1)*F(2) +E(2)*F(1))        KOR06490
       V(3,4)=DCMPLX( E(3)*F(4) -E(4)*F(3),-E(1)*F(2) +E(2)*F(1))        KOR06500
       V(1,3)=DCMPLX( E(4)*F(1) -E(1)*F(4),-E(2)*F(3) +E(3)*F(2))        KOR06510
       V(2,4)=DCMPLX( E(4)*F(1) +E(1)*F(4), E(2)*F(3) +E(3)*F(2))        KOR06520
       V(1,4)=DCMPLX( E(3)*F(1) +E(1)*F(3), E(4)*F(2) +E(2)*F(4))        KOR06530
       V(2,3)=DCMPLX( E(3)*F(1) -E(1)*F(3), E(4)*F(2) -E(2)*F(4))        KOR06540
       V(1,4)=DCMPLX( E(3)*F(1) +E(1)*F(3), E(4)*F(2) +E(2)*F(4))        KOR06530
       V(2,3)=DCMPLX( E(3)*F(1) -E(1)*F(3), E(4)*F(2) -E(2)*F(4))        KOR06540
      else
       do 8 k=1,4
        E(K)=E1(K)
        F(K)=F1(K)
 8    continue 
        IF (ISPIN.EQ.0) THEN
          E(1)=0.0
          F(1)=0.0
          E(2)=0.0
          F(2)=0.0
          E(3)=0.0
          F(3)=0.0
        ENDIF 
       V(1,1)=DCMPLX( E(4)*F(4) -E(1)*F(1) +E(2)*F(2) +E(3)*F(3),  ZER)  KOR06450
       V(2,2)=DCMPLX( E(4)*F(4) +E(1)*F(1) -E(2)*F(2) +E(3)*F(3),  ZER)  KOR06460
       V(3,3)=DCMPLX( E(4)*F(4) -E(1)*F(1) -E(2)*F(2) -E(3)*F(3),  ZER)  KOR06470
       V(4,4)=DCMPLX( E(4)*F(4) +E(1)*F(1) +E(2)*F(2) -E(3)*F(3),  ZER)  KOR06480
       V(1,2)=DCMPLX( E(3)*F(4) +E(4)*F(3), E(1)*F(2) +E(2)*F(1))        KOR06490
       V(3,4)=DCMPLX( E(3)*F(4) -E(4)*F(3),-E(1)*F(2) +E(2)*F(1))        KOR06500
       V(1,3)=DCMPLX( E(4)*F(1) -E(1)*F(4),-E(2)*F(3) +E(3)*F(2))        KOR06510
       V(2,4)=DCMPLX( E(4)*F(1) +E(1)*F(4), E(2)*F(3) +E(3)*F(2))        KOR06520
       V(1,4)=DCMPLX( E(3)*F(1) +E(1)*F(3), E(4)*F(2) +E(2)*F(4))        KOR06530
       V(2,3)=DCMPLX( E(3)*F(1) -E(1)*F(3), E(4)*F(2) -E(2)*F(4))        KOR06540
       V(1,4)=DCMPLX( E(3)*F(1) +E(1)*F(3), E(4)*F(2) +E(2)*F(4))        KOR06530
       V(2,3)=DCMPLX( E(3)*F(1) -E(1)*F(3), E(4)*F(2) -E(2)*F(4))        KOR06540
      endif
      V(2,1)=DCONJG(V(1,2))                                             KOR06550
      V(4,3)=DCONJG(V(3,4))                                             KOR06560
      V(3,1)=DCONJG(V(1,3))                                             KOR06570
      V(4,1)=DCONJG(V(1,4))                                             KOR06580
      V(4,2)=DCONJG(V(2,4))                                             KOR06590
      V(3,2)=DCONJG(V(2,3))                                             KOR06600
      RETURN                                                            KOR06610
      END                                                               KOR06620

      SUBROUTINE STARB(ENE1,AMF1,IDE1,IDF1,AMZ1,SINW1,INRAN,XK1,XKMM)
C     ***************************************************************
C     ****************************************************************
C     *                                                              *
C     *  START IS ROUTINE SETING INITIAL VALUES TO CERTAIN VARIABLES *
C     *  AND PRINTING SOME USEFULL OUTPUT                            *
C     *  MUST BE CALLED BY USER BEFORE FIRST EVENT IS GENERATED      *
C     *  ENE=ABS(ENE1) IS BEAM ENERY IN GEV UNITS, NEGATIVE VALUE    *
C     *  CAUSES SWITCHING OFF RADIATIVE CORRECTIONS. SINW2 IN THE    *
C     *  SQUARE OF THE WEINBERG ANGLE, SWITCHING OFF Z0 CONTRIBUTION *
C     *  MAY BE ACHIEVED BY SETING SINW2=-0.5   .                    *
C     *  INRAN -INITIALISATION CONSTANT FOR RANDOM NUMBER GENERATOR  *
C     *  ANY POSITIVE INTEGER.                                       *
C     ****************************************************************
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON / CONST / PI,ALFA,ALF1,QE2,QF2,QEF
      COMMON / UTIL1 / XK,C1,S1,C2,S2,CF,SF,CG,SG,V
      COMMON / UTIL2 / XK0,XKMIN,XKMAX
      COMMON / ENERG / ENE,AEL2,AMF2,AMF,ALGEL,ALGMF,BETI,BT1,ATH2
      COMMON / SIGMA / SIG0,SIG0CM,SOFT,SOF1,F2RE,BRM,BOX
      COMMON / WEAK  / QCE,QCF,CVE,CVF,CAE,CAF,ZPROP
      COMMON / INOUT / NINP,NOUT
      COMMON / CONTRL/ SWT(6),ISPIN
      COMMON / RNF   / INIRAN,NGEN
      COMMON / VACPOL/ IFVAC
C     ****************************************************************
C     *  FIRST VERSION WRITTEN   20.04.1982, NO SPIN YET.            *
C     *  SECOND VERSION  20.03.1983,                                 *
C     *  SPIN CORRELATIONS IN THE DOUBLE DECAY INCLUDED.             *
C     *  THIRD VERSION 22.12.1983,                                   *
C     *  INITIAL SPIN INCLUDED.                                      *
C     ****************************************************************
C
      ENE=ABS(ENE1)
C-----PHOTON MINIMUM AND MAXIMUM ENERGY IN UNITS OF BEAM ENERGY ENE
      XKMIN=0.0
      XKMAX=XKMM
C;;   XK0=0.01
      XK0=XK1
      INIRAN=INRAN
      PI=4.*ATAN(1.)
      ALFA=1./137.036
      ALF1=ALFA/PI
C-----SWITCHING OFF RADIATIVE CORRECTIONS
      IF(ENE1.LT.0.) ALF1=0.
      IF(ENE1.LT.0.) XKMAX=.9*XK0
      CMTR=389.385E-30
      DO 6 I=1,6
   6  SWT(I)=1.
C.....WARNING, THE ABOVE ASIGNMENTS IS NOT AN ERROR, IT IS FOR PURPOSE.
      ISPIN=1
      NGEN=9
      DUMMY=RNF100(-2)
      AEL=.51110034E-3/ENE
C     FINAL FERMION MASS
C;;   AMFIN=1.782
      AMFIN=AMF1
      AMF=AMFIN/ENE
      AEL2=AEL**2
      AMF2=AMF**2
      BT1=SQRT(1.-AMF)*SQRT(1.+AMF)
      SVAR=4.*ENE**2
      ALGEL= LOG(4./AEL2)
      ALGMF= LOG(4./AMF2)
C     ****************************************************************
C     *   FERMION CHARGES                                            *
C     *   QCE  INCOMING (BEAM)   FERMION CHARGE                      *
C     *   QCF  OUTGOING FERMION  ( HEAVY LEPTON )  CHARGE            *
C     *   SINW2  SIN OF WEIBERG ANGLE SQUARED                        *
C     *   ELECTRON COUPLING CONSTANTS  CVE , CAE                     *
C     *   AND TAU COUPLING CONSTANTS   CVF , CAF                     *
C     ****************************************************************
C     FOR QUARK PRODUCTION IDFIN SCHOULD BE CHANGED APROPRIATELY
C;;   IDFIN=-2
C;;   CALL SETWS(   -2,SINW2,QCE,CVE,CAE,AMZ,GAMM)
C;;   CALL SETWS(IDFIN,SINW2,QCF,CVF,CAF,AMZ,GAMM)

C;;;  WEAK COUPLING CONSTANTS
C     IDE IS THE INCOMING FERMION IDENTIFIER
C     IDF IS THE OUTGOING FERMION IDENTIFIER
C     IDF=2   MUON,TAU...
C     IDF=3   UP QUARK   ( U,C,T...)
C     IDF=4   DOWN QUARK  ( D,S,B...)
C     IDF NEGATIVE DENOTES ANTIPARTICLE
C     IDE=-2   INCOMING POSITRON
      IDE= IDE1
      IDF= IDF1
      SINW2=ABS(SINW1)
      CALL SETCUP(-IDE,SINW2,QCE,CVE,CAE)
      CALL SETCUP(-IDF,SINW2,QCF,CVF,CAF)
      AMZ=AMZ1

C-----SWITCHING OFF Z0 CONTRIBUTION FOR TESTS
      IF(SINW1.GT. 0D0) GOTO 15
      AMZ=10000.
      CAE=0.
      CVE=0.
   15 ZPROP=0.
C   15 ZPROP=0./(1.-AMZ**2/ENE**2/4.)
      QE2=QCE**2
      QF2=QCF**2
      QEF=QCE*QCF
      COLR=1.
      IF(IABS(IDF).NE.2) COLR=3.
      SIG0=COLR*4.*QE2*QF2*PI*ALFA**2/3./SVAR
C------------------   SOFT PHOTON PARAMETERS
      ALK0= LOG(XK0)
      BETI=QE2*2.*ALF1*(ALGEL-1.)
      DSXI=BETI*ALK0+QE2*ALF1*(1.5*ALGEL-2.+PI*PI/3.)
      Y= LOG((1.+BT1)**2/AMF2)
      ATH2=QF2*Y
      BETF=QF2*2*ALF1*((1.+BT1**2)/(2.*BT1)*Y-1.)
      DSXF=BETF*(ALK0+.5*ALGMF)+QF2*ALF1*((3.+2.*BT1**2)/(2.*BT1)*Y
     $-2.-(1.+BT1**2)/(2.*BT1)*(Y**2+4.*DILOGT(2*BT1/(1.+BT1))-PI**2))
      F2RE=-QF2*ALF1*.25*AMF2/BT1*Y
      PIREL=ALF1*(5./9.-1./3.*ALGEL)
      PIRMU=ALF1*(5./9.-1./3.* LOG(SVAR/.10566**2))
      PIRTA=ALF1*(8./9.-BT1**2/3.-BT1/6.*(3.-BT1**2)*Y)
      PIRE=PIREL+PIRTA+PIRMU+PIRET(SVAR)
      IF (IFVAC.EQ.0) THEN
        WRITE(6,*) 'Vaccum polarization switched off: pire set to zero'
        PIRE=0.0
      ENDIF
      IF(ALF1.EQ.0.) PIRE=0.
      ZCON=2.*ZPROP/QCE/QCF*CVE*CVF
      SOFT=DSXI+DSXF-2.*PIRE+ZCON
      SOF1=DSXI+DSXF-2.*PIRE
C
      IF(XKMIN.LT.XK0) XKMIN=0.
      XKMAX= MAX (XKMAX,XK0)
      XKMAX= MIN (XKMAX,(1.-AMF2))
C
      WRITE(NOUT,1000) ENE,SINW2,INIRAN
      WRITE(NOUT,1004) AMZ,CVE,CAE,CVF,CAF
C
      CSOFT=0.
      IF(XKMIN.EQ.0.) CSOFT=XKDEF(XK0)
      CSTOT=XKDEF(XKMAX)-XKDEF(XKMIN)
      WRITE(NOUT,1006) CSOFT,CSTOT
C
      SIG0CM=SIG0*CMTR
      WRITE(NOUT,1010)    SIG0CM
      IF(ALF1.EQ.0.) WRITE(NOUT,1017)
      DUMM=RRGEN(-5.D0)
C
      RETURN
 1000 FORMAT(//,1H0,10(10H**********)//
     -  /20X,    40HSTART PARAMETERS ARE ...                ,
     -  /50X,    10HENERGY    ,F10.4,10H  GEV     ,
     -  /50X,    10HSINW2     ,F10.4,
     -  /50X,    10HINRAN     ,I10)
 1004 FORMAT(1H0,
     -  /20X,    40HMASS OF ELECTROWEAK BOSON Z0 IS  (GEV)  ,F10.4,
     -  /20X,    30HCOUPLIG CONSTANTS: CVE, CAE    ,2F10.4,
     -  /20X,    30H                   CVF, CAF    ,2F10.4)
 1006 FORMAT(1H0,
     -  /20X,    40HCONTRIBUTIONS TO SOFT CROSS SECT. ARE...,
     -  /20X,    40HBORN + SOFT PHOTON + VERTEX CORR. INIT. ,F10.4,
     -  /20X,    40HTOTAL CROSS SECTION - APPROXIMATE       ,F10.4)
 1010 FORMAT(1H ,
     -  /20X,    40HALL ABOVE CROSS SECTIONS ARE GIVEN IN   ,
     -  /20X,    40HUNITS OF THE LOWEST ORDER ( POINTLIKE ) ,
     -  /20X,    40HONE PHOTON CROSS-SECTION  SIG0 WHICH IS ,
     -  /20X,    10HEQUAL TO  ,E20.5,6H CM**2)
 1017 FORMAT(1H0,
     -  /20X,    40HNO RAD. CORRECTIONS, ONLY LOWEST ORDER    )
      END
      SUBROUTINE SETCUP(IDF,SIN2,QC,CV,CA)
C     ************************************
C SETCUP CALCULATES CV,CA WHICH CORRESPOND TO A GIVEN VALUE
C OF TEH WEINBERG ANGLE.
C NOTE THAT SIGN OF AXIAL COUPL CONST. MAY BE DIFFERENT FROM CHOICES IN
C THE LITERATURE. IT IS OPPOSITE TO THAT IN CERN BOOKLET.
C IDF IS QUARK OR LEPTON IDENTIFIER, QC ITS CHARGE  (S.J.)
      IMPLICIT REAL*8(A-H,O-Z)
      B=1./SQRT(16.*SIN2*(1.-SIN2))
      IDFERM=IABS(IDF)
      GO TO (1,2,3,4), IDFERM
C     NOT USED  ( NEUTRINO )
    1 QC=0.
      CV=B
      CA=B
      GO TO 500
C     ELECTRON, MUON ...
    2 QC=-1.
      CV=(-1.+4.*SIN2)*B
      CA=-B
      GO TO 500
C     UP QUARKS
    3 QC=2./3.
      CV=(1.-8./3.*SIN2)*B
      CA=B
      GO TO 500
C     DOWN QUARKS
    4 QC=-1./3.
      CV=(-1.+4./3.*SIN2)*B
      CA=-B
  500 IF(IDF.GT.0) RETURN
C     ANTIPARTICLES
      QC=-QC
      CV=-CV
      CA=+CA
      RETURN
      END
      FUNCTION PIRET(S)
C     *****************
      IMPLICIT REAL*8(A-H,O-Z)
C-----IT RETURNS THE VALUE OF THE HADRONIC CONTRIBUTION TO VACUUM
C-----POLARISATION, USING PARAMETRISATION OF H. BURKHARD TASSO NOTE
C-----NO. 192, DECEMBER 1981.
      IF(S.LT.1.)
     $                PIRET=-1.3450E-9 -2.3020E-3* LOG(1.+4.091*S)
      IF(S.GT.1.0.AND.S.LT.64)
     $                PIRET=-1.5120E-3 -2.8220E-3* LOG(1.+1.218*S)
      IF(S.GT.64)
     $                PIRET=-1.1344E-3 -3.0680E-3* LOG(1.+0.99992*S)
      RETURN
      END
      SUBROUTINE EVENTB
C     ****************
      IMPLICIT REAL*8(A-H,O-Z)
C     ****************************************************************
C     *  EVENT IS CENTRAL  ROUTINE FOR SIMULATION OF THE SPINLESS    *
C     *  EVENTS, IT GENERATES ALL ANGULAR VARIABLES AND THE MONENTA  *
C     *  OF TAU+ TAU- AND GAMMA (IF PRESENT).                        *
C     ****************************************************************
      COMMON / CONST / PI,ALFA,ALF1,QE2,QF2,QEF
      COMMON / UTIL  / QP(4),QM(4),PH(4)
      COMMON / UTIL2 / XK0,XKMIN,XKMAX
      COMMON / UTIL1 / XK,C1,S1,C2,S2,CF,SF,CG,SG,V
      COMMON / WEAK  / QCE,QCF,CVE,CVF,CAE,CAF,ZPROP
      COMMON / ENERG / ENE,AEL2,AMF2,AMF,ALGEL,ALGMF,BETI,BT1,ATH2
      COMMON / CONTRL/ SWT(6),ISPIN
      COMMON / SIGMA / SIG0,SIG0CM,SOFT,SOF1,F2RE,BRM,BOX
      REAL*4 RRR
      FUND(C1,S1,C2,S2)=(1.-.5*XK*(1.-C1))**2+
     +( XKT*S1*S2*CF-(1.-.5*XK)*C1*C2-.5*XK*C2 )**2
C-----
    1 CONTINUE
      R=RNF100(1)
C-----RAW  XK-DISTRIBUTION ,  CHOICE BETWEEN SOFT AND HARD EMISSION
      XK=RRGEN(R)
      IF(XK.GT.XK0) GO TO 20
C-----****************************************************************
C-----SOFT PHOTON EMISSION, FIRST THE ANGULAR DISTRIBUTION
C-----WITH ONLY C-SYMETRIC COMPONENT
   10 FIG=2.*PI*RNF100(4)
   11 XK=0.
      C1=1.-2.*RNF100(6)
      S1=SQRT((1.-C1)*(1.+C1))
      C2=1.
      S2=0.
      CF=1.
      SF=0.
      V=BT1
      WT=((2.-(S1*V)**2)*(1.+SOFT)+4.*F2RE)/(2.*(1.+SOFT))
      IF(RNF100(8).GT.WT) GO TO 11
C-----****************************************************************
C-----IMPOSING  C-ODD (INTERFERENCE,BOX ETC.) TERMS
      CALL BRMBOX
      IF(QEF.NE.0.) ZCONA=4.*ZPROP/QCE/QCF*CAE*CAF
      IF(QEF.EQ.0.) ZCONA=0.
      WT=.5*( 1. + ( ALF1*QEF*((2.-(S1*V)**2)*BRM+BOX) +C1*V*ZCONA)
     $            /((2.-(S1*V)**2)*(1.+SOFT)+4.*F2RE)   )
      IF(RNF100(9).GT.WT) GO TO 10
      GO TO 400
C-----****************************************************************
C-----   HARD PHOTON BREMSSTRAHLUNG,
C.....1  MODELING XK-DISTRIBUTION
C.....2  CHOICE BETWEEN INITIAL AND FINAL BREMSSTRAHLUNG
C.....3  GENERATING ANGULAR VARIABLES
C------------------------
C.....1111111111111111111111111111111111111111111111111111111111111111
   20 CONTINUE
      XK1=1.-XK
      XKT=SQRT(XK1)
      V=SQRT(ABS(1.-AMF2/XK1))
      EPS1=AMF2/XK1/(1.+V)
      U=1.-.5*AEL2
      EPS=.5*AEL2
      ROIT=.5*BETI*(1.+XK1*XK1)/XK/XK1
      ROFT=1.5*QF2*ALF1*(1.+XK1*XK1-2.*AMF2)/XK*ATH2
      ROI=BETI*(1.+XK1**2)/XK/XK1*V*(3.-V**2)/4.
      ROF=QF2*ALF1/XK*( (1.+XK1*XK1-AMF2*XK-.50*AMF2**2)*
     $   LOG((1.+V)**2*XK1/AMF2) -((2.+AMF2)*XK1+XK**2)*V )
      WT=(ROI+ROF)/(ROIT+ROFT)
      SWT(1)=SWT(1)+1.
      SWT(2)=SWT(2)+WT
      SWT(3)=SWT(3)+WT*WT
      IF(RNF100(2).GT.WT) GO TO 1
C.....2222222222222222222222222222222222222222222222222222222222222222
   25 CONTINUE
      IF(RNF100(3)-ROI/(ROI+ROF)) 31,1,41
C-----
C.....3333333333333333333333333333333333333333333333333333333333333333
C-----INITIAL STATE RADIATION, ANGULAR VARIABLES
C-----
   31 FIG=2.*PI*RNF100(4)
      R=RNF100(5)
      DEL1=EPS*((2.-EPS)/EPS)**R
      DEL2=2.-DEL1
      CALL RANMAR(RRR,1)
      IF(RRR.GT.0.5) GO TO 35
      A=DEL1
      DEL1=DEL2
      DEL2=A
   35 C1=1.-DEL1
      S1=SQRT((DEL1-EPS)*(DEL2-EPS))
      ZET1=1.-V+2.*V*RNF100(6)
      ZET2=2.-ZET1
      C2=1.-ZET1
      S2=SQRT((ZET1-EPS1)*(ZET2-EPS1))
      FI=2.*PI*RNF100(7)
      CF=COS(FI)
      SF=SIN(FI)
      D1=2.*FUND( C1, S1, C2, S2)+2.*AMF2/XK1*(1.-.5*XK*DEL1)**2
      D2=2.*FUND(-C1,-S1, C2, S2)+2.*AMF2/XK1*(1.-.5*XK*DEL2)**2
      WT=(D1*(1.-AEL2/XK1/DEL2)+D2*(1.-AEL2/XK1/DEL1) )
     $    /(4.*(1.+XK1*XK1))
      IF(RNF100(8).GT.WT) GO TO 31
      GO TO 200
C.....2222222222222222222222222222222222222222222222222222222222222222
C-----FINAL STATE RADIATION, ANGULAR VARIABLES
C-----
   41 FIG=2.*PI*RNF100(4)
      DEL1=EPS+2.*U*RNF100(5)
      DEL2=2.-DEL1
      C1=1.-DEL1
      S1=SQRT((DEL1-EPS)*(DEL2-EPS))
      R=RNF100(6)
      ZET1=EPS1*((2.-EPS1)/EPS1)**R
      ZET2=2.-ZET1
      CALL RANMAR(RRR,1)
      IF(RRR.GT.0.5) GO TO 45
      A=ZET1
      ZET1=ZET2
      ZET2=A
   45 C2=1.-ZET1
      S2=SQRT((ZET1-EPS1)*(ZET2-EPS1))
      FI=2.*PI*RNF100(7)
      CF=COS(FI)
      SF=SIN(FI)
      D1=2.*FUND(-C2,-S2,-C1,-S1)+2.*AMF2
      D2=2.*FUND( C2, S2,-C1,-S1)+2.*AMF2
      D3=AMF2*XK*XK*(1.+C1*C1)-8.*AMF2*XK
      WT=(D1*(1.-AMF2/ZET2)+D2*(1.-AMF2/ZET1)+D3)
     $   /(4.*(1.+XK1*XK1)-2.*AMF2)
      IF(RNF100(8).GT.WT) GO TO 41
C-----****************************************************************
C-----INTRODUCING INTERFRRENCE TERMS IN GENERATED ANGULAR DISTRIBU-
C-----TIONS FOR HARD BREMSSTRAHLUNG EVENTS.
  200 CONTINUE
      WT=.5*WINTH(DUM)
      IF(RNF100(9).GT.WT) GO TO 25
C-----UNTIL THIS POINT VARIABLES C2 AND S2 WERE MULTIPLIED BY V.
      C2=C2/V
      S2=S2/V
C-----
C-----CONSTRUCTION MOMENTA OUT OF ANGULAR VARIABLES USING TRALOR
  400 CONTINUE
      CG=COS(FIG)
      SG=SIN(FIG)
      DO 420 I=1,3
      QP(I)=0.
  420 QM(I)=0.
      QP(4)=AMF
      CALL TRALOR(1,QP)
      QM(4)=AMF
      CALL TRALOR(2,QM)
      DO 430 I=1,4
  430 PH(I)=-QP(I)-QM(I)
      PH(4)=2.+PH(4)
      IF(XK.EQ.0.) PH(4)=0.
C
      RETURN
      END
      SUBROUTINE BRMBOX
C     *****************
      IMPLICIT REAL*8(A-H,O-Z)
C     ****************************************************************
C     *                                                              *
C     *  CONTRIBUTIONS FROM THE SOFT BREMSSTRAHLUNG AD BOX DIAGR.    *
C     *  SPIN AMPLITUDES FOR FINITE PART OF BOX CONTIBUTIONS         *
C     ****************************************************************
      COMMON / CONST / PI,ALFA,ALF1,QE2,QF2,QEF
      COMMON / ENERG / ENE,AEL2,AMF2,AMF,ALGEL,ALGMF,BETI,BT1,ATH2
      COMMON / SIGMA / SIG0,SIG0CM,SOFT,SOF1,F2RE,BRM,BOX
      COMMON / UTIL1 / XK,C1,S1,C2,S2,CF,SF,CG,SG,V
      COMMON / UTIL2 / XK0,XKMIN,XKMAX
      COMMON / BOXY  / Z1,Z2,Z3
      COMPLEX*16 Z1,Z2,Z3,ZERO,AA,BB,FD,FQ,ALP,ALM
      EQUIVALENCE (ALGEL,AE),(ALGMF,AF)
      DATA ENIT/0./
      COMMON /REINIT/ IFINI
      data iik /0/
      IF (IFINI.EQ.0) ENIT=0. 
C
      IF(ENIT.EQ.ENE) GO TO 10
      ENIT=ENE
      ALK0= LOG(XK0)
      ZERO=DCMPLX(0.D0,0.D0)
      ALP=DCMPLX(AE+AF,2.D0*PI)
      ALM=DCMPLX(AE-AF,0.D0)
      BTR=(1.+BT1)**2/AMF2
      FDRE=.5*(AE*AE+PI*PI/3.)
      FQRE=.5*( LOG(BTR)**2+PI*PI/3.+4.*DILOGT(-1/BTR))/BT1
      FD=DCMPLX(FDRE,-PI*AE)
      FQ=DCMPLX(FQRE,-PI* LOG(BTR))
   10 CONTINUE
      BRM=0.
      Z1=ZERO
      Z2=ZERO
      Z3=ZERO
      V=BT1
      DO 20 I=1,2
      SGN=1.
      IF(I.NE.1) SGN=-1.
      C=SGN*C1
      S=SGN*S1
      TR=2.-2.*C*V-AMF2
      DL=.5*TR/S/S/V/V
      RO=(V-C)/TR
      X=(1.-C*V)/SQRT(TR)
      X2=X*X
      Y=.5*(SQRT(TR)+AMF2/(1.+V))
      BRM=BRM+SGN*(
     $   2*(DILOGT(-X/(1.-Y))-DILOGT((1-X)/(1.-Y))-DILOGT((1+X)/Y)
     $  +DILOGT(X/Y))+ LOG(Y/(1.-Y))**2-DILOGT(X2)+.5* LOG(X2)**2
     $   - LOG(X2)* LOG(1.-X2)   )
      A1=2.* LOG(.5*(1.-C*V))+AE+AF
      B1= LOG(.5*(1.-C*V))**2-2.*DILOGT(.5*TR/(1.-C*V))
     $                                       -.5*AE*AE-.5*AF*AF
      AA=DCMPLX(A1,0.D0)
      BB=DCMPLX(B1,PI*A1)
      Z1=Z1+(        V*RO*AA    +(DL-1.)*BB            +DL*FD
     $       +(1.-V*C*DL)*FQ        -.5*ALP   +.5*AMF2/TR*ALM )*SGN
      Z2=Z2           +RO*AA       -C*DL*BB     +C*(1.-DL)*FD
     $        +(V*DL+C-V)*FQ      -.5/V*ALP +.5*AMF2/TR/V*ALM
      Z3=Z3         -S/TR*AA-.5*TR/S/V/V*BB     +S*(1.-DL)*FD
     $       +.5*C*TR/V/S*FQ                       +S/TR*ALM
   20 CONTINUE
      BRM=BRM+4.* LOG((1.-V*C1)/(1.+V*C1))*ALK0
C      BRM=0.0
C      Z1=ZERO 
C      Z3=ZERO 
C      Z2=ZERO
C      IF (IIK.NE.5) THEN
C       IIK=5
C      write(6,*) 'boxy wyzerowane' 
C      endif
      BOX=DREAL(Z1+C1*Z2+AMF2*S1*Z3)
      RETURN
      END
      SUBROUTINE TRALOR(KTO,VEC)
C     **************************
      IMPLICIT REAL*8(A-H,O-Z)
C
C     ******************************************************************
C     *   TRALOR TRANSFORMES FOUR-VECTOR VEC FROM TAU REST SYSTEM      *
C     *   TO LAB SYSTEM. RECOMMENDED TO USE  FOR DECAY PRODUCTS.       *
C     *   KTO=1,2 DENOTES TAU+ AND TAU- CORRESPONDINGLY                *
C     ******************************************************************
C
      COMMON / UTIL1 / XK,C1,S1,C2,S2,CF,SF,CG,SG,V
      COMMON / UTIL2 / XK0,XKMIN,XKMAX
      COMMON / ENERG / ENE,AEL2,AMF2,AMF,ALGEL,ALGMF,BETI,BT1,ATH2
      DIMENSION VEC(4),VEC1(4),TL(4,4)
C IBLAD=1 makes program as with the error which was removed april/may 93. 
C IBLAD=0 is the right choice.
      DATA IBLAD / 0/
C
      Y=SQRT(1.-XK)
      A=Y/AMF
      B=SQRT((A-1.)*(A+1.))
      IF(KTO.EQ.2) B=-B
      BB=.5*XK/Y
      GB=(1.-.5*XK)/Y
C
      IF (XK.GT.0.2*XK0) THEN
        H1= C1*S2*CF+GB*S1*C2
        H2=-S1*S2*CF+GB*C1*C2
        TL(1,1)= CF
        TL(1,2)=-C2*SF
        TL(1,3)=-A*S2*SF
        TL(1,4)=-B*S2*SF
        TL(2,1)= C1*SF
        TL(2,2)= C1*C2*CF-GB*S1*S2
        TL(2,3)=-B*BB*S1+A*H1
        TL(2,4)=-A*BB*S1+B*H1
        TL(3,1)=-S1*SF
        TL(3,2)=-S1*C2*CF-GB*C1*S2
        TL(3,3)=-B*BB*C1+A*H2
        TL(3,4)=-A*BB*C1+B*H2
        TL(4,1)= 0.
        TL(4,2)= BB*S2
        TL(4,3)= B*GB-A*BB*C2
        TL(4,4)= A*GB-B*BB*C2
      ELSE
        H1=-S1
        IF (IBLAD.EQ.1) H1=S1
        H2= C1
        TL(1,1)= 1.0
        TL(1,2)= 0.0
        TL(1,3)= 0.0
        TL(1,4)= 0.0
        TL(2,1)= 0.0
        TL(2,2)= H2
        TL(2,3)= A*H1
        TL(2,4)= B*H1
        TL(3,1)= 0.0
        TL(3,2)=-H1
        TL(3,3)= A*H2
        TL(3,4)= B*H2
        TL(4,1)= 0.
        TL(4,2)= 0.
        TL(4,3)= B
        TL(4,4)= A
      ENDIF
C
      DO 100 I=1,4
  100 VEC1(I)=VEC(I)
      DO 110 I=1,4
      SUM=0.
      DO 105 J=1,4
  105 SUM=SUM+TL(I,J)*VEC1(J)
  110 VEC(I)=SUM
C     ROTATION ARROUND THE BEAM
      A=VEC(1)
      VEC(1)=CG*A-SG*VEC(2)
      VEC(2)=SG*A+CG*VEC(2)
C
      RETURN
      END
      FUNCTION WINTH(DUM)
C     *******************
      IMPLICIT REAL*8(A-H,O-Z)
C     ****************************************************************
C     * HERE THE CONTRIBUTION FROM THE INTERFERENCE OF THE INITIAL   *
C     * AND FINAL STATE BREMSSTRAHLUNG IS CALCULATED FOR USE IN      *
C     * SUBROUTINE EVENT  ( HARD BREMSSTARHLUNG ONLY)                *
C     ****************************************************************
C
      COMMON / CONST / PI,ALFA,ALF1,QE2,QF2,QEF
      COMMON / UTIL1 / XK,C1,S1,C2,S2,CF,SF,CG,SG,V
      COMMON / UTIL2 / XK0,XKMIN,XKMAX
      COMMON / ENERG / ENE,AEL2,AMF2,AMF,ALGEL,ALGMF,BETI,BT1,ATH2
      EQUIVALENCE (AMF2,AM),(AEL2,AL)
C
      Z1=SQRT(1.-XK)*S1*S2*CF-(1.-.5*XK)*C1*C2
      Z2=1.-.5*XK
      T = Z1+Z2+.5*XK*( C1-C2)
      U1=-Z1+Z2+.5*XK*(-C1-C2)
      U =-Z1+Z2+.5*XK*( C1+C2)
      T1= Z1+Z2+.5*XK*(-C1+C2)
      TT=T*T
      UU=U*U
      TT1=T1*T1
      UU1=U1*U1
      SS=2.
      SP=2.*(1.-XK)
      X1=XK*(1.-C1)
      X2=XK*(1.+C1)
      IF(C1.GT.0.9) X1=XK*(AEL2+S1**2)/(1.+C1)
      IF(C1.LT.-.9) X2=XK*(AEL2+S1**2)/(1.-C1)
      Y1=XK*(1.-C2)
      Y2=XK*(1.+C2)
      AINI=(TT+UU+AM/SP*(T+U)**2)*(1.-AL/SP*X1/X2)
     $   +(TT1+UU1+AM/SP*(T1+U1)**2)*(1.-AL/SP*X2/X1)
      AINI=AINI*QE2/(SP*X1*X2)
      AFIN=(TT+UU1+AM*SS)*(1.-AM*(Y1+Y2)/Y2/SS)
     $    +(UU+TT1+AM*SS)*(1.-AM*(Y1+Y2)/Y1/SS)
     $    +AM*(X1*X1+X2*X2)/SS-4.*AM*(SS-SP)
      AFIN=AFIN*QF2/(SS*Y1*Y2)
      ANTR=(TT+TT1+UU+UU1+AM*SS+AM*SP)
     $     *(T*X2*Y2+T1*X1*Y1-U*X2*Y1-U1*X1*Y2)
     $      +AM*X1*X2*((SS-SP)*(T+T1-U-U1)-(X1-X2)*(Y1-Y2))
      ANTR=ANTR*QEF/(SS*SP*X1*X2*Y1*Y2)
      WINTH=1.+ANTR/(AINI+AFIN)
      RETURN
      END
      SUBROUTINE FINISB(CSTCMT,ERREL)
C     ************************
      IMPLICIT REAL*8(A-H,O-Z)
C**********************************************************************
C     FINISH CALCULATES TOTAL CROSS SECTION FOR GENERATED EVENTS      I
C     USING AVERAGE WEIGHTS. IT GIVES STATISTICAL ERRORS DEPENDING ON I
C     THE NUMBER OF THE GENERATED EVENTS.                             I
C     CSTOT IS TOTAL EXACT CROSS SECTION GIVEN IN  CM**2              I
C     TO BE USED TO RENORMALISE HISTOGRAMS IN  CM**2 UNITS            I
C**********************************************************************
      COMMON / SIGMA / SIG0,SIG0CM,SOFT,SOF1,F2RE,BRM,BOX
      COMMON / CONTRL/ SWT(6),ISPIN
      COMMON / UTIL2 / XK0,XKMIN,XKMAX
      COMMON / INOUT / NINP,NOUT
C;;
C
      AWTA=0.
      DWTA=0.
      IF(SWT(1).EQ.0.) GO TO 10
      AWTA=SWT(2)/SWT(1)
      DWTA=SQRT(SWT(3)/SWT(2)**2-1./SWT(1))*100.
   10 AWTB=SWT(5)/SWT(4)
      DWTB=SQRT(SWT(6)/SWT(5)**2-1./SWT(4))*100.
C-----
      CSOFT=0.
      IF(XKMIN.EQ.0.) CSOFT=XKDEF(XK0)
      CSTOT=XKDEF(XKMAX)-XKDEF(XKMIN)
      CSHAR=CSTOT-CSOFT
C-----
      CSTOT=(CSOFT+AWTA*CSHAR)*AWTB
      DWTT=AWTA*CSHAR/(CSOFT+AWTA*CSHAR)
      DWTT=DWTT*DWTA+DWTB
      CSTCM=CSTOT*SIG0CM
C;;
      ERREL=SQRT((DWTT*DWTA)**2+DWTB**2)/100.
      CSTCMT=CSTCM

      NEVA=INT(SWT(1)-1.)
      NEVB=INT(SWT(4)-1.)
C
      WRITE(NOUT,1000)       NEVA,AWTA,DWTA,
     $                       NEVB,AWTB,DWTB,
     $                           CSTOT,DWTT
C
 1000 FORMAT(1H0,10(10H**********),/,7H FINISB,//
     -  /21X, 20H NO. OF CRUDE EVENTS,20H      AVERAGE WEIGHT,
     -                                20H      PERCENT ERRORS,
     -  /11X, 20HHARD BREMSS. WEIGHT ,I10, F20.6,F10.2,
     -  /11X, 20HSPIN WEIGHT         ,I10, F20.6,F10.2,
     - //11X, 40HTOTAL EXACT CROSS SECT. IN SIG0 UNITS
     -                                   , F10.6,F10.2)
      RETURN
      END
      FUNCTION XKDEF(XK)
C     ******************
      IMPLICIT REAL*8(A-H,O-Z)
C
C     ****************************************************************
C     *                                                              *
C     *  DEFINES RAW CROSS SECTION FOR PHOT. MOMENTUM  .LT. XK       *
C     *  USED IN RRGEN TO GENERATE RAW XK DISTRIBUTION               *
C     *                                                              *
C     ****************************************************************
C
      COMMON / SIGMA / SIG0,SIG0CM,SOFT,SOF1,F2RE,BRM,BOX
      COMMON / CONST / PI,ALFA,ALF1,QE2,QF2,QEF
      COMMON / UTIL2 / XK0,XKMIN,XKMAX
      COMMON / ENERG / ENE,AEL2,AMF2,AMF,ALGEL,ALGMF,BETI,BT1,ATH2
      DATA ENIT /.0/
      COMMON /REINIT/ IFINI
      FUNH(X)=BETI*( LOG(X)-.5*X-.5* LOG(1.-X))
     $   +3.*ALF1*ATH2*((1.-AMF2)* LOG(X)-X+.25*X*X)
C
      IF (IFINI.EQ.0) ENIT=0. 
      IF(ENIT.EQ.ENE) GO TO 10
      ENIT=ENE
      SOFSIG=BT1*((1.+.5*AMF2)*(1.+SOFT)+3.*F2RE)
      SUDIS0=SOFSIG-FUNH(XK0)
      SUDIST=SUDIS0+FUNH(1.-AMF2)
   10 CONTINUE
      IF(XK.GT.0.) GO TO 110
      XKDEF=0.
      RETURN
  110 IF(XK.GT.XK0) GO TO 120
      XKDEF=SOFSIG*XK/XK0
      RETURN
  120 IF(XK.GT.(1.-AMF2)) GO TO 140
      XKDEF=SUDIS0+FUNH(XK)
      RETURN
  140 XKDEF=SUDIST
      RETURN
      END
      FUNCTION RRGEN(R)
C     *****************
      IMPLICIT REAL*8(A-H,O-Z)
C
C     ****************************************************************
C     *                                                              *
C     *  RRGEN IS GENERAL ROUTINE GENERATING ARBITRARY ONE DIM.      *
C     *  DISTRIBUTION DEFINED THROUGH XKDEF FUNCTION.                *
C     *  IT MEMORIZES THE SCHAPE OF DISTRIBUTION IN XX-MATRIX STEP   *
C     *  BY STEP WITH BETTER AND BETTER PRECISSION.  MATRIX XX       *
C     *  IS UPDATED AT THE MOMENT WHEN CERTAIN NUMBER OF EVENTS      *
C     *  (THAT LISTET IN MATRIX LIST ) HAS BEEN GENERATED.           *
C     *                                                              *
C     ****************************************************************
C
      COMMON / UTIL2 / XK0,XKMIN,XKMAX
      DIMENSION  XX(1025),LIST(11)
      DATA LIST
     $/1,2,3,4,64,256,1024,4096,16384,65536,-1/
      DATA IEV,LEN /0,1024/
C
      IEV=IEV+1
      IF(R.LT.0.) IEV=1
      IF(IEV.NE.1) GO TO 10
      IP=1
      EPS =.05/FLOAT(LEN)
      EPS1=.00025
      ID=LEN
      IW=1
      XW=1.
      XX(1)=XKMIN
      XX(LEN+1)=XKMAX
      F0=XKDEF(XKMIN)
      DF=XKDEF(XKMAX)-F0
   10 CONTINUE
      IF(IEV.NE.LIST(IP))GO TO 300
      IP=IP+1
      DO 100 I=1,IW
      IA1=ID*(I-1)+1
      IA2=IA1+ID
      IA=(IA1+IA2)/2
C     ITERATION COME ON
      X1=XX(IA1)
      X2=XX(IA2)
      IF((X2-X1).LT.EPS1) GO TO 31
      Y1=XKDEF(X1)
      Y2=XKDEF(X2)
      Y=FLOAT(IA-1)/FLOAT(LEN)
      DO 30  ITER=1,30
      X=.5*(X1+X2)
      F=(XKDEF(X)-F0)/DF
      IF(Y-F) 20,31,21
   20 X2=X
      Y2=Y
      GO TO 23
   21 X1=X
      Y1=Y
   23 IF((Y2-Y1) .LT.EPS.AND.(X2-X1).LT.EPS1) GO TO 31
   30 CONTINUE
   31 XX(IA)=.5*(X1+X2)
C     END OF ITERATION
  100 CONTINUE
      ID=ID/2
      IW=IW*2
      XW=XW*2.
C
  300 CONTINUE
      I=INT(.5*XW*R)
      IA1=2*I*ID+1
      IA2=IA1+ID
      IA3=IA2+ID
      X1=XX(IA1)
      X2=XX(IA2)
      X3=XX(IA3)
      Y=R*XW-FLOAT(2*I)
      X=.5*(Y-1.)*(Y-2.)*X1-Y*(Y-2.)*X2+.5*Y*(Y-1)*X3
      X= MAX (X,X1)
      X= MIN (X,X3)
      RRGEN=X
      RETURN
C=======================================================================
C===================END OF CPC PART ====================================
C=======================================================================
      END
      FUNCTION RNF100(IGEN)
C     *********************
C======================================================================
C======================================================================
C===================*** JMCLIB ***=====================================
C============= LIBRARY OF THE MONTE CARLO =============================
C================AND LORENTZ KINEMATICS================================
C==============THIS ROUTINES WILL BECOME===============================
C====================OBSOLETE !========================================
C==EG==ALL RANDOM GENERATOS SHOULD BE REPLACED BY RANMAR===============
C======================================================================
C             R N F 1 0 0
C THIS IS THE QUASIRANDOM SHUFFLING TYPE RANDOM NUMBER GENERATOR
C EQUIVALENT TO THAT IN FOWL CERN PROGRAM LIBRARY W-505.
C IT CONTAINS NGEN INDEPENDENT PARALLEL SUBGENERATORS INDEXED
C WITH THE PARAMETER IGEN ( GENERALLY NGEN.LE.100).
C RANDOM NUMBERS PASS THROUGH A BUFFER ( MATRIX BUFOR ) OF THE
C LENGHT NGEN*LENBUF IN ORDER TO KILL CORRELATIONS BETWEEN
C SUBGENERATORS. EVERY SUBGENNERATOR SHOULD SERVICE ONE INTEGRATION
C VARIABLE. INIRAN IS AN INITIALIZATION POSITIVE INTEGER PARAMETER
C COMMON TO ALL SUBGENERATORS.
C LENBUF SHOULD NOT BE LESS THEN NGEN.
C               ***  WARNING   ***
C THIS PARTICULAR VERSION IS LIMITED TO 20 SUBGENERATORS, FOR MORE
C ONE SHOULD EXTEND BUFOR AND LENBUF.
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /RNF/ INIRAN,NGEN
      DIMENSION BUFOR(800)
      DIMENSION KQCONS(100),QQCONS(100),SSER(100)
      DATA LENBUF/40/
      DATA KQCONS /
     *   2,   3,   5,   7,  11,  13,  17,  19,  23,  29,  31,
     *  37,  41,  43,  47,  53,  59,  61,  67,  71,  73,  79,
     *  83,  89,  97, 101, 103, 107, 109, 113, 127, 131, 137,
     * 139, 149, 151, 157, 163, 167, 173, 179, 181, 191, 193,
     * 197, 199, 211, 223, 227, 229, 233, 239, 241, 251, 257,
     * 263, 269, 271, 277, 281, 283, 293, 307, 311, 313, 317,
     * 331, 337, 347, 349, 353, 359, 367, 373, 379, 383, 389,
     * 397, 401, 409, 419, 421, 431, 433, 439, 443, 449, 457,
     * 461, 463, 467, 479, 487, 491, 499, 503, 509, 521, 523, 541/
      DATA IWARM /0/

      IF(IGEN.GT.0) GO TO 300
C INITIALISATION OR REINITIALISATION
      IF(IGEN.NE.-2) GO TO 910
      IF(NGEN.LE.0.OR.NGEN.GT.20) GOTO 920
      IF(INIRAN.LE.0) GOTO 930
      DUMX=RNDMD(-1)
      IWARM=1
      XLEN=FLOAT(LENBUF)
      DO 30 IGN=1,NGEN
      DXX=KQCONS(IGN)
      QQCONS(IGN)=SQRT(DXX)
      NDEX=LENBUF*(IGN-1)
      SER=INIRAN
      DO 29 K=1,LENBUF
      INDEX=NDEX+K
      BUFOR(INDEX)=MOD((SER*QQCONS(IGN)),1.D0)
   29 SER=SER+1.
   30 SSER(IGN)=SER
      RETURN

C GENERATION OF THE RANDOM NUMBER
  300 CONTINUE
      IF(IGEN.GT.NGEN) GOTO 940
      IF(IWARM.EQ.0)   GOTO 950
      INDEX=LENBUF*(IGEN-1)+INT(XLEN*RNDMD(1))+1
      RNF100=BUFOR(INDEX)
      SER=SSER(IGEN)
      BUFOR(INDEX)=MOD((SER*QQCONS(IGEN)),1.D0)
      SSER(IGEN)=SER+1.
      RETURN

 910  PRINT 9100
 9100 FORMAT('  RNF100: WRONG IGEN ')
      STOP
 920  PRINT 9200
 9200 FORMAT('  RNF100: NGEN<1 OR NGEN>20 ')
      STOP
 930  PRINT 9300
 9300 FORMAT('  RNF100: INIRAN.LE.0 ')
      STOP
 940  PRINT 9400
 9400 FORMAT('  RNF100: IGEN>NGEN ')
      STOP
 950  PRINT 9500
 9500 FORMAT('  RNF100: LACK OF INITIALISATION')
      STOP
      END
      FUNCTION RNDMD(IDUMM)
C     ********************
      REAL*8 RNDMD
      DATA IC,IY /65536,13/
C---REINITIALISATION
      IF(IDUMM.EQ.-1) THEN
         IC=65536
         IY=13
         RNDMD=0
         RETURN
      ENDIF
      IY=IY*25
      IY=MOD(IY,IC)
      IY=IY*125
      IY=MOD(IY,IC)
      RNDMD=FLOAT(IY)/FLOAT(IC)
      RETURN
      END
      SUBROUTINE DUMPZ4(JK,PP)
C     **********************
C PRINTS SINGLE FOUR MOMENTUM
      REAL*4 PP(4)
      COMMON / INOUT / NINP,NOUT
      AMS=PP(4)**2
      DO 10 I=1,3
   10 AMS=AMS-PP(I)**2
      IF(AMS.GT.0.0) AMS=SQRT(AMS)
      WRITE(NOUT,1000)
      WRITE(NOUT,1502) JK,(PP(I),I=1,4),AMS
 1000 FORMAT(1X,'* DUMPZ4 *-------',8(10H----------))
 1502 FORMAT(10X,I6,3X,'FOURMOMENTUM  ',5(1X,F12.5))
      RETURN
C======================================================================
C================END OF JMCLIB=========================================
C======================================================================
      END
