      SUBROUTINE MASET(AMZ,AMH,AMT)
C======================================================================
C============WE START WITH ROUTINES RENAMING ENTRIES===================
C======================================================================
C
      IMPLICIT REAL*8 (A-H,O-Z)
      CALL DZINI (AMZ,AMH,AMT)
      END
      FUNCTION BORNR (MODE,SVAR,COSTHE,TA,TB)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8            ENE ,AMIN,AMFIN
      COMMON / KEYSET / KEYGSW,KEYRAD,KEYTAB
C
      BORNR=   BORNDZ(MODE,SVAR,COSTHE,TA,TB)
C
        IF ((ABS(IDF) .GE. 3).AND.(KEYGSW.GT.1)) THEN
C         QCD correction for quarks (not only alpha_s but 
C         note that there is no SVAR dependence !!!
          CORQCD = 1.D0+ALFSPI(4.D0*ENE*ENE)
          BORNR = BORNR*CORQCD
        END IF
      END
      SUBROUTINE PRMROB(ZMASS,GAMZ0,GAMZ,WMASS,GAMW0,GAMW,SIN2W)
      IMPLICIT REAL*8 (A-H,O-Z)
      CALL       DZEWZW(AMW,SW2,GAMZF,GAMWF)
      ZMASS=AMW/SQRT(1D0-SW2)
      GAMZ0=GAMZF
      GAMZ =GAMZF
      WMASS=AMW
      GAMW0=GAMWF
      GAMW =GAMWF
      SIN2W=SW2
      END
       SUBROUTINE DZEWZW (AMW,SW2,GAMZF,GAMWF)
*
      IMPLICIT REAL*8   (A-H,O-Z)
*     REAL*4            AMW,SW2,GAMZF,GAMWF
*
      COMMON/CDZZWG/AMZ,AMH,GMU,A0,GAMZ,GAMW,CALSZ,CALST
      COMMON/CDZWSM/AMW2,AMZ2,R,R1,R12,R2,AMH2,RW,RW1,RW12,RW2,RZ,RZ1,
     *              RZ12,RZ2,ALR,ALRW,ALRZ,SW2M,CW2M,AKSX,R1W,R1W2
C
      AMW=DSQRT(AMW2)
      SW2=R1
      GAMZF=GAMZ
      GAMWF=GAMW
      END

      SUBROUTINE
     $   DZOVRI(NPARD,WMASS,ZMASS,TMASS,HMASS,ALFAS,ZPARD,PARTZ,PARTW)
C THIS ROUTINE CAN BE USED TO OVERWRITE INPUT FOR THE ELECTROWEAK
C LIBRAY (DEFINED BELOW IN DZINI)
*
      IMPLICIT REAL*8(A-H,O-W,Y-Z)
*
      DIMENSION PARTZ(0:11),PARTW(3)
      DIMENSION NPARD(10),ZPARD(20)
      END
      SUBROUTINE DZINI (XMZ,XMH,XMT)
*     *****************************************
C======================================================================
C============INTEFACE STARTS HERE =====================================
C======================================================================
************************************************************************
* Interface to DIZET of the Dubna-Zeuthen EWRC group in KORALZ         *
* refer to C.P.C 1990,***                                              *
* initialization of the package                                        *
************************************************************************
*
      IMPLICIT REAL*8   (A-H,O-Z)
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8            ENE ,AMIN,AMFIN
      COMMON / INOUT / INUT,IOUT
      COMMON/JAKBOX/IBOX
      DIMENSION PARTZ(0:11),PARTW(3)
      DIMENSION NPARD(10),ZPARD(20)

*
      CALL GIVIZO( IDE, 1,AIZOR,QE,KDUMM)
      CALL GIVIZO( IDF, 1,AIZOR,QF,KOLOR)
      TMASS=XMT
      HMASS=XMH
      WMASS=   80D0
      ZMASS=XMZ
      ALFAS=0.12D0
      XKOLOR=KOLOR
*



*
*----------------------------------------------------------------------*
* CHOICE OF HADRONIC VACUUM POLARISATION:                              *
* IHVP :    IHVP=1: HADR. VAC. POLARIZATION OF JEGERLEHNER, REF. 11    *
*      I         2:       OF JEGERLEHNER(1988)                         *
*      I         3:       OF BURKHARDT ET AL., REF. 10                 *
*----------------------------------------------------------------------*
      IFVPOL=3
      NPARD(1) = IFVPOL
*----------------------------------------------------------------------*
* HANDLING OF ALPHA**2 T-MASS TERMS:                                   *
* IAMT4: IAMT4 = 0: NO  MT**4 CORRECTIONS,                             *
*      I       = 1: WITH MT**4 CORRECTIONS RESUMED, SEE REF. 7.        *
*                   IN ORDER TO HAVE COMPLETE BACKWARD COMPATIBILITY,  *
*                   NO COMMON RESUMMATION WITH IQCD.NE.0 TERMS IS DONE *
*      I       = 2: WITH RESUMMATION RECIPE DUE TO BARDIN/KNIEHL,      *
*                   SIMILAR TO THAT OF REF. 12                         *
*      I       = 3: WITH RESUMMATION RECIPE OF REFS. 13-15             *
*----------------------------------------------------------------------*
      IFAMT4=3
      NPARD(2) = IFAMT4
*----------------------------------------------------------------------*
* HANDLING OF HIGHER ORDER (ALPHA*ALPHA.S) T-MASS TERMS:               *
* IQCD :    THE Z-WIDTH HAS FIXED QCD FACTOR (1+ALFAS/PI).             *
*      I    ADDITIONAL OPTIONS ARE FROM REF.8, WITH RUNNING ALPHA.S    *
*      I    IQCD=0: NO QCD CORRS. TO VECTOR BOSON SELF ENERGIES        *
*      I    IN DELTA-R, WIDTHS, CROSS SECTION                          *
*      I         3: APPROXIM. FAST QCD CORRS. (REALISED FOR  Z-WIDTH   *
*      I            AND LEP PROCESSES)                                 *
*      I            IMPORTANT NOTICE: THESE ARE RELIABLE ONLY FOR LEP-I*
*      I         4: EXACT FORMULAE                                     *
*----------------------------------------------------------------------*
      IFQCDC=1
      NPARD(3) = IFQCDC
*----------------------------------------------------------------------*
* CHOICE OF INPUT PARAMETERS BESIDES AMT, AMH, ALPHA.S:                *
* IMOMS: IMOMS = 1: (CONVENTIONAL)    ALPHA, G.MU, AMZ (OUTPUT: AMW)   *
*      I       = 2: INPUT INSTEAD IS: ALPHA, G.MU, AMW (OUTPUT: AMZ)   *
*      I       = 3:                   ALPHA,  AMZ, AMW (OUTPUT: GMU)   *
* WHERE                                                                *
*      I G.MU..... MUON DECAY CONSTANT                                 *
*      I AMT...... T-QUARK MASS                                        *
*      I AMH...... HIGGS BOSON MASS                                    *
*      I ALST..... STRONG COUPLING CONSTANT ALPHA.S (.11)              *
*----------------------------------------------------------------------*

      NPARD(4) = 1
*----------------------------------------------------------------------*
* HANDLING OF HADRONIC VACUUM POLARISATION IN DELTA.R AND RUNNING ALPHA*
* IMASS: IMASS = 0: DEFAULT, USES A FIT TO DATA                        *
*      I       = 1: USES EFFECTIVE QUARK MASSES.OPTION EXISTS FOR TESTS*
*----------------------------------------------------------------------*
      IMASS =0
      NPARD(5) = IMASS
*----------------------------------------------------------------------*
* IALST: IALST = 0: QCDCOR AND QCDCOB WILL BE CALCULATED USING         *
*      I            LAMBDA(QCD)                                        *
*      I       = 1: THEY WILL BE CALCULATED IN TERMS OF ALPHA_STRONG   *
*      I            AS GIVEN BY THE USER (QCDVAR AT IALST=1)           *
*----------------------------------------------------------------------*
      IFALST=1
      NPARD(6) = IFALST
*----------------------------------------------------------------------*
* IQCD3: IQCD3 = 0: NO THIRD ORDER QCD CORRECTION IN QCDCOR AND QCDCOB *
*      I       = 1:  A THIRD ORDER QCD CORRECTION IN QCDCOR AND QCDCOB *
*----------------------------------------------------------------------*
      IFQCD3=1
      NPARD(7) = IFQCD3
*----------------------------------------------------------------------*
* IF IMASK=0: QUARK MASSES ARE USED EVERYWHERE                         *
*         =1: PHYSICAL THRESHOLD ARE USED IN THE PHASE SPACE           *
*----------------------------------------------------------------------*
      IMASK =0
      NPARD(8) = IMASK
*----------------------------------------------------------------------*
* IF IALPH=0: ALMSB4 IS INPUT FOR ALPHAS                               *
*         =1: ALMSB5 IS INPUT FOR ALPHAS                               *
*----------------------------------------------------------------------*
      IFALPH=0
      NPARD(9) = IFALPH
*----------------------------------------------------------------------*
* VERSION 4_6  OF THE PACKAGE INCLUDES R.BARBIERI AND UPDATE OF QCDCOF *
*                                      TO KUENH & CHETYRKIN CORRECTIONS*
*----------------------------------------------------------------------*
      IFBARB=2
      NPARD(10)= IFBARB
*----------------------------------------------------------------------*
* IF IBOX=0, heavy box contribution is neglected                       *
* IF IBOX=1, heavy box contribution is included                        *
*----------------------------------------------------------------------*
      IBOX=0
      IF (ENE.GT.80) THEN 
        IBOX=1
        WRITE(IOUT,*) 'INTERFACE TO ELECTROWEAK LIBRARY:',
     $              ' your center of mass energy is high'
        WRITE(IOUT,*) 'HEAVY BOXES are set on; program will slow'
        WRITE(IOUT,*) 'NOTE THAT above 160 GeV CMS energy,  ', 
     $                'tests of the interface were not done'
      ENDIF
*
      CALL DZOVRI(NPARD,WMASS,ZMASS,TMASS,HMASS,ALFAS,ZPARD,PARTZ,PARTW)
      CALL DIZET (NPARD,WMASS,ZMASS,TMASS,HMASS,ALFAS,ZPARD,PARTZ,PARTW)
      CALL QRKFIX (IDF,ZPARD(16)-1.0,ZPARD(17)-1.0)
      WRITE(IOUT,1000) IBOX,QE,QF,XKOLOR,AMFIN,ZMASS,TMASS,HMASS,ALFAS,
     $                 ZPARD(16),ZPARD(17)
      WRITE(IOUT,1001) (NPARD(I),I=1,10)
 1000 FORMAT(/
     +, ' ELEKTROWEAK LIBRARY DIZET BY DUBNA/ZEUTHEN GROUP',/
     +, ' INTERFACE TO THE KORALZ PROGRAM.             ',/
     +, ' LAST UPDATE: FEBRUARY 1993.                 ',//
     +, ' START PARAMETERS (MASSES, WIDTHS ARE IN GEV):',//
     +, ' note that DIZET has its own all fermion masses',/
     +, ' these may be different from the final state mass',/
     +, ' defined below:',//
     +, ' heavy box switch: IBOX=',I2,/,/
     +, ' INITIAL CHARGE=',F8.4,/' FINAL CHARGE  =',F8.4,/
     +, ' FINAL COLOR   =',F8.4,/' FINAL MASS    =',F8.4,/
     +, ' Z BOSON MASS  =',F8.4,/' T QUARK MASS  =',F8.4,/
     +, ' HIGGS MASS    =',F8.2,/' ALFA STRONG   =',F8.4,/
     +, ' QCD CORR.FACTOR TO Z-WIDTH CHANNELS (NO B) =',F15.10
     +, /
     +, ' QCD CORR.FACTOR TO Z-WIDTH CHANNEL (INTO B)=',F15.10
     +, //)
 1001 FORMAT(/
     +, ' furter flags, see routine DIZET for explanation',/
     +, '  IHVP =',I2,'       IAMT4 =',I2,/
     +, '  IQCD =',I2,'       IMOMS =',I2,/
     +, ' IMASS =',I2,'       IALST =',I2,/
     +, ' IQCD3 =',I2,'       IMASK =',I2,/
     +, ' IALPH =',I2,'      IFBARB =',I2,/
     +, //)
*
*
      END
      SUBROUTINE CZYBOX(IIBOX)
C THIS ROUTINE TRANSFORMS TO THE BORNDZ WHETHER BOXES HAVE TO BE
C CALCULATED (IIBOX=1) OR NOT (IIBOX=0)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/JAKBOX/IBOX
      IIBOX=IBOX
      END
      SUBROUTINE QRKFIX (AMASS,ALFA1,ALFA2)
      IMPLICIT REAL*8 (A-H,O-Z)
C THIS ROUTINE TAKES THE VALUE OF ALPHA_QCD FROM DIZET
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8            ENE ,AMIN,AMFIN
      COMMON / IDFC  / IDFF
      COMMON / DZQCDT/  ALFA
C alpha_QCD included in formfacors ?
      IF (ABS(IDFF).EQ.5)  THEN
          ALFA=ALFA1
       ELSE
          ALFA=ALFA2
       ENDIF
      END

      FUNCTION ALFSPI(S)
C THIS FUNCTION TRANSMITS TO KORALZ VALUE OF THE QCD correction factor
C USED IN DZ-LIBRARY.
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / DZQCDT/  ALFA
      ALFSPI=ALFA
      END
      FUNCTION BORNDZ(MODE,SVAR,COSTHE,TA,TB)
C ----------------------------------------------------------------------
C THIS ROUTINE PROVIDES BORN CROSS SECTION. IT HAS THE SAME         *
C STRUCTURE AS FUNTIS AND FUNTIH, THUS CAN BE USED AS SIMPLER       *
C EXAMPLE OF THE METHOD APPLIED THERE                               *
C 18.04. IT IS NOT SO SIMPLE NOW THERE ARE 2 MODES SIMPLE OLD ONE   *
C AND THE NEW ONE WHERE ALSO ELECTROWEAK CORRECTIONS ARE ADDED      *
C
C     called by : BORNY, BORAS, BORNV, WAGA, WEIGHT
C ----------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8            ENE ,AMIN,AMFIN
      COMMON / IDFC  / IDFF
      COMMON / GAUSPM /SS,POLN,T3E,QE,T3F,QF
     &                ,XUPGI   ,XUPZI   ,XUPGF   ,XUPZF
     &                ,NDIAG0,NDIAGA,KEYA,KEYZ
     &                ,ITCE,JTCE,ITCF,JTCF,KOLOR
      REAL*8           SS,POLN,T3E,QE,T3F,QF
     &                ,XUPGI(2),XUPZI(2),XUPGF(2),XUPZF(2)
      COMMON / QEDPRM /ALFINV,ALFPI,XK0
      REAL*8           ALFINV,ALFPI,XK0
      COMMON / INSPIN / SEPS1,SEPS2
      REAL*8            SEPS1,SEPS2
C=====================================================================
      COMMON / GSWPRM /SWSQ,AMW,AMZ,AMH,AMTOP,GAMMZ
      REAL*8           SWSQ,AMW,AMZ,AMH,AMTOP,GAMMZ
C     SWSQ        = sin2 (theta Weinberg)
C     AMW,AMZ     = W & Z boson masses respectively
C     AMH         = the Higgs mass
C     AMTOP       = the top mass
C     GAMMZ       = Z0 width
      COMMON / KEYSET / KEYGSW,KEYRAD,KEYTAB
      COMMON /NEWMOD/  AMNEUT,NNEUT
      REAL*8           AMNEUT
      COMPLEX*16 GSW(7)
      COMPLEX*16 ABORN(2,2),APHOT(2,2),AZETT(2,2)
      COMPLEX*16 XUPZFP(2),XUPZIP(2)
      COMPLEX*16 ABORNM(2,2),APHOTM(2,2),AZETTM(2,2)
      COMPLEX*16 PROPA,PROPZ
      COMPLEX*16 XR,XI,PROPW,AW(2,2)
      COMPLEX*16 XUPF,XUPI,XFF(4),XFEM,XFOTA,XRHO,XKE,XKF,XKEF
      COMPLEX*16 XTHING,XVE,XVF,XVEF
      REAL*8 XM2,XP2
      DATA AW/4*(0.D0,0.D0)/,XI/(0.D0,1.D0)/,XR/(1.D0,0.D0)/
      DATA XGW/2.5D0/
      DATA MODE0 /-5/
      DATA SVAR0,COST0 /-5.D0,-6.D0/
      DATA PI /3.141592653589793238462643D0/
C
C MEMORIZATION =========================================================
      IF ( MODE.NE.MODE0.OR.SVAR.NE.SVAR0.OR.COSTHE.NE.COST0) THEN
C ** PROPAGATORS
        MODE0=MODE
        SVAR0=SVAR
        COST0=COSTHE
        SINTHE=SQRT(1.D0-COSTHE**2)
        BETA=SQRT(MAX(0D0,1D0-4D0*AMFIN**2/SVAR))
        CALL CZYBOX(IBOX)
C I MULTIPLY AXIAL COUPLING BY BETA FACTOR.
        XUPZFP(1)=0.5D0*(XUPZF(1)+XUPZF(2))+0.5*BETA*(XUPZF(1)-XUPZF(2))
        XUPZFP(2)=0.5D0*(XUPZF(1)+XUPZF(2))-0.5*BETA*(XUPZF(1)-XUPZF(2))
        XUPZIP(1)=0.5D0*(XUPZI(1)+XUPZI(2))+0.5*(XUPZI(1)-XUPZI(2))
        XUPZIP(2)=0.5D0*(XUPZI(1)+XUPZI(2))-0.5*(XUPZI(1)-XUPZI(2))
C FINAL STATE VECTOR COUPLING
        XUPF     =0.5D0*(XUPZF(1)+XUPZF(2))
        XUPI     =0.5D0*(XUPZI(1)+XUPZI(2))
        XTHING   =0D0
      IF (MODE.GT.0.AND.KEYGSW.GT.1) THEN
C I MULTIPLY AXIAL COUPLING BY BETA FACTOR.
C I ADD ALSO FORMFACTORS
*********************************************************
*
* INITIALISATION OF S-DEPENDENT WEAK FORM FACTORS AND
* PHOTONIC VACUUM POLARISATION (WEAK BOX CONTRIBUTIONS
* LEFT OUT HERE, THEY DEPEND ON ACOS)
*
           IF (KEYTAB.EQ.0) THEN
             SV=SVAR/2D0
             IF (ABS(IDFF).EQ.5) THEN
                IBFLA=1
             ELSE
                IBFLA=0
             ENDIF
            CALL ROKANC(0,IBFLA,-SV,-SVAR,SV,QE,QF,XFF,XFEM,XFOTA)
           ELSEIF (KEYTAB.EQ.1) THEN
             CALL TABLUJ(0,SVAR,GSW)
             XFF(1)=GSW(1)
             XFF(2)=GSW(2)
             XFF(3)=GSW(3)
             XFF(4)=GSW(4)
C            XFFA  =UNDEFINED !
             XFEM  =GSW(6)
             XFOTA =GSW(7)
           ELSE
             PRINT *, 'STOP IN BORNDZ: UNDEFINED KEYTAB, KEYTAB=',KEYTAB
             STOP
           ENDIF
*
*********************************************************
              XRHO =XFF(1)
              XKE  =XFF(2)
              XKF  =XFF(3)
              XKEF =XFF(4)
              QFM=DABS(QF)
              QEM=DABS(QE)
              XE  =1.D0-4.D0*SWSQ*QEM
              XF  =1.D0-4.D0*SWSQ*QFM
              XEF =-1.D0+XE+XF+16.D0*QEM*QFM*SWSQ*SWSQ
              XVE  =1.D0-4.D0*SWSQ*QEM*XKE
              XVF  =1.D0-4.D0*SWSQ*QFM*XKF
              XVEF =-1.D0+XVE+XVF+16.D0*QEM*QFM*SWSQ*SWSQ*XKEF
C I MULTIPLY AXIAL  COUPLING BY BETA FACTOR.
C I MULTIPLY VECTOR COUPLING BY FORM-FACTOR.
        XUPZFP(1)=0.5D0*(XUPZF(1)+XUPZF(2))*XVF/XF
     &           +0.5*BETA*(XUPZF(1)-XUPZF(2))
        XUPZFP(2)=0.5D0*(XUPZF(1)+XUPZF(2))*XVF/XF
     &           -0.5*BETA*(XUPZF(1)-XUPZF(2))
        XUPZIP(1)=0.5D0*(XUPZI(1)+XUPZI(2))*XVE/XE
     &           +0.5*(XUPZI(1)-XUPZI(2))
        XUPZIP(2)=0.5D0*(XUPZI(1)+XUPZI(2))*XVE/XE
     &           -0.5*(XUPZI(1)-XUPZI(2))
C FINAL STATE VECTOR COUPLING
        XUPF     =0.5D0*(XUPZF(1)+XUPZF(2))*XVF/XF
C DOUBLE VECTOR FORMFACTOR THING
        XTHING=0.25D0*(XUPZF(1)+XUPZF(2))*(XUPZI(1)+XUPZI(2))*
     &         (XVEF/XEF-XVF*XVE/XE/XF)
        PROPA =1D0/SVAR/(2D0-XFEM)
        PROPZ =1D0/DCMPLX(SVAR-AMZ**2,SVAR/AMZ*GAMMZ)
C I REPLACE BORN NORMALIZATION OF Z PROPAGATOR BY THE BETTER ONE
        GMU  = 1.16637D-5
        DEL1 =GMU*AMZ**2*ALFINV/(DSQRT(2.D0)*8.D0*PI)
        DEL0 =1./(SWSQ*(1.-SWSQ))/16.
        PROPZ = PROPZ*DEL1/DEL0*XRHO
      ELSE
        PROPA =1D0/SVAR
        PROPZ =1D0/DCMPLX(SVAR-AMZ**2,SVAR/AMZ*GAMMZ)
        IF (KEYGSW.EQ.0) PROPZ=0.D0
      ENDIF
      IF (IABS(IDF).EQ.1) THEN
C*** NUNUB SPECIAL : W PROPAGATOR IN t-CHANNEL
      DO 15 I=1,2
      DO 15 J=1,2
      AW(I,J)=(0.D0,0.D0)
  15  CONTINUE
        IF(MODE.NE.1) THEN
        XMW=AMZ*DSQRT(1D0-SWSQ)
        XCOUP=1.D0/2.D0/SWSQ
         IF (IDE.LT.0) THEN
           AW(2,1)=- DCMPLX(XCOUP*(1.D0-COSTHE))/XMW/XMW
         ELSE
           AW(1,2)=- DCMPLX(XCOUP*(1.D0-COSTHE))/XMW/XMW
         ENDIF
        ELSE
        XMW=AMZ*DSQRT(1D0-SWSQ)
        XP2=(SVAR*(1.D0+COSTHE)/2.+XMW*XMW)**2+(XMW*XGW)**2
        PROPW=DCMPLX(-(SVAR*(1.D0+COSTHE)/2+XMW*XMW)/XP2)
        PROPW=PROPW-XI*DCMPLX(XMW*XGW/XP2)
        XCOUP=1.D0/2.D0/SWSQ
          IF (IDE.LT.0) THEN
           AW(2,1)= PROPW*DCMPLX(XCOUP*(1.D0-COSTHE))
          ELSE
           AW(1,2)= PROPW*DCMPLX(XCOUP*(1.D0-COSTHE))
          ENDIF
C disputable lines .....
C          IF(KEYGSW.GT.1) THEN
C           AW(1,2)=AW(1,2)*DEL1/DEL0
C           AW(2,1)=AW(2,1)*DEL1/DEL0
C          ENDIF
C end of disputable lines
        ENDIF
      ENDIF
      DO 50 I=1,2
      DO 50 J=1,2
      REGULA= (3-2*I)*(3-2*J) + COSTHE
      REGULM=-(3-2*I)*(3-2*J) * SINTHE *2.D0*AMFIN/SQRT(SVAR)
      APHOT(I,J)=PROPA*(XUPGI(I)*XUPGF(J)*REGULA)
      AZETT(I,J)=PROPZ*(XUPZIP(I)*XUPZFP(J)+XTHING)*REGULA
       ABORN(I,J)=APHOT(I,J)+AZETT(I,J)+AW(I,J)
      APHOTM(I,J)=PROPA*DCMPLX(0D0,1D0)*XUPGI(I)*XUPGF(J)*REGULM
      AZETTM(I,J)=PROPZ*DCMPLX(0D0,1D0)*(XUPZIP(I)*XUPF+XTHING)*REGULM
       ABORNM(I,J)=APHOTM(I,J)+AZETTM(I,J)
   50 CONTINUE
      ENDIF
C
C******************
C* IN CALCULATING CROSS SECTION ONLY DIAGONAL ELEMENTS
C* OF THE SPIN DENSITY MATRICES ENTER (LONGITUD. POL. ONLY.)
C* HELICITY CONSERVATION EXPLICITLY OBEYED
      POLAR1=  (SEPS1)
      POLAR2= (-SEPS2)
      BORN=0D0
      DO 150 I=1,2
      HELIC= 3-2*I
      DO 150 J=1,2
      HELIT=3-2*J
      FACTOR=KOLOR*(1D0+HELIC*POLAR1)*(1D0-HELIC*POLAR2)/4D0
      FACTOM=FACTOR*(1+HELIT*TA)*(1-HELIT*TB)
      FACTOR=FACTOR*(1+HELIT*TA)*(1+HELIT*TB)
      IF(IABS(IDF).NE.1) THEN
      BORN=BORN+CDABS(ABORN(I,J))**2*FACTOR
C MASS TERM IN BORN
       IF (MODE.GE.1) THEN
C mass terms included in BORN. Is it better ?
C--       IF (MODE.GE.5) THEN
       BORN=BORN+CDABS(ABORNM(I,J))**2*FACTOM
      ENDIF
      ELSE
        XM2=CDABS(ABORN(I,J))**2+(NNEUT-1)*CDABS(AZETT(I,J))**2
        XM3=CDABS(ABORNM(I,J))**2+(NNEUT-1)*CDABS(AZETTM(I,J))**2
        BORN=BORN+(XM2+XM3)*FACTOR
      ENDIF
  150 CONTINUE
C************
      FUNT=BORN
      IF(FUNT.LT.0.D0)  FUNT=BORN
C
      IF (SVAR.GT.4D0*AMFIN**2) THEN
C PHASE SPACE THRESHOLD FACTOR
        THRESH=SQRT(1-4D0*AMFIN**2/SVAR)
        BORNDZ= FUNT*SVAR**2*THRESH
      ELSE
        THRESH=0.D0
        BORNDZ=0.D0
      ENDIF
C ZW HERE WAS AN ERROR 19. 05. 1989

      IF (IBOX.EQ.1.AND.KEYGSW.GT.1.AND.MODE.GT.0.AND.IDF**2.NE.1) THEN
        BOXY=BOKSUJ(MODE,SVAR,COSTHE,TA,TB)*(1.D0+TA*TB)**2*KOLOR
        BORNDZ=BORNDZ+BOXY
      ENDIF
      END
      FUNCTION BOKSUJ (IWEAK,STOT,COSTH,HEPL,HEMI)
*     ********************************************
*
************************************************************************
* Interface to DIZET of the Dubna-Zeuthen EWRC group in KORALZ         *
* refer to C.P.C 1990,***                                              *
* calculation of the differential cross section                        *
************************************************************************
*
      IMPLICIT REAL*8     (A-H,O-Z)
*
C COMMONS OF DIZET
      COMMON/CDZPRM/QE,QF,COLORF,AMF,MODE,IHVP,IAMT4,IQCD,IBOX
      COMMON/CDZBM /S,ALAMP,ALAME
C COMMONS OF KORALZ
      COMMON / QEDPRM /ALFINV,ALFPI,XK0
      REAL*8           ALFINV,ALFPI,XK0
      COMMON / INSPIN / SEPS1,SEPS2
      REAL*8            SEPS1,SEPS2
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8            ENE ,AMIN,AMFIN
      DATA CMTR /389.385D 3/
      DATA PI /3.141592653589793238462643D0/

      MODE = IWEAK
      S = STOT
      IF ( IDE.GT.0) THEN
        ALAMP=-SEPS1
        ALAME= SEPS2
        SA=-HEPL
        SB= HEMI
      ELSE
        ALAMP= SEPS1
        ALAME=-SEPS2
        SA= HEPL
        SB=-HEMI
      ENDIF
      BOKSUJ = DZBOX  (COSTH,SA,SB)
C FIX NORMALIZATION OF X-SECTIONS FROM NANOBARNS TO QED LOWEST ORDER
        SIG0=4.D0*PI/ALFINV**2/3.D0/S
      BOKSUJ=BOKSUJ/SIG0/CMTR*8/3
      END
      FUNCTION DZBOX  (RACOS,RHELPL,RHELMI)
*
      IMPLICIT REAL*8     (A-H,O-W,Y-Z)
      IMPLICIT COMPLEX*16 (X)
*     REAL*4        RACOS,RHELPL,RHELMI
*     REAL*4        S,ALAMP,ALAME
*
      COMMON/CDZBM /S,ALAMP,ALAME
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8            ENE ,AMIN,AMFIN

      COMMON/CDZZWG/AMZ,AMH,GMU,A0,GAMZ,GAMW,CALSZ,CALST
      COMMON/CDZWSM/AMW2,AMZ2,R,R1,R12,R2,AMH2,RW,RW1,RW12,RW2,RZ,RZ1,
     *              RZ12,RZ2,ALR,ALRW,ALRZ,SW2M,CW2M,AKSX,R1W,R1W2
C*      COMMON/CDZPRM/MODE,IHVP,IQCD,IBOX,QE,QF,COLORF,AMF
C      COMMON/CDZPRM/AMF, MODE,,,,
      COMMON/CDZCON/PI,PI2,F1,D3,ALFAI,AL4PI,AL2PI,AL1PI
      COMMON/CDZFMF/XVPOL,XRHO,XKE,XKF,XKEF,XCHI,XFAM2,XFZM2,XFAZI
      COMMON/CDZBOX/QE,QF,ALAM1,ALAM2,HELI1,HELI2,SC,VE,VF,CRFAC
      DATA SCOLD /-1.D0/, MODOLD /-1/
      AMF=AMFIN
*
***********************************************************************
*
* THIS FUNCTION CALCULATES BOX CONTRIBUTION TO
* THE DIFFERENTIAL CROSS SECTION FOR
* ELASTIC TWO FERMION PRODUCTION IN ELECTRON POSITRON ANNIHILATION
* AT ARBITRARY ENERGY (MUCH LARGER THAN THE FERMION MASSES)
* IN NANOBARN FOR ARBITRARY POLARISATIONS AND HELICITIES
*                DSIG/DCOS
*
* AUTHORS:  DUBNA-ZEUTHEN EWRC GROUP
*
* REFERENCES:
* D. BARDIN, P. CHRISTOVA, O. FEDORENKO: NUCL. PHYS. B197(1982)1
* D. BARDIN, A. LEIKE, T. RIEMANN, M. SACHWITZ: PHYS.LETT.B206(1988)539
* D. BARDIN, C. BURDIK, P. CHRISTOVA, T. RIEMANN:Z.PHYSIK C (1989)
* D. BARDIN, M. BILENKY, G. MITSELMAKHER, T. RIEMANN, M. SACHWITZ:
* "A REALISTIC APPROACH TO THE STANDARD Z PEAK", TO APPEAR IN:
* Z.PHYSIK C (1989)
* D. BARDIN, M. BILENKY, T. RIEMANN, M. SACHWITZ, H. VOGT, P. CHRISTOVA:
* PHE 89-9, SUBMITTED TO COMPUTER PHYSICS COMMUNICATIONS
*       (THE LAST TWO REFERENCES CORRESPONDS TO THE FORMULAE USED)
*
* FURTHER COMMENTS SEE SUBROUTINE DZEWIN
*
* MODE:  THIS ROUTINE SHOULD BE CALLED ONLY WHEN MODE=1
*
**********************************************************************
*
*
      ACOS  = RACOS
      HELPL = RHELPL
      HELMI = RHELMI
      SC=S
      DALAMP= ALAMP
      DALAME= ALAME
      COMI2=1.D0-ACOS*ACOS
      COPL2=1.D0+ACOS*ACOS
      ALAM1=1.D0-DALAMP*DALAME
      ALAM2=DALAMP-DALAME
      HELI1=(1.D0-HELPL*HELMI)/4.D0
      HELI2=(HELPL-HELMI)/4.D0
*
* THE HELI1,2 TAKE INTO ACCOUNT THAT NO SUM HAS BEEN PERFORMED
* OVER FINAL STATE HELICITIES.
**********
*
* PREPARATION FOR DIFFERENT HELICITY STATES
       HP = INT(HELPL)
       HM = INT(HELMI)
        IF(HP.NE.0.AND.HM.NE.0) THEN
           HELI1 = (1.D0-HELPL*HELMI)/4.D0
           HELI2 = (HELPL-HELMI)/4.D0
        ENDIF
        IF(HP.EQ.0.AND.HM.EQ.0) THEN
                   HELI1 = 1.D0
                   HELI2 = 0.D0
        ENDIF
       IF(HP.EQ.0.AND.HM.NE.0) THEN
                    HELI1 = .5D0
                    HELI2 = -.5D0*HELMI
       ENDIF
       IF(HP.NE.0.AND.HM.EQ.0) THEN
                    HELI1 = .5D0
                    HELI2 =  .5D0*HELPL
       ENDIF
        MODE=1
      IF (SC .NE. SCOLD .OR. MODE .NE. MODOLD)  THEN
        SCOLD=SC
        MODOLD=MODE
*
* PURE ENERGY DEPENDENT PART
* ONLY FOR NEW S THE WEAK FORM FACTORS HAVE TO BE CALCULATED
*
*
        CNANOB=.389386D6
        FMU = AMF*AMF/SC
        FMUSQ= DSQRT(1.D0-4.D0*FMU)
        CRFAC=CNANOB*FMUSQ
        SW2=R1
        CONST=GMU*AMZ2*ALFAI/(DSQRT(2.D0)*8.D0*PI)
        GAMZS=GAMZ*SC/AMZ2
* THE SW2 IS THE WEAK MIXING ANGLE DEFINED WITH W AND Z MASS
        QFM=DABS(QF)
        QEM=DABS(QE)
        VE=1.D0-4.D0*SW2*QEM
        VF=1.D0-4.D0*SW2*QFM
*
* THE FOREGOING WIDTH FUNCTION IS S-DEPENDENT AND GAMZ CONTAINS
* ELECTROWEAK AND QCD O(ALFA) CORRS., SEE SBR ZWRATE
        XM2S=DCMPLX(AMZ2,-GAMZS*AMZ)
        XCHI=CONST*SC/(SC-XM2S)
*
              XRHO =DCMPLX(1.D0,0.D0)
              XKE  =XRHO
              XKF  =XRHO
              XKEF =XRHO
              XVE  =DCMPLX(1.D0-4.D0*SW2*QEM,0.D0)
              XVF  =DCMPLX(1.D0-4.D0*SW2*QFM,0.D0)
              XVEF =-1.D0+XVE+XVF+16.D0*QEM*QFM*SW2*SW2
              XVPOL=DCMPLX(1.D0,0.D0)
*
      ENDIF
*
* FOR FINITE MASS CORRECTION :
*
      XFACA =QEM*QFM*XVPOL
      XFACAB=DCONJG(XFACA)
      XFAM2 =XFACA*XFACAB
      XFACZ =XCHI*XRHO
      XFZM2 =XFACZ*DCONJG(XFACZ)
      XFAZI =2.D0*XFACZ*XFACAB
*
* CALCULATION OF THE BOX CONTRIB TO THE
* CROSS SECTION IN NANOBARN
*
              DEWCBX= DZEWBX (RACOS)
*
      DZBOX =DEWCBX
      END
      SUBROUTINE CINT
C======================================================================
C============TABULATION OF THE FORMFACTORS=============================
C======================================================================
C ----------------------------------------------------------------------
* THIS IS AN ENTRY OF EASY INITIALISATION OF FORMFACTORS
* CALCULATED IN ROUTINE ROKAP AND TABULATED IN ROUTINE TABLUJ
C
C     called by : KORALZ
C ----------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON / KEYSET / KEYGSW,KEYRAD,KEYTAB
      COMPLEX*16 GSW(7)
      COMMON / INOUT / INUT,IOUT
*
      IF (KEYTAB.EQ.1.AND.KEYGSW.GT.1)
     $CALL TABLUJ(-1,0D0,GSW)
      END
      SUBROUTINE TABLUJ(MODE,S,GSW)
C ----------------------------------------------------------------------
* FAST ROUTINE FOR EVALUATION OF ELECTROWEAK FORMFACTORS
* IT PROVIDES FORMFACTORS FOR POSITIVE SS, TABULATED IN
* LOOK UP TABLES, AND THEN CALCULATED BY LINEAR INTERPOLATION.
* PRIOR TO ITS NORMAL USE, IT SHOULD BE CALLED LIKE CALL TABLUJ(-1,0.,..
C
C     CALLED BY : CINT, BORN(DZ)
C ----------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8            ENE ,AMIN,AMFIN
      COMMON / IDFC  / IDFF
      COMPLEX*16 GSW(7)
      COMPLEX*16 CYY(201,7),CZZ(41,7)
      COMPLEX*16 XFF(4),XFEM,XFOTA
      DATA NPOIN,NPOIN2 /120,20/
      DATA INIT/0/
      DATA WMAX/240.001D0/ 
C
      IF (MODE.EQ.-1) THEN
* INITIALISATION MODE
        INIT=INIT+1
        CALL PRMOUT(AMZ,GAMMZ,GAMMZ1,WMASS,GAMMW,GAMMW1,SWSQ)
        CALL GIVIZO( IDE, 1,AIZOR,QE,KDUMM)
        CALL GIVIZO( IDF, 1,AIZOR,QF,KOLOR)
             IF (ABS(IDFF).EQ.5) THEN
                IBFLA=1
             ELSE
                IBFLA=0
             ENDIF
* IN WIDE S RANGE
        WMIN=0.010D0
C
        DO 110 I=0,NPOIN
        X=DFLOAT(I)/DFLOAT(NPOIN)
        WW =WMIN*(WMAX/WMIN)**X
        SSS=WW*WW
        SV=SSS/2D0
        CALL ROKANC(0,IBFLA,-SV,-SSS,SV,QE,QF,XFF,XFEM,XFOTA)
        DO 51 KK=1,4
   51   CYY(I+1,KK)=XFF(KK)
        CYY(I+1,5 )=123.456
        CYY(I+1,6 )=XFEM
        CYY(I+1,7 )=XFOTA
  110   CONTINUE
* NEAR Z0 RESONANCE
        WMIN2=AMZ-2D0*GAMMZ
        WMAX2=AMZ+2D0*GAMMZ
        DO 115 I=0,NPOIN2
        X=DFLOAT(I)/DFLOAT(NPOIN2)
        WW =WMIN2+(WMAX2-WMIN2)*X
        SSS=WW*WW
        CALL ROKANC(0,IBFLA,-SV,-SSS,SV,QE,QF,XFF,XFEM,XFOTA)
        DO 52 KK=1,4
   52   CZZ(I+1,KK)=XFF(KK)
        CZZ(I+1,5 )=123.456
        CZZ(I+1,6 )=XFEM
        CZZ(I+1,7 )=XFOTA
  115   CONTINUE
C
      ELSE
* OPERATIONAL MODE
        IF(INIT.EQ.0) GOTO 910
        W=SQRT(S)
        IF(W.LT.WMIN2.OR.W.GT.WMAX2) THEN
* IN A WIDE RANGE
          IF(W.LT.WMIN.OR.W.GT.WMAX) GOTO 920
          X= LOG( W/WMIN)/LOG(WMAX/WMIN)
          I= INT(NPOIN*X)+1
          H= X*NPOIN-DFLOAT(I-1)
          DO 53 KK=1,7
   53     GSW(KK)=CYY(I,KK)*(1-H)+CYY(I+1,KK)*H
        ELSE
* NEAR Z0 RESONANCE
          X= (W-WMIN2)/(WMAX2-WMIN2)
          I= INT(NPOIN2*X)+1
          H= X*NPOIN2-DFLOAT(I-1)
          DO 54 KK=1,7
   54     GSW(KK)=CZZ(I,KK)*(1-H)+CZZ(I+1,KK)*H
        ENDIF
      ENDIF
      RETURN
  910 PRINT *,'   TABLUJ: LACK OF INITIALISATION.'
      STOP
  920 PRINT *,'   TABLUJ: S OUT OF PREDEFINED RANGE '
      STOP
      END
      FUNCTION BORNH(MODE,SVAR,COSTHE,TA,TB)
C======================================================================
C============ROUTINES TO DETACH SECOND ELECTROWEAK LIBRARY=============
C======================================================================
      IMPLICIT REAL*8(A-H,O-Z)
      PRINT *, 'SORRY, SECOND ELECTROWEAK LIBRARY IS NOT INTERFACED'
      BORNH=5.
      STOP
      END
      SUBROUTINE PRMHOL(ZMASS,GAMZ0,GAMMZ,WMASS,GAMW0,GAMW,SIN2W)
      IMPLICIT REAL*8(A-H,O-Z)
      PRINT *, 'SORRY, SECOND ELECTROWEAK LIBRARY IS NOT INTERFACED'
      STOP
      END
      SUBROUTINE HOLSTA(IDF,KEYGSW,YMZ,YMH,YMT)
      IMPLICIT REAL*8(A-H,O-Z)
      PRINT *, 'SORRY, SECOND ELECTROWEAK LIBRARY IS NOT INTERFACED'
      STOP
      END






