      SUBROUTINE MASET(AMZ,AMH,AMT)
C======================================================================
C============WE START WITH ROUTINES RENAMING ENTRIES===================
C======================================================================
C
      IMPLICIT REAL*8 (A-H,O-Z)
      CALL DZINI (AMZ,AMH,AMT)
      END
      FUNCTION BORNR (MODE,SVAR,COSTHE,TA,TB)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8            ENE ,AMIN,AMFIN
      COMMON / KEYSET / KEYGSW,KEYRAD,KEYTAB
C
      BORNR=   BORNDZ(MODE,SVAR,COSTHE,TA,TB)
C
        IF ((ABS(IDF) .GE. 3).AND.(KEYGSW.GT.1)) THEN
C         QCD correction for quarks (not only alpha_s but 
C         note that there is no SVAR dependence !!!
          CORQCD = 1.D0+ALFSPI(4.D0*ENE*ENE)
          BORNR = BORNR*CORQCD
        END IF
      END
      SUBROUTINE PRMROB(ZMASS,GAMZ0,GAMZ,WMASS,GAMW0,GAMW,SIN2W)
      IMPLICIT REAL*8 (A-H,O-Z)
      CALL       DZEWZW(AMW,SW2,GAMZF,GAMWF)
      ZMASS=AMW/SQRT(1D0-SW2)
      GAMZ0=GAMZF
      GAMZ =GAMZF
      WMASS=AMW
      GAMW0=GAMWF
      GAMW =GAMWF
      SIN2W=SW2
      END
       SUBROUTINE DZEWZW (AMW,SW2,GAMZF,GAMWF)
*
      IMPLICIT REAL*8   (A-H,O-Z)
*     REAL*4            AMW,SW2,GAMZF,GAMWF
*
      COMMON/CDZZWG/CAMZ,CAMH,GMU,A0,GAMZ,GAMW,CALSZ,CALST,CALXI,CALQED
      COMMON/CDZWSM/AMW2,AMZ2,R,R1,R12,R2,AMH2,RW,RW1,RW12,RW2,RZ,RZ1,
     *      RZ12,RZ2,ALR,ALRW,ALRZ,SW2M,CW2M,AKSX,R1W,R1W2
C
      AMW=DSQRT(AMW2)
      SW2=R1
      GAMZF=GAMZ
      GAMWF=GAMW
      END
      SUBROUTINE  DZOVRI(
     $   NPARD,WMASS,ZMASS,TMASS,HMASS,ALQED,ALFAS,ZPARD,PARTZ,PARTW)
C THIS ROUTINE CAN BE USED TO OVERWRITE INPUT FOR THE ELECTROWEAK
C LIBRAY (DEFINED BELOW IN DZINI)
*
      IMPLICIT REAL*8(A-H,O-W,Y-Z)
*
      DIMENSION PARTZ(0:11),PARTW(3)
      DIMENSION NPARD(21),ZPARD(30)
      END
      SUBROUTINE DZINI (XMZ,XMH,XMT)
*     *****************************************
C======================================================================
C============INTEFACE STARTS HERE =====================================
C======================================================================
************************************************************************
* Interface to DIZET of the Dubna-Zeuthen EWRC group in KORALZ         *
* refer to C.P.C 1990,***                                              *
* initialization of the package,                                       *
*                                                                      *
*  WARNING:       COMMENTS ON INPUTS  ARE FOR DIZET 4.9                *
*                 FOR UP TO DATE SEE FILE dizet6_05.f                  *
*                                                                      *
************************************************************************
*
      IMPLICIT REAL*8   (A-H,O-Z)
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8            ENE ,AMIN,AMFIN
      COMMON / INOUT / INUT,IOUT
      COMMON/JAKBOX/IBOX
      COMMON / KEYSET / KEYGSW,KEYRAD,KEYTAB
      DIMENSION PARTZ(0:11),PARTW(3)
      DIMENSION NPARD(21),ZPARD(30)

*
      CALL GIVIZO( IDE, 1,AIZOR,QE,KDUMM)
      CALL GIVIZO( IDF, 1,AIZOR,QF,KOLOR)
      TMASS=XMT
      HMASS=XMH
      WMASS=   80D0
      ZMASS=XMZ
      ALFAS=0.125  !! 0.125D0
      XKOLOR=KOLOR
*



*
*----------------------------------------------------------------------*
* CHOICE OF HADRONIC VACUUM POLARISATION:                              *
* IHVP :    IHVP=1: HADR. VAC. POLARIZATION OF JEGERLEHNER, REF. 11    *
*      I         2:       OF JEGERLEHNER(1988)                         *
*      I         3:       OF BURKHARDT ET AL., REF. 10                 *
*----------------------------------------------------------------------*
      IFVPOL=3
      NPARD(1) = IFVPOL
*----------------------------------------------------------------------*
* HANDLING OF ALPHA**2 T-MASS TERMS:                                   *
* IAMT4: IAMT4 = 0: NO  MT**4 CORRECTIONS,                             *
*      I       = 1: WITH MT**4 CORRECTIONS RESUMED, SEE REF. 7.        *
*                   IN ORDER TO HAVE COMPLETE BACKWARD COMPATIBILITY,  *
*                   NO COMMON RESUMMATION WITH IQCD.NE.0 TERMS IS DONE *
*      I       = 2: WITH RESUMMATION RECIPE DUE TO BARDIN/KNIEHL,      *
*                   SIMILAR TO THAT OF REF. 12                         *
*      I       = 3: WITH RESUMMATION RECIPE OF REFS. 13-15             *
*----------------------------------------------------------------------*
      IFAMT4=3
      NPARD(2) = IFAMT4
*----------------------------------------------------------------------*
* HANDLING OF HIGHER ORDER (ALPHA*ALPHA.S) T-MASS TERMS:               *
* IQCD :    THE Z-WIDTH HAS FIXED QCD FACTOR (1+ALFAS/PI).             *
*      I    ADDITIONAL OPTIONS ARE FROM REF.8, WITH RUNNING ALPHA.S    *
*      I    IQCD=0: NO QCD CORRS. TO VECTOR BOSON SELF ENERGIES        *
*      I    IN DELTA-R, WIDTHS, CROSS SECTION                          *
*      I         3: APPROXIM. FAST QCD CORRS. (REALISED FOR  Z-WIDTH   *
*      I            AND LEP PROCESSES)                                 *
*      I            IMPORTANT NOTICE: THESE ARE RELIABLE ONLY FOR LEP-I*
*      I         4: EXACT FORMULAE                                     *
*----------------------------------------------------------------------*
      IFQCDC=1
      NPARD(3) = IFQCDC
*----------------------------------------------------------------------*
* CHOICE OF INPUT PARAMETERS BESIDES AMT, AMH, ALPHA.S:                *
* IMOMS: IMOMS = 1: (CONVENTIONAL)    ALPHA, G.MU, AMZ (OUTPUT: AMW)   *
*      I       = 2: INPUT INSTEAD IS: ALPHA, G.MU, AMW (OUTPUT: AMZ)   *
*      I       = 3:                   ALPHA,  AMZ, AMW (OUTPUT: GMU)   *
* WHERE                                                                *
*      I G.MU..... MUON DECAY CONSTANT                                 *
*      I AMT...... T-QUARK MASS                                        *
*      I AMH...... HIGGS BOSON MASS                                    *
*      I ALST..... STRONG COUPLING CONSTANT ALPHA.S (.11)              *
*----------------------------------------------------------------------*

      NPARD(4) = 1
*----------------------------------------------------------------------*
* HANDLING OF HADRONIC VACUUM POLARISATION IN DELTA.R AND RUNNING ALPHA*
* IMASS: IMASS = 0: DEFAULT, USES A FIT TO DATA                        *
*      I       = 1: USES EFFECTIVE QUARK MASSES.OPTION EXISTS FOR TESTS*
*----------------------------------------------------------------------*
      IMASS =0
      NPARD(5) = IMASS
*----------------------------------------------------------------------*
* IALST: IALST = 0: QCDCOR AND QCDCOB WILL BE CALCULATED USING         *
*      I            LAMBDA(QCD)                                        *
*      I       = 1: THEY WILL BE CALCULATED IN TERMS OF ALPHA_STRONG   *
*      I            AS GIVEN BY THE USER (QCDVAR AT IALST=1)           *
*----------------------------------------------------------------------*
      IFALST=1
      NPARD(6) = IFALST
*----------------------------------------------------------------------*
* IQCD3: IQCD3 = 0: NO THIRD ORDER QCD CORRECTION IN QCDCOR AND QCDCOB *
*      I       = 1:  A THIRD ORDER QCD CORRECTION IN QCDCOR AND QCDCOB *
*----------------------------------------------------------------------*
      IFQCD3=1
      NPARD(7) = IFQCD3
*----------------------------------------------------------------------*
* IF IMASK=0: QUARK MASSES ARE USED EVERYWHERE                         *
*         =1: PHYSICAL THRESHOLD ARE USED IN THE PHASE SPACE           *
*----------------------------------------------------------------------*
      IMASK =0
      NPARD(8) = IMASK
*----------------------------------------------------------------------*
* IF IALPH=0: ALMSB4 IS INPUT FOR ALPHAS                               *
*         =1: ALMSB5 IS INPUT FOR ALPHAS                               *
*----------------------------------------------------------------------*
      IFALPH=0
      NPARD(9) = IFALPH
*----------------------------------------------------------------------*
* VERSION 4_6  OF THE PACKAGE INCLUDES R.BARBIERI AND UPDATE OF QCDCOF *
*                                      TO KUENH & CHETYRKIN CORRECTIONS*
*----------------------------------------------------------------------*
      IFBARB=2
      NPARD(10)= IFBARB

*------------------------------------------------------------------------
* THE PROGRAM DIZET IS A WEAK LIBRARY. IT CALCULATES ELECTROWEAK
* RADIATIVE CORRECTIONS IN THE STANDARD THEORY.
* ----------------------------------------------------------------------
* FOR THE CALCULATION OF
*       W-BOSON MASS AND WEAK MIXING ANGLE,
*       Z-BOSON WIDTH,
*       W-BOSON WIDTH,
* --- CALL DIZET(...).
* ----------------------------------------------------------------------
* FOR THE CALCULATION OF
*       WEAK FORM FACTORS
*       FOR 2-FERMION INTO 2-FERMION NEUTRAL CURRENT PROCESSES
*       AND OF RUNNING ALPHA.QED,
* --- CALL ROKANC(...).
* FOR THE CALCULATION OF
*       WEAK FORM FACTORS
*       FOR 2-FERMION INTO 2-FERMION CHARGED CURRENT PROCESSES,
* --- CALL RHOCC(...).
* IN BOTH CASES, AN EARLIER CALL OF DIZET(...) IS NECESSARY.
*------------------------------------------------------------------------
*         SOME RELEVANT REFERENCES:
*-----------------------------------------------------------------------
*     BASICS OF THE ONE-LOOP CALCULATIONS IN THE UNITARY GAUGE, DELTA.R:
*  1. D.BARDIN, P.CHRISTOVA, O.FEDORENKO:    NUCL. PHYS. B175 (1980) 435
*                                            NUCL. PHYS. B197 (1982) 1
* ----------------------------------------------------------------------
*     CALCULATION OF THE Z WIDTH:
*  2. A.AKHUNDOV, D.BARDIN, T.RIEMANN:       NUCL. PHYS. B276 (1986) 1
* ----------------------------------------------------------------------
*     CALCULATION OF THE W WIDTH:
*  3. D.BARDIN, S.RIEMANN, T.RIEMANN:        Z. PHYSIK C32 (1986) 121
* ----------------------------------------------------------------------
*     EWRC FOR FERMION PAIR PRODUCTION IN THE ANNIHILATION CHANNEL:
*  4. D.BARDIN, S.BILENKY, G.MITSELMAKHER,T.RIEMANN, M.SACHWITZ:
*                                            Z. PHYSIK C44 (1989) 493
*     ADDITIONAL TBW-VERTEX CORRECTIONS IN B-QUARK PRODUCTION DUE TO
*     T-MASS: SEE REF. 2.
* ---------------------------------------------------------------------
*     EWRC FOR NC AND CC DEEP INELASTIC EP SCATTERING:
*     D.BARDIN, C.BURDIK, P.CHRISTOVA, T.RIEMANN:
*  5.                                        Z. PHYSIK C42 (1989) 679
*  6.                                        Z. PHYSIK C44 (1989) 149
* ----------------------------------------------------------------------
*     EWRC FOR BHABHA SCATTERING AND HIGHER ORDER (IN ALPHA.QED)
*     T-MASS EFFECTS:
*  7. D.BARDIN, W.HOLLIK, T.RIEMANN:         Z. PHYSIK C49 (1991) 485
* ----------------------------------------------------------------------
*     HIGHER ORDER (IN ALPHA.STRONG) T-MASS EFFECTS:
*  8. D.BARDIN, S.TSCHISHOV:              PROC. SEMINAR "PHYSICS OF E+E-
*                                         INTERACTIONS", DUBNA 1988;
*                                         DUBNA, E2-89-525 (1989)
*  9. SEE ALSO: A.DJOUADI,C.VERZEGNASSI:  PHYS. LETTERS B195 (1987) 265
*               A. DJOUADI:               NUOVO CIM. 100A (1988) 357
* ----------------------------------------------------------------------
*     CALCULATION OF RUNNING ALPHA.QED, SEE:
* 10. H.BURKHARDT, F.JEGERLEHNER, G.PENSO, C.VERZEGNASSI:
*                                         Z. PHYSIK C43 (1989) 497
* 11. F. JEGERLEHNER:                     PSI-PR-91-16 (1991)
*                    TO APPEAR IN: PROGRESS IN PARTICLE AND NUCLEAR
*                    PHYSICS, ED. A. FASSLER, PERGAMON PRESS, OXFORD,U.K
* ----------------------------------------------------------------------
*     COMMON RESUMMATION OF THE HIGHER ORDER TERMS FOLLOWS:
* 12. F.HALZEN, B. KNIEHL:                   NUCL. PHYS. B353 (1991) 567
* ----------------------------------------------------------------------
*     FOR A VARIATION OF HANDLING OF REMAINDER TERMS IN THIS SUMMATION,
*     SEE ALSO REF. 13
* ----------------------------------------------------------------------
*     ANOTHER RECIPE FOR THE RESUMMATION OF HIGHER ORDERS IS DUE TO:
* 13. S.FANCHIOTTI,A.SIRLIN: NYU PREPR.(FEB 1990), IN MEMORIAM M.A.B.BEG
* 14. G.DEGRASSI, S.FANCHIOTTI, A.SIRLIN:    NUCL. PHYS. B351 (1991) 49
* 15. G. DEGRASSI, A.SIRLIN:                 NUCL. PHYS. B352 (1991) 342
* =====================================================================*
*
*
* IF THE CALL WAS 'CALL DIZET(...)':                                   *
*-------------------------------------                                 *
*         FLAGS TO BE SET BY THE USER, EXPLAINED BELOW                 *
*       ------------------------------------------------               *
* NPAR(1) = IHVP                                                       *
* NPAR(2) = IAMT4                                                      *
* NPAR(3) = IQCD                                                       *
* NPAR(4) = IMOMS                                                      *
* NPAR(5) = IMASS                                                      *
* NPAR(6) = ISCRE                                                      *
* NPAR(7) = IALEM                                                      *
* NPAR(8) = IMASK                                                      *
* NPAR(9) = ISCAL                                                     *
* NPAR(10)= IBARB                                                      *
* NPAR(11)= IFTJR                                                      *
* NPAR(12)= IFACR                                                     *
* NPAR(13)= IFACT                                                      *
* NPAR(14)= IHIGS                                                      *
* NPAR(15)= IAFMT                                                      *
* ---------------------------------------------------------------------*
*         INPUT PARAMETERS TO BE SET BY THE USER                       *
*       ------------------------------------------                     *
* AMW  -  W-BOSON MASS (BUT IS BEING CALCULATED FOR NPAR(4)=1)         *
* AMZ  -  Z-BOSON MASS (BUT IS BEING CALCULATED FOR NPAR(4)=2)         *
*    NOTE: DUE TO A POSSIBLE RECALCULATION, THE AMZ, AMW CANNOT BE     *
*         ASSIGNED BY A PARAMETER STATEMENT (INPUT/OUTPUT VARIABLES)   *
* AMT  -  T-QUARK MASS                                                 *
* AMH  -  HIGGS BOSON MASS                                             *
* ALQED - ALPHA_EM(MZ)                                                 *
* ---------------------------------------------------------------------*
*         OUTPUT OF THE DIZET PACKAGE                                  *
*       --------------------------------                               *
* ZPAR(1) = DR                                                         *
* ZPAR(2) = DRREM                                                      *
* ZPAR(3) = SW2                                                        *
* ZPAR(4) = GMUC                                                       *
* ZPAR(5-14) = STORES EFFECTIVE SIN'S FOR ALL PARTIAL Z-DECAY CHANNELS *
* 5- NEUTRINO,  6-ELECTRON,  7-MUON, 8-TAU, 9-UP, 10-DOWN, 11-CHARM,   *
* 12-STRANGE , 13-TOP     , 14-BOTTOM.                                 *
* ZPAR(15)= ALPHST                                                     *
* ZPAR(16-30)= QCDCOR(0-14)                                            *
*                                                                      *
* AMW  -  W-BOSON MASS (BUT IS INPUT IF NPAR(4)=2,3)                   *
* AMZ  -  Z-BOSON MASS (BUT IS INPUT IF NPAR(4)=1,3)                   *
* GMUC -  MUON DECAY CONSTANT (IT IS SET TO GMU IF NPAR(4)=1,2)        *
* GMUC -  MUON DECAY CONSTANT (IT IS CALCULATED IF NPAR(4)=3  )        *
*         IF GMU IS CALCULATED FROM AMZ, AMW, IT DEVIATES FROM THE     *
*         EXPERIMENTAL VALUE!                                          *
* DR   -  DELTA.R, THE LOOP CORRECTION TO THE MUON DECAY CONSTANT G.MU *
* DRREM - THE REMAINDER CONTRIBUTION OF THE ORDER ALPHA CALCULATION    *
*         OF DELTA.R AFTER SEPARATION OF THE RESUMMED TERMS            *
* SW2  -  WEAK MIXING ANGLE DEFINED BY WEAK BOSON MASSES               *
* ALPHST - THE QCD COUPLING CONSTANT AS USED IN THE HADRONIC (QUARK)   *
*         DECAY CHANNELS OF THE GAUGE BOSON WIDTHS.                    *
* QCDCOR(I) - QCD CORRECTION FACTOR FOR QUARK PRODUCTION PROCESSES AND *
*         Z - BOSON I-th PARTIAL WIDTHS INTO QUARKS.                   *
*                                                                      *
* PARTZ(I) - PARTIAL DECAY WIDTHS OF THE Z-BOSON FOR THE CHANNELS:     *
*        I=0: NEUTRINO              I= 7: STRANGE                      *
*        I=1: ELECTRON              I= 8: TOP (NOT PART OF WIDTH)      *
*        I=2: MUON                  I= 9: BOTTOM                       *
*        I=3: TAU                   I=10: ALL HADRONS                  *
*        I=4: UP                    I=11: TOTAL                        *
*        I=5: DOWN                                                     *
*        I=6: CHARM                                                    *
* PARTW(I) - PARTIAL DECAY WIDTHS OF THE W-BOSON FOR THE CHANNELS:     *
*        I=1: ONE OF LEPTONIC              I= 2: ONE OF QUARKONIC      *
*        I=3: TOTAL                                                    *
*======================================================================*
* THE OTHER TWO POSSIBLE CALLS HAVE FLAGS, INPUT AND OUTPUT WHICH ARE  *
* COMMENTED AT THE BEGINNING OF THE SUBROUTINES ROKANC AND RHOCC.      *
*======================================================================*
*                                                                      *
* THE FLAGS INTRODUCED ABOVE HAVE THE FOLLOWING MEANING:               *
*----------------------------------------------------------------------*
* CHOICE OF HADRONIC VACUUM POLARISATION:                              *
* IHVP :    IHVP=1: HADR. VAC. POLARIZATION OF JEGERLEHNER, REF. 11    *
*      I         2:       OF JEGERLEHNER(1988)                         *
*      I         3:       OF BURKHARDT ET AL., REF. 10                 *
*----------------------------------------------------------------------*
* HANDLING OF HIGHER ORDER (ALPHA*ALPHA.S) T-MASS TERMS:               *
* IQCD :    THE Z-WIDTH HAS FIXED QCD FACTOR (1+ALFAS/PI).             *
*      I    ADDITIONAL OPTIONS ARE FROM REF.8, WITH RUNNING ALPHA.S    *
*      I    IQCD=0: NO QCD CORRS. TO VECTOR BOSON SELF ENERGIES        *
*      I    IN DELTA-R, WIDTHS, CROSS SECTION                          *
*      I         3: APPROXIM. FAST QCD CORRS. (REALISED FOR  Z-WIDTH   *
*      I            AND LEP PROCESSES)                                 *
*      I            IMPORTANT NOTICE: THESE ARE RELIABLE ONLY FOR LEP-I*
*      I         4: EXACT FORMULAE                                     *
*----------------------------------------------------------------------*
* HANDLING OF ALPHA**2 T-MASS TERMS:                                   *
* IAMT4: IAMT4 = 0: NO  MT**4 CORRECTIONS,                             *
*      I       = 1: WITH MT**4 CORRECTIONS RESUMED, SEE REF. 7.        *
*                   IN ORDER TO HAVE COMPLETE BACKWARD COMPATIBILITY,  *
*                   NO COMMON RESUMMATION WITH IQCD.NE.0 TERMS IS DONE *
*      I       = 2: WITH RESUMMATION RECIPE DUE TO BARDIN/KNIEHL,      *
*                   SIMILAR TO THAT OF REF. 12                         *
*      I       = 3: WITH RESUMMATION RECIPE OF REFS. 13-15             *
*----------------------------------------------------------------------*
* HANDLING OF HADRONIC VACUUM POLARISATION IN DELTA.R AND RUNNING ALPHA*
* IMASS: IMASS = 0: DEFAULT, USES A FIT TO DATA                        *
*      I       = 1: USES EFFECTIVE QUARK MASSES.OPTION EXISTS FOR TESTS*
*----------------------------------------------------------------------*
* IF IMASK=0: QUARK MASSES ARE USED EVERYWHERE                         *
*         =1: PHYSICAL THRESHOLD ARE USED IN THE PHASE SPACE           *
*----------------------------------------------------------------------*
* IF ISCRE=0: SCALE OF THE REMAINDER TERMS = 1                         *
*         =1: ------------------------------ RENORD                    *
*         =2: ------------------------------ RENORM (not recommended)  *
*----------------------------------------------------------------------*
* IF ISCAL=0: SCALET=1                                                 *
*         =1: SCALET=SCLAVR+SCTPLU     |                               *
*         =2: SCALET=SCLAVR            | Kniehl's                      *
*         =3: SCALET=SCLAVR-SCTMIN     |                               *
*         =4: SCALET=SIRLIN'S 0.204    |                               *
*----------------------------------------------------------------------*
* IF IFACR=0: NON   -EXPANDED DR                                       *
*         =1: PARTLY-EXPANDED DR, RESPECTING DRL*DRR-ORDER             *
*         =2: PARTLY-EXPANDED DR, VIOLATING  DRL*DRR-ORDER       (n.r.)*
*         =3: FULLY -EXPANDED DR, DOUBLE VIOLATING DRL*DRR-ORDER (n.r.)*
*----------------------------------------------------------------------*
* IF IFACT=0: NON   -EXPANDED RHO AND KAPPA    analogs      ff level   *
*         =1: PARTLY-EXPANDED RHO AND KAPPA       of        ff level   *
*         =2: PARTLY-EXPANDED RHO AND KAPPA     those       ff level   *
*         =3: FULLY -EXPANDED RHO AND KAPPA    in IFACR     ff level   *
*         =4: FULLY -NEGLECTED REM^2 TERMS               width level   *
*         =5:       -FAMOUS EW/QCD NON FACTORIZATION     width level   *
*----------------------------------------------------------------------*
* IHIGS: IHIGS = 0: LEADING HIGGS CONTRIBUTION IS NOT RESUMMED         *
*      I       = 1: LEADING HIGGS CONTRIBUTION IS     RESUMMED         *
*----------------------------------------------------------------------*
* IALEM: IALEM = 0: RELEASES ALQED FOR THE FIT, IT MUST BE GIVEN THEN  *
*      I       = 1: ALQED IS CALCULATED FROM A PARAMETRIZATION - IVPOL *
*----------------------------------------------------------------------*
* CHOICE OF INPUT PARAMETERS BESIDES AMT, AMH, ALPHA.S:                *
* IMOMS: IMOMS = 1: (CONVENTIONAL)    ALPHA, G.MU, AMZ (OUTPUT: AMW)   *
*      I       = 2: INPUT INSTEAD IS: ALPHA, G.MU, AMW (OUTPUT: AMZ)   *
*      I       = 3:                   ALPHA,  AMZ, AMW (OUTPUT: GMU)   *
* WHERE                                                                *
*      I G.MU..... MUON DECAY CONSTANT                                 *
*      I AMT...... T-QUARK MASS                                        *
*      I AMH...... HIGGS BOSON MASS                                    *
*      I ALST..... STRONG COUPLING CONSTANT ALPHA.S (.11)              *
*----------------------------------------------------------------------*

*----------------------------------------------------------------------*
* IF IBOX=0, heavy box contribution is neglected                       *
* IF IBOX=1, heavy box contribution is included                        *
*----------------------------------------------------------------------*
      IBOX=0

* Default setting of integer flags
      IHVP =1
      IAMT4=3
      IQCDD=2
      IMOMS=1
      IMASS=0
      ISCRE=0
      IALEM=1
      IMASK=0
      ISCAL=0
      IBARB=2
      IFTJR=1
      IFACR=0
      IFACT=0
      IHIGS=0
      IAFMT=1


* Default setting of integer flags as in KK
      IHVP =1
      IAMT4=4
      IQCDD=3
      IMOMS=1
      IMASS=0
      ISCRE=0
      IALEM=3
      IMASK=0
      ISCAL=0
      IBARB=2
      IFTJR=1
      IFACR=0
      IFACT=0
      IHIGS=0
      IAFMT=1
      Iewlc = 1
      Iczak = 1 
      Ihig2 = 1
      Iale2 = 3 
      Igfer = 2
      iddzz = 1
* Preferrred setting of parameter vector NPAR
      NPARD(1)=IHVP
      NPARD(2)=IAMT4
      NPARD(3)=IQCDD
      NPARD(4)=IMOMS
      NPARD(5)=IMASS
      NPARD(6)=ISCRE
      NPARD(7)=IALEM
      NPARD(8)=IMASK
      NPARD(9)=ISCAL
      NPARD(10)=IBARB
      NPARD(11)=IFTJR
      NPARD(12)=IFACR
      NPARD(13)=IFACT
      NPARD(14)=IHIGS
      NPARD(15)=IAFMT
      NPARD(16)= IEWLC                                                      
      NPARD(17)= ICZAK                                                      
      NPARD(18)= IHIG2                                                      
      NPARD(19)= IALE2                                                      
      NPARD(20)= IGFER                                                      
      NPARD(21)= IDDZZ

      ALPHQED=1D0/128.86674175D0
 !     ALSTRT=ALFAS
 !     DAL5H=0.0
      IF (ENE.GT.60) THEN 
        IBOX=1
        keytab=1
        WRITE(IOUT,*) 'INTERFACE TO ELECTROWEAK LIBRARY:',
     $              ' your center of mass energy is high'  
        WRITE(IOUT,*) 'HEAVY BOXES are set on, '
        WRITE(IOUT,*) 'NOTE THAT above 146 GeV CMS energy,  ', 
     $                'tests of the interface were not done'
      ENDIF
*
      CALL DZOVRI(
     $ NPARD,WMASS,ZMASS,TMASS,HMASS,alphqed,ALFAS,ZPARD,PARTZ,PARTW)
      
      CALL DIZET (
     $ NPARD,WMASS,ZMASS,TMASS,HMASS,DAL5H,alphqed,ALFAS,
     $ ALSTRT,ZPARD,PARTZ,PARTW)
      
      CALL QRKFIX (IDF,ZPARD(20)-1.0,ZPARD(25)-1.0)
!     stop
      WRITE(IOUT,1000) IBOX,QE,QF,XKOLOR,AMFIN,ZMASS,TMASS,HMASS,ALFAS,
     $                 ALPHQED,ZPARD(20),ZPARD(25)
      WRITE(IOUT,1001) (NPARD(I),I=1,15)
      WRITE(IOUT,1011) (NPARD(I),I=16,21)
        WRITE(IOUT,*) 'ZPAR-MATRIX: standard output of DIZET:'
        WRITE(IOUT,*) '- . - . - . - . - . - . - . - . - . - .' 
       DO II=1,30 
        WRITE(IOUT,1033) II,ZPARD(II)
        IF(II.EQ.3) WRITE(IOUT,*) '---------' 
        IF(II.EQ.14) WRITE(IOUT,*) ' '
        IF(II.EQ.4) WRITE(IOUT,*) ' '
       ENDDO
C
 1033 FORMAT(1x,'ZPAR(',I2,')=',F12.8)

 1000 FORMAT(/
     +, ' ELEKTROWEAK LIB DIZET (4.9;5.0;6.05) BY DUBNA/ZEUTHEN GROUP',/
     +, ' INTERFACE TO THE KORALZ PROGRAM.             ',/
     +, ' LAST UPDATE: OCTOBER 1995  Jul 99.                 ',//
     +, ' START PARAMETERS (MASSES, WIDTHS ARE IN GEV):',//
     +, ' note that DIZET has its own all fermion masses',/
     +, ' these may be different from the final state mass',/
     +, ' defined below:',//
     +, ' heavy box switch: IBOX=',I2,/,/
     +, ' INITIAL CHARGE=',F8.4,/' FINAL CHARGE  =',F8.4,/
     +, ' FINAL COLOR   =',F8.4,/' FINAL MASS    =',F8.4,/
     +, ' Z BOSON MASS  =',F8.4,/' T QUARK MASS  =',F8.4,/
     +, ' HIGGS MASS    =',F8.2,/' ALFA STRONG   =',F8.4,/
     +, ' ALPHA-QED     =',F8.6,/
     +, ' QCD CORR.FACTOR TO Z-WIDTH CHANNELS (NO B) =',F15.10
     +, /
     +, ' QCD CORR.FACTOR TO Z-WIDTH CHANNEL (INTO B)=',F15.10
     +, //)
 1001 FORMAT(/
     +, ' furter flags, see routine DIZET for explanation',/
     +, '  IHVP =',I2,'       IAMT4 =',I2,/
     +, '  IQCD =',I2,'       IMOMS =',I2,/
     +, ' IMASS =',I2,'       ISCRE =',I2,/
     +, ' IALEM =',I2,'       IMASK =',I2,/
     +, ' ISCAL =',I2,'       IBARB =',I2,/
     +, ' IFTJR =',I2,'       IFACR =',I2,/
     +, ' IFACT =',I2,'       IHIGS =',I2,/
     +, ' IAFMT =',I2,'              ',   /
     +, //)
*
 1011 FORMAT(/
     +, ' furter flags dz6.05, see routine DIZET for explanation',/
     +, '  IEWLC =',I2,'       ICZAK =',I2,/
     +, '  IHIG2 =',I2,'       IALE2 =',I2,/
     +, '  IGFER =',I2,'       IDDZZ =',I2,/
     +, //)
*
*
      END
      SUBROUTINE CZYBOX(IIBOX)
C THIS ROUTINE TRANSFORMS TO THE BORNDZ WHETHER BOXES HAVE TO BE
C CALCULATED (IIBOX=1) OR NOT (IIBOX=0)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/JAKBOX/IBOX
      IIBOX=IBOX
      END
      SUBROUTINE QRKFIX (idfn,ALFA1,ALFA2)
      IMPLICIT REAL*8 (A-H,O-Z)
C THIS ROUTINE TAKES THE VALUE OF ALPHA_QCD FROM DIZET
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8            ENE ,AMIN,AMFIN
      COMMON / IDFC  / IDFF
      COMMON / DZQCDT/  ALFA
C alpha_QCD included in formfacors ?
      IF (ABS(IDFF).EQ.5)  THEN
          ALFA=ALFA1
       ELSE
          ALFA=ALFA2
       ENDIF
      END

      FUNCTION ALFSPI(S)
C THIS FUNCTION TRANSMITS TO KORALZ VALUE OF THE QCD correction factor
C USED IN DZ-LIBRARY.
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / DZQCDT/  ALFA
      ALFSPI=ALFA
      END
      FUNCTION BORNDZ(MODE,SVAR,COSTHE,TA,TB)
C ----------------------------------------------------------------------
C THIS ROUTINE PROVIDES BORN CROSS SECTION. IT HAS THE SAME         *
C STRUCTURE AS FUNTIS AND FUNTIH, THUS CAN BE USED AS SIMPLER       *
C EXAMPLE OF THE METHOD APPLIED THERE                               *
C 18.04. IT IS NOT SO SIMPLE NOW THERE ARE 2 MODES SIMPLE OLD ONE   *
C AND THE NEW ONE WHERE ALSO ELECTROWEAK CORRECTIONS ARE ADDED      *
C
C     called by : BORNY, BORAS, BORNV, WAGA, WEIGHT
C ----------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8            ENE ,AMIN,AMFIN
      COMMON / IDFC  / IDFF
      COMMON / GAUSPM /SS,POLN,T3E,QE,T3F,QF
     &                ,XUPGI   ,XUPZI   ,XUPGF   ,XUPZF
     &                ,NDIAG0,NDIAGA,KEYA,KEYZ
     &                ,ITCE,JTCE,ITCF,JTCF,KOLOR
      REAL*8           SS,POLN,T3E,QE,T3F,QF
     &                ,XUPGI(2),XUPZI(2),XUPGF(2),XUPZF(2)
      COMMON / QEDPRM /ALFINV,ALFPI,XK0
      REAL*8           ALFINV,ALFPI,XK0
      COMMON / INSPIN / SEPS1,SEPS2
      REAL*8            SEPS1,SEPS2
      common /specx/ ifleptok,inter,xmx,delta
      real*8 xmx,delta
C=====================================================================
      COMMON / GSWPRM /SWSQ,AMW,AMZ,AMH,AMTOP,GAMMZ
      REAL*8           SWSQ,AMW,AMZ,AMH,AMTOP,GAMMZ
C     SWSQ        = sin2 (theta Weinberg)
C     AMW,AMZ     = W & Z boson masses respectively
C     AMH         = the Higgs mass
C     AMTOP       = the top mass
C     GAMMZ       = Z0 width
      COMMON / KEYSET / KEYGSW,KEYRAD,KEYTAB
      COMMON /NEWMOD/  AMNEUT,NNEUT
      REAL*8           AMNEUT
      COMPLEX*16 GSW(7)
      COMPLEX*16 ABORN(2,2),APHOT(2,2),AZETT(2,2)
      COMPLEX*16 XUPZFP(2),XUPZIP(2)
      COMPLEX*16 ABORNM(2,2),APHOTM(2,2),AZETTM(2,2)
      COMPLEX*16 PROPA,PROPZ
      COMPLEX*16 XR,XI,PROPW,AW(2,2),AWM(2,2)
      COMPLEX*16 XUPF,XUPI,XFF(4),XFEM,XFOTA,XRHO,XKE,XKF,XKEF
      COMPLEX*16 XTHING,XVE,XVF,XVEF
      REAL*8 XM2,XP2
      DATA AW/4*(0.D0,0.D0)/,XI/(0.D0,1.D0)/,XR/(1.D0,0.D0)/
      DATA AWM/4*(0.D0,0.D0)/
      DATA XGW/2.5D0/
      DATA MODE0 /-5/
      DATA SVAR0,COST0 /-5.D0,-6.D0/
      DATA PI /3.141592653589793238462643D0/
C
C MEMORIZATION =========================================================
      IF ( MODE.NE.MODE0.OR.SVAR.NE.SVAR0.OR.COSTHE.NE.COST0) THEN
C ** PROPAGATORS
        MODE0=MODE
        SVAR0=SVAR
        COST0=COSTHE
        SINTHE=SQRT(1.D0-COSTHE**2)
        BETA=SQRT(MAX(0D0,1D0-4D0*AMFIN**2/SVAR))
        CALL CZYBOX(IBOX)
C I MULTIPLY AXIAL COUPLING BY BETA FACTOR.
        XUPZFP(1)=0.5D0*(XUPZF(1)+XUPZF(2))+0.5*BETA*(XUPZF(1)-XUPZF(2))
        XUPZFP(2)=0.5D0*(XUPZF(1)+XUPZF(2))-0.5*BETA*(XUPZF(1)-XUPZF(2))
        XUPZIP(1)=0.5D0*(XUPZI(1)+XUPZI(2))+0.5*(XUPZI(1)-XUPZI(2))
        XUPZIP(2)=0.5D0*(XUPZI(1)+XUPZI(2))-0.5*(XUPZI(1)-XUPZI(2))
C FINAL STATE VECTOR COUPLING
        XUPF     =0.5D0*(XUPZF(1)+XUPZF(2))
        XUPI     =0.5D0*(XUPZI(1)+XUPZI(2))
        XTHING   =0D0


      IF (MODE.GT.0.AND.KEYGSW.GT.1) THEN
C I MULTIPLY AXIAL COUPLING BY BETA FACTOR.
C I ADD ALSO FORMFACTORS
*********************************************************
*
* INITIALISATION OF S-DEPENDENT WEAK FORM FACTORS AND
* PHOTONIC VACUUM POLARISATION (WEAK BOX CONTRIBUTIONS
* LEFT OUT HERE, THEY DEPEND ON ACOS)
*
           IF (KEYTAB.EQ.0) THEN
             SV=SVAR/2D0
             SVT=-SV*(1-COSTHE)
             SVU=-SV*(1+COSTHE)
             IF (ABS(IDFF).EQ.5) THEN
                IBFLA=1
             ELSE
                IBFLA=0
             ENDIF
            CALL ROKANC(IBOX,IBFLA, SVU,-SVAR, SVT,QE,QF,XFF,XFEM,XFOTA)
           ELSEIF (KEYTAB.EQ.1) THEN
             CALL TABLUJ(0,SVAR,costhe,GSW)
             XFF(1)=GSW(1)
             XFF(2)=GSW(2)
             XFF(3)=GSW(3)
             XFF(4)=GSW(4)
C            XFFA  =UNDEFINED !
             XFEM  =GSW(6)
             XFOTA =GSW(7)
           ELSE
             PRINT *, 'STOP IN BORNDZ: UNDEFINED KEYTAB, KEYTAB=',KEYTAB
             STOP
           ENDIF
*
*********************************************************
              XRHO =XFF(1)
              XKE  =XFF(2)
              XKF  =XFF(3)
              XKEF =XFF(4)
              QFM=DABS(QF)
              QEM=DABS(QE)
              XE  =1.D0-4.D0*SWSQ*QEM
              XF  =1.D0-4.D0*SWSQ*QFM
              XEF =-1.D0+XE+XF+16.D0*QEM*QFM*SWSQ*SWSQ
              XVE  =1.D0-4.D0*SWSQ*QEM*XKE
              XVF  =1.D0-4.D0*SWSQ*QFM*XKF
              XVEF =-1.D0+XVE+XVF+16.D0*QEM*QFM*SWSQ*SWSQ*XKEF
C I MULTIPLY AXIAL  COUPLING BY BETA FACTOR.
C I MULTIPLY VECTOR COUPLING BY FORM-FACTOR.
        XUPZFP(1)=0.5D0*(XUPZF(1)+XUPZF(2))*XVF/XF
     &           +0.5*BETA*(XUPZF(1)-XUPZF(2))
        XUPZFP(2)=0.5D0*(XUPZF(1)+XUPZF(2))*XVF/XF
     &           -0.5*BETA*(XUPZF(1)-XUPZF(2))
        XUPZIP(1)=0.5D0*(XUPZI(1)+XUPZI(2))*XVE/XE
     &           +0.5*(XUPZI(1)-XUPZI(2))
        XUPZIP(2)=0.5D0*(XUPZI(1)+XUPZI(2))*XVE/XE
     &           -0.5*(XUPZI(1)-XUPZI(2))
C FINAL STATE VECTOR COUPLING
        XUPF     =0.5D0*(XUPZF(1)+XUPZF(2))*XVF/XF
C DOUBLE VECTOR FORMFACTOR THING
        XTHING=0.25D0*(XUPZF(1)+XUPZF(2))*(XUPZI(1)+XUPZI(2))*
     &         (XVEF/XEF-XVF*XVE/XE/XF)
        PROPA =1D0/SVAR/(2D0-XFEM)
        PROPZ =1D0/DCMPLX(SVAR-AMZ**2,SVAR/AMZ*GAMMZ)
C I REPLACE BORN NORMALIZATION OF Z PROPAGATOR BY THE BETTER ONE
        GMU  = 1.16637D-5
        DEL1 =GMU*AMZ**2*ALFINV/(DSQRT(2.D0)*8.D0*PI)
        DEL0 =1./(SWSQ*(1.-SWSQ))/16.
        PROPZ = PROPZ*DEL1/DEL0*XRHO
      ELSE
        PROPA =1D0/SVAR
        PROPZ =1D0/DCMPLX(SVAR-AMZ**2,SVAR/AMZ*GAMMZ)
        IF (KEYGSW.EQ.0) PROPZ=0.D0
      ENDIF
      IF (IABS(IDF).EQ.1) THEN
C*** NUNUB SPECIAL : W PROPAGATOR IN t-CHANNEL
      DO 15 I=1,2
      DO 15 J=1,2
      AW(I,J)=(0.D0,0.D0)
  15  CONTINUE
        IF(MODE.NE.1) THEN
        XMW=AMZ*DSQRT(1D0-SWSQ)
        XCOUP=1.D0/2.D0/SWSQ
         IF (IDE.LT.0) THEN
           AW(2,1)=- DCMPLX(XCOUP*(1.D0-COSTHE))/XMW/XMW
         ELSE
           AW(1,2)=- DCMPLX(XCOUP*(1.D0-COSTHE))/XMW/XMW
         ENDIF
        ELSE
        XMW=AMZ*DSQRT(1D0-SWSQ)
        XP2=(SVAR*(1.D0+COSTHE)/2.+XMW*XMW)**2+(XMW*XGW)**2
        PROPW=DCMPLX(-(SVAR*(1.D0+COSTHE)/2+XMW*XMW)/XP2)
        PROPW=PROPW-XI*DCMPLX(XMW*XGW/XP2)
        XCOUP=1.D0/2.D0/SWSQ
          IF (IDE.LT.0) THEN
           AW(2,1)= PROPW*DCMPLX(XCOUP*(1.D0-COSTHE))
          ELSE
           AW(1,2)= PROPW*DCMPLX(XCOUP*(1.D0-COSTHE))
          ENDIF
C disputable lines .....
C          IF(KEYGSW.GT.1) THEN
C           AW(1,2)=AW(1,2)*DEL1/DEL0
C           AW(2,1)=AW(2,1)*DEL1/DEL0
C          ENDIF
C end of disputable lines
        ENDIF
      ENDIF

      IF (IABS(IDF).eq.3*ifleptok.or.IABS(IDF).eq.4*ifleptok)  THEN

C*** exotic  SPECIAL for quarks : X PROPAGATOR IN t-CHANNEL
        XMW=xmx  ! GeV
        XGW=1*.0
        iqq= inter/iabs(inter) ! -1 i.e. slightly like W entry (3) i.e leptoq ch=4/3,1/3
        iktor=iabs(inter)
        if (ide.gt.0) iktor=3-iktor
!        delta=-0.7 !  *iqq !! ???
C iskal switch for scalar (0) and vector (1) leptoquarks
        iskal=1
        XCOUP=1.D0/2D0/SWSQ*(1D0+delta)**2
        iktorx=iktor
        iqx=1
        if (iskal.eq.0) xcoup=-xcoup/2
        if (iskal.eq.0) iktorx=3-iktor
        if (iskal.eq.0) iqx=-1
        coso=costhe
! to optimize reweighting
        idum=-iqq*(-1)**(IABS(IDF)-3)
      DO 16 I=1,2
      DO 16 J=1,2
      AW(I,J)=(0.D0,0.D0)
      AWM(I,J)=(0.D0,0.D0)
 16   CONTINUE
        IF(MODE.NE.1) THEN


         IF (Iqq.LT.0) THEN
           AW(3-iktor,iktor)= idum* DCMPLX(XCOUP*(1.D0-COSo))/XMW/XMW
           AWM(iktor,iktor)=idum*  DCMPLX(XCOUP*(1.D0+1D0))/XMW/XMW*0
         else
           AW(iktor,iktor)= idum* DCMPLX(XCOUP*(1.D0+COSo))/XMW/XMW
           AWM(iktor,iktor)=idum*  DCMPLX(XCOUP*(1.D0+1D0))/XMW/XMW*0

         ENDIF
        ELSE

        XP2=(SVAR*(1.D0-iqq*iqx*COSo)/2.+XMW*XMW)**2+(XMW*XGW)**2
        PROPW=DCMPLX(-(SVAR*(1.D0-iqq*iqx*COSo)/2+XMW*XMW)/XP2)
        PROPW=PROPW-XI*DCMPLX(XMW*XGW/XP2)

          IF (Iqq.LT.0) THEN
           AW(3-iktor,iktor)=  PROPW*DCMPLX(XCOUP*(1.D0-COSo))
           AWM(iktor,iktor)=  PROPW*DCMPLX(XCOUP*(1.D0+1D0))*0
          ELSE
           AW(iktor,iktor)=   PROPW*DCMPLX(XCOUP*(1.D0+COSo))
           AWM(iktor,iktor)=   PROPW*DCMPLX(XCOUP*(1.D0+1D0))*0
          ENDIF
C disputable lines .....
C          IF(KEYGSW.GT.1) THEN
C           AW(1,2)=AW(1,2)*DEL1/DEL0
C           AW(2,1)=AW(2,1)*DEL1/DEL0
C          ENDIF
C end of disputable lines
        ENDIF
      ENDIF




      DO 50 I=1,2
      DO 50 J=1,2
      REGULA= (3-2*I)*(3-2*J) + COSTHE
      REGULM=-(3-2*I)*(3-2*J) * SINTHE *2.D0*AMFIN/SQRT(SVAR)
      APHOT(I,J)=PROPA*(XUPGI(I)*XUPGF(J)*REGULA)
      AZETT(I,J)=PROPZ*(XUPZIP(I)*XUPZFP(J)+XTHING)*REGULA
       ABORN(I,J)=APHOT(I,J)+AZETT(I,J)+AW(I,J)
      APHOTM(I,J)=PROPA*DCMPLX(0D0,1D0)*XUPGI(I)*XUPGF(J)*REGULM
      AZETTM(I,J)=PROPZ*DCMPLX(0D0,1D0)*(XUPZIP(I)*XUPF+XTHING)*REGULM
       ABORNM(I,J)=APHOTM(I,J)+AZETTM(I,J)+AWM(I,J)
   50 CONTINUE
      ENDIF
C
C******************
C* IN CALCULATING CROSS SECTION ONLY DIAGONAL ELEMENTS
C* OF THE SPIN DENSITY MATRICES ENTER (LONGITUD. POL. ONLY.)
C* HELICITY CONSERVATION EXPLICITLY OBEYED
      POLAR1=  (SEPS1)
      POLAR2= (-SEPS2)
      BORN=0D0
      DO 150 I=1,2
      HELIC= 3-2*I
      DO 150 J=1,2
      HELIT=3-2*J
      FACTOR=KOLOR*(1D0+HELIC*POLAR1)*(1D0-HELIC*POLAR2)/4D0
      FACTOM=FACTOR*(1+HELIT*TA)*(1-HELIT*TB)
      FACTOR=FACTOR*(1+HELIT*TA)*(1+HELIT*TB)
      IF(IABS(IDF).NE.1) THEN
      BORN=BORN+CDABS(ABORN(I,J))**2*FACTOR
C MASS TERM IN BORN
       IF (MODE.GE.1) THEN
C mass terms included in BORN. Is it better ?
C--       IF (MODE.GE.5) THEN
       BORN=BORN+CDABS(ABORNM(I,J))**2*FACTOM
      ENDIF
      ELSE
        XM2=CDABS(ABORN(I,J))**2+(NNEUT-1)*CDABS(AZETT(I,J))**2
        XM3=CDABS(ABORNM(I,J))**2+(NNEUT-1)*CDABS(AZETTM(I,J))**2
        BORN=BORN+(XM2+XM3)*FACTOR
      ENDIF
  150 CONTINUE
C************
      FUNT=BORN
      IF(FUNT.LT.0.D0)  FUNT=BORN
C
      IF (SVAR.GT.4D0*AMFIN**2) THEN
C PHASE SPACE THRESHOLD FACTOR
        THRESH=SQRT(1-4D0*AMFIN**2/SVAR)
        BORNDZ= FUNT*SVAR**2*THRESH
      ELSE
        THRESH=0.D0
        BORNDZ=0.D0
      ENDIF
C ZW HERE WAS AN ERROR 19. 05. 1989
      END
      SUBROUTINE CINT
C======================================================================
C============TABULATION OF THE FORMFACTORS=============================
C======================================================================
C ----------------------------------------------------------------------
* THIS IS AN ENTRY OF EASY INITIALISATION OF FORMFACTORS
* CALCULATED IN ROUTINE ROKAP AND TABULATED IN ROUTINE TABLUJ
C
C     called by : KORALZ
C ----------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON / KEYSET / KEYGSW,KEYRAD,KEYTAB
      COMPLEX*16 GSW(7)
      COMMON / INOUT / INUT,IOUT
*
      IF (KEYTAB.EQ.1.AND.KEYGSW.GT.1)
     $CALL TABLUJ(-1,0D0,0D0,GSW)
      END
      SUBROUTINE TABLUJ(MODE,S,COSTHE,GSW)
C ----------------------------------------------------------------------
* FAST ROUTINE FOR EVALUATION OF ELECTROWEAK FORMFACTORS
* IT PROVIDES FORMFACTORS FOR POSITIVE SS, TABULATED IN
* LOOK UP TABLES, AND THEN CALCULATED BY LINEAR INTERPOLATION.
* PRIOR TO ITS NORMAL USE, IT SHOULD BE CALLED LIKE CALL TABLUJ(-1,0.,..
C
C     CALLED BY : CINT, BORN(DZ)
C ----------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8            ENE ,AMIN,AMFIN
      COMMON / IDFC  / IDFF
      COMMON / INOUT / INUT,IOUT
      COMPLEX*16 GSW(7)
      COMPLEX*16 CYY(201,7),CZZ(41,7),CTT(201,41,7)
      COMPLEX*16 XFF(4),XFEM,XFOTA 
      DATA NPOIN,NPOIN2,NPOIN3,NPOIN4 /120,20,120,14/
      DATA INIT/0/
      data nev/0/
      DATA WMAX,WMBOX/120.001D0,240.001D0/ 
C
      IF (MODE.EQ.-1) THEN
* INITIALISATION MODE
        CALL CZYBOX(IBOX)
        INIT=INIT+1
        CALL PRMOUT(AMZ,GAMMZ,GAMMZ1,WMASS,GAMMW,GAMMW1,SWSQ)
        CALL GIVIZO( IDE, 1,AIZOR,QE,KDUMM)
        CALL GIVIZO( IDF, 1,AIZOR,QF,KOLOR)
             IF (ABS(IDFF).EQ.5) THEN
                IBFLA=1
             ELSE
                IBFLA=0
             ENDIF
* IN WIDE S RANGE
        WMIN=0.010D0
        WRITE(IOUT,*) 'PRETABULATION, section a:'
C

        DO 110 I=0,NPOIN
        X=DFLOAT(I)/DFLOAT(NPOIN)
        WW =WMIN*(WMAX/WMIN)**X
        SSS=WW*WW
        SV=SSS/2D0
        CALL ROKANC(0,IBFLA,-SV,-SSS,SV,QE,QF,XFF,XFEM,XFOTA)
        DO 51 KK=1,4
   51   CYY(I+1,KK)=XFF(KK)
        CYY(I+1,5 )=123.456
        CYY(I+1,6 )=XFEM
        CYY(I+1,7 )=XFOTA
  110   CONTINUE
* NEAR Z0 RESONANCE 
       WRITE(IOUT,*) 'PRETABULATION,section b:'
        WMIN2=AMZ-2D0*GAMMZ
        WMAX2=AMZ+2D0*GAMMZ
        DO 115 I=0,NPOIN2
        X=DFLOAT(I)/DFLOAT(NPOIN2)
        WW =WMIN2+(WMAX2-WMIN2)*X
        SSS=WW*WW
        sv=sss/2
        CALL ROKANC(0,IBFLA,-SV,-SSS,SV,QE,QF,XFF,XFEM,XFOTA)
        DO 52 KK=1,4
   52   CZZ(I+1,KK)=XFF(KK)
        CZZ(I+1,5 )=123.456
        CZZ(I+1,6 )=XFEM
        CZZ(I+1,7 )=XFOTA
  115   CONTINUE
C
        IF (2*ENE.GT.WMAX) THEN 
* In the region of boxes
        WRITE(IOUT,*) 'INTERFACE TO ELECTROWEAK LIBRARY: CINT'
        WRITE(IOUT,*) 'heavy box energy zone: pretabulation enlarged'
        WRITE(IOUT,*) 'WARNING: initialization will take long time'
        WRITE(IOUT,*) 'lets count ...'
        WMIN3=(WMAX)
        WMAX3=(WMBOX)
        DO  I=0,NPOIN3
        IF(MOD(I,10).EQ.0) WRITE(IOUT,*) 'I=',I,' IMAX=',NPOIN3        
        DO  J=0,NPOIN4
         X=DFLOAT(I)/DFLOAT(NPOIN3)
         WW =WMIN3+(WMAX3-WMIN3)*X
         SSS=WW*WW
         COSI=-1D0+2D0*DFLOAT(J)/DFLOAT(NPOIN4)
         COSI=COSI*(1D0-1D-8)
         IF(J.EQ.     0) COSI=COSI+.3D0/DFLOAT(NPOIN4)
         IF(J.EQ.NPOIN4) COSI=COSI-.3D0/DFLOAT(NPOIN4)
         ST=SSS*(1D0-COSI)/2D0
         SU=SSS*(1D0+COSI)/2D0
         CALL ROKANC(IBOX,IBFLA,-SU,-SSS,-ST,QE,QF,XFF,XFEM,XFOTA)
         DO  KK=1,4
          CTT(I+1,J+1,KK)=XFF(KK)
         ENDDO
         CTT(I+1,J+1,5 )=123.456
         CTT(I+1,J+1,6 )=XFEM
         CTT(I+1,J+1,7 )=XFOTA
C         WRITE(6,*) 'I=',I+1,'j=',j+1,'s=',sss,'costhe=',cosi
C         write(6,*) CTT(I+1,J+1,6 ),CTT(I+1,J+1,7 )
C         write(6,*) CTT(I+1,J+1,1 ),CTT(I+1,J+1,2 )
C         write(6,*) CTT(I+1,J+1,3 ),CTT(I+1,J+1,4 )
        ENDDO
        ENDDO

        ENDIF
       WRITE(IOUT,*) '... PRETABULATIN finished  now !'
C
      ELSE
* OPERATIONAL MODE
        IF(INIT.EQ.0) GOTO 910
        W=(SQRT(S))
        IF(W.GT.WMAX) THEN
* in the region of boxes
          X= (W-WMIN3)/(WMAX3-WMIN3)
          I= INT(NPOIN3*X)+1
          H= X*NPOIN3-DFLOAT(I-1)

          X= (1D0+COSTHE)/2D0
          J= INT(NPOIN4*X)+1
          H1= X*NPOIN4-DFLOAT(J-1)
          DO  KK=1,7
           GSW(KK)=(CTT(I,J  ,KK)*(1-H)+CTT(I+1,J  ,KK)*H)*(1D0-H1)
     $            +(CTT(I,J+1,KK)*(1-H)+CTT(I+1,J+1,KK)*H)*H1
          ENDDO
C         nev=nev+1
C         if (nev.lt.20) then
C          WRITE(6,*) 'I=',I,'j=',j,'s=',s,'costhe=',costhe
C          write(6,*) gsw(6),gsw(7)
C          write(6,*) gsw(1),gsw(2)
C          write(6,*) gsw(3),gsw(4)
C         endif

        ELSEIF(W.LT.WMIN2.OR.W.GT.WMAX2) THEN
* IN A WIDE RANGE
          IF(W.LT.WMIN.OR.W.GT.WMAX) GOTO 920
          X= LOG( W/WMIN)/LOG(WMAX/WMIN)
          I= INT(NPOIN*X)+1
          H= X*NPOIN-DFLOAT(I-1)
          DO 53 KK=1,7
   53     GSW(KK)=CYY(I,KK)*(1-H)+CYY(I+1,KK)*H
        ELSE
* NEAR Z0 RESONANCE
          X= (W-WMIN2)/(WMAX2-WMIN2)
          I= INT(NPOIN2*X)+1
          H= X*NPOIN2-DFLOAT(I-1)
          DO 54 KK=1,7
   54     GSW(KK)=CZZ(I,KK)*(1-H)+CZZ(I+1,KK)*H
        ENDIF
      ENDIF
      RETURN
  910 PRINT *,'   TABLUJ: LACK OF INITIALISATION.'
      STOP
  920 PRINT *,'   TABLUJ: S OUT OF PREDEFINED RANGE '
      STOP
      END
      FUNCTION BORNH(MODE,SVAR,COSTHE,TA,TB)
C======================================================================
C============ROUTINES TO DETACH SECOND ELECTROWEAK LIBRARY=============
C======================================================================
      IMPLICIT REAL*8(A-H,O-Z)
      PRINT *, 'SORRY, SECOND ELECTROWEAK LIBRARY IS NOT INTERFACED'
      BORNH=5.
      STOP
      END
      SUBROUTINE PRMHOL(ZMASS,GAMZ0,GAMMZ,WMASS,GAMW0,GAMW,SIN2W)
      IMPLICIT REAL*8(A-H,O-Z)
      PRINT *, 'SORRY, SECOND ELECTROWEAK LIBRARY IS NOT INTERFACED'
      STOP
      END
      SUBROUTINE HOLSTA(IDF,KEYGSW,YMZ,YMH,YMT)
      IMPLICIT REAL*8(A-H,O-Z)
      PRINT *, 'SORRY, SECOND ELECTROWEAK LIBRARY IS NOT INTERFACED'
      STOP
      END


 
      SUBROUTINE DZERO(A,B,X0,R,EPS,MXF,F)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL MFLAG,RFLAG
      EXTERNAL F
      DATA RFLAG /.FALSE./
      PARAMETER (ONE = 1, HALF = ONE/2)
 
      XA=MIN(A,B)
      XB=MAX(A,B)
      FA=F(XA,1)
      FB=F(XB,2)
      IF(FA*FB .GT. 0) GO TO 5
      MC=0
 
    1 X0=HALF*(XA+XB)
      R=X0-XA
      EE=EPS*(ABS(X0)+1)
      IF(R .LE. EE) GO TO 4
      F1=FA
      X1=XA
      F2=FB
      X2=XB
 
    2 FX=F(X0,2)
      MC=MC+1
      IF(MC .GT. MXF) GO TO 6
      IF(FX*FA .GT. 0) THEN
       XA=X0
       FA=FX
      ELSE
       XB=X0
       FB=FX
      END IF
 
    3 U1=F1-F2
      U2=X1-X2
      U3=F2-FX
      U4=X2-X0
      IF(U2 .EQ. 0 .OR. U4 .EQ. 0) GO TO 1
      F3=FX
      X3=X0
      U1=U1/U2
      U2=U3/U4
      CA=U1-U2
      CB=(X1+X2)*U2-(X2+X0)*U1
      CC=(X1-X0)*F1-X1*(CA*X1+CB)
      IF(CA .EQ. 0) THEN
       IF(CB .EQ. 0) GO TO 1
       X0=-CC/CB
      ELSE
       U3=CB/(2*CA)
       U4=U3*U3-CC/CA
       IF(U4 .LT. 0) GO TO 1
       X0=-U3+SIGN(SQRT(U4),X0+U3)
      END IF
      IF(X0 .LT. XA .OR. X0 .GT. XB) GO TO 1
 
      R=MIN(ABS(X0-X3),ABS(X0-X2))
      EE=EPS*(ABS(X0)+1)
      IF(R .GT. EE) THEN
       F1=F2
       X1=X2
       F2=F3
       X2=X3
       GO TO 2
      END IF
 
      FX=F(X0,2)
      IF(FX .EQ. 0) GO TO 4
      IF(FX*FA .LT. 0) THEN
       XX=X0-EE
       IF(XX .LE. XA) GO TO 4
       FF=F(XX,2)
       FB=FF
       XB=XX
      ELSE
       XX=X0+EE
       IF(XX .GE. XB) GO TO 4
       FF=F(XX,2)
       FA=FF
       XA=XX
      END IF
      IF(FX*FF .GT. 0) THEN
       MC=MC+2
       IF(MC .GT. MXF) GO TO 6
       F1=F3
       X1=X3
       F2=FX
       X2=X0
       X0=XX
       FX=FF
       GO TO 3
      END IF
 
    4 R=EE
      FF=F(X0,3)
      RETURN
    5 WRITE(6,*) 'C205.1',LGFILE,MFLAG,RFLAG
      IF(MFLAG) THEN
       IF(LGFILE .EQ. 0) WRITE(*,100)
       IF(LGFILE .NE. 0) WRITE(LGFILE,100)
      END IF
      IF(.NOT.RFLAG) STOP
      R=-2*(XB-XA)
      X0=0
      RETURN
    6 WRITE(6,*) 'C205.2',LGFILE,MFLAG,RFLAG
      IF(MFLAG) THEN
       IF(LGFILE .EQ. 0) WRITE(*,101)
       IF(LGFILE .NE. 0) WRITE(LGFILE,101)
      END IF
      IF(.NOT.RFLAG) STOP
      R=-HALF*ABS(XB-XA)
      X0=0
      RETURN
  100 FORMAT(1X,'***** CERN C205 DZERO ... F(A) AND F(B)',
     1          ' HAVE THE SAME SIGN')
  101 FORMAT(1X,'***** CERN C205 DZERO ... TOO MANY FUNCTION CALLS')
      END






