      SUBROUTINE HOLINT(S,T,M1,IST,I5ST)                                HOLINT 2
      IMPLICIT REAL*8(A-Z)                                              HOLINT 3
      COMPLEX*16 IST,I5ST,SPENCE,CDLOG,X1,X2,Y1,Y2,LN2,SP4,P1,P2,K1,    HOLINT 4
     1           LN,SQX,SQY,Z1,Z2,Z3,Z4,M                               HOLINT 5
      GZ=2.6D0                                                          HOLINT 6
      XM2=M1*M1                                                         HOLINT 7
      YM2=-M1*GZ                                                        HOLINT 8
      M=DCMPLX(XM2,YM2)                                                 HOLINT 9
      SQY=CDSQRT(1.D0-4.D0*M/S)                                         HOLINT10
      SQX=CDSQRT(1.D0-4.D0*M/S*(1.D0+M/T))                              HOLINT11
      Y1=(1.D0+SQY)*.5D0                                                HOLINT12
      Y2=(1.D0-SQY)*.5D0                                                HOLINT13
      X1=(1.D0+SQX)*.5D0                                                HOLINT14
      X2=(1.D0-SQX)*.5D0                                                HOLINT15
      Z1=X1/(X1-Y1)                                                     HOLINT16
      Z2=X1/(X1-Y2)                                                     HOLINT17
      Z3=X2/(X2-Y1)                                                     HOLINT18
      Z4=X2/(X2-Y2)                                                     HOLINT19
      SP4=SPENCE(Z1)+SPENCE(Z2)-SPENCE(Z3)-SPENCE(Z4)                   HOLINT20
      LN=CDLOG(-Y1/Y2)                                                  HOLINT21
      LN2=LN*LN                                                         HOLINT22
      SP4=SP4/(X1-X2)                                                   HOLINT23
      K1=SPENCE(1.D0+T/M)-LN2-3.1415926536D0**2/6.                      HOLINT24
      P1=(2.D0*T+S+2.D0*M)/(S+T)/2.D0                                   HOLINT25
      P2=(S+2.D0*T-4.D0*T*M/S+2.D0*M*M/T-2.D0*M*M/S)/(S+T)/2.D0         HOLINT26
      I5ST=S/(S+T)*(P1*K1+.5D0*CDLOG(-T/M)+(Y2-Y1)/2.D0*LN-P2*SP4)      HOLINT27
      IST =I5ST+2.D0*LN2+2.D0*SP4                                       HOLINT28
      END                                                               HOLINT29
      SUBROUTINE MNHOLK                                                 MNHOLK 2
*****************************************************************       MNHOLK 3
*                                                                       MNHOLK 4
*  differential cross section for                                       MNHOLK 5
*                                                                       MNHOLK 6
*       e+ e- ----> mu+ mu-                                             MNHOLK 7
*                                                                       MNHOLK 8
*  Born and with weak O(alfa), no QED corrections                       MNHOLK 9
*                                                                       MNHOLK10
*  Input:  MZ   Z mass                                                  MNHOLK11
*          MH   Higgs mass                                              MNHOLK12
*          MT   top mass                                                MNHOLK13
*          WMS  center of mass energy                                   MNHOLK14
*                                                                       MNHOLK15
*          S1   e- helicity  (+1 or -1)                                 MNHOLK16
*          S2   e+ helicity                                             MNHOLK17
*          S3   mu- (tau-) helicity                                     MNHOLK18
*          S4   mu+ (tau+) helicity                                     MNHOLK19
*                                                                       MNHOLK20
*  Output: d sigma/d omega  in nano-barn                                MNHOLK21
*                                                                       MNHOLK22
*****************************************************************       MNHOLK23
      IMPLICIT REAL*8(A-Z)                                              MNHOLK24
      INTEGER I,K                                                       MNHOLK25
      DIMENSION T(6),DB(6),DC(6)                                        MNHOLK26
      COMMON /HELIC/ S1,S2,S3,S4                                        HELIC  2
      REAL*8         S1,S2,S3,S4                                        HELIC  3
*                                                                       MNHOLK28
*  define helicities                                                    MNHOLK29
      S1 = -1D0                                                         MNHOLK30
      S2 = -S1                                                          MNHOLK31
      S3 = -1D0                                                         MNHOLK32
      S4 = -S3                                                          MNHOLK33
*                                                                       MNHOLK34
*  fix input parameters                                                 MNHOLK35
      READ(5,*) MZ                                                      MNHOLK36
      READ(5,*) MH                                                      MNHOLK37
      READ(5,*) MT                                                      MNHOLK38
*                                                                       MNHOLK39
*  cms energy                                                           MNHOLK40
      READ(5,*) WMS                                                     MNHOLK41
      S = WMS**2                                                        MNHOLK42
*                                                                       MNHOLK43
*  scattering angles in degrees                                         MNHOLK44
      T(1)=30D0                                                         MNHOLK45
      T(2)=60D0                                                         MNHOLK46
      T(3)=90D0                                                         MNHOLK47
      T(4)=120D0                                                        MNHOLK48
      T(5)=150D0                                                        MNHOLK49
      T(6)=180D0                                                        MNHOLK50
*                                                                       MNHOLK51
*  numerical constants                                                  MNHOLK52
      ALFA = 1D0/137.03604D0                                            MNHOLK53
      PI   = 3.1415926536D0                                             MNHOLK54
      CONV = ALFA*ALFA/4D0/S*389385.7D0                                 MNHOLK55
*                                                                       MNHOLK56
*  initialization                                                       MNHOLK57
      WRITE(6,101) MZ,MH,MT                                             MNHOLK58
      WRITE(6,102) WMS                                                  MNHOLK59
101   FORMAT('   MZ = ',F4.1,'  MH = ',F6.1,'  MT = ',F5.1,//)          MNHOLK60
102   FORMAT('   CMS ENERGY = ',F4.1,/)                                 MNHOLK61
*                                                                       MNHOLK62
*HOLC2 ALFAS HAS BEEN INTRODUCED                                        MNHOLK63
      CALL SETMU(MZ,MH,MT,XSW,GAMZ,GZ0,ALFAS)                           MNHOLK64
      WRITE(6,103) XSW                                                  MNHOLK65
      WRITE(6,104) GAMZ                                                 MNHOLK66
      WRITE(6,105) GZ0                                                  MNHOLK67
103   FORMAT('   SIN**2(THETA-W) = ',F6.4,/)                            MNHOLK68
104   FORMAT('   Z WIDTH         = ',F6.4,/)                            MNHOLK69
105   FORMAT('   BORN Z WIDTH    = ',F6.4,//)                           MNHOLK70
*                                                                       MNHOLK71
*  calculation of the cross section                                     MNHOLK72
      DO 2 I=1,6                                                        MNHOLK73
        CT = DCOS(T(I)*PI/180D0)                                        MNHOLK74
*HOLC2 ALFAS HAS BEEN INTRODUCED                                        MNHOLK75
        CALL DIFMU(S,CT,MZ,MH,MT,SIG0,SIG,ALFAS)                        MNHOLK76
        DIFBOR = CONV*SIG0                                              MNHOLK77
        DIFMUS = CONV*SIG                                               MNHOLK78
        DB(I)  = DIFBOR                                                 MNHOLK79
        DC(I)  = DIFMUS                                                 MNHOLK80
2     CONTINUE                                                          MNHOLK81
      WRITE(6,107)                                                      MNHOLK82
*                                                                       MNHOLK83
      DO 3 I=1,6                                                        MNHOLK84
        WRITE(6,106) T(I), DC(I), DB(I)                                 MNHOLK85
3     CONTINUE                                                          MNHOLK86
106   FORMAT(1H ,5X,F7.0,2(6X,F7.5))                                    MNHOLK87
107   FORMAT('       THETA       BORN+WEAK     BORN',/)                 MNHOLK88
      STOP                                                              MNHOLK89
      END                                                               MNHOLK90
      SUBROUTINE SETMU(XMZ,XMH,XMT,XSW,GAMZ,GZ0,ALFAS)                  SETMU  2
*HOLC2 ALFAS HAS BEEN INTRODUCED                                        SETMU  3
************************************************************************SETMU  4
*                                                                      *SETMU  5
*   completion of the parameter set for                                *SETMU  6
*                                                                      *SETMU  7
*         e+ e-  --->  mu+ mu-                                         *SETMU  8
*                                                                      *SETMU  9
*   XSW:  sin**2(theta-W)                                               SETMU 10
*   GAMZ: physical (corrected) Z width                                  SETMU 11
*   GZ0:  lowest order "Z width" for Born cross section                *SETMU 12
*                                                                      *SETMU 13
*                                                                      *SETMU 14
* The parameters are derived from the input together with the          *SETMU 15
* Fermi constant  G-mu.                                                *SETMU 16
* also:  soft   photonic corrections (virtual + bremsstrahlung)        *SETMU 17
*                                                                      *SETMU 18
* Input:   XMZ = Z MASS          (GEV)                                 *SETMU 19
*          XMH = HIGGS MASS      (GEV)                                 *SETMU 20
*          XMT = TOP MASS        (GEV)                                 *SETMU 21
* The values of various masses and couplings in the PARAMETER state-   *SETMU 22
* ments should be identical to the values used in the PARAMETER state- *SETMU 23
* ments used in the subprograms RNORM,RESZ,IMSZ,REPG,IMPG,RESGZ,DELIMZ *SETMU 24
*    Author:     Wolfgang Hollik  (Universitaet Hamburg and DESY)      *SETMU 25
*    based on:   Gerrit Burgers (CERN/TH)       Version:  July  1988   *SETMU 26
************************************************************************SETMU 27
      IMPLICIT DOUBLE PRECISION(A-Z)                                    SETMU 28
      INTEGER I,ICOUNT,J,K                                              SETMU 29
      COMPLEX*16 CHIG, CHIZ, CHIGZ, CGG, SGZ, SZZ,                      SETMU 30
     .           AMM, APP, AMP, APM,                                    SETMU 31
     .           L2, L3, L2Z, L2W, L3W,                                 SETMU 32
     .           FZV, FZA, FGV, FGA, FZVF, FZAF, FGVF, FGAF , ONE,      SETMU 33
     .           FLE, FLF, FLGE, FLGF,                                  SETMU 34
     .           VE, AE, VF, AF, CHI ,                                  SETMU 35
     .           CG1, CG3, CH1, CH3                                     SETMU 36
*CORR: NEXT LINE IS INSERTED                                            SETMU 37
     .           ,CGGE,SGZE                                             SETMU 38
      DIMENSION VE(8), AE(8), VF(8), AF(8), CHI(8)                      SETMU 39
      COMMON /HOLBOS/MZ,MW,MH                                           HOLBOS 2
      REAL*8         MZ,MW,MH                                           HOLBOS 3
      COMMON /HAD/XU,XD,XS,XC,XB,MT                                     HAD    2
      REAL*8      XU,XD,XS,XC,XB,MT                                     HAD    3
      COMMON /RENORM/ DELTAR, RESW0, RESWW, RESZZ, SUBZZ, SUBWW, SUBGZ  RENORM 2
      REAL*8          DELTAR, RESW0, RESWW, RESZZ, SUBZZ, SUBWW, SUBGZ  RENORM 3
      COMMON/COUPL/ SW,CW,SW1,CW1, V,A,VU,VD                            COUPL  2
      REAL*8        SW,CW,SW1,CW1, V,A,VU,VD                            COUPL  3
      PARAMETER(PI=3.1415926535897932D0, ALFINV=137.036D0)              DIFMU  2
      PARAMETER(ONE=(1.D0,0.D0))                                        DIFMU  3
      PARAMETER(A0=37.281D0**2)                                         DIFMU  4
      PARAMETER(ME=0.5110034D-3,MMU=0.10565943D0,MTAU=1.7842D0,         DIFMU  5
     .          MU=0.04145D0,MD=0.04146D0,MS=0.150D0,MC=1.5D0,MB=4.5D0) DIFMU  6
*HOLC2 ALFAS HAS BEEN REMOVED                                           DIFMU  7
      PARAMETER(MPI=0.140D0)                                            DIFMU  8
      PARAMETER(EPS=1.D-3)                                              DIFMU  9
      SAVE                                                              DIFMU 10
      DATA ICOUNT /0/                                                   DIFMU 11
*                                                                       DIFMU 12
      IF(ICOUNT.EQ.0 .OR. ABS(MZ-XMZ).GT.EPS .OR. ABS(MH-XMH).GT.EPS    DIFMU 13
     .   .OR. ABS(MT-XMT).GT.EPS .OR. ABS(ALFAS-ALFAS).GT.EPS) THEN     DIFMU 14
         WRITE(6,'('' INITIALISING... '')')                             DIFMU 15
         ICOUNT=ICOUNT+1                                                DIFMU 16
         MZ=XMZ                                                         DIFMU 17
         MH=XMH                                                         DIFMU 18
         MT=XMT                                                         DIFMU 19
*        ALFAS=XALFAS                                                   DIFMU 20
*                                                                       DIFMU 21
* Iterative determination of SW and MW from MZ,MH and MT                DIFMU 22
* SW is sin**2 theta weak.  Start with approximate value.               DIFMU 23
         SQ=DSQRT(1.D0-4.D0*A0/MZ**2/(1.D0-.07D0))                      DIFMU 24
         SWOLD=(1.D0-SQ)/2.D0                                           DIFMU 25
         MW=MZ*SQRT(1.D0-SWOLD)                                         DIFMU 26
         CALL RNORM(MZ,MW,MH,MT)                                        DIFMU 27
* RNORM calculates the Common/RENORM/ which contains DELTAR and the re- DIFMU 28
* normalisation constants RESZZ, SUBZZ (needed later in the calculation DIFMU 29
* of the real part of the Z self energy) and RESGZ (for the Z photon    DIFMU 30
* mixing).  Also the coupling constants in Common/COUPL/ are calculated.DIFMU 31
         DO 1 I=1,10                                                    DIFMU 32
           SQ=DSQRT(1.D0-4.D0*A0/MZ**2/(1.D0-DELTAR))                   DIFMU 33
           SW=(1.D0-SQ)/2.D0                                            DIFMU 34
           MW=MZ*SQRT(1.D0-SW)                                          DIFMU 35
           CALL RNORM(MZ,MW,MH,MT)                                      DIFMU 36
           IF(ABS(SW-SWOLD).LT.3D-6) GOTO 2                             DIFMU 37
           SWOLD= SW                                                    DIFMU 38
   1     CONTINUE                                                       DIFMU 39
         WRITE(6,'('' NO SUFFICIENT CONVERGENCE FOR SW IN 10 STEPS'')') DIFMU 40
   2     CONTINUE                                                       DIFMU 41
*  couplings and  charges:                                              DIFMU 42
         GAE = -1D0/(4D0*SW1*CW1)                                       DIFMU 43
         GVE = -(1D0-4D0*SW)/(4.D0*SW1*CW1)                             DIFMU 44
         QE = -1.D0                                                     DIFMU 45
         GAF= GAE                                                       DIFMU 46
         GVF= GVE                                                       DIFMU 47
         QF = -1.D0                                                     DIFMU 48
*uu      GAF= -GAE                                                      DIFMU 49
*uu      GVF= (1.D0-8.D0*SW/3.D0)/(2.D0*SW1*CW1)                        DIFMU 50
*uu      QF = 2.D0/3.D0                                                 DIFMU 51
*dd      GAF=  GAE                                                      DIFMU 52
*dd      GVF= (4.D0*SW/3.D0-1.D0)/(2.D0*SW1*CW1)                        DIFMU 53
*dd      QF =-1.D0/3.D0                                                 DIFMU 54
*                                                                       DIFMU 55
*  threshold and final state corrections for quarks                     DIFMU 56
         SMIN  = 4.D0*MMU**2                                            DIFMU 57
         RQUARK= 1.D0                                                   DIFMU 58
*qq      SMIN  = 4.D0*MPI**2                                            DIFMU 59
*qq      RQUARK= 3. * (1.+ALFAS*(1.+ALFAS*(1.98-5.*0.115)/PI)/PI)       DIFMU 60
*                                                                       DIFMU 61
* CORR: NEXT LINE (COMMENT) IS INCORRECT                                DIFMU 62
*  DELIMZ()/(1+PIZZ) is the correction to the Z widt                    DIFMU 63
*HOLC2 DUM REPLACED BY ALFAS                                            DIFMU 64
         DELTIM=DELIMZ(ALFAS)                                           DIFMU 65
*                                                                       DIFMU 66
         AL4PI = 1.D0/(4.D0*PI*ALFINV)                                  DIFMU 67
         WRITE(6,'(''+              ...FINISHED'')')                    DIFMU 68
      ENDIF                                                             DIFMU 69
*  Z width:                                                             DIFMU 70
* CORR    GZ0  = IMSZ(MZ**2)/MZ                                         DIFMU 71
* CORR    GAMZ = (GZ0+DELTIM)/(1D0+PIZZ(MZ**2))                         DIFMU 72
* CORR   * BEGIN OF NEW PART ***********************************        DIFMU 73
*  PIZ is the derivative of the denominator of the full Z propagator    DIFMU 74
*  AT S=MZ**2, PIZZ(MZ**2) THE DERIVATIVE OF THE 1PI RESZ(S)            DIFMU 75
*     PIZ   = PIZZ(MZ**2) - RESGZ(MZ**2)**2/(1.D0-REPG(MZ**2))/MZ**4    DIFMU 76
      Z   = MZ**2                                                       DIFMU 77
      ZE  = MZ**2+EPS                                                   DIFMU 78
      CGG = 1.D0/(1.D0-DCMPLX(REPG(Z),IMPG(Z)) )                        DIFMU 79
      SGZ = DCMPLX(RESGZ(Z),IMSGZ(Z) )                                  DIFMU 80
      CGGE= 1.D0/(1.D0-DCMPLX(REPG(ZE),IMPG(ZE)) )                      DIFMU 81
      SGZE= DCMPLX(RESGZ(ZE),IMSGZ(ZE) )                                DIFMU 82
      PIZ   = PIZZ(Z) -(DREAL(CGGE*SGZE**2)/ZE-DREAL(CGG*SGZ**2)/Z)/EPS DIFMU 83
      PIGZ  = DREAL(SGZ/MZ**2    )                                      DIFMU 84
*  GAMZ is the Z0 width                                                 DIFMU 85
      GAMZ=(IMSZ(Z)+ DREAL(DCMPLX(0.D0,1.D0)*CGG*SGZ**2)/Z +            DIFMU 86
     . MZ*DELTIM)/MZ/(1D0+PIZ)                                          DIFMU 87
*   CORR  *** END OF NEW PART  *****************************            DIFMU 88
      XSW  = SW                                                         DIFMU 89
      RETURN                                                            DIFMU 90
      END                                                               DIFMU 91
      SUBROUTINE DIFMU(S,CT,XMZ,XMH,XMT,SIG0,SIG,ALFAS)                 DIFMU 92
*HOLC2 ALFAS HAS BEEN INTRODUCED                                        DIFMU 93
************************************************************************DIFMU 94
*                                                                      *DIFMU 95
*   The differential cross section for                                 *DIFMU 96
*                                                                      *DIFMU 97
*         e+ e-  --->  mu+ mu-                                         *DIFMU 98
*                                                                      *DIFMU 99
*   SIG0: Born,   SIG : with O(alfa) corrections                        DIFMU100
*                                                                       DIFMU101
*   (or u ubar or d dbar, by including a few lines which have been     *DIFMU102
*    commented out like "*qq" and "*dd")                               *DIFMU103
*                                                                      *DIFMU104
* INCLUDED: one loop Z Self-energy + corrected Z width, photon vacuum  *DIFMU105
* polarisation, photon-Z mixing, non-photonic vertex corrections       *DIFMU106
* also:  soft   photonic corrections (virtual + bremsstrahlung)        *DIFMU107
*                                                                      *DIFMU108
* INPUT:   S   = (CMS-ENERGY)**2 (GEV**2)                              *DIFMU109
*          XMZ = Z MASS          (GEV)                                 *DIFMU110
*          XMH = HIGGS MASS      (GEV)                                 *DIFMU111
*          XMT = TOP MASS        (GEV)                                 *DIFMU112
* The values of various masses and couplings in the PARAMETER state-   *DIFMU113
* ments should be identical to the values used in the PARAMETER state- *DIFMU114
* ments used in the subprograms RNORM,RESZ,IMSZ,REPG,IMPG,RESGZ,DELIMZ *DIFMU115
*    Author:     Wolfgang Hollik  (Universitaet Hamburg and DESY)      *DIFMU116
*    based on:   Gerrit Burgers (CERN/TH)       Version:  July  1988   *DIFMU117
************************************************************************DIFMU118
      IMPLICIT DOUBLE PRECISION(A-Z)                                    DIFMU119
      INTEGER I,ICOUNT,J,K                                              DIFMU120
      COMPLEX*16 CHIG, CHIZ, CHIGZ, CGG, SGZ, SZZ, CHI0,                DIFMU121
     .           AMM, APP, AMP, APM,                                    DIFMU122
     .           L2, L3, L2Z, L2W, L3W,                                 DIFMU123
     .           FZV, FZA, FGV, FGA, FZVF, FZAF, FGVF, FGAF , ONE,      DIFMU124
     .           FLE, FLF, FLGE, FLGF,                                  DIFMU125
     .           VE, AE, VF, AF, CHI ,                                  DIFMU126
     .           CG1, CG3, CH1, CH3                                     DIFMU127
      DIMENSION VE(11), AE(11), VF(11), AF(11), CHI(11)                 DIFMU128
      COMMON /HELIC/ S1,S2,S3,S4                                        HELIC  2
      REAL*8         S1,S2,S3,S4                                        HELIC  3
      COMMON /HOLBOS/MZ,MW,MH                                           HOLBOS 2
      REAL*8         MZ,MW,MH                                           HOLBOS 3
      COMMON /HAD/XU,XD,XS,XC,XB,MT                                     HAD    2
      REAL*8      XU,XD,XS,XC,XB,MT                                     HAD    3
      COMMON /RENORM/ DELTAR, RESW0, RESWW, RESZZ, SUBZZ, SUBWW, SUBGZ  RENORM 2
      REAL*8          DELTAR, RESW0, RESWW, RESZZ, SUBZZ, SUBWW, SUBGZ  RENORM 3
      COMMON/COUPL/ SW,CW,SW1,CW1, V,A,VU,VD                            COUPL  2
      REAL*8        SW,CW,SW1,CW1, V,A,VU,VD                            COUPL  3
      PARAMETER(PI=3.1415926535897932D0, ALFINV=137.036D0)              DIFMU134
      PARAMETER(ONE=(1.D0,0.D0))                                        DIFMU135
      PARAMETER(A0=37.281D0**2)                                         DIFMU136
      PARAMETER(ME=0.5110034D-3,MMU=0.10565943D0,MTAU=1.7842D0,         DIFMU137
     .          MU=0.04145D0,MD=0.04146D0,MS=0.150D0,MC=1.5D0,MB=4.5D0) DIFMU138
*HOLC2 ALFAS HAS BEEN REMOVED                                           DIFMU139
      PARAMETER(MPI=0.140D0)                                            DIFMU140
      PARAMETER(EPS=1.D-3)                                              DIFMU141
      SAVE                                                              DIFMU142
      DATA ICOUNT /0/                                                   DIFMU143
      DATA SZERO  /0.D0/                                                DIFMU144
      DATA YMZ,YMH,YMT /0.0,0.0,0.0/                                    DIFMU145
*                                                                       DIFMU146
* The following block-if is executed when DIFMU  is called for the firstDIFMU147
* time.  From then on, this block-if  is only executed when the mass    DIFMU148
* parameters have changed with respect to the previous call.  As a largeDIFMU149
* part of the calculation of DIFMU  is independent of s, this saves     DIFMU150
* much computertime                                                     DIFMU151
      IF(ICOUNT.EQ.0 .OR. ABS(YMZ-XMZ).GT.EPS .OR. ABS(YMH-XMH).GT.EPS  DIFMU152
     .   .OR. ABS(YMT-XMT).GT.EPS .OR. ABS(ALFAS-ALFAS).GT.EPS) THEN    DIFMU153
*        WRITE(5,'('' INITIALISING... '')')                             DIFMU154
         ICOUNT=ICOUNT+1                                                DIFMU155
         MZ=XMZ                                                         DIFMU156
         MH=XMH                                                         DIFMU157
         MT=XMT                                                         DIFMU158
         YMZ=XMZ                                                        DIFMU159
         YMH=XMH                                                        DIFMU160
         YMT=XMT                                                        DIFMU161
*        ALFAS=XALFAS                                                   DIFMU162
*                                                                       DIFMU163
* Iterative determination of SW and MW from MZ,MH and MT                DIFMU164
* SW is sin**2 theta weak.  Start with approximate value.               DIFMU165
         SQ=DSQRT(1.D0-4.D0*A0/MZ**2/(1.D0-.07D0))                      DIFMU166
         SWOLD=(1.D0-SQ)/2.D0                                           DIFMU167
         MW=MZ*SQRT(1.D0-SWOLD)                                         DIFMU168
         CALL RNORM(MZ,MW,MH,MT)                                        DIFMU169
* RNORM calculates the Common/RENORM/ which contains DELTAR and the re- DIFMU170
* normalisation constants RESZZ, SUBZZ (needed later in the calculation DIFMU171
* of the real part of the Z self energy) and RESGZ (for the Z photon    DIFMU172
* mixing).  Also the coupling constants in Common/COUPL/ are calculated.DIFMU173
         DO 1 I=1,10                                                    DIFMU174
           SQ=DSQRT(1.D0-4.D0*A0/MZ**2/(1.D0-DELTAR))                   DIFMU175
           SW=(1.D0-SQ)/2.D0                                            DIFMU176
           MW=MZ*SQRT(1.D0-SW)                                          DIFMU177
           CALL RNORM(MZ,MW,MH,MT)                                      DIFMU178
           IF(ABS(SW-SWOLD).LT.3D-6) GOTO 2                             DIFMU179
           SWOLD= SW                                                    DIFMU180
   1     CONTINUE                                                       DIFMU181
         WRITE(6,'('' NO SUFFICIENT CONVERGENCE FOR SW IN 10 STEPS'')') DIFMU182
   2     CONTINUE                                                       DIFMU183
*  couplings and  charges:                                              DIFMU184
         GAE = -1D0/(4D0*SW1*CW1)                                       DIFMU185
         GVE = -(1D0-4D0*SW)/(4.D0*SW1*CW1)                             DIFMU186
         QE = -1.D0                                                     DIFMU187
         GAF= GAE                                                       DIFMU188
         GVF= GVE                                                       DIFMU189
         QF = -1.D0                                                     DIFMU190
*uu      GAF= -GAE                                                      DIFMU191
*uu      GVF= (1.D0-8.D0*SW/3.D0)/(2.D0*SW1*CW1)                        DIFMU192
*uu      QF = 2.D0/3.D0                                                 DIFMU193
*dd      GAF=  GAE                                                      DIFMU194
*dd      GVF= (4.D0*SW/3.D0-1.D0)/(2.D0*SW1*CW1)                        DIFMU195
*dd      QF =-1.D0/3.D0                                                 DIFMU196
*                                                                       DIFMU197
*  threshold and final state corrections for quarks                     DIFMU198
         SMIN  = 4.D0*MMU**2                                            DIFMU199
         RQUARK= 1.D0                                                   DIFMU200
*qq      SMIN  = 4.D0*MPI**2                                            DIFMU201
*qq      RQUARK= 3. * (1.+ALFAS*(1.+ALFAS*(1.98-5.*0.115)/PI)/PI)       DIFMU202
*                                                                       DIFMU203
*  DELIMZ()/(1+PIZZ) is the correction to the Z widt                    DIFMU204
*HOLC2 DUM REPLACED BY ALFAS                                            DIFMU205
         DELTIM=DELIMZ(ALFAS)                                           DIFMU206
*                                                                       DIFMU207
         AL4PI = 1.D0/(4.D0*PI*ALFINV)                                  DIFMU208
*        WRITE(6,'(''+              ...FINISHED'')')                    DIFMU209
      ENDIF                                                             DIFMU210
*                                                                       DIFMU211
* Begin of the   S dependent part.                                      DIFMU212
* N is a normalisation factor to convert the cross section into nbarn   DIFMU213
      N     = 0.D0                                                      DIFMU214
      IF(S.GT.SMIN)                                                     DIFMU215
     .  N   = RQUARK*389385.7D0*4.D0*PI/(3.D0*ALFINV**2*S)              DIFMU216
     .        * SQRT(1.D0-SMIN/S)*(1.D0+0.5D0*SMIN/S)                   DIFMU217
*                                                                       DIFMU218
      IF (ABS(SZERO-S).GT.EPS) THEN                                     DIFMU219
C ==== SPEED =========== BEGIN ====                                     DIFMU220
      SZERO=S                                                           DIFMU221
* The irreducible one-particle self-energies in one loop,               DIFMU222
* 1-CGG is the photon-vacuum polarisation, SGZ is the gamma-Z mixing,   DIFMU223
* SZZ is the ZZ self-energy.                                            DIFMU224
* The correction to the ZZ self-energy is     s*DELTIM/MZ               DIFMU225
      CGG = 1.D0 - DCMPLX(REPG(S),IMPG(S))                              DIFMU226
      SGZ = DCMPLX(RESGZ(S),IMSGZ(S))                                   DIFMU227
      SZZ = DCMPLX(RESZ(S),IMSZ(S)+S*DELTIM/MZ)                         DIFMU228
*                                                                       DIFMU229
*HOLC2 CHIZ,CHIG,AND CHIGZ ARE REPLACED                                 DIFMU230
* The Z propagator CHIZ.  The Z width is IM(CHIZ)/(1+PZZ)               DIFMU231
      CHIZ=S/(S-MZ**2+SZZ-SGZ**2/(S*CGG))                               DIFMU232
* The photon propagator CHIG.                                           DIFMU233
      CHIG=1D0/(CGG                                                     DIFMU234
     .     -SGZ**2/(S*(S-MZ**2+SZZ)))                                   DIFMU235
* The mixing propagator CHIGZ                                           DIFMU236
      CHIGZ= SGZ/((S-MZ**2+SZZ)*CGG-SGZ**2/S)                           DIFMU237
      PIGZ=RESGZ(S)/S                                                   DIFMU238
*                                                                       DIFMU239
* The non-photonic vertex corrections FZM,FZP,FGM,FGP.                  DIFMU240
      L2Z=L2(MZ**2/S)                                                   DIFMU241
      L2W=L2(MW**2/S)                                                   DIFMU242
      L3W=L3(MW**2/S)                                                   DIFMU243
      FLE=L2W/(8D0*SW1*CW1*SW)-.75D0*CW1/(SW1*SW)*L3W                   DIFMU244
      FLF=-FLE*QF/DABS(QF)+4D0/9D0/QF/(8*SW1*CW1)*L3W                   DIFMU245
      FZV=AL4PI*(GVE*(GVE**2+3D0*GAE**2)*L2Z+FLE)                       DIFMU246
      FZA=AL4PI*(GAE*(3D0*GVE**2+GAE**2)*L2Z+FLE)                       DIFMU247
      FLGE=.75D0/SW*L3W                                                 DIFMU248
      FLGF=-.75D0/SW*QF/DABS(QF)*L3W                                    DIFMU249
     .     +L2W/(18D0*SW*QF)                                            DIFMU250
      FGV=AL4PI*((GVE**2+GAE**2)*L2Z+FLGE)                              DIFMU251
      FGA=AL4PI*(2D0*GVE*GAE*L2Z+FLGE)                                  DIFMU252
      FZVF=AL4PI*(GVF*(GVF**2+3D0*GAF**2)*L2Z+FLF)                      DIFMU253
      FZAF=AL4PI*(GAF*(3D0*GVF**2+GAF**2)*L2Z+FLF)                      DIFMU254
      FGVF=AL4PI*(-QF*(GVF**2+GAF**2)*L2Z+FLGF)                         DIFMU255
      FGAF=AL4PI*(-QF*2D0*GVF*GAF*L2Z+FLGF)                             DIFMU256
*                                                                       DIFMU257
* The definition of form factors and propagators                        DIFMU258
      VE(1)=QE                                                          DIFMU259
      AE(1)=0D0                                                         DIFMU260
      VF(1)=QF                                                          DIFMU261
      AF(1)=0D0                                                         DIFMU262
      CHI(1)=CHIG                                                       DIFMU263
      VE(2)=GVE                                                         DIFMU264
      AE(2)=GAE                                                         DIFMU265
      VF(2)=GVF                                                         DIFMU266
      AF(2)=GAF                                                         DIFMU267
      CHI(2)=CHIZ                                                       DIFMU268
      VE(3)=QE                                                          DIFMU269
      AE(3)=0D0                                                         DIFMU270
      VF(3)=GVF                                                         DIFMU271
      AF(3)=GAF                                                         DIFMU272
      CHI(3)=CHIGZ                                                      DIFMU273
      VE(4)=GVE                                                         DIFMU274
      AE(4)=GAE                                                         DIFMU275
      VF(4)=QF                                                          DIFMU276
      AF(4)=0D0                                                         DIFMU277
      CHI(4)=CHIGZ                                                      DIFMU278
      VE(5)=FZV                                                         DIFMU279
      AE(5)=FZA                                                         DIFMU280
      VF(5)=GVF                                                         DIFMU281
      AF(5)=GAF                                                         DIFMU282
      CHI(5)=CHIZ                                                       DIFMU283
      VE(6)=GVE                                                         DIFMU284
      AE(6)=GAE                                                         DIFMU285
      VF(6)=FZVF                                                        DIFMU286
      AF(6)=FZAF                                                        DIFMU287
      CHI(6)=CHIZ                                                       DIFMU288
      VE(7)=FGV                                                         DIFMU289
      AE(7)=FGA                                                         DIFMU290
      VF(7)=QF                                                          DIFMU291
      AF(7)=0D0                                                         DIFMU292
      CHI(7)=CHIG                                                       DIFMU293
      VE(8)=QE                                                          DIFMU294
      AE(8)=0D0                                                         DIFMU295
      VF(8)=FGVF                                                        DIFMU296
      AF(8)=FGAF                                                        DIFMU297
      CHI(8)=CHIG                                                       DIFMU298
C                                                                       DIFMU299
C  heavy box diagrams                                                   DIFMU300
      VE(9) =GVE**2+GAE**2                                              DIFMU301
      AE(9) =2D0*GVE*GAE                                                DIFMU302
      VE(10)=AE(9)                                                      DIFMU303
      AE(10)=VE(9)                                                      DIFMU304
      VE(11)=1D0/(4D0*SW)**2                                            DIFMU305
      AE(11)=VE(11)                                                     DIFMU306
      VF(9) =GVF**2+GAF**2                                              DIFMU307
      AF(9) =2D0*GVF*GAF                                                DIFMU308
      VF(10)=AF(9)                                                      DIFMU309
      AF(10)=VF(9)                                                      DIFMU310
      VF(11)=1D0/(4D0*SW)**2                                            DIFMU311
      AF(11)=VF(11)                                                     DIFMU312
      T=-S/2D0*(1D0-CT)                                                 DIFMU313
      U=-S/2D0*(1D0+CT)                                                 DIFMU314
      CALL HOLINT(S,T,MZ,IZT,I5ZT)                                      DIFMU315
      CALL HOLINT(S,U,MZ,IZU,I5ZU)                                      DIFMU316
      CALL HOLINT(S,T,MW,IWT,I5WT)                                      DIFMU317
      CHI(9) =2D0*AL4PI*(IZT-IZU)                                       DIFMU318
      CHI(10)=2D0*AL4PI*(I5ZT+I5ZU)                                     DIFMU319
      CHI(11)=2D0*AL4PI*(IWT+I5WT)                                      DIFMU320
      ENDIF                                                             DIFMU321
C ====SPEED=====END                                                     DIFMU322
* The invariant functions in the cross section                          DIFMU323
      CG1=0D0                                                           DIFMU324
      CG3=0D0                                                           DIFMU325
      CH1=0D0                                                           DIFMU326
      CH3=0D0                                                           DIFMU327
      DO 11 J=1,11                                                      DIFMU328
        DO 10 K=1,11                                                    DIFMU329
        CG1=CG1+(VE(J)*DCONJG(VE(K))+AE(J)*DCONJG(AE(K)))               DIFMU330
     .         *(VF(J)*DCONJG(VF(K))+AF(J)*DCONJG(AF(K)))               DIFMU331
     .         *CHI(J)*DCONJG(CHI(K))                                   DIFMU332
        CG3=CG3+(VE(J)*DCONJG(AE(K))+AE(J)*DCONJG(VE(K)))               DIFMU333
     .         *(VF(J)*DCONJG(AF(K))+AF(J)*DCONJG(VF(K)))               DIFMU334
     .         *CHI(J)*DCONJG(CHI(K))                                   DIFMU335
        CH1=CH1+(VE(J)*DCONJG(AE(K))+AE(J)*DCONJG(VE(K)))               DIFMU336
     .         *(VF(J)*DCONJG(VF(K))+AF(J)*DCONJG(AF(K)))               DIFMU337
     .         *CHI(J)*DCONJG(CHI(K))                                   DIFMU338
        CH3=CH3+(VE(J)*DCONJG(VE(K))+AE(J)*DCONJG(AE(K)))               DIFMU339
     .         *(VF(J)*DCONJG(AF(K))+AF(J)*DCONJG(VF(K)))               DIFMU340
     .         *CHI(J)*DCONJG(CHI(K))                                   DIFMU341
10      CONTINUE                                                        DIFMU342
11    CONTINUE                                                          DIFMU343
      G1=DREAL(CG1)                                                     DIFMU344
      G3=DREAL(CG3)                                                     DIFMU345
      H1=DREAL(CH1)                                                     DIFMU346
      H3=DREAL(CH3)                                                     DIFMU347
*                                                                       DIFMU348
*  The non-QED cross section                                            DIFMU349
      SYM = (1D0-S1*S2)*(1-S3*S4)*G1                                    DIFMU350
     .     +(S2-S1)*(S4-S3) *G3                                         DIFMU351
     .     +(S2-S1)*(1D0-S3*S4)*H1                                      DIFMU352
     .     +(1D0-S1*S2)*(S4-S3)*H1                                      DIFMU353
      ASY = (1D0-S1*S2)*(1-S3*S4)*G3                                    DIFMU354
     .     +(S2-S1)*(S4-S3) *G1                                         DIFMU355
     .     +(S2-S1)*(1D0-S3*S4)*H1                                      DIFMU356
     .     +(1D0-S1*S2)*(S4-S3)*H1                                      DIFMU357
      SIG = SYM*(1D0+CT*CT) + ASY*2D0*CT                                DIFMU358
*  The Born cross section                                               DIFMU359
      CHI0 = S/DCMPLX(S-MZ**2,IMSZ(MZ**2))                              DIFMU360
      CHI1 = DREAL(CHI0)                                                DIFMU361
      CHI2 = DREAL(CHI0*DCONJG(CHI0))                                   DIFMU362
      G10  = 1D0+2D0*GVE**2*CHI1+(GVE**2+GAE**2)**2*CHI2                DIFMU363
      G30  =     2D0*GAE**2*CHI1+4D0*GVE**2*GAE**2*CHI2                 DIFMU364
      H0   =     2D0*GVE*GAE*(CHI1+(GVE**2+GAE**2)*CHI2)                DIFMU365
      SY0 = (1D0-S1*S2)*(1-S3*S4)*G10                                   DIFMU366
     .     +(S2-S1)*(S4-S3) *G30                                        DIFMU367
     .     +(S2-S1)*(1D0-S3*S4)*H0                                      DIFMU368
     .     +(1D0-S1*S2)*(S4-S3)*H0                                      DIFMU369
      AS0 = (1D0-S1*S2)*(1-S3*S4)*G30                                   DIFMU370
     .     +(S2-S1)*(S4-S3) *G10                                        DIFMU371
     .     +(S2-S1)*(1D0-S3*S4)*H0                                      DIFMU372
     .     +(1D0-S1*S2)*(S4-S3)*H0                                      DIFMU373
      SIG0 = SY0*(1D0+CT*CT) + AS0*2D0*CT                               DIFMU374
*                                                                       DIFMU375
*  QED corrections                                                      DIFMU376
      END                                                               DIFMU377
      DOUBLE PRECISION FUNCTION RESZ(S)                                 RESZ   2
*********************************************************************** RESZ   3
* Real part of the 1-loop Z selfenergy.                               * RESZ   4
* A large s-independent part comes from the renormalisation constants * RESZ   5
* RESZZ and SUBZZ.  They are calculated in a separate subprogram,     * RESZ   6
* RNORM, and put into the common RENORM                               * RESZ   7
*                                                                     * RESZ   8
*                Author:  Gerrit Burgers        CERN/TH               * RESZ   9
*********************************************************************** RESZ  10
      IMPLICIT DOUBLE PRECISION(A-Z)                                    RESZ  11
      COMMON /RENORM/ DELTAR, RESW0, RESWW, RESZZ, SUBZZ, SUBWW, SUBGZ  RENORM 2
      REAL*8          DELTAR, RESW0, RESWW, RESZZ, SUBZZ, SUBWW, SUBGZ  RENORM 3
      COMMON/COUPL/ SW,CW,SW1,CW1, V,A,VU,VD                            COUPL  2
      REAL*8        SW,CW,SW1,CW1, V,A,VU,VD                            COUPL  3
      COMMON /HOLBOS/MZ,MW,MH                                           HOLBOS 2
      REAL*8         MZ,MW,MH                                           HOLBOS 3
      COMMON /HAD/XU,XD,XS,XC,XB,MT                                     HAD    2
      REAL*8      XU,XD,XS,XC,XB,MT                                     HAD    3
* One can either pass the hadron masses via the common (here MT)        RESZ  16
* or via the parmeter statement (here MU,MD,MS,MC and MB)               RESZ  17
      PARAMETER(PI=3.1415926535897932D0, ALFINV=137.036D0)              RESZ  18
      PARAMETER(ME=0.5110034D-3,MMU=0.10565943D0,MTAU=1.7842D0,         RESZ  19
     .          MU=0.04145D0,MD=0.04146D0,MS=0.150D0,                   RESZ  20
     .          MC=1.5D0,MB=4.5D0)                                      RESZ  21
      Z  = MZ**2                                                        RESZ  22
      W  = MW**2                                                        RESZ  23
      H  = MH**2                                                        RESZ  24
      RESZ=                                                             RESZ  25
     . 2.D0*A**2*S*(FH(S,ME,ME)+FH(S,MMU,MMU)+FH(S,MTAU,MTAU)-1.D0)/3.D0RESZ  26
      RESZ= RESZ                                                        RESZ  27
     . +(((V**2+A**2)*(S+2.D0*ME**2)-6.D0*ME**2*A**2)*FH(S,ME,ME)       RESZ  28
     .  +((V**2+A**2)*(S+2.D0*MMU**2)-6.D0*MMU**2*A**2)*FH(S,MMU,MMU)   RESZ  29
     . +((V**2+A**2)*(S+2.D0*MTAU**2)-6.D0*MTAU**2*A**2)*FH(S,MTAU,MTAU)RESZ  30
     .  -(V**2+A**2)*S )/3.D0                                           RESZ  31
      RESZ= RESZ                                                        RESZ  32
     .+(((VU**2+A**2)*(S+2.D0*MU**2)-6.D0*MU**2*A**2)*FH(S,MU,MU)       RESZ  33
     . +((VU**2+A**2)*(S+2.D0*MC**2)-6.D0*MC**2*A**2)*FH(S,MC,MC)       RESZ  34
     . +((VU**2+A**2)*(S+2.D0*MT**2)-6.D0*MT**2*A**2)*FH(S,MT,MT)       RESZ  35
     . -(VU**2+A**2)*S )                                                RESZ  36
      RESZ= RESZ                                                        RESZ  37
     .+(((VD**2+A**2)*(S+2.D0*MD**2)-6.D0*MD**2*A**2)*FH(S,MD,MD)       RESZ  38
     . +((VD**2+A**2)*(S+2.D0*MS**2)-6.D0*MS**2*A**2)*FH(S,MS,MS)       RESZ  39
     . +((VD**2+A**2)*(S+2.D0*MB**2)-6.D0*MB**2*A**2)*FH(S,MB,MB)       RESZ  40
     . -(VD**2+A**2)*S )                                                RESZ  41
      RESZ= RESZ                                                        RESZ  42
     .+((CW**2*(-10.D0*S-20.D0*W)+(CW-SW)**2*(2.D0*W+S/4.D0)+3.D0*W)*   RESZ  43
     .   FH(S,MW,MW)                                                    RESZ  44
     . +S*(-2.D0*CW**2/3.D0+(CW-SW)**2/6.D0) )*4.D0*A**2/3.D0           RESZ  45
      RESZ= RESZ                                                        RESZ  46
     .+((10.D0*Z-2.D0*H+S+(H-Z)**2/S)*FH(S,MH,MZ)                       RESZ  47
     . +(10.D0*Z-2.D0*H+S)*(1.D0-(H+Z)*LOG(MH/MZ)/(H-Z)-LOG(MH*MZ/W))   RESZ  48
     . -2.D0*H*LOG(H/W)-2.D0*Z*LOG(Z/W)+2.D0*S/3.D0)*A**2/3.D0          RESZ  49
      RESZ= RESZ/(PI*ALFINV)                                            RESZ  50
*                                                                       RESZ  51
* renormalisation                                                       RESZ  52
      RESZ= RESZ- RESZZ + (S-Z)*SUBZZ                                   RESZ  53
      END                                                               RESZ  54
      DOUBLE PRECISION FUNCTION RESGZ(S)                                RESGZ  2
*********************************************************************** RESGZ  3
* Real part of the 1-loop Z-gamma mixing.                             * RESGZ  4
* A large s-independent part comes from the renormalisation constant  * RESGZ  5
* SUBGZ, which is calculated in a separate subprogram, RNORM and put  * RESGZ  6
* into the common RENORM                                              * RESGZ  7
*                                                                     * RESGZ  8
*                Author:  Gerrit Burgers        CERN/TH               * RESGZ  9
*********************************************************************** RESGZ 10
      IMPLICIT REAL*8(A-Z)                                              RESGZ 11
      COMMON /RENORM/ DELTAR, RESW0, RESWW, RESZZ, SUBZZ, SUBWW, SUBGZ  RENORM 2
      REAL*8          DELTAR, RESW0, RESWW, RESZZ, SUBZZ, SUBWW, SUBGZ  RENORM 3
      COMMON /HOLBOS/MZ,MW,MH                                           HOLBOS 2
      REAL*8         MZ,MW,MH                                           HOLBOS 3
      COMMON/COUPL/ SW,CW,SW1,CW1, VE,A,VU,VD                           COUPR  2
      REAL*8        SW,CW,SW1,CW1, VE,A,VU,VD                           COUPR  3
      COMMON /HAD/XU,XD,XS,XC,XB,MT                                     HAD    2
      REAL*8      XU,XD,XS,XC,XB,MT                                     HAD    3
* One can either pass the hadron masses via the common (here MT)        RESGZ 16
* or via the parmeter statement (here MU,MD,MS,MC and MB)               RESGZ 17
      PARAMETER(PI=3.1415926535897932D0, ALFINV=137.036D0)              RESGZ 18
      PARAMETER(ME=0.5110034D-3,MMU=0.10565943D0,MTAU=1.7842D0,         RESGZ 19
     .          MU=0.04145D0,MD=0.04146D0,MS=0.150D0,                   RESGZ 20
     .          MC=1.5D0,MB=4.5D0)                                      RESGZ 21
      PARAMETER(QE=-1.D0,QU=2.D0/3.D0,QD=-1.D0/3.D0)                    RESGZ 22
      Z  = MZ**2                                                        RESGZ 23
      W  = MW**2                                                        RESGZ 24
      H  = MH**2                                                        RESGZ 25
      RESGZ=                                                            RESGZ 26
     .    S*(QE*VE)*(V(S,ME)+V(S,MMU)+V(S,MTAU))/3.D0                   RESGZ 27
     .   +S*(QU*VU)*(V(S,MU)+V(S,MC)+V(S,MT))                           RESGZ 28
     .   +S*(QD*VD)*(V(S,MD)+V(S,MS)+V(S,MB))                           RESGZ 29
     .   -A*(S/9.D0+  ((S/3.D0-S*V(S,MW))/(S+2.D0*W))*                  RESGZ 30
     .       (S*(3.D0*CW+1.D0/6.D0)+W*(4.D0*CW+4.D0/3.D0)))             RESGZ 31
      RESGZ= RESGZ/(PI*ALFINV)                                          RESGZ 32
*                                                                       RESGZ 33
* renormalisation                                                       RESGZ 34
      RESGZ=RESGZ + S*SUBGZ                                             RESGZ 35
      END                                                               RESGZ 36
      DOUBLE PRECISION FUNCTION IMSZ(S)                                 IMSZ   2
************************************************************************IMSZ   3
* Imaginary part of the 1-loop Z self-energy                           *IMSZ   4
*                                                                      *IMSZ   5
*                Author:  Gerrit Burgers        CERN/TH                *IMSZ   6
************************************************************************IMSZ   7
      IMPLICIT DOUBLE PRECISION(A-Z)                                    IMSZ   8
      COMMON /HOLBOS/MZ,MW,MH                                           HOLBOS 2
      REAL*8         MZ,MW,MH                                           HOLBOS 3
      COMMON /HAD/XU,XD,XS,XC,XB,MT                                     HAD    2
      REAL*8      XU,XD,XS,XC,XB,MT                                     HAD    3
      COMMON/COUPL/ SW,CW,SW1,CW1, V,A,VU,VD                            COUPL  2
      REAL*8        SW,CW,SW1,CW1, V,A,VU,VD                            COUPL  3
      PARAMETER(ALFINV=137.036D0)                                       IMSZ  12
      PARAMETER(ME=0.5110034D-3,MMU=0.10565943D0,MTAU=1.7842D0,         IMSZ  13
     .          MU=0.04145D0,MD=0.04146D0,MS=0.150D0,                   IMSZ  14
     .          MC=1.5D0,MB=4.5D0)                                      IMSZ  15
      IMSZ= 0.D0                                                        IMSZ  16
      IF(S .GT. 0.D0)       IMSZ = IMSZ + 2.D0*A**2*S                   IMSZ  17
      IF(S .GT. 4.D0*ME**2)   IMSZ = IMSZ + SQRT(1.D0-4.D0*ME**2/S)*    IMSZ  18
     .            ((V**2+A**2)*(S+2.D0*ME**2)-6.D0*ME**2*A**2)/3.D0     IMSZ  19
      IF(S .GT. 4.D0*MMU**2)  IMSZ = IMSZ + SQRT(1.D0-4.D0*MMU**2/S)*   IMSZ  20
     .            ((V**2+A**2)*(S+2.D0*MMU**2)-6.D0*MMU**2*A**2)/3.D0   IMSZ  21
      IF(S .GT. 4.D0*MTAU**2) IMSZ = IMSZ + SQRT(1.D0-4.D0*MTAU**2/S)*  IMSZ  22
     .            ((V**2+A**2)*(S+2.D0*MTAU**2)-6.D0*MTAU**2*A**2)/3.D0 IMSZ  23
      IF(S .GT. 4.D0*MU**2)   IMSZ = IMSZ + SQRT(1.D0-4.D0*MU**2/S)*    IMSZ  24
     .            ((VU**2+A**2)*(S+2.D0*MU**2)-6.D0*MU**2*A**2)         IMSZ  25
      IF(S .GT. 4.D0*MC**2)   IMSZ = IMSZ + SQRT(1.D0-4.D0*MC**2/S)*    IMSZ  26
     .            ((VU**2+A**2)*(S+2.D0*MC**2)-6.D0*MC**2*A**2)         IMSZ  27
      IF(S .GT. 4.D0*MT**2)   IMSZ = IMSZ + SQRT(1.D0-4.D0*MT**2/S)*    IMSZ  28
     .            ((VU**2+A**2)*(S+2.D0*MT**2)-6.D0*MT**2*A**2)         IMSZ  29
      IF(S .GT. 4.D0*MD**2)   IMSZ = IMSZ + SQRT(1.D0-4.D0*MD**2/S)*    IMSZ  30
     .            ((VD**2+A**2)*(S+2.D0*MD**2)-6.D0*MD**2*A**2)         IMSZ  31
      IF(S .GT. 4.D0*MS**2)   IMSZ = IMSZ + SQRT(1.D0-4.D0*MS**2/S)*    IMSZ  32
     .            ((VD**2+A**2)*(S+2.D0*MS**2)-6.D0*MS**2*A**2)         IMSZ  33
      IF(S .GT. 4.D0*MB**2)   IMSZ = IMSZ + SQRT(1.D0-4.D0*MB**2/S)*    IMSZ  34
     .            ((VD**2+A**2)*(S+2.D0*MB**2)-6.D0*MB**2*A**2)         IMSZ  35
      IF(S .GT. 4.D0*MW**2)   IMSZ = IMSZ + SQRT(1.D0-4.D0*MW**2/S)*    IMSZ  36
     .            ((-10.D0*S-20.D0*MW**2)*CW**2+(2.D0*MW**2+S/4.D0)*    IMSZ  37
     .             (CW-SW)**2+3.D0*MW**2)*4.D0*A**2/3.D0                IMSZ  38
      IF(S .GT. (MH+MZ)**2) IMSZ = IMSZ +                               IMSZ  39
     .            (10.D0*MZ**2-2.D0*MH**2+S+(MH**2-MZ**2)**2/S)*A**2*   IMSZ  40
     .             SQRT((1.D0-(MZ-MH)**2/S)*(1-(MZ+MH)**2/S))/3.D0      IMSZ  41
      IMSZ=IMSZ/ALFINV                                                  IMSZ  42
      END                                                               IMSZ  43
      FUNCTION FF(A,Z,Y)                                                FF     2
* Author: R. Kleiss (Leiden and Cern/TH)                                FF     3
      IMPLICIT COMPLEX*16(A-H,O-Z)                                      FF     4
      REAL*8 A,A2,Y                                                     FF     5
C                                                                       FF     6
      Z2=Z*Z                                                            FF     7
      Z3=Z*Z2                                                           FF     8
      Z4=Z*Z3                                                           FF     9
      A2=A*A                                                            FF    10
C                                                                       FF    11
      C0 = ( Z4 - 2.*A*Z2 + A2 ) /Z4 *                                  FF    12
     .     ( Z4 - 24.*Z3 + (48.+10.*A)*Z2 - 24.*A*Z + A2)               FF    13
      C1 = A2*A2/(3.*Z)                                                 FF    14
      C2 = - A*A2*( 24.*Z - A )/(2.*Z2)                                 FF    15
      C3 = A2*( 8.*Z2*(A+6.) - 24.*A*Z + A2 ) /Z3                       FF    16
      C4 = -A2*( 24.*Z3 + 8.*Z2*(A+6.) - 24.*A*Z + A2 )/Z4              FF    17
      C5 = Z3 - 24.*Z2 + 8.*Z*(A+6.) + 24.*A                            FF    18
      C6 = Z2/2. - 12.*Z + 4.*(A+6.)                                    FF    19
      C7 = Z/3. - 8.                                                    FF    20
      C8 = 1./4.                                                        FF    21
C                                                                       FF    22
      FF = C0*CDLOG(Y-Z) + C4*DLOG(Y) +                                 FF    23
     . (C1+Y*(C2+Y*(C3+Y*Y*(C5+Y*(C6+Y*(C7+Y*C8))))))/(Y*Y*Y)           FF    24
      RETURN                                                            FF    25
      END                                                               FF    26
      DOUBLE PRECISION FUNCTION FH(S,MA,MB)                             FH     2
* Real part of the function F(s,ma,mb)                                  FH     3
      IMPLICIT REAL*8(A-Z)                                              FH     4
      PARAMETER(EPS=1.D-6)                                              FH     5
      MA2=MA**2                                                         FH     6
      MB2=MB**2                                                         FH     7
      IF(ABS(S).LT.EPS) THEN                                            FH     8
             F=0.0D0                                                    FH     9
      ELSEIF(MA.LT.EPS) THEN                                            FH    10
           IF(S.GT.MB2+EPS) THEN                                        FH    11
             F=1.D0+(1.D0-MB2/S)*LOG(1./(S/MB2-1.D0))                   FH    12
           ELSEIF(S.LT.MB2-EPS) THEN                                    FH    13
             F=1.D0+(1.D0-MB2/S)*LOG(1./(1.D0-S/MB2))                   FH    14
           ELSE                                                         FH    15
             F=1.D0                                                     FH    16
           ENDIF                                                        FH    17
      ELSE                                                              FH    18
          IF(ABS(MB-MA).LT.EPS) THEN                                    FH    19
           F=2.D0                                                       FH    20
          ELSE                                                          FH    21
           F=1.D0+((MA2-MB2)/S-(MA2+MB2)/(MA2-MB2))*LOG(MB/MA)          FH    22
          ENDIF                                                         FH    23
          IF(S.GE.(MA+MB)**2) THEN                                      FH    24
            RPLUS=SQRT(S-(MA+MB)**2)                                    FH    25
            RMIN =SQRT(S-(MA-MB)**2)                                    FH    26
            F=F- RPLUS*RMIN*LOG((RPLUS+RMIN)**2/(4.D0*MA*MB))/S         FH    27
          ELSEIF(S.LT.(MA-MB)**2) THEN                                  FH    28
            RPLUS=SQRT((MA+MB)**2-S)                                    FH    29
            RMIN =SQRT((MA-MB)**2-S)                                    FH    30
            F=F+ RPLUS*RMIN*LOG((RPLUS+RMIN)**2/(4.D0*MA*MB))/S         FH    31
          ELSE                                                          FH    32
            RPLUS=SQRT((MA+MB)**2-S)                                    FH    33
            RMIN =SQRT(S-(MA-MB)**2)                                    FH    34
            F=F- 2.D0*RPLUS*RMIN*ATAN(RMIN/RPLUS)/S                     FH    35
          ENDIF                                                         FH    36
        ENDIF                                                           FH    37
        FH=F                                                            FH    38
        END                                                             FH    39
      SUBROUTINE FORMFA(SW,MZ,MT,ZB)                                    FORMFA 2
C  WEAK Z0-B-B  FORM FACTOR , TOP CONTRIBUTIONS ONLY                    FORMFA 3
      IMPLICIT REAL*8(A-Z)                                              FORMFA 4
      INTEGER J                                                         FORMFA 5
      COMPLEX*16 TV,ZB,H1,H2,H3,                                        FORMFA 6
     .           C0,C1P,C1M,C20,C2P,C2M,H4                              FORMFA 7
      DIMENSION TV(6)                                                   FORMFA 8
C                                                                       FORMFA 9
      MB=4.5D0                                                          FORMFA10
      MF=MB                                                             FORMFA11
      XMF=MF*MF                                                         FORMFA12
      XMZ=MZ*MZ                                                         FORMFA13
      XMT=MT*MT                                                         FORMFA14
      S=XMZ                                                             FORMFA15
C  SOME COMBINATIONS OF COUPLING CONSTANTS                              FORMFA16
C  (REDUNDANT VARIABLES ARE RELICTS FROM OTHER VERSIONS,                FORMFA17
C   KEPT ONLY BECAUSE OF LACK OF TIME)                                  FORMFA18
      QE=-1D0                                                           FORMFA19
      QF=2D0/3D0                                                        FORMFA20
      SW4=.25D0/SW                                                      FORMFA21
      CW=1.D0-SW                                                        FORMFA22
      SW1=DSQRT(SW)                                                     FORMFA23
      CW1=DSQRT(CW)                                                     FORMFA24
      MW=MZ*CW1                                                         FORMFA25
      XMW=MW*MW                                                         FORMFA26
      CS=CW1*SW1                                                        FORMFA27
      A=-1.D0/(4.D0*SW1*CW1)                                            FORMFA28
      V=(1.D0-4.D0*SW)*A                                                FORMFA29
      VU=(8.D0/3.D0*SW-1.D0)*A                                          FORMFA30
      VD=(1.D0-4.D0/3.D0*SW)*A                                          FORMFA31
      AU=-A                                                             FORMFA32
      AD=A                                                              FORMFA33
      VF=VU                                                             FORMFA34
      AF=AU                                                             FORMFA35
      VF2=VF**2                                                         FORMFA36
      AF2=AF**2                                                         FORMFA37
      WF=VF2+AF2                                                        FORMFA38
      WF1=VF2-AF2                                                       FORMFA39
      UF=2.D0*VF*AF                                                     FORMFA40
      AB= -AF                                                           FORMFA41
      VB=(1.D0-4.D0/3.D0*SW)*AB                                         FORMFA42
C---------------------------------------------------------------        FORMFA43
C                                                                       FORMFA44
C  FINITE  PART OF THE FERMION RENORMALIZATION CONSTANT                 FORMFA45
C                                                                       FORMFA46
      CALL BQUER1(XMF,MT,MW,B0TW,B1TW,P0TW,P1TW)                        FORMFA47
      ZLEFT=(B1TW+XMF*P1TW)/2D0/SW*(2D0+MT*MT/XMW)                      FORMFA48
C----------------------------------------------------------------       FORMFA49
C                                                                       FORMFA50
C  NOW THE CONTRIBUTION OF EACH DIAGRAM IS COMPUTED:                    FORMFA51
C                                                                       FORMFA52
C--------------------------------------------------------------         FORMFA53
C------------ W EXCHANGE  -------------------------------------         FORMFA54
      CALL CFUNC(S,MT,MT,MW,C0,C1P,C1M,C20,C2P,C2M)                     FORMFA55
      H1=4.D0*C20-2.D0-2.D0*S*C2P+2.D0*S*C2M+4.D0*S*C1P                 FORMFA56
     1   -2.D0*S*C0  +.5D0+2.D0*DLOG(MW/MT)                             FORMFA57
      H2=-2D0*XMT*C0                                                    FORMFA58
C                  Z0                                                   FORMFA59
      GV =(VU+AU)*SW4                                                   FORMFA60
      GA= (VU-AU)*SW4                                                   FORMFA61
      TV(1)=GV*H1+GA*H2                                                 FORMFA62
C-------------------------------------------------------                FORMFA63
C----------  PHI EXCHANGE  -----------------------------                FORMFA64
      H1=2.D0*C20-.5D0-S*C2P+S*C2M-.25D0                                FORMFA65
     1   +DLOG(MW/MT)                                                   FORMFA66
      H2=-XMT*C0                                                        FORMFA67
C                 Z0                                                    FORMFA68
      L1=(VU-AU)*XMT/XMW*SW4                                            FORMFA69
      L2=(VU+AU)*XMT/XMW*SW4                                            FORMFA70
      TV(2)=L1*H1+L2*H2                                                 FORMFA71
C-----------------------------------------------------------------      FORMFA72
C----------  W+ W- EXCHANGE  -------------------------------------      FORMFA73
      CALL CFUNC(S,MW,MW,MT,C0,C1P,C1M,C20,C2P,C2M)                     FORMFA74
      H1=12.D0*C20-2.D0-2.D0*S*C2P+2.D0*S*C2M+4.D0*S*C1P+.5D0           FORMFA75
C               Z0                                                      FORMFA76
      L1=-SW4*CW1/SW1                                                   FORMFA77
      TV(3)=L1*H1                                                       FORMFA78
C------------------------------------------------------                 FORMFA79
C-----------  PHI+ PHI- EXCHANGE  ---------------------                 FORMFA80
      H1=2.D0*C20-.25D0                                                 FORMFA81
C              Z0                                                       FORMFA82
      L1=(SW-CW)/8.D0/CS/SW*XMT/XMW                                     FORMFA83
      TV(4)=L1*H1                                                       FORMFA84
C----------------------------------------------------------             FORMFA85
C----------- W(DOWN) PHI(UP)  EXCHANGE-------------------               FORMFA86
C     CALL CFUNC(S,MW,MW,MT,C0,C1P,C1M,C20,C2P,C2M)                     FORMFA87
C                Z0                                                     FORMFA88
      TV(5)=-XMT/4D0/CS*C0                                              FORMFA89
C----------- PHI(DOWN) - W(UP)  EXCHANGE----------------------          FORMFA90
C            Z0                                                         FORMFA91
      TV(6)=TV(5)                                                       FORMFA92
C-------------------------------------------------------------          FORMFA93
C                                                                       FORMFA94
C   NOW THE SINGLE CONTRIBUTIONS ARE SUMMED UP FOR THE Z0               FORMFA95
C   FORMFACTORS.                                                        FORMFA96
C   FIRST THE FINITE PART FROM THE COUNTERTERM FOR                      FORMFA97
C   THE LEFT HANDED FORMFACTOR                                          FORMFA98
      ZB=(2D0/3D0*SW-1)/4D0/CS*ZLEFT                                    FORMFA99
C   IS USED FOR INITIALIZATION:                                         FORMF100
C   NOW THE DIAGRAMS:                                                   FORMF101
      DO 9 J=1,6                                                        FORMF102
      ZB=ZB+TV(J)                                                       FORMF103
9     CONTINUE                                                          FORMF104
C                                                                       FORMF105
      RETURN                                                            FORMF106
      END                                                               FORMF107
C                                                                       FORMF108
C**********************************************************8            FORMF109
C                                                                       FORMF110
      SUBROUTINE CFUNC(S,M1,M2,M3,C0,C1P,C1M,C20,C2P,C2M)               CFUNC  2
C  DEFINITION OF THE INVARIANT FUNCTIONS IN THE 3-POINT INTEGRALS       CFUNC  3
C  WITH EQUAL EXTERNAL MASSES MF.                                       CFUNC  4
C  S = MOMENTUM TRANSFER; M1,M2,M3 ARE THE INTERNAL MASSES              CFUNC  5
C                                                                       CFUNC  6
C                                   P2 ( = PF)                          CFUNC  7
C                        M2   .                                         CFUNC  8
C                                                                       CFUNC  9
C               S .     .       M3                                      CFUNC 10
C                                                                       CFUNC 11
C                        M1   .                                         CFUNC 12
C                                  P1 ( = -PF)                          CFUNC 13
C                                                                       CFUNC 14
C                                                                       CFUNC 15
C  C0 = SCALAR INTEGRAL, C1P/M = C1+/-,  C2P/M= C2+/-                   CFUNC 16
C                                                                       CFUNC 17
      IMPLICIT REAL*8(A-Z)                                              CFUNC 18
      COMPLEX*16 C0, C1P,C1M,C20,C2P,C2M,CSCAL,B0S12,B031,B032,         CFUNC 19
     &           B132,B131,B1S12,C1,C2                                  CFUNC 20
      MB=4.5D0                                                          CFUNC 21
      MF=MB                                                             CFUNC 22
      XMF=MF*MF                                                         CFUNC 23
      C0=CSCAL(S,M1,M2,M3)                                              CFUNC 24
      CALL BQUER(S,M1,M2,B0S12,B1S12)                                   CFUNC 25
      CALL BQUER(XMF,M3,M1,B031,B131)                                   CFUNC 26
      CALL BQUER(XMF,M3,M2,B032,B132)                                   CFUNC 27
C                                                                       CFUNC 28
C  B0JK := B0(XMF,MJ,MK),  B1JK:= B1(XMF,MF,MK)                         CFUNC 29
C  B0S12 := B0(S,M1,M2)                                                 CFUNC 30
C                                                                       CFUNC 31
C  THE C1 FUNCTIONS:                                                    CFUNC 32
C                                                                       CFUNC 33
      MS=4.D0*XMF-S                                                     CFUNC 34
      XM1=M1**2                                                         CFUNC 35
      XM2=M2**2                                                         CFUNC 36
      XM3=M3**2                                                         CFUNC 37
      C1=.5D0*DLOG(XM3/M1/M2)+B0S12-.5D0*(B031+B032)                    CFUNC 38
     &   +(XMF+XM3-XM1/2.D0-XM2/2.D0) *C0                               CFUNC 39
      C1P=C1/MS                                                         CFUNC 40
      C1M=(DLOG(M2/M1)+B031-B032+(XM2-XM1)*C0)/2.D0/S                   CFUNC 41
C                                                                       CFUNC 42
C  THE C2 FUNCTIONS:                                                    CFUNC 43
C                                                                       CFUNC 44
      C2=1.D0+B0S12+(XM1+XM2-2.D0*XM3-2.D0*XMF)*C1P+(XM1-XM2)*C1M       CFUNC 45
     &   +2.D0*XM3*C0                                                   CFUNC 46
      C20=C2/4.D0                                                       CFUNC 47
      C2=                     (B131+B132+2.D0*B0S12-.5D0)/4.D0          CFUNC 48
     &   +(2.D0*XM3-XM1-XM2+2.D0*XMF)/2.D0*C1P-C20                      CFUNC 49
      C2P=C2/MS                                                         CFUNC 50
      C2=                    -(B131+B132-.5D0)/4.D0                     CFUNC 51
     &   -(XM1-XM2)/2.D0*C1M-C20                                        CFUNC 52
      C2M=C2/S                                                          CFUNC 53
C                                                                       CFUNC 54
      RETURN                                                            CFUNC 55
      END                                                               CFUNC 56
C                                                                       CFUNC 57
C********************************************************               CFUNC 58
C                                                                       CFUNC 59
      SUBROUTINE BQUER(S,M1,M2,B0,B1)                                   BQUER  2
C                                                                       BQUER  3
C  B0 AND B1 ARE THE (FINITE) INARIANT FUNCTIONS IN THE                 BQUER  4
C  2-POINT INTEGRALS.                                                   BQUER  5
C  S = Q**2;  M1,M2 ARE THE INTERNAL MASSES                             BQUER  6
C                                                                       BQUER  7
      IMPLICIT REAL*8(A-Z)                                              BQUER  8
      EXTERNAL FH,GH                                                    BQUER  9
      COMPLEX*16 B0,B1,CF                                               BQUER 10
      XM1=M1**2                                                         BQUER 11
      XM2=M2**2                                                         BQUER 12
      LM=DLOG(M2/M1)                                                    BQUER 13
      CF=DCMPLX( FH(S,M1,M2),GH(S,M1,M2))                               BQUER 14
      IF (M1.EQ.M2) GOTO 10                                             BQUER 15
      B0=1.D0-(XM2+XM1)/(XM2-XM1)*LM+CF                                 BQUER 16
      B1=-.25D0+XM1/(XM2-XM1)*LM+(XM2-XM1-S)/2.D0/S*CF                  BQUER 17
      GOTO 20                                                           BQUER 18
10    CONTINUE                                                          BQUER 19
      B0=CF                                                             BQUER 20
      B1=-.5D0*CF                                                       BQUER 21
20    RETURN                                                            BQUER 22
      END                                                               BQUER 23
C                                                                       BQUER 24
C********************************************************               BQUER 25
C                                                                       BQUER 26
      SUBROUTINE BQUER1(X,M1,M2,B0,B1,P0,P1)                            BQUER1 2
C                                                                       BQUER1 3
C  B0 AND B1 ARE THE (FINITE) INARIANT FUNCTIONS IN THE                 BQUER1 4
C  2-POINT INTEGRALS, P0 AND P1 THEIR DERIVATIVES.                      BQUER1 5
C  REAL PARTS ONLY, NEEDED FOR FERMION RENORMALIZATION.                 BQUER1 6
C  X = Q**2;  M1,M2 ARE THE INTERNAL MASSES                             BQUER1 7
C                                                                       BQUER1 8
      IMPLICIT REAL*8(A-Z)                                              BQUER1 9
      EXTERNAL FH                                                       BQUER110
      LM=DLOG(M2/M1)                                                    BQUER111
      CF=FH(X,M1,M2)                                                    BQUER112
      XM1=M1**2                                                         BQUER113
      XM2=M2**2                                                         BQUER114
      IF (M1.EQ.M2) GOTO 10                                             BQUER115
      B0=1.D0-(XM2+XM1)/(XM2-XM1)*LM+CF                                 BQUER116
      B1=-.25D0+XM1/(XM2-XM1)*LM+(XM2-XM1-X)/2.D0/X*CF                  BQUER117
      GOTO 20                                                           BQUER118
10    B0=CF                                                             BQUER119
      B1=-B0/2.D0                                                       BQUER120
20    CONTINUE                                                          BQUER121
C                                                                       BQUER122
C   CALCULATION OF THE DERIVATIVES:                                     BQUER123
C                                                                       BQUER124
      SM=XM1+XM2                                                        BQUER125
      DM=XM2-XM1                                                        BQUER126
      SM12=(M1+M2)**2                                                   BQUER127
      DM12=(M1-M2)**2                                                   BQUER128
      S=DSQRT(DABS(SM12-X))                                             BQUER129
      D=DSQRT(DABS(DM12-X))                                             BQUER130
      KLAM=(DM*DM/(X*X)-SM/X)/S/D                                       BQUER131
      ANF=-1.D0/X+DM/(X*X)*LM                                           BQUER132
      IF (X.LT.DM12) GOTO 30                                            BQUER133
      IF (X.GT.SM12) GOTO 40                                            BQUER134
      FACT=2.D0*DATAN(D/S)                                              BQUER135
      GOTO 41                                                           BQUER136
30    EPS=1.D0                                                          BQUER137
      FACT=DLOG(DABS((S+D)/(S-D)))                                      BQUER138
      GOTO 41                                                           BQUER139
40    EPS=-1.D0                                                         BQUER140
      FACT=-DLOG(DABS((S+D)/(S-D)))                                     BQUER141
41    CONTINUE                                                          BQUER142
      DERIV=ANF-KLAM*FACT                                               BQUER143
      P0=DERIV                                                          BQUER144
      B1P=.5D0-LM-2.D0*B1-B0+(XM2-XM1-X)*DERIV                          BQUER145
      P1=B1P/2.D0/X                                                     BQUER146
      RETURN                                                            BQUER147
      END                                                               BQUER148
C                                                                       BQUER149
C**************************************************************         BQUER150
C                                                             *         BQUER151
C  THE SCALAR VERTEX INTEGRAL WITH EQUAL EXTERNAL MASSES MF   *         BQUER152
C                                                             *         BQUER153
C**************************************************************         BQUER154
C                                                                       BQUER155
      COMPLEX FUNCTION CSCAL*16(S,M1,M2,M3)                             CSCAL  2
C                                                                       CSCAL  3
C  S = MOMENTUM TRANSFER; M1,M2,M3  ARE THE INTERNAL MASSES             CSCAL  4
C                                                                       CSCAL  5
      IMPLICIT REAL*8 (A-Y)                                             CSCAL  6
      COMPLEX*16 Z1,Z2,Z11,Z12,Z21 ,Z22,CL1,CL2,CL3,CSPEN,SPENCE,       CSCAL  7
     &           INT,DCMPLX                                             CSCAL  8
      MF=4.5D0                                                          CSCAL  9
      XMF=MF*MF                                                         CSCAL 10
C.........XMF ETC.   ARE FERMION AND BOSON MASSES SQUARED               CSCAL 11
      XM1=M1*M1                                                         CSCAL 12
      XM2=M2*M2                                                         CSCAL 13
      XM3=M3*M3                                                         CSCAL 14
C                                                                       CSCAL 15
C..T'HOOFT-VELTMAN PARAMETERS                                           CSCAL 16
      A=1.D0                                                            CSCAL 17
      B=XMF/S                                                           CSCAL 18
      C=-1.D0                                                           CSCAL 19
      D=XM1-XM2-S                                                       CSCAL 20
      E=XM3-XM1-XMF+S                                                   CSCAL 21
      F=XM2/S                                                           CSCAL 22
      D=D/S                                                             CSCAL 23
      E=E/S                                                             CSCAL 24
C..DISCRIMINANTE FOR ALPHA-EQUATION                                     CSCAL 25
      DISC=C*C-4.D0*A*B                                                 CSCAL 26
      IF (DISC .LT. 0.D0) GOTO 500                                      CSCAL 27
      AL=(-C-DSQRT(DISC))/2.D0/B                                        CSCAL 28
      NENNER=C+2.D0*AL*B                                                CSCAL 29
C..THE FIRST INTEGRAL.............................................      CSCAL 30
      Y0=-(D+E*AL+2.D0*A+C*AL)/NENNER                                   CSCAL 31
      Y01=Y0-1.D0                                                       CSCAL 32
      D1=(C+E)**2-4.D0*B*(A+D+F)                                        CSCAL 33
      X1=-(C+E)/2.D0/B                                                  CSCAL 34
      IF (D1.GT.0.D0) GOTO 10                                           CSCAL 35
C.......COMPLEX ZEROES OF LOGARITHMS                                    CSCAL 36
      SQ1=DSQRT(-D1)                                                    CSCAL 37
      X2=SQ1/2.D0/B                                                     CSCAL 38
      Z1=DCMPLX(X1,X2)                                                  CSCAL 39
      Z2=DCMPLX(X1,-X2)                                                 CSCAL 40
      Z11=Y0/(Y0-Z1)                                                    CSCAL 41
      Z12=Y01/(Y0-Z1)                                                   CSCAL 42
      Z21=Y0/(Y0-Z2)                                                    CSCAL 43
      Z22=Y01/(Y0-Z2)                                                   CSCAL 44
      CL1=SPENCE(Z11)-SPENCE(Z12)+SPENCE(Z21)-SPENCE(Z22)               CSCAL 45
      GOTO 15                                                           CSCAL 46
10    CONTINUE                                                          CSCAL 47
C........REAL ZEROES                                                    CSCAL 48
      SQ1=DSQRT(D1)                                                     CSCAL 49
      X2=SQ1/2.D0/B                                                     CSCAL 50
      Y1=X1+X2                                                          CSCAL 51
      Y2=X1-X2                                                          CSCAL 52
      SIG1= Y0/DABS(Y0)                                                 CSCAL 53
      SIG2= Y01/DABS(Y01)                                               CSCAL 54
      Y11=Y0/(Y0-Y1)                                                    CSCAL 55
      Y12=Y01/(Y0-Y1)                                                   CSCAL 56
      Y21=Y0/(Y0-Y2)                                                    CSCAL 57
      Y22=Y01/(Y0-Y2)                                                   CSCAL 58
      CL1=CSPEN(Y11,SIG1)-CSPEN(Y12,SIG2)+CSPEN(Y21,-SIG1)              CSCAL 59
     &   -CSPEN(Y22,-SIG2)                                              CSCAL 60
15    CONTINUE                                                          CSCAL 61
C..THE SECOND INTEGRAL............................................      CSCAL 62
      Y0=-(D+E*AL)/NENNER/(1.D0-AL)                                     CSCAL 63
      Y01=Y0-1.D0                                                       CSCAL 64
      D2=(E+D)**2-4.D0*F*(A+B+C)                                        CSCAL 65
      X1=-(E+D)/2.D0/(A+B+C)                                            CSCAL 66
      IF(D2.GT.0.D0) GOTO 20                                            CSCAL 67
C.......COMPLEX ZEROES OF LOGARITHMS                                    CSCAL 68
      SQ2=DSQRT(-D2)                                                    CSCAL 69
      X2=SQ2/2.D0/(A+B+C)                                               CSCAL 70
      Z1=DCMPLX(X1,X2)                                                  CSCAL 71
      Z2=DCMPLX(X1,-X2)                                                 CSCAL 72
      Z11=Y0/(Y0-Z1)                                                    CSCAL 73
      Z12=Y01/(Y0-Z1)                                                   CSCAL 74
      Z21=Y0/(Y0-Z2)                                                    CSCAL 75
      Z22=Y01/(Y0-Z2)                                                   CSCAL 76
      CL2=SPENCE(Z11)-SPENCE(Z12)+SPENCE(Z21)-SPENCE(Z22)               CSCAL 77
      GOTO 25                                                           CSCAL 78
20    CONTINUE                                                          CSCAL 79
C........REAL ZEROES                                                    CSCAL 80
      X2=DSQRT(D2)/2.D0/(A+B+C)                                         CSCAL 81
      Y1=X1+X2                                                          CSCAL 82
      Y2=X1-X2                                                          CSCAL 83
      Y11=Y0/(Y0-Y1)                                                    CSCAL 84
      Y12=Y01/(Y0-Y1)                                                   CSCAL 85
      Y21=Y0/(Y0-Y2)                                                    CSCAL 86
      Y22=Y01/(Y0-Y2)                                                   CSCAL 87
      SIG1= Y0/DABS(Y0)                                                 CSCAL 88
      SIG2= Y01/DABS(Y01)                                               CSCAL 89
      CL2=CSPEN(Y11,SIG1)-CSPEN(Y12,SIG2)+CSPEN(Y21,-SIG1)              CSCAL 90
     &   -CSPEN(Y22,-SIG2)                                              CSCAL 91
25    CONTINUE                                                          CSCAL 92
C..THE THIRD INTEGRAL............................................       CSCAL 93
      Y0=(D+E*AL)/NENNER/AL                                             CSCAL 94
      Y01=Y0-1.D0                                                       CSCAL 95
      D3=D*D-4.D0*A*F                                                   CSCAL 96
      X1=-D/2.D0/A                                                      CSCAL 97
      IF (D3.GT.0.D0) GOTO 30                                           CSCAL 98
C........COMPLEX ZEROES OF LOGARITHMS                                   CSCAL 99
      SQ3=DSQRT(-D3)                                                    CSCAL100
      X2=SQ3/2.D0/A                                                     CSCAL101
      Z1=DCMPLX(X1,X2)                                                  CSCAL102
      Z2=DCMPLX(X1,-X2)                                                 CSCAL103
      Z11=Y0/(Y0-Z1)                                                    CSCAL104
      Z12=Y01/(Y0-Z1)                                                   CSCAL105
      Z21=Y0/(Y0-Z2)                                                    CSCAL106
      Z22=Y01/(Y0-Z2)                                                   CSCAL107
      CL3=SPENCE(Z11)-SPENCE(Z12)+SPENCE(Z21)-SPENCE(Z22)               CSCAL108
      GOTO 35                                                           CSCAL109
30    CONTINUE                                                          CSCAL110
C........REAL ZEROES                                                    CSCAL111
      X2=DSQRT(D3)/2.D0/A                                               CSCAL112
      Y1=X1+X2                                                          CSCAL113
      Y2=X1-X2                                                          CSCAL114
 31   FORMAT(1H ,3E12.4)                                                CSCAL115
      Y11=Y0 /(Y0-Y1)                                                   CSCAL116
      Y12=Y01/(Y0-Y1)                                                   CSCAL117
      Y21=Y0/(Y0-Y2)                                                    CSCAL118
      Y22=Y01/(Y0-Y2)                                                   CSCAL119
      SIG1= Y0/DABS(Y0)                                                 CSCAL120
      SIG2= Y01/DABS(Y01)                                               CSCAL121
      CL3=CSPEN(Y11,SIG1)-CSPEN(Y12,SIG2)+CSPEN(Y21,-SIG1)              CSCAL122
     &   -CSPEN(Y22,-SIG2)                                              CSCAL123
35    CONTINUE                                                          CSCAL124
C..SUMMATION OF THE 3 INTEGRALS ....................................    CSCAL125
      INT=-CL1+CL2-CL3                                                  CSCAL126
      CSCAL=INT/NENNER/S                                                CSCAL127
      GOTO 501                                                          CSCAL128
500   CONTINUE                                                          CSCAL129
C..ERROR MESSAGE FOR COMPLEX ALPHA................................      CSCAL130
      WRITE(6,21)                                                       CSCAL131
21    FORMAT(1H ,'  I CANNOT HANDLE A COMPLEX ALPHA')                   CSCAL132
501   RETURN                                                            CSCAL133
      END                                                               CSCAL134
C                                                                       CSCAL135
C*******************************************************************    CSCAL136
C                                                                       CSCAL137
      COMPLEX FUNCTION CSPEN*16(X,SIG)                                  CSPEN  2
      IMPLICIT REAL*8(A-Y)                                              CSPEN  3
      COMPLEX*16 Z,CPI,SPENCE,ZX                                        CSPEN  4
      PI=3.1415926536D0                                                 CSPEN  5
      PI6=PI*PI/6.D0                                                    CSPEN  6
      CPI=DCMPLX(0.D0,PI)                                               CSPEN  7
      IF (X.LT.1.D0) GOTO 10                                            CSPEN  8
      IF(X.EQ.1.D0) GOTO 11                                             CSPEN  9
      LX=DLOG(X)                                                        CSPEN 10
      X1=1.D0-X                                                         CSPEN 11
      LX1=DLOG(-X1)                                                     CSPEN 12
      Z=DCMPLX(X1,0.D0)                                                 CSPEN 13
      IF (SIG.GT.0.D0) GOTO 5                                           CSPEN 14
      CSPEN=-SPENCE(Z)+PI6-LX*(LX1+CPI)                                 CSPEN 15
      GOTO 20                                                           CSPEN 16
5     CSPEN=-SPENCE(Z)+PI6-LX*(LX1-CPI)                                 CSPEN 17
      GOTO 20                                                           CSPEN 18
10    ZX=DCMPLX(X,0.D0)                                                 CSPEN 19
      CSPEN=SPENCE(ZX)                                                  CSPEN 20
      GOTO 20                                                           CSPEN 21
11    CSPEN=DCMPLX(PI6,0.D0)                                            CSPEN 22
20    RETURN                                                            CSPEN 23
      END                                                               CSPEN 24
C                                                                       CSPEN 25
C**************************************************************         CSPEN 26
C                                                                       CSPEN 27
      COMPLEX FUNCTION CLN*16(X,SIG)                                    CLN    2
      IMPLICIT REAL*8(A-Z)                                              CLN    3
      COMPLEX*16 Z,CPI,CDLOG                                            CLN    4
      PI=3.1415926536D0                                                 CLN    5
      CPI=DCMPLX(0.D0,PI)                                               CLN    6
      IF (X.GT.0.D0) GOTO 10                                            CLN    7
      X1=-X                                                             CLN    8
      IF (SIG.GT.0.D0) GOTO 5                                           CLN    9
      CLN=DLOG(X1)-CPI                                                  CLN   10
      GOTO 20                                                           CLN   11
5     CLN=DLOG(X1)+CPI                                                  CLN   12
      GOTO 20                                                           CLN   13
10    Y=DLOG(X)                                                         CLN   14
      CLN=DCMPLX(Y,0.D0)                                                CLN   15
20    RETURN                                                            CLN   16
      END                                                               CLN   17
      DOUBLE PRECISION FUNCTION DF(S,MA,MB)                             DF     2
*****   Derivative of the real part of the function F(s,ma,mb).    *****DF     3
      IMPLICIT REAL*8(A-Z)                                              DF     4
      PARAMETER(EPS=1.D-6)                                              DF     5
      IF(S.LT.(MA-MB)**2) THEN                                          DF     6
         RPLUS=SQRT((MA+MB)**2-S)                                       DF     7
         RMIN =SQRT((MA-MB)**2-S)                                       DF     8
         DF=( (MB**2-MA**2)*LOG(MB/MA)/S-                               DF     9
     .   ((RMIN**2+2.D0*RMIN**2*RPLUS**2/S+RPLUS**2)/(2.D0*RMIN*RPLUS))*DF    10
     .           LOG((RMIN+RPLUS)**2/(4.D0*MA*MB))  -1.D0 )/S           DF    11
      ELSEIF(S.LT.(MA+MB)**2) THEN                                      DF    12
         RPLUS=SQRT((MA+MB)**2/S-1.D0)                                  DF    13
         RMIN =SQRT(1.D0-(MA-MB)**2/S)                                  DF    14
         DF=( (MB**2-MA**2)*LOG(MB/MA)/S+                               DF    15
     .        ((RMIN**2+2.D0*RMIN**2*RPLUS**2-RPLUS**2)/(RMIN*RPLUS))*  DF    16
     .           ATAN(RMIN/RPLUS)  -1.D0 )/S                            DF    17
      ELSE                                                              DF    18
         RPLUS=SQRT(S-(MA+MB)**2)                                       DF    19
         RMIN =SQRT(S-(MA-MB)**2)                                       DF    20
         DF=( (MB**2-MA**2)*LOG(MB/MA)/S-                               DF    21
     .   ((RMIN**2-2.D0*RMIN**2*RPLUS**2/S+RPLUS**2)/(2.D0*RMIN*RPLUS))*DF    22
     .           LOG((RMIN+RPLUS)**2/(4.D0*MA*MB))  -1.D0 )/S           DF    23
*        Y=SQRT(S-4.D0*MA**2)                                           DF    24
*        Z=SQRT(S)                                                      DF    25
*        DF=( (Y**2-S)*LOG((Z+Y)/(Z-Y))/(2.D0*Z*Y)-1.D0)/S              DF    26
      ENDIF                                                             DF    27
      END                                                               DF    28
      DOUBLE PRECISION FUNCTION PIZZ(S)                                 PIZZ   2
*********************************************************************** PIZZ   3
* Derivative of the real part of the 1-loop Z selfenergy.             * PIZZ   4
* DF is the derivative of the function F with respect to s.           * PIZZ   5
* A large s-independent part comes from the renormalisation constant  * PIZZ   6
* SUBZZ which is calculated in a separate subprogram, RNORM and put   * PIZZ   7
* into the common RENORM                                              * PIZZ   8
*                                                                     * PIZZ   9
*                Author:  Gerrit Burgers        CERN/TH               * PIZZ  10
*********************************************************************** PIZZ  11
      IMPLICIT DOUBLE PRECISION(A-Z)                                    PIZZ  12
      COMMON /RENORM/ DELTAR, RESW0, RESWW, RESZZ, SUBZZ, SUBWW, SUBGZ  RENORM 2
      REAL*8          DELTAR, RESW0, RESWW, RESZZ, SUBZZ, SUBWW, SUBGZ  RENORM 3
      COMMON/COUPL/ SW,CW,SW1,CW1, V,A,VU,VD                            COUPL  2
      REAL*8        SW,CW,SW1,CW1, V,A,VU,VD                            COUPL  3
      COMMON /HOLBOS/MZ,MW,MH                                           HOLBOS 2
      REAL*8         MZ,MW,MH                                           HOLBOS 3
      COMMON /HAD/XU,XD,XS,XC,XB,MT                                     HAD    2
      REAL*8      XU,XD,XS,XC,XB,MT                                     HAD    3
* One can either pass the hadron masses via the common (here MT)        PIZZ  17
* or via the parmeter statement (here MU,MD,MS,MC and MB)               PIZZ  18
      PARAMETER(PI=3.1415926535897932D0, ALFINV=137.036D0)              PIZZ  19
      PARAMETER(ME=0.5110034D-3,MMU=0.10565943D0,MTAU=1.7842D0,         PIZZ  20
     .          MU=0.04145D0,MD=0.04146D0,MS=0.150D0,                   PIZZ  21
     .          MC=1.5D0,MB=4.5D0)                                      PIZZ  22
      Z  = MZ**2                                                        PIZZ  23
      W  = MW**2                                                        PIZZ  24
      H  = MH**2                                                        PIZZ  25
      PIZZ=                                                             PIZZ  26
     . 2.D0*A**2*S*(DF(S,ME,ME)+DF(S,MMU,MMU)+DF(S,MTAU,MTAU))/3.D0+    PIZZ  27
     . 2.D0*A**2*(FH(S,ME,ME)+FH(S,MMU,MMU)+FH(S,MTAU,MTAU)-1.D0)/3.D0  PIZZ  28
      PIZZ= PIZZ                                                        PIZZ  29
     .+(((V**2+A**2)*(S+2.D0*ME**2)-6.D0*ME**2*A**2)*DF(S,ME,ME)        PIZZ  30
     . +((V**2+A**2)*(S+2.D0*MMU**2)-6.D0*MMU**2*A**2)*DF(S,MMU,MMU)    PIZZ  31
     .+((V**2+A**2)*(S+2.D0*MTAU**2)-6.D0*MTAU**2*A**2)*DF(S,MTAU,MTAU) PIZZ  32
     .+(V**2+A**2)*(FH(S,ME,ME)+FH(S,MMU,MMU)+FH(S,MTAU,MTAU)-1.D0))/3D0PIZZ  33
      PIZZ= PIZZ                                                        PIZZ  34
     .+(((VU**2+A**2)*(S+2.D0*MU**2)-6.D0*MU**2*A**2)*DF(S,MU,MU)       PIZZ  35
     . +((VU**2+A**2)*(S+2.D0*MC**2)-6.D0*MC**2*A**2)*DF(S,MC,MC)       PIZZ  36
     . +((VU**2+A**2)*(S+2.D0*MT**2)-6.D0*MT**2*A**2)*DF(S,MT,MT)       PIZZ  37
     . +(VU**2+A**2)*(FH(S,MU,MU)+FH(S,MC,MC)+FH(S,MT,MT)-1.D0))        PIZZ  38
      PIZZ= PIZZ                                                        PIZZ  39
     .+(((VD**2+A**2)*(S+2.D0*MD**2)-6.D0*MD**2*A**2)*DF(S,MD,MD)       PIZZ  40
     . +((VD**2+A**2)*(S+2.D0*MS**2)-6.D0*MS**2*A**2)*DF(S,MS,MS)       PIZZ  41
     . +((VD**2+A**2)*(S+2.D0*MB**2)-6.D0*MB**2*A**2)*DF(S,MB,MB)       PIZZ  42
     . +(VD**2+A**2)*(FH(S,MD,MD)+FH(S,MS,MS)+FH(S,MB,MB)-1.D0))        PIZZ  43
      PIZZ= PIZZ                                                        PIZZ  44
     .+((CW**2*(-10.D0*S-20.D0*W)+(CW-SW)**2*(2.D0*W+S/4.D0)+3.D0*W)*   PIZZ  45
     .  DF(S,MW,MW)                                                     PIZZ  46
     . +(-10.D0*CW**2+(CW-SW)**2/4.D0)*FH(S,MW,MW)                      PIZZ  47
     . +(-2.D0*CW**2/3.D0+(CW-SW)**2/6.D0) )*4.D0*A**2/3.D0             PIZZ  48
      PIZZ= PIZZ                                                        PIZZ  49
     .+((10.D0*Z-2.D0*H+S+(H-Z)**2/S)*DF(S,MH,MZ)                       PIZZ  50
     . +(1.D0-(H-Z)**2/S**2)*FH(S,MH,MZ)                                PIZZ  51
     . +(1.D0-(H+Z)*LOG(MH/MZ)/(H-Z)-LOG(MH*MZ/W))+2.D0/3.D0)*A**2/3    PIZZ  52
      PIZZ= PIZZ/(PI*ALFINV)                                            PIZZ  53
* renormalisation                                                       PIZZ  54
      PIZZ= PIZZ  +   SUBZZ                                             PIZZ  55
      END                                                               PIZZ  56
      COMPLEX FUNCTION L2*16(X)                                         L2     2
      IMPLICIT DOUBLE PRECISION (A-Z)                                   L2     3
      PARAMETER(PI=3.1415926535897932D0,Z2=1.64493406684823D0)          L2     4
* Statement function (Sp(u)=Li2(x), u=-log(1-x) ):                      L2     5
      SP(U)=((((((-1.D0/10886400.D0)*U**2+1.D0/211680.D0)*U**2-         L2     6
     .         1.D0/3600)*U**2+1.D0/36.D0)*U-1.D0/4.D0)*U+1.D0)*U       L2     7
*                                                                       L2     8
      REL2 = -7.D0/2.D0-2.D0*X-(X+3.D0/2.D0)*LOG(X**2)                  L2     9
      IF(X.GT.1) THEN                                                   L2    10
        U    = -LOG(1.D0+1.D0/X)                                        L2    11
        IML2 = -PI*(2.D0*(1.D0+X)**2*U+3.D0+2.D0*X)                     L2    12
        REL2 =  REL2+2.D0*(1.D0+X)**2*(-SP(U)-U*LOG(X))                 L2    13
      ELSEIF(X.GT.0.D0) THEN                                            L2    14
        U    = -LOG(1.D0+X)                                             L2    15
        U1   =  LOG(X)                                                  L2    16
        IML2 = -PI*(2.D0*(1.D0+X)**2*(U+LOG(X))+3.D0+2.D0*X)            L2    17
        REL2 =  REL2+2.D0*(1.D0+X)**2*(SP(U)+Z2-U1**2/2.D0-U*U1)        L2    18
      ELSEIF(X.GT.-1.D0/2.D0) THEN                                      L2    19
        U    = -LOG(1.D0+X)                                             L2    20
        U1   =  LOG(-X)                                                 L2    21
        IML2 =  0.D0                                                    L2    22
        REL2 =  REL2+2.D0*(1.D0+X)**2*(SP(U)-2.D0*Z2-U1**2/2.D0-U*U1)   L2    23
      ELSEIF(X.GT.-2.D0) THEN                                           L2    24
        U    = -LOG(-X)                                                 L2    25
        IML2 =  0.D0                                                    L2    26
        REL2 =  REL2+2.D0*(1.D0+X)**2*(-SP(U)-Z2-U**2/2.D0)             L2    27
      ELSE                                                              L2    28
        U    = -LOG(1.D0+1.D0/X)                                        L2    29
        IML2 =  0.D0                                                    L2    30
        REL2 =  REL2+2.D0*(1.D0+X)**2*(-SP(U)-U*LOG(-X))                L2    31
      ENDIF                                                             L2    32
      L2=DCMPLX(REL2,IML2)                                              L2    33
      END                                                               L2    34
      COMPLEX FUNCTION L3*16(X)                                         L3     2
      IMPLICIT DOUBLE PRECISION (A-Z)                                   L3     3
      PARAMETER(PI=3.1415926535897932D0)                                L3     4
      IF(X.GT.1.D0/4.D0) THEN                                           L3     5
        SQ  =SQRT(4.D0*X-1.D0)                                          L3     6
        F   =ATAN(1.D0/SQ)                                              L3     7
        IML3=0.D0                                                       L3     8
        REL3=(2.5D0-2.D0*X+(4.D0*X+2.D0)*SQ*F-8.D0*X*(X+2.D0)*F**2)/3.D0L3     9
      ELSEIF(X.GT.0.D0) THEN                                            L3    10
        SQ  =SQRT(1.D0-4.D0*X)                                          L3    11
        F   =LOG((1.D0+SQ)/(1.D0-SQ))                                   L3    12
        IML3=-PI*((2.D0*X+1.D0)*SQ+2.D0*X*(X+2.D0)*F)/3.D0              L3    13
        REL3=(2.5D0-2.D0*X+(2.D0*X+1.D0)*SQ*F+                          L3    14
     .                                2.D0*X*(X+2.D0)*(F**2-PI**2))/3.D0L3    15
      ELSE                                                              L3    16
        SQ  =SQRT(1.D0-4.D0*X)                                          L3    17
        F   =LOG((SQ+1.D0)/(SQ-1.D0))                                   L3    18
        IML3=0.D0                                                       L3    19
        REL3=(2.5D0-2.D0*X+(2.D0*X+1.D0)*SQ*F+2.D0*X*(X+2.D0)*F**2)/3.D0L3    20
      ENDIF                                                             L3    21
      L3=DCMPLX(REL3,IML3)                                              L3    22
      END                                                               L3    23
      DOUBLE PRECISION FUNCTION GH(S,MA,MB)                             GH     2
* Imaginary part of the function F(s,ma,mb)                             GH     3
      IMPLICIT DOUBLE PRECISION (A-Z)                                   GH     4
      PARAMETER (PI=3.1415926535897932D0)                               GH     5
      G = 0.D0                                                          GH     6
      IF(S.GT.(MA+MB)**2)  G=PI*SQRT((S-(MA+MB)**2)*(S-(MA-MB)**2))/S   GH     7
      GH=G                                                              GH     8
      END                                                               GH     9
      COMPLEX FUNCTION SPENCE*16(XX)                                    SPENCE 2
C  THE DILOGARITHM FOR GENERAL COMPLEX ARGUMENT.                        SPENCE 3
C  NOT ALLOWED: REAL(XX) GT 1 WITH IMAG(XX)=0.                          SPENCE 4
      IMPLICIT REAL*8(A-Z)                                              SPENCE 5
      INTEGER N                                                         SPENCE 6
      COMPLEX*16 XX,X,Z,D,P,       CDLOG                                SPENCE 7
      DIMENSION A(19)                                                   SPENCE 8
      PI=3.1415926536D0                                                 SPENCE 9
      X=XX                                                              SPENCE10
      XR=DREAL(X)                                                       SPENCE11
      XI=DIMAG(X)                                                       SPENCE12
      IF(XR.NE.1.) GOTO 111                                             SPENCE13
      IF(XI.EQ.0.) GOTO 20                                              SPENCE14
111   CONTINUE                                                          SPENCE15
C    PROJECTION INTO THE CONVERGENCE RADIUS                             SPENCE16
      VOR=1.D0                                                          SPENCE17
      P=DCMPLX(0.D0,0.D0)                                               SPENCE18
      R=DREAL(X)                                                        SPENCE19
      IF (R .LE. 0.5D0) GOTO 1                                          SPENCE20
      P=PI*PI/6.D0- CDLOG(X)*CDLOG(1.D0-X)                              SPENCE21
      VOR=-1.D0                                                         SPENCE22
      X=1.D0-X                                                          SPENCE23
    1 CONTINUE                                                          SPENCE24
      B=CDABS(X)                                                        SPENCE25
      IF (B .LT. 1.D0) GOTO 2                                           SPENCE26
      P=P - (PI*PI/6.D0+ CDLOG(-X)*CDLOG(-X)/2.D0)*VOR                  SPENCE27
      VOR=VOR*(-1.D0)                                                   SPENCE28
      X=1.D0/X                                                          SPENCE29
    2 CONTINUE                                                          SPENCE30
C    CALCULATION OF THE SPENCE FUNCTION                                 SPENCE31
      A(1)=1.D0                                                         SPENCE32
      A(2)=-0.5D0                                                       SPENCE33
      A(3)=1.D0/6.D0                                                    SPENCE34
      A(5)=-1.D0/30.D0                                                  SPENCE35
      A(7)=1.D0/42.D0                                                   SPENCE36
      A(9)=-1.D0/30.D0                                                  SPENCE37
      A(11)=5.D0/66.D0                                                  SPENCE38
      A(13)=-691.D0/2730.D0                                             SPENCE39
      A(15)=7.D0/6.D0                                                   SPENCE40
      A(17)=-3617.D0/510.D0                                             SPENCE41
      A(19)=43867.D0/798.D0                                             SPENCE42
      DO 5 N=2,9,1                                                      SPENCE43
      A(2*N)=0.D0                                                       SPENCE44
    5 CONTINUE                                                          SPENCE45
      Z=(-1.D0)*CDLOG(1.D0-X)                                           SPENCE46
      D=DCMPLX(A(19),0.D0)                                              SPENCE47
      DO 10 N=1,18,1                                                    SPENCE48
      D=D*Z/(20.D0-N) + A(19-N)                                         SPENCE49
   10 CONTINUE                                                          SPENCE50
      D=D*Z                                                             SPENCE51
      SPENCE=D*VOR + P                                                  SPENCE52
      GOTO 30                                                           SPENCE53
   20 CONTINUE                                                          SPENCE54
      SPENCE=PI*PI/6.D0                                                 SPENCE55
   30 CONTINUE                                                          SPENCE56
      RETURN                                                            SPENCE57
      END                                                               SPENCE58
      DOUBLE PRECISION FUNCTION V(S,M)                                  V      2
***************************************************************         V      3
* Real part of the 1-loop QED vacuumpolarisation contribution *         V      4
* from a fermion with mass m                                  *         V      5
*                                                             *         V      6
*   Relation with the function F:                             *         V      7
*     V(s,m) = 1/3 - (1 + 2m**2/s)*F(s,m,m)                   *         V      8
***************************************************************         V      9
      IMPLICIT DOUBLE PRECISION (A-Z)                                   V     10
      IF(S.EQ.0) THEN                                                   V     11
        V = 0.D0                                                        V     12
      ELSE IF(S.LT.0) THEN                                              V     13
        X = SQRT(1.D0-4.D0*M**2/S)                                      V     14
        V = -8.D0/3.D0+X**2-                                            V     15
     .          X*(3.D0-X**2)*LOG(-4.D0*M**2/(S*(1.D0+X)**2))/2.D0      V     16
      ELSE IF(S.LT.4.D0*M**2) THEN                                      V     17
        X = SQRT(4.D0*M**2/S-1.D0)                                      V     18
        V = -8.D0/3.D0-X**2+X*(3.D0+X**2)*ATAN(1.D0/X)                  V     19
      ELSE                                                              V     20
        X = SQRT(1.D0-4.D0*M**2/S)                                      V     21
        V = -8.D0/3.D0+X**2-                                            V     22
     .          X*(3.D0-X**2)*LOG(4.D0*M**2/(S*(1.D0+X)**2))/2.D0       V     23
      ENDIF                                                             V     24
      END                                                               V     25
      DOUBLE PRECISION FUNCTION REPG(S)                                 REPG   2
*********************************************************************   REPG   3
*    Real part of the 1-loop QED vacuumpolarisation                 *   REPG   4
*                                                                   *   REPG   5
*                Author:  Gerrit Burgers        CERN/TH             *   REPG   6
*********************************************************************   REPG   7
      IMPLICIT REAL*8(A-Z)                                              REPG   8
      COMMON /HOLBOS/MZ,MW,MH                                           HOLBOS 2
      REAL*8         MZ,MW,MH                                           HOLBOS 3
      COMMON /HAD/XU,XD,XS,XC,XB,MT                                     HAD    2
      REAL*8      XU,XD,XS,XC,XB,MT                                     HAD    3
* One can either pass the hadron masses via the common (here MT)        REPG  11
* or via the parmeter statement (here MU,MD,MS,MC and MB)               REPG  12
      PARAMETER(PI=3.1415926535897932D0, ALFINV=137.036D0)              REPG  13
      PARAMETER(ME=0.5110034D-3,MMU=0.10565943D0,MTAU=1.7842D0,         REPG  14
     .          MU=0.04145D0,MD=0.04146D0,MS=0.150D0,                   REPG  15
     .          MC=1.5D0,MB=4.5D0)                                      REPG  16
      PARAMETER(QU=4.D0/3.D0,QD=1.D0/3.D0)                              REPG  17
      REPG=         (V(S,ME)+V(S,MMU)+V(S,MTAU)                         REPG  18
     .          +QU*(V(S,MU)+V(S,MC)+ V(S,MT))                          REPG  19
     .          +QD*(V(S,MD)+V(S,MS)+ V(S,MB)))/3.D0                    REPG  20
      REPG= REPG+ (-(3.D0*S+4.D0*MW**2)*V(S,MW)+S/3.D0)/                REPG  21
     .          (4.D0*S+8.D0*MW**2)                                     REPG  22
      REPG= REPG/(PI*ALFINV)                                            REPG  23
      END                                                               REPG  24
*DKIMPG                                                                 REPG  25
      DOUBLE PRECISION FUNCTION IMPG(S)                                 REPG  26
*********************************************************************   REPG  27
*    Imaginary part of the 1-loop QED vacuumpolarisation            *   REPG  28
*                                                                   *   REPG  29
*                Author:  Gerrit Burgers        CERN/TH             *   REPG  30
*********************************************************************   REPG  31
      IMPLICIT REAL*8(A-Z)                                              REPG  32
      COMMON /HOLBOS/MZ,MW,MH                                           HOLBOS 2
      REAL*8         MZ,MW,MH                                           HOLBOS 3
      COMMON /HAD/XU,XD,XS,XC,XB,MT                                     HAD    2
      REAL*8      XU,XD,XS,XC,XB,MT                                     HAD    3
* One can either pass the hadron masses via the common (here MT)        REPG  35
* or via the parmeter statement (here MU,MD,MS,MC and MB)               REPG  36
      PARAMETER(ALFINV=137.036D0)                                       REPG  37
      PARAMETER(ME=0.5110034D-3,MMU=0.10565943D0,MTAU=1.7842D0,         REPG  38
     .          MU=0.04145D0,MD=0.04146D0,MS=0.150D0,                   REPG  39
     .          MC=1.5D0,MB=4.5D0)                                      REPG  40
      PARAMETER(QU=4.D0/3.D0,QD=1.D0/3.D0)                              REPG  41
      IMPG=0.D0                                                         REPG  42
      IF(S.GT.(4.D0*ME**2))                                             REPG  43
     .    IMPG=IMPG-SQRT(1.D0-4.D0*ME**2/S)*(1.D0+2.D0*ME**2/S)/3.D0    REPG  44
      IF(S.GT.(4.D0*MMU**2))                                            REPG  45
     .    IMPG=IMPG-SQRT(1.D0-4.D0*MMU**2/S)*(1.D0+2.D0*MMU**2/S)/3.D0  REPG  46
      IF(S.GT.(4.D0*MTAU**2))                                           REPG  47
     .    IMPG=IMPG-SQRT(1.D0-4.D0*MTAU**2/S)*(1.D0+2.D0*MTAU**2/S)/3.D0REPG  48
      IF(S.GT.(4.D0*MU**2))                                             REPG  49
     .    IMPG=IMPG-QU*SQRT(1.D0-4.D0*MU**2/S)*(1.D0+2.D0*MU**2/S)/3.D0 REPG  50
      IF(S.GT.(4.D0*MC**2))                                             REPG  51
     .    IMPG=IMPG-QU*SQRT(1.D0-4.D0*MC**2/S)*(1.D0+2.D0*MC**2/S)/3.D0 REPG  52
      IF(S.GT.(4.D0*MT**2))                                             REPG  53
     .    IMPG=IMPG-QU*SQRT(1.D0-4.D0*MT**2/S)*(1.D0+2.D0*MT**2/S)/3.D0 REPG  54
      IF(S.GT.(4.D0*MD**2))                                             REPG  55
     .    IMPG=IMPG-QD*SQRT(1.D0-4.D0*MD**2/S)*(1.D0+2.D0*MD**2/S)/3.D0 REPG  56
      IF(S.GT.(4.D0*MS**2))                                             REPG  57
     .    IMPG=IMPG-QD*SQRT(1.D0-4.D0*MS**2/S)*(1.D0+2.D0*MS**2/S)/3.D0 REPG  58
      IF(S.GT.(4.D0*MB**2))                                             REPG  59
     .    IMPG=IMPG-QD*SQRT(1.D0-4.D0*MB**2/S)*(1.D0+2.D0*MB**2/S)/3.D0 REPG  60
      IF(S.GT.(4.D0*MW**2))                                             REPG  61
     .    IMPG=IMPG+SQRT(1.D0-4.D0*MW**2/S)*(3.D0/4.D0+MW**2/S)         REPG  62
      IMPG= IMPG/ALFINV                                                 REPG  63
      END                                                               REPG  64
      DOUBLE PRECISION FUNCTION IMSGZ(S)                                IMSGZ  2
*********************************************************************   IMSGZ  3
*    Imaginary part of the 1-loop Z-gamma mixing                    *   IMSGZ  4
*    Fermion masses are neglected, except for the top               *   IMSGZ  5
*                Author:  Gerrit Burgers        CERN/TH             *   IMSGZ  6
*********************************************************************   IMSGZ  7
      IMPLICIT REAL*8(A-Z)                                              IMSGZ  8
      COMMON /HOLBOS/MZ,MW,MH                                           HOLBOS 2
      REAL*8         MZ,MW,MH                                           HOLBOS 3
      COMMON /HAD/XU,XD,XS,XC,XB,MT                                     HAD    2
      REAL*8      XU,XD,XS,XC,XB,MT                                     HAD    3
      COMMON/COUPL/ SW,CW,SW1,CW1, V,A,VU,VD                            COUPL  2
      REAL*8        SW,CW,SW1,CW1, V,A,VU,VD                            COUPL  3
* One can either pass the hadron masses via the common (here MT)        IMSGZ 12
* or via the parmeter statement (here MU,MD,MS,MC and MB)               IMSGZ 13
      PARAMETER(ALFINV=137.036D0)                                       IMSGZ 14
      PARAMETER(ME=0.5110034D-3,MMU=0.10565943D0,MTAU=1.7842D0,         IMSGZ 15
     .          MU=0.04145D0,MD=0.04146D0,MS=0.150D0,MC=1.5D0,MB=4.5D0) IMSGZ 16
      PARAMETER(QE=-1.D0,QU=2.D0/3.D0,QD=-1.D0/3.D0)                    IMSGZ 17
      IMSGZ=0.D0                                                        IMSGZ 18
      IF(S.GT.(4.D0*ME**2))   IMSGZ= IMSGZ-S*QE*V/3.D0                  IMSGZ 19
      IF(S.GT.(4.D0*MMU**2))  IMSGZ= IMSGZ-S*QE*V/3.D0                  IMSGZ 20
      IF(S.GT.(4.D0*MTAU**2)) IMSGZ= IMSGZ-S*QE*V/3.D0                  IMSGZ 21
      IF(S.GT.(4.D0*MU**2))   IMSGZ= IMSGZ-S*QU*VU                      IMSGZ 22
      IF(S.GT.(4.D0*MC**2))   IMSGZ= IMSGZ-S*QU*VU                      IMSGZ 23
      IF(S.GT.(4.D0*MT**2))   IMSGZ= IMSGZ-S*QU*VU                      IMSGZ 24
     .                     *SQRT(1.D0-4.D0*MT**2/S)*(1.D0+2.D0*MT**2/S) IMSGZ 25
      IF(S.GT.(4.D0*MD**2))   IMSGZ= IMSGZ-S*QD*VD                      IMSGZ 26
      IF(S.GT.(4.D0*MS**2))   IMSGZ= IMSGZ-S*QD*VD                      IMSGZ 27
      IF(S.GT.(4.D0*MB**2))   IMSGZ= IMSGZ-S*QD*VD                      IMSGZ 28
      IF(S.GT.(4.D0*MW**2))   IMSGZ= IMSGZ+S*A*SQRT(1.D0-4.D0*MW**2/S)* IMSGZ 29
     .  (3.D0*CW+1.D0/6.D0)+MW**2/S*(4.D0*CW+4.D0/3.D0)                 IMSGZ 30
      IMSGZ= IMSGZ/ALFINV                                               IMSGZ 31
      END                                                               IMSGZ 32
      DOUBLE PRECISION FUNCTION DELIMZ(ALFAS)                           DELIMZ 2
************************************************************************DELIMZ 3
*                                                                      *DELIMZ 4
*   CORRECTION TO IMAGINARY PART OF PROPER Z SELF ENERGY AT MZ**2      *DELIMZ 5
*   No weak correction Z --> t tbar, because probably the toponium     *DELIMZ 6
*   threshold is above the Z mass, if not this correction is rather    *DELIMZ 7
*   small and lengthy to calculate                                     *DELIMZ 8
*   The topmass dependence of the weak correction to the b bar partial *DELIMZ 9
*   is taken properly into account, and calculated in the subroutine   *DELIMZ10
*   FORMFA.                                                            *DELIMZ11
*   The decay into Higss+fermionpair is also taken into account, and   *DELIMZ12
*   calculated using an algorithm by Ronald Kleiss.                     DELIMZ13
*                                                                      *DELIMZ14
*      N.B.  The imaginary part of the selfenergy is related to the    *DELIMZ15
*            width of the Z by an factor (1+PIZZ)                      *DELIMZ16
*                                                                      *DELIMZ17
*     Author:           Gerrit Burgers,  CERN/TH                       *DELIMZ18
*     Author of FORMFA: Wolfgang Hollik, Universitaet Hamburg and DESY *DELIMZ19
*     Author of FF:     Ronald Kleiss,   University at Leiden and Cern *DELIMZ20
************************************************************************DELIMZ21
C                                                                       DELIMZ22
      IMPLICIT DOUBLE PRECISION (A-Z)                                   DELIMZ23
      COMPLEX*16 ZB,XQ,Z1,Z0,FF                                         DELIMZ24
      COMMON /HOLBOS/MZ,MW,MH                                           HOLBOS 2
      REAL*8         MZ,MW,MH                                           HOLBOS 3
      COMMON /HAD/XU,XD,XS,XC,XB,MT                                     HAD    2
      REAL*8      XU,XD,XS,XC,XB,MT                                     HAD    3
      COMMON/COUPL/ SW,CW,SW1,CW1, V,A,VU,VD                            COUPL  2
      REAL*8        SW,CW,SW1,CW1, V,A,VU,VD                            COUPL  3
      COMMON /RENORM/ DELTAR, RESW0, RESWW, RESZZ, SUBZZ, SUBWW, SUBGZ  RENORM 2
      REAL*8          DELTAR, RESW0, RESWW, RESZZ, SUBZZ, SUBWW, SUBGZ  RENORM 3
      PARAMETER(PI=3.1415926535897932D0,Z2=1.64493406684823D0)          DELIMZ29
      PARAMETER(ALFINV=137.036D0)                                       DELIMZ30
      PARAMETER(Q=-1.D0,QU=2.D0/3.D0,QD=-1.D0/3.D0)                     DELIMZ31
      PARAMETER(ME=0.5110034D-3,MMU=0.10565943D0,MTAU=1.7842D0,         DELIMZ32
     .          MU=0.0415D0,MD=0.0416D0,MS=0.150D0,MC=1.5D0,MB=4.5D0)   DELIMZ33
      PARAMETER(GFERMI=1.16637D-5)                                             
* Statement function (Sp(u)=Li2(x), u=-log(1-x) ):                      DELIMZ34
      SP(U)=((((((-1.D0/10886400.D0)*U**2+1.D0/211680.D0)*U**2-         DELIMZ35
     .         1.D0/3600)*U**2+1.D0/36.D0)*U-1.D0/4.D0)*U+1.D0)*U       DELIMZ36
*                                                                       DELIMZ37
*  Coupling constants                                                   DELIMZ38
      AU   = -A                                                         DELIMZ39
      AD   =  A                                                         DELIMZ40
      ANU  = -A                                                         DELIMZ41
*  Phase space factor, alpha/4pi                                        DELIMZ42
      KIN  =  MZ/(3.D0*ALFINV)                                          DELIMZ43
      API  =  1.D0/(4.D0*PI*ALFINV)                                     DELIMZ44
*  QCD and QED correction factors (not for partial tt width)            DELIMZ45
      RQCD = (1.D0+ALFAS*(1.98D0-5.D0*0.115D0)/PI)*ALFAS/PI  
     $       -12.8D0*(ALFAS/PI)**3
      RQED =  3.D0*API                                                  DELIMZ47
*  Weak vertex correction functions                                     DELIMZ48
*  NB   Z-gamma mixing is not a correction to the proper Z self energy, DELIMZ49
*       and is dealt with explicitly in the propagator, not in this     DELIMZ50
*       subroutine                                                      DELIMZ51
        U  = -LOG(1.D0+CW)                                              DELIMZ52
        U1 =  LOG(CW)                                                   DELIMZ53
        SQ =  SQRT(4.D0*CW-1.D0)                                        DELIMZ54
        F     =ATAN(1.D0/SQ)                                            DELIMZ55
      L2Z  = -11.D0/2.D0+4.D0*Z2                                        DELIMZ56
      L2W  = -7.D0/2.D0-2.D0*CW-(CW+3.D0/2.D0)*LOG(CW**2)               DELIMZ57
     .       +2.D0*(1.D0+CW)**2*(SP(U)+Z2-U1**2/2.D0-U*U1)              DELIMZ58
      L3W  = (2.5D0-2D0*CW+(4D0*CW+2D0)*SQ*F-8D0*CW*(CW+2D0)*F**2)/3D0  DELIMZ59
* Neutrinos                                                             DELIMZ60
      FN= (L2Z/(4D0*SW*CW)+(2D0*SW-1D0)/2D0/SW*L2W+3D0*CW/SW*L3W)       DELIMZ61
     .       *ANU*API                                                   DELIMZ62
      DWEAKN = 2D0*KIN*2D0*ANU*FN                                       DELIMZ63
                                                                        DELIMZ64
* Charged leptons                                                       DELIMZ65
      LEFT=L2W/(8D0*SW*SW1*CW1)-.75D0*CW1/SW/SW1*L3W                    DELIMZ66
      FVE =(V*(V**2+3D0*A**2)*L2Z+LEFT)*API                             DELIMZ67
      FAE =(A*(3D0*V**2+A**2)*L2Z+LEFT)*API                             DELIMZ68
      DWEAKE=2D0*KIN*(V*FVE+A*FAE)                                      DELIMZ69
      DQEDEE= RQED*KIN*(V**2+A**2)                                      DELIMZ70
* Down and strange quarks                                               DELIMZ71
      DQCDDD= RQCD*3.D0*KIN*(VD**2+A**2)                                DELIMZ72
      LEFT= 1.D0*(1D0-4D0/3D0*SW)/(8D0*SW*SW1*CW1)*L2W                  DELIMZ73
     .      -3D0/4D0*CW1/SW1/SW*L3W                                     DELIMZ74
      FVD=(VD*(VD**2+3D0*A**2)*L2Z+LEFT)*API                            DELIMZ75
      FAD=(AD*(3D0*VD**2+A**2)*L2Z+LEFT)*API                            DELIMZ76
      DWEAKD=2D0*KIN*(VD*FVD+AD*FAD)*3D0                                DELIMZ77
      DQEDDD = RQED*QD**2*3.D0*KIN*(VD**2+A**2)                         DELIMZ78
* Bottom quark                                                          DELIMZ79
        R   =MB**2/MZ**2                                                DELIMZ80
        X   =(1.D0-SQRT(1.D0-4.D0*R))/(1.D0+SQRT(1.D0-4.D0*R))          DELIMZ81
        LNX =LOG(X)                                                     DELIMZ82
        LNZ =LOG(1.D0-X)                                                DELIMZ83
        LNY =LOG(1.D0+X)                                                DELIMZ84
        LI2 = SP(-LNZ)                                                  DELIMZ85
        LI2M=SP(-LNY)                                                   DELIMZ86
        PV =(1.D0-4.D0*R**2)*                                           DELIMZ87
     .   (8.D0*LI2+4.D0*LI2M+4.D0*LNX*LNZ+2.D0*LNX*LNY)+                DELIMZ88
     .      SQRT(1.D0-4.D0*R)*                                          DELIMZ89
     .   ((.75D0+4.5D0*R)-(1.D0+2.D0*R)*(4.D0*LNZ+2.D0*LNY-3.D0*LNX))+  DELIMZ90
     .      (-3.D0+2.D0*R+7.D0*R**2)*LNX                                DELIMZ91
        PA =(1.D0-6.D0*R+8.D0*R**2)*                                    DELIMZ92
     .   (8.D0*LI2+4.D0*LI2M+4.D0*LNX*LNZ+2.D0*LNX*LNY)+                DELIMZ93
     .       SQRT(1.D0-4.D0*R)*                                         DELIMZ94
     .   ((.75D0-9D0*R+3D0*R**2)-(1D0-4D0*R)*(4D0*LNZ+2D0*LNY-3D0*LNX))+DELIMZ95
     .      (-3.D0+11.D0*R-5.D0*R**2-6.D0*R**3)*LNX                     DELIMZ96
C--      DQCDBB=3.D0*KIN*(ALFAS/PI)*(4./3.)*(VD**2*PV+A**2*PA)  
C--     .    +ALFAS**2*(1.98D0-5.D0*0.115D0)*3.D0*KIN*(VD**2+A**2)/PI**2 
*  alte version (vor 23.5.93):
         AL4PI = 1.D0/(4.D0*PI*ALFINV)                                  DIFMU 67
      XT  =  MZ/2D0/MT  
      GZBB=3.D0*KIN*(VD**2+A**2)
      DQCDBB=GZBB*(RQCD+.005D0)+AA/(VD**2+AA)*GZBB*(ALFAS/PI)**2
     .      *(-9.25D0+1.037D0*XT*XT+0.632D0*XT**4
     .        +6D0*DLOG(2D0*XT))/3D0
      CALL FORMFA(SW,MZ,MT,ZB)                                          DELIMZ99
      LEFT=DREAL(ZB)                                                    DELIM100
*   2-loop vertex corrections for bb,
*   Barbieri et al., CERN-TH.6713/92
      X=MT/MH
      XXT =  GFERMI*MT**2/(8D0*PI**2*DSQRT(2D0))
*  x = mtop/mhiggs
      IF(X.GT.2D0) THEN
      R=1D0/(X*X)
      LR=DLOG(R)
      TT=311D0+24D0*PI**2+282D0*LR+90D0*LR**2                                  
     .   -4D0*R*(40D0+6D0*PI**2+15D0*LR+18D0*LR**2)
     .   +.03D0*R*R*(24209D0-6000D0*PI**2-45420*LR-18000D0*LR**2)
      TT= TT/144D0
              ELSE
         IF(X.GT.0.1D0) THEN
         TT=1.2D0+.9389D0*(X-1.5D0)**2-.3889D0*(X-1.5D0)**3
                     ELSE
         TT=(27D0-PI**2)/3D0-4D0*PI*X
         ENDIF
      ENDIF
      TAU2=TT
*   QCD corrections, Fleischer et al., Phys. Lett. B 293 (1992) 437
      DTAU=-2D0*XXT*(1D0-ALFAS/PI*(PI**2/3D0-1D0) )
     .      -2D0*XXT**2*TAU2
      ZB1=LEFT*4*SW1*CW1*AL4PI
      ZB2=ZB1-AL4PI/(2D0*CW*SW)*(MT/MZ)**2-DTAU
      LEFT=ZB2/(4D0*SW1*CW1*AL4PI)
      FVB=(VD*(VD**2+3D0*A**2)*L2Z+LEFT)*API                            DELIM101
      FAB=(AD*(3D0*VD**2+A**2)*L2Z+LEFT)*API                            DELIM102
      DWEAKB=2D0*KIN*(VD*FVB+AD*FAB)*3D0                                DELIM103
      DQEDBB=3.D0*KIN*4.D0*API*QD**2*PV                                 DELIM104
* Up and charmed quarks                                                 DELIM105
      DQCDUU= RQCD*3.D0*KIN*(VU**2+A**2)                                DELIM106
      LEFT=(2D0/3D0*SW-1D0)/(8D0*SW*SW1*CW1)*L2W                        DELIM107
     .     +.75D0*CW1/SW1/SW*L3W                                        DELIM108
      FVU=(VU*(VU**2+3D0*A**2)*L2Z+LEFT)*API                            DELIM109
      FAU=(AU*(3D0*VU**2+A**2)*L2Z+LEFT)*API                            DELIM110
      DWEAKU=2D0*KIN*(VU*FVU+AU*FAU)*3D0                                DELIM111
      DQEDUU = RQED*QU**2*3.D0*KIN*(VU**2+A**2)                         DELIM112
* Top quark (if toponium threshold below MZ)                            DELIM113
      IF(MZ.GT.2.D0*MT) THEN                                            DELIM114
        R   =MT**2/MZ**2                                                DELIM115
        X   =(1.D0-SQRT(1.D0-4.D0*R))/(1.D0+SQRT(1.D0-4.D0*R))          DELIM116
        LNX =LOG(X)                                                     DELIM117
        LNZ =LOG(1.D0-X)                                                DELIM118
        LNY =LOG(1.D0+X)                                                DELIM119
        IF(X.LE.0.5D0) THEN                                             DELIM120
           LI2 = SP(-LNZ)                                               DELIM121
        ELSE                                                            DELIM122
           LI2 =-SP(-LNX)+Z2-LNX*LNZ                                    DELIM123
        ENDIF                                                           DELIM124
        LI2M=SP(-LNY)                                                   DELIM125
        PV =(1.D0-4.D0*R**2)*                                           DELIM126
     .   (8.D0*LI2+4.D0*LI2M+4.D0*LNX*LNZ+2.D0*LNX*LNY)+                DELIM127
     .      SQRT(1.D0-4.D0*R)*                                          DELIM128
     .   ((.75D0+4.5D0*R)-(1.D0+2.D0*R)*(4.D0*LNZ+2.D0*LNY-3.D0*LNX))+  DELIM129
     .      (-3.D0+2.D0*R+7.D0*R**2)*LNX                                DELIM130
        PA =(1.D0-6.D0*R+8.D0*R**2)*                                    DELIM131
     .   (8.D0*LI2+4.D0*LI2M+4.D0*LNX*LNZ+2.D0*LNX*LNY)+                DELIM132
     .       SQRT(1.D0-4.D0*R)*                                         DELIM133
     .   ((.75D0-9D0*R+3D0*R**2)-(1D0-4D0*R)*(4D0*LNZ+2D0*LNY-3D0*LNX))+DELIM134
     .      (-3.D0+11.D0*R-5.D0*R**2-6.D0*R**3)*LNX                     DELIM135
        DQCDTT=3.D0*KIN*(ALFAS/PI)*(4./3.)*(VU**2*PV+A**2*PA)           DELIM136
        DQEDTT=3.D0*KIN*4.D0*API*QU**2*PV                               DELIM137
*   (the weak correction is not calculated)                             DELIM138
      ELSE                                                              DELIM139
        DQCDTT=0.0D0                                                    DELIM140
        DQEDTT=0.0D0                                                    DELIM141
      ENDIF                                                             DELIM142
* Calculation of the Higgs-fermion-fermion width:                       DELIM143
      IF(MH.GE.MZ) THEN                                                 DELIM144
            GHFF=0.D0                                                   DELIM145
                   ELSE                                                 DELIM146
            X1   = 2.D0*MH/MZ                                           DELIM147
            AA   = X1**2                                                DELIM148
            B    = IMSZ(MZ**2)/MZ**2                                    DELIM149
            XQ   = DCMPLX(MH**2/MZ**2,B)                                DELIM150
            Z1   = XQ + CDSQRT( XQ*XQ - AA )                            DELIM151
            Z0   = 2.*XQ - Z1                                           DELIM152
            FACT = (4.D0*API*A**2/(24.D0*B))*                           DELIM153
     .             DIMAG(1./(Z1-Z0) *(FF(AA,Z1,2.D0) -                  DELIM154
     .                   FF(AA,Z1,X1) - FF(AA,Z0,2.D0) + FF(AA,Z0,X1) ))DELIM155
            GHFF= FACT*IMSZ(MZ**2)/MZ                                   DELIM156
      ENDIF                                                             DELIM157
* Total correction                                                      DELIM158
      DELIMZ =                    2.D0*DQCDDD+DQCDBB+2.D0*DQCDUU+DQCDTT+DELIM159
     .    3.D0*DWEAKN+3.D0*DWEAKE+2.D0*DWEAKD+DWEAKB+2.D0*DWEAKU+       DELIM160
     .                3.D0*DQEDEE+2.D0*DQEDDD+DQEDBB+2.D0*DQEDUU+DQEDTT+DELIM161
     .    GHFF                                                          DELIM162
      END                                                               DELIM163
      SUBROUTINE RNORM(MZ,MW,MH,MT)                                     RNORM  2
************************************************************************RNORM  3
*  Standard Model calculation                                          *RNORM  4
*  Calculation of "DELTAR" and various renormalisation constants,      *RNORM  5
*  SUBZZ, SUBWW, SUBGZ which relate the real parts of the renormalised *RNORM  6
*  1PI Z, WW and ZG selfenergies RESZ(s)), RESW(s) and RESGZ(s) to the *RNORM  7
*  finite part unrenormalised ones RESZU(s), RESWU(s) and RESGZU(s).   *RNORM  8
*  Also RESW0=RESWU(0), RESWW=RESWU(mw**2), RESZ0=RESZU(0), RESZZ=     *RNORM  9
*  RESZU(mz**2)-mz**2*Re( (PIGZ(mz**2))**2/(1-PIGG(mz**2)) )           *RNORM 10
*                                             ARE                      *RNORM 11
*  calculated.  Here we use the On-Shell Scheme, as in                 *RNORM 12
*                                                                      *RNORM 13
*    References: M. Boehm, W. Hollik, H. Spiesberger,                  *RNORM 14
*                Fort. der Physik 34(1986)687                          *RNORM 15
*                G. Burgers and W. Hollik, contribution to the Yellow  *RNORM 16
*                Book on Polarization at LEP (CERN-TH.5131/88)         *RNORM 17
*                                                                      *RNORM 18
*                                                                      *RNORM 19
*    DELTAR  connects the Fermi coupling constant to MZ, MW and the    *RNORM 20
*    fine structure constant alfa.                                     *RNORM 21
*    RESZ(s) = RESZ(s) - RESZZ + (s-mz**2)*SUBZZ                       *RNORM 22
*    RESW(s) = RESW(s) - RESWW + (s-mw**2)*SUBWW                       *RNORM 23
*    RESGZ(s)= RESGZ(s) + s * SUBGZ                                    *RNORM 24
*    DELTAR =  RESW(0) + (alfa/(4pi*sw))(6+(7-4sw)*log(cw)/(2sw))      *RNORM 25
*                                                                      *RNORM 26
*    SW = sin**2(thetaweak) = 1 - MW**2/MZ**2                          *RNORM 27
*    CW = 1-SW                                                         *RNORM 28
*                                                                      *RNORM 29
*    THE RESULTS ARE PUT IN  COMMON/RENORM/                            *RNORM 30
*                                                                      *RNORM 31
*    Author:  Gerrit Burgers        CERN/TH                            *RNORM 32
************************************************************************RNORM 33
      IMPLICIT DOUBLE PRECISION (A-Z)                                   RNORM 34
      INTEGER I                                                         RNORM 35
      COMPLEX*16  DELALF, PIGZ                                          RNORM 36
      COMMON /RENORM/ DELTAR, RESW0, RESWW, RESZZ, SUBZZ, SUBWW, SUBGZ  RENORM 2
      REAL*8          DELTAR, RESW0, RESWW, RESZZ, SUBZZ, SUBWW, SUBGZ  RENORM 3
      COMMON/COUPL/ SW,CW,SW1,CW1, V,A,VU,VD                            COUPL  2
      REAL*8        SW,CW,SW1,CW1, V,A,VU,VD                            COUPL  3
      PARAMETER(PI=3.1415926535897932D0, ALFINV=137.036D0)              RNORM 39
      PARAMETER(ME=0.5110034D-3,MMU=0.10565943D0,MTAU=1.7842D0,         RNORM 40
     .          MU=0.0415D0,MD=0.0416D0,MS=0.150D0,MC=1.5D0,MB=4.5D0)   RNORM 41
      PARAMETER(QE=-1.D0,QU=2.D0/3.D0,QD=-1.D0/3.D0)                    RNORM 42
      Z  = MZ**2                                                        RNORM 43
      W  = MW**2                                                        RNORM 44
      H  = MH**2                                                        RNORM 45
* sin(thetaw) etc                                                       RNORM 46
         CW=MW**2/MZ**2                                                 RNORM 47
         SW=1.D0-CW                                                     RNORM 48
         SW1=SQRT(SW)                                                   RNORM 49
         CW1=SQRT(CW)                                                   RNORM 50
* coupling constants:                                                   RNORM 51
* the neutrino axial coupling is A and the electron, up and down vector RNORM 52
* couplings are V, VU and VD.                                           RNORM 53
         A=-1.D0/(4.D0*SW1*CW1)                                         RNORM 54
         V=(1.D0-4.D0*SW)*A                                             RNORM 55
         VU=(8.D0/3.D0*SW-1.D0)*A                                       RNORM 56
         VD=(1.D0-4.D0/3.D0*SW)*A                                       RNORM 57
*                                                                       RNORM 58
         IF(DABS(MU/MD-1.D0).GT.1.D-6) THEN                             RNORM 59
             FMUMD=(MU**2+MD**2)*LOG(MU/MD)/(MU**2-MD**2)               RNORM 60
          ELSE                                                          RNORM 61
            FMUMD=1.D0                                                  RNORM 62
          ENDIF                                                         RNORM 63
      RESW0=                                                            RNORM 64
     . -(ME**2+MMU**2+MTAU**2)/(4.D0*SW)                                RNORM 65
      RESW0= RESW0                                                      RNORM 66
     . +(-3.D0*(MU**2+MD**2)/4.D0+MU**2*MD**2*FMUMD/(MU**2+MD**2)       RNORM 67
     .   +((MU**2+MD**2)/2.D0)*FMUMD                                    RNORM 68
     .   -3.D0*(MC**2+MS**2)/4.D0+MC**2*MS**2*LOG(MC/MS)/(MC**2-MS**2)  RNORM 69
     .   +((MC**2+MS**2)**2/2.D0)*LOG(MC/MS)/(MC**2-MS**2)              RNORM 70
     .   -3.D0*(MT**2+MB**2)/4.D0+MT**2*MB**2*LOG(MT/MB)/(MT**2-MB**2)  RNORM 71
     .   +((MT**2+MB**2)**2/2.D0)*LOG(MT/MB)/(MT**2-MB**2))/SW          RNORM 72
      RESW0= RESW0                                                      RNORM 73
     .   -(MT**2-MB**2)*LOG(MT/MB)/(2.D0*SW)                            RNORM 74
     .   -(MC**2-MS**2)*LOG(MC/MS)/(2.D0*SW)                            RNORM 75
     .   -(MU**2-MD**2)*LOG(MU/MD)/(2.D0*SW)                            RNORM 76
      RESW0= RESW0                                                      RNORM 77
     .   +((CW/SW)*(Z+3.D0*W)-W*SW/CW+W/(4.D0*SW))*Z*LOG(Z/W)/(Z-W)     RNORM 78
     .   -(2.D0*CW/SW)*(Z+W)+W*SW/CW+(-7.D0*W-3.D0*Z)/(24.D0*SW)        RNORM 79
      RESW0= RESW0                                                      RNORM 80
     .  +W/3.D0-4.D0*W/3.D0                                             RNORM 81
      RESW0= RESW0                                                      RNORM 82
     .  +(-18.D0*H*W*LOG(H/W)/(H-W)+25.D0*W-3.D0*H)/(24.D0*SW)          RNORM 83
      RESW0=RESW0/(4.D0*PI*ALFINV)                                      RNORM 84
*                                                                       RNORM 85
      RESWW=                                                            RNORM 86
     . +((W-ME**2/2.D0-ME**4/(2.D0*W))*FH(W,0.D0,ME)-ME**2/2.D0         RNORM 87
     .  +(W-MMU**2/2.D0-MMU**4/(2.D0*W))*FH(W,0.D0,MMU)-MMU**2/2.D0     RNORM 88
     .  +(W-MTAU**2/2.D0-MTAU**4/(2.D0*W))*FH(W,0D0,MTAU)-MTAU**2/2.D0  RNORM 89
     .  + 2.D0*W)/(3.D0*SW)                                             RNORM 90
      RESWW= RESWW                                                      RNORM 91
     . +((W-(MU**2+MD**2)/2.D0-(MU**2-MD**2)**2/(2.D0*W))*FH(W,MU,MD)   RNORM 92
     .  -(W-(MU**2+MD**2)/2.D0)*FMUMD-(MU**2+MD**2)/2.D0                RNORM 93
     .  +(W-(MC**2+MS**2)/2.D0-(MC**2-MS**2)**2/(2.D0*W))*FH(W,MC,MS)   RNORM 94
     .  -(W-(MC**2+MS**2)/2.D0)*(MC**2+MS**2)*LOG(MC/MS)/(MC**2-MS**2)  RNORM 95
     .  -(MC**2+MS**2)/2.D0                                             RNORM 96
     .  +(W-(MT**2+MB**2)/2.D0-(MT**2-MB**2)**2/(2.D0*W))*FH(W,MT,MB)   RNORM 97
     .  -(W-(MT**2+MB**2)/2.D0)*(MT**2+MB**2)*LOG(MT/MB)/(MT**2-MB**2)  RNORM 98
     .  -(MT**2+MB**2)/2.D0+2.D0*W)/SW                                  RNORM 99
      RESWW= RESWW                                                      RNORM100
     .  -(MT**2-MB**2)*LOG(MT/MB)/(2.D0*SW)                             RNORM101
     .  -(MC**2-MS**2)*LOG(MC/MS)/(2.D0*SW)                             RNORM102
     .  -(MU**2-MD**2)*LOG(MU/MD)/(2.D0*SW)                             RNORM103
      RESWW= RESWW                                                      RNORM104
     .  +(-(CW/(3.D0*SW))*(7.D0*Z+17.D0*W-2.D0*(Z-W)**2/W)+W*SW/CW      RNORM105
     .    -(1.D0/(6.D0*SW))*(W/2.D0+Z-(Z-W)**2/(2.D0*W)))*FH(W,MZ,MW)   RNORM106
     .   +((CW/(3.D0*SW))*(7.D0*Z+17.D0*W-4.D0*(Z-W))                   RNORM107
     .   -(SW/CW)*W+(1.D0/(6.D0*SW))*(3.D0*W/2.D0))*Z*LOG(Z/W)/(Z-W)    RNORM108
     .    -(CW/(3.D0*SW))*(7.D0*Z+17.D0*W+2.D0*W/3.D0)                  RNORM109
     .    +(SW/CW)*W+(1.D0/(6.D0*SW))*(-1.D0*W/3.D0-Z)                  RNORM110
      RESWW= RESWW                                                      RNORM111
     .  -80.D0*W/9.D0                                                   RNORM112
      RESWW= RESWW                                                      RNORM113
     .  +((11.D0*W/2.D0-H+(H-W)**2/(2.D0*W))*FH(W,MH,MW)                RNORM114
     .    -(9.D0*W/2.D0)*H*LOG(H/W)/(H-W)+6.D0*W-H)/(6.D0*SW)           RNORM115
      RESWW=RESWW/(4.D0*PI*ALFINV)                                      RNORM116
*                                                                       RNORM117
      RESZ0 = (A**2/3.D0)*( 21.D0*Z/2.D0-3.D0*H/2.D0                    RNORM118
     .                     -12.D0*Z*LOG(Z/W)-9.D0*H*Z*LOG(H/Z)/(H-Z))   RNORM119
      RESZ0= RESZ0/(PI*ALFINV)                                          RNORM120
*                                                                       RNORM121
      RESZZ= 2.D0*A**2*Z*(FH(Z,ME,ME)+FH(Z,MMU,MMU)+FH(Z,MTAU,MTAU)     RNORM122
     .                    - 1.D0)/3.D0                                  RNORM123
      RESZZ= RESZZ                                                      RNORM124
     . +(((V**2+A**2)*(Z+2.D0*ME**2)-6.D0*ME**2*A**2)*FH(Z,ME,ME)       RNORM125
     .  +((V**2+A**2)*(Z+2.D0*MMU**2)-6.D0*MMU**2*A**2)*FH(Z,MMU,MMU)   RNORM126
     .  +((V**2+A**2)*(Z+2.D0*MTAU**2)-6D0*MTAU**2*A**2)*FH(Z,MTAU,MTAU)RNORM127
     .  -(V**2+A**2)*Z )/3.D0                                           RNORM128
      RESZZ= RESZZ                                                      RNORM129
     . +(((VU**2+A**2)*(Z+2.D0*MU**2)-6.D0*MU**2*A**2)*FH(Z,MU,MU)      RNORM130
     .  +((VU**2+A**2)*(Z+2.D0*MC**2)-6.D0*MC**2*A**2)*FH(Z,MC,MC)      RNORM131
     .  +((VU**2+A**2)*(Z+2.D0*MT**2)-6.D0*MT**2*A**2)*FH(Z,MT,MT)      RNORM132
     .  -(VU**2+A**2)*Z )                                               RNORM133
      RESZZ= RESZZ                                                      RNORM134
     . +(((VD**2+A**2)*(Z+2.D0*MD**2)-6.D0*MD**2*A**2)*FH(Z,MD,MD)      RNORM135
     .  +((VD**2+A**2)*(Z+2.D0*MS**2)-6.D0*MS**2*A**2)*FH(Z,MS,MS)      RNORM136
     .  +((VD**2+A**2)*(Z+2.D0*MB**2)-6.D0*MB**2*A**2)*FH(Z,MB,MB)      RNORM137
     . -(VD**2+A**2)*Z )                                                RNORM138
      RESZZ= RESZZ                                                      RNORM139
     . +(((-10.D0*Z-20.D0*W)*CW**2+(2.D0*W+Z/4.D0)*(CW-SW)**2+3.D0*W)*  RNORM140
     .    FH(Z,MW,MW)+Z*(-2.D0*CW**2/3.D0+(CW-SW)**2/6D0) )*4.*A**2/3.D0RNORM141
      RESZZ= RESZZ                                                      RNORM142
     .+((11.D0*Z-2.D0*H+(H-Z)**2/Z)*FH(Z,MH,MZ)                         RNORM143
     . +(11.D0*Z-2.D0*H)*(1.D0-(H+Z)*LOG(MH/MZ)/(H-Z)-LOG(MH*MZ/W))     RNORM144
     . -2.D0*H*LOG(H/W)-2.D0*Z*LOG(Z/W)+2.D0*Z/3.D0)*A**2/3.D0          RNORM145
      RESZZ= RESZZ/(PI*ALFINV)                                          RNORM146
*                                                                       RNORM147
* Z-gamma mixing at MZ**2:                                              RNORM148
      PIGZU=                                                            RNORM149
     .      (QE*V )*(P(Z,ME)+P(Z,MMU)+P(Z,MTAU))/3.D0                   RNORM150
     .   +  (QU*VU)*(P(Z,MU)+P(Z,MC)+P(Z,MT))                           RNORM151
     .   +  (QD*VD)*(P(Z,MD)+P(Z,MS)+P(Z,MB))                           RNORM152
     .   -A*(1.D0/9.D0+  ((1.D0/3.D0-P(Z,MW))/(Z+2.D0*W))*              RNORM153
     .       (Z*(3.D0*CW+1.D0/6.D0)+W*(4.D0*CW+4.D0/3.D0)))             RNORM154
      PIGZU = PIGZU/(PI*ALFINV)                                         RNORM155
*                                                                       RNORM156
      SUMQQ = (LOG(MU/MD)+LOG(MC/MS)+LOG(MT/MB))/(2.D0*PI*ALFINV)       RNORM157
      SUMTB = 0.D0                                                      RNORM158
*                                                                       RNORM159
*** if you wish, you can include a strong correction:                   RNORM160
***   SUMTB =  -((ALFAS/PI)*(2.D0*PI**2+6.)/9.)*                        RNORM161
***  .               (3.*MT**2/(16.*SW*CW*MZ**2*ALFINV*PI))             RNORM162
*                                                                       RNORM163
      DELRHO = RESZ0/Z - RESW0/W + SUMTB                                RNORM164
      DELALF = 1.D0-DCMPLX(REPG(MZ**2),IMPG(MZ**2))                     RNORM165
      IMPGZ  = IMSGZ(MZ**2)/MZ**2                                       RNORM166
      RESZZ0 = RESZZ                                                    RNORM167
      RESOLD = RESZZ                                                    RNORM168
      DO 10 I=1,10                                                      RNORM169
        SUBGZ1= -(CW1/SW1)*(RESZZ/Z-RESWW/W+SUMTB)-SUMQQ/(6.D0*CW1*SW1) RNORM170
        PIGZ  = DCMPLX(PIGZU+SUBGZ,IMPGZ)                               RNORM171
        RESZZ = RESZZ0-Z*DREAL(PIGZ**2/DELALF)                          RNORM172
        IF(ABS(RESZZ-RESOLD)/Z .LT. 1D-6) GOTO 20                       RNORM173
        RESOLD= RESZZ                                                   RNORM174
 10   CONTINUE                                                          RNORM175
      WRITE(6,'('' NO SUFFICIENT CONVERGENCE FOR RESZZ IN 10 STEPS'')') RNORM176
 20   SUBZZ1= ((CW-SW)/SW)*(RESZZ/Z-RESWW/W+SUMTB)+SUMQQ/(3.D0*SW)+     RNORM177
     .        1.D0/(6.D0*PI*ALFINV)                                     RNORM178
      SUBWW1= (CW/SW)*(RESZZ/Z-RESWW/W+SUMTB)+SUMQQ/(3.D0*SW)+          RNORM179
     .        1.D0/(6.D0*PI*ALFINV)                                     RNORM180
      DELTR1 = RESW0/W - RESWW/W - SUBWW1+                              RNORM181
     .  (6.D0+(7.D0-4.D0*SW)*LOG(CW)/(2.D0*SW))/(4.D0*PI*ALFINV*SW)     RNORM182
*  THE IRREDUCIBLE 2-LOOP PART:                                         RNORM183
      GFERMI=1.16637D-5                                                 RNORM184
C      DRO2=3D0*(GFERMI*MT**2/(8D0*PI**2*DSQRT(2D0)))**2                 RNORM185
C     .                                 *(19D0-2D0*PI**2)                RNORM186
* THE RHO PARAMETER ACCORDING TO BARBIERI ET AL.
      XXT=GFERMI*MT**2/(8D0*PI**2*DSQRT(2D0))
      X=MH/MT
      R=1D0/X**2                                                         
      LR=DLOG(R)
      HR=49D0/4D0+PI**2+27D0/2D0*LR+1.5D0*LR**2
     .  +R/3D0*(2D0-12D0*PI**2+12D0*LR-27D0*LR**2)
     .  +R*R/48D0*(1613D0-240D0*PI**2-1500D0*LR-720D0*LR**2)
      A0=19D0-2D0*PI**2
      X4=4D0    
      T=1D0/X4**2
      LT=DLOG(T)
      H4=49D0/4D0+PI**2+27D0/2D0*LT+1.5D0*LT**2
     .  +T/3D0*(2D0-12D0*PI**2+12D0*LT-27D0*LT**2)
     .  +T*T/48D0*(1613D0-240D0*PI**2-1500D0*LT-720D0*LT**2)
      DH=(27D0/2D0+3D0*LT)/T
     .   +4D0-18D0*LT
     .  +1D0/3D0*(2D0-12D0*PI**2+12D0*LT-27D0*LT**2)
     .  +T/24D0*(1613D0-240D0*PI**2-1500D0*LT-720D0*LT**2)
     .   -T/48D0*(1500D0+2D0*720D0*LT)
      DH4=-DH*2D0/X4**3
      A1=-(2.5D0+A0)*5D0
      A3=(H4-2D0*DH4-A0-2D0*A1)/(-32D0)
      A2=(DH4-A1-48D0*A3)/8D0 
      IF(X.GT.2D0) THEN
      R2=HR
             ELSE
      R2=A0+A1*X+A2*X**2+A3*X**3
         ENDIF
      DRO2=3D0*XXT**2*R2
*           QCD A LA KNIEHL                                              
      ALFAS=.12D0
      KF=12D0*PI/23D0
      ALFST=KF/(2D0*DLOG(MT/MZ)+KF/ALFAS)
      DQCD=-ALFST/PI*2D0*(PI**2/3D0+1D0)
     .      *GFERMI*MT**2/(8D0*PI**2*DSQRT(2D0))
      DRO2=DRO2+DQCD*1D0
      DELTAR=DELTR1-CW/SW*DRO2                                          RNORM187
      SUBZZ=SUBZZ1+(CW-SW)/SW*DRO2                                      RNORM188
      SUBWW=SUBWW1+CW/SW*DRO2                                           RNORM189
      SUBGZ=SUBGZ1-CW1/SW1*DRO2                                         RNORM190
      END                                                               RNORM191
      DOUBLE PRECISION FUNCTION P(S,M)                                  P      2
***************************************************************         P      3
* Real part of the 1-loop QED vacuumpolarisation contribution *         P      4
* from a fermion with mass m                                  *         P      5
*                                                             *         P      6
*   Relation with the function F:                             *         P      7
*     P(s,m) = 1/3 - (1 + 2m**2/s)*F(s,m,m)                   *         P      8
***************************************************************         P      9
      IMPLICIT DOUBLE PRECISION (A-Z)                                   P     10
      IF(S.EQ.0) THEN                                                   P     11
        P = 0.D0                                                        P     12
      ELSE IF(S.LT.0) THEN                                              P     13
        X = SQRT(1.D0-4.D0*M**2/S)                                      P     14
        P = -8.D0/3.D0+X**2-                                            P     15
     .          X*(3.D0-X**2)*LOG(-4.D0*M**2/(S*(1.D0+X)**2))/2.D0      P     16
      ELSE IF(S.LT.4.D0*M**2) THEN                                      P     17
        X = SQRT(4.D0*M**2/S-1.D0)                                      P     18
        P = -8.D0/3.D0-X**2+X*(3.D0+X**2)*ATAN(1.D0/X)                  P     19
      ELSE                                                              P     20
        X = SQRT(1.D0-4.D0*M**2/S)                                      P     21
        P = -8.D0/3.D0+X**2-                                            P     22
     .          X*(3.D0-X**2)*LOG(4.D0*M**2/(S*(1.D0+X)**2))/2.D0       P     23
      ENDIF                                                             P     24
      END                                                               P     25
