      SUBROUTINE CINT
      END
      FUNCTION BORNR(MODE,SVAR,COSTHE,TA,TB)                            BORNH  2
C ----------------------------------------------------------------------BORNH  3
C THIS ROUTINE PROVIDES BORN CROSS SECTION. IT HAS THE SAME         *   BORNH  4
C STRUCTURE AS FUNTIS AND FUNTIH, THUS CAN BE USED AS SIMPLER       *   BORNH  5
C EXAMPLE OF THE METHOD APPLIED THERE                               *   BORNH  6
C 18.04. IT IS NOT SO SIMPLE NOW THERE ARE 2 MODES SIMPLE OLD ONE   *   BORNH  7
C AND THE NEW ONE WHERE ALSO ELECTROWEAK CORRECTIONS ARE ADDED      *   BORNH  8
C                                                                       BORNH  9
C     called by : BORNY, BORAS, BORNV, WAGA, WEIGHT                     BORNH 10
C ----------------------------------------------------------------------BORNH 11
      IMPLICIT REAL*8(A-H,O-Z)                                          BORNH 12
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF                         BEAMPM 2
      REAL*8            ENE ,AMIN,AMFIN                                 BEAMPM 3
      COMMON / GAUSPM /SS,POLN,T3E,QE,T3F,QF                            GAUSPM 2
     &                ,XUPGI   ,XUPZI   ,XUPGF   ,XUPZF                 GAUSPM 3
     &                ,NDIAG0,NDIAGA,KEYA,KEYZ                          GAUSPM 4
     &                ,ITCE,JTCE,ITCF,JTCF,KOLOR                        GAUSPM 5
      REAL*8           SS,POLN,T3E,QE,T3F,QF                            GAUSPM 6
     &                ,XUPGI(2),XUPZI(2),XUPGF(2),XUPZF(2)              GAUSPM 7
      COMMON / QEDPRM /ALFINV,ALFPI,XK0                                 QEDPRM 2
      REAL*8           ALFINV,ALFPI,XK0                                 QEDPRM 3
      COMMON / INSPIN / SEPS1,SEPS2                                     INSPIN 2
      REAL*8            SEPS1,SEPS2                                     INSPIN 3
      COMMON / KEYSET / KEYGSW,KEYRAD,KEYTAB                            KEYSET 2
      COMMON /HOL/ XMZ,XMH,XMT,XSW,GAMZ,GZ0                             HOL    2
      REAL*8       XMZ,XMH,XMT,XSW,GAMZ,GZ0                             HOL    3
      COMMON /HELIC/ S1,S2,S3,S4                                        HELIC  2
      REAL*8         S1,S2,S3,S4                                        HELIC  3
      IF ( IDE.LT.0) THEN                                               BORNH 20
        S1=-SEPS1                                                       BORNH 21
        S2=SEPS2                                                        BORNH 22
        S3=-TA                                                          BORNH 23
        S4=TB                                                           BORNH 24
      ELSE                                                              BORNH 25
        S1= SEPS1                                                       BORNH 26
        S2=-SEPS2                                                       BORNH 27
        S3= TA                                                          BORNH 28
        S4=-TB                                                          BORNH 29
      ENDIF                                                             BORNH 30
      IF (MODE.EQ.1.AND.KEYGSW.GE.2) THEN                               BORNH 31
      ALFAS=0.12D0                                                      ALFAS  1
      CALL DIFMU(SVAR,COSTHE,XMZ,XMH,XMT,SIG0,SIG,ALFAS)                ALFAS  2
        BORN=SIG                                                        BORNH 33
      ELSE                                                              BORNH 34
      CALL DIFM0(SVAR,COSTHE,XMZ,XMH,XMT,SIG0,SIG)                      BORNH 35
        BORN=SIG0                                                       BORNH 36
      ENDIF                                                             BORNH 37
      FACTOR=1.D0                                                       BORNH 38
C                                                                       BORNH 39
C THIS IS A BIT CRUDE METHOD OF INTRODUCING THRESHOLD BEHAVIOUR         BORNH 40
      IF (SVAR.GT.4D0*AMFIN**2) THEN                                    BORNH 41
        THRESH=SQRT(1-4D0*AMFIN**2/SVAR)*(1D0+2D0*AMFIN**2/SVAR)        BORNH 42
      ELSE                                                              BORNH 43
        THRESH=0.D0                                                     BORNH 44
      ENDIF                                                             BORNH 45
      BORNR = BORN*FACTOR*THRESH                                        BORNH 46
      END                                                               BORNH 47
      SUBROUTINE PRMROB(ZMASS,GAMZ0,GAMMZ,WMASS,GAMW0,GAMW,SIN2W)       PRMHOL 2
C     ***********************************************************       PRMHOL 3
C     to get useful variables                                           PRMHOL 4
      IMPLICIT REAL*8(A-Z)                                              PRMHOL 5
      COMMON /HOL/ XMZ,XMH,XMT,XSW,GAMZ,GZ0                             HOL    2
      REAL*8       XMZ,XMH,XMT,XSW,GAMZ,GZ0                             HOL    3
      ZMASS=XMZ                                                         PRMHOL 7
      SIN2W=XSW                                                   
      GAMMZ=GAMZ                                                        PRMHOL 9
      GAMZ0=GAMZ
COLD  WMASS=0.D0                                                        PRMHOL11
CHBU  do instead :                                                      PRMHOL12
      WMASS=ZMASS*SQRT(1.D0-SIN2W)                                      PRMHOL13
CHBU  end of insert                                                     PRMHOL14
      GAMW=0.D0                                                         PRMHOL15
      GAMW0=0.D0                                                        PRMHOL16
      END                                                               PRMHOL17
      SUBROUTINE MASET(AMZ,AMH,AMT)
C======================================================================
C============WE START WITH ROUTINES RENAMING ENTRIES===================
C======================================================================
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8            ENE ,AMIN,AMFIN
      COMMON / KEYSET / KEYGSW,KEYRAD,KEYTAB
      COMMON / INOUT / INUT,IOUT
      YMZ=AMZ
      YMH=AMH
      YMT=AMT
      WRITE(IOUT,'('' ELECTROWEAK CORRECTIONS ACCORDING TO '')')
      WRITE(IOUT,'('' W. Hollik                            '')')
      IF(IDF**2.NE.4) THEN
        WRITE(IOUT,'('' this library can be used only for mu or tau'')')
        STOP
      ENDIF
      CALL HOLST(IDF,KEYGSW,YMZ,YMH,YMT)
      END
      SUBROUTINE HOLST(IDF,KEYGSW,YMZ,YMH,YMT)                          HOLSTA 2
C     ********************************                                  HOLSTA 3
C     initialization                                                    HOLSTA 4
      IMPLICIT REAL*8(A-Z)                                              HOLSTA 5
      COMMON /HOL/ XMZ,XMH,XMT,XSW,GAMZ,GZ0                             HOL    2
      REAL*8       XMZ,XMH,XMT,XSW,GAMZ,GZ0                             HOL    3
*holc2 introducing alfa-strong                                          HOLSTA 7
      ALFAS=.12D0                                                       HOLSTA 8
      XMZ=YMZ                                                           HOLSTA 9
      XMH=YMH                                                           HOLSTA10
      XMT=YMT                                                           HOLSTA11
*holc2 introducing alfa-strong                                          HOLSTA12
      CALL SETMU(XMZ,XMH,XMT,XSW,GAMZ,GZ0,ALFAS)                        HOLSTA13
      END                                                               HOLSTA14
      SUBROUTINE DIFM0(S,CT,XMZ,XMH,XMT,SIG0,SIG)                       DIFM0  2
************************************************************************DIFM0  3
*                                                                      *DIFM0  4
*   The differential cross section for                                 *DIFM0  5
*                                                                      *DIFM0  6
*         e+ e-  --->  mu+ mu-                                         *DIFM0  7
*                                                                      *DIFM0  8
*   SIG0: Born,   SIG : with O(alfa) corrections                        DIFM0  9
*                                                                       DIFM0 10
*   (or u ubar or d dbar, by including a few lines which have been     *DIFM0 11
*    commented out like "*qq" and "*dd")                               *DIFM0 12
*                                                                      *DIFM0 13
* INCLUDED: one loop Z Self-energy + corrected Z width, photon vacuum  *DIFM0 14
* polarisation, photon-Z mixing, non-photonic vertex corrections       *DIFM0 15
* also:  soft   photonic corrections (virtual + bremsstrahlung)        *DIFM0 16
*                                                                      *DIFM0 17
* INPUT:   S   = (CMS-ENERGY)**2 (GEV**2)                              *DIFM0 18
*          XMZ = Z MASS          (GEV)                                 *DIFM0 19
*          XMH = HIGGS MASS      (GEV)                                 *DIFM0 20
*          XMT = TOP MASS        (GEV)                                 *DIFM0 21
* The values of various masses and couplings in the PARAMETER state-   *DIFM0 22
* ments should be identical to the values used in the PARAMETER state- *DIFM0 23
* ments used in the subprograms RNORM,RESZ,IMSZ,REPG,IMPG,RESGZ,DELIMZ *DIFM0 24
*    Author:     Wolfgang Hollik  (Universitaet Hamburg and DESY)      *DIFM0 25
*    based on:   Gerrit Burgers (CERN/TH)       Version:  July  1988   *DIFM0 26
************************************************************************DIFM0 27
      IMPLICIT DOUBLE PRECISION(A-Z)                                    DIFM0 28
      INTEGER I,ICOUNT,J,K                                              DIFM0 29
      COMPLEX*16 CHIG, CHIZ, CHIGZ, CGG, SGZ, SZZ, CHI0,                DIFM0 30
     .           AMM, APP, AMP, APM,                                    DIFM0 31
     .           L2, L3, L2Z, L2W, L3W,                                 DIFM0 32
     .           FZV, FZA, FGV, FGA, FZVF, FZAF, FGVF, FGAF , ONE,      DIFM0 33
     .           FLE, FLF, FLGE, FLGF,                                  DIFM0 34
     .           VE, AE, VF, AF, CHI ,                                  DIFM0 35
     .           CG1, CG3, CH1, CH3                                     DIFM0 36
      DIMENSION VE(8), AE(8), VF(8), AF(8), CHI(8)                      DIFM0 37
      COMMON /HELIC/ S1,S2,S3,S4                                        HELIC  2
      REAL*8         S1,S2,S3,S4                                        HELIC  3
      COMMON /HOLBOS/MZ,MW,MH                                           HOLBOS 2
      REAL*8         MZ,MW,MH                                           HOLBOS 3
      COMMON /HAD/XU,XD,XS,XC,XB,MT                                     HAD    2
      REAL*8      XU,XD,XS,XC,XB,MT                                     HAD    3
      COMMON /RENORM/ DELTAR, RESW0, RESWW, RESZZ, SUBZZ, SUBWW, SUBGZ  RENORM 2
      REAL*8          DELTAR, RESW0, RESWW, RESZZ, SUBZZ, SUBWW, SUBGZ  RENORM 3
      COMMON/COUPL/ SW,CW,SW1,CW1, V,A,VU,VD                            COUPL  2
      REAL*8        SW,CW,SW1,CW1, V,A,VU,VD                            COUPL  3
      COMMON / GSWPRM /SWSQ,AMW,AMZ,AMH,AMTOP,GAMMZ                     GSWPRM 2
      REAL*8           SWSQ,AMW,AMZ,AMH,AMTOP,GAMMZ                     GSWPRM 3
C     SWSQ        = sin2 (theta Weinberg)                               GSWPRM 4
C     AMW,AMZ     = W & Z boson masses respectively                     GSWPRM 5
C     AMH         = the Higgs mass                                      GSWPRM 6
C     AMTOP       = the top mass                                        GSWPRM 7
C     GAMMZ       = Z0 width                                            GSWPRM 8
      COMMON / KEYSET / KEYGSW,KEYRAD,KEYTAB                            KEYSET 2
      INTEGER KEYGSW,KEYRAD,KEYTAB                                      DIFM0 45
      PARAMETER(PI=3.1415926535897932D0, ALFINV=137.036D0)              DIFM0 46
      PARAMETER(ONE=(1.D0,0.D0))                                        DIFM0 47
      PARAMETER(A0=37.281D0**2)                                         DIFM0 48
      PARAMETER(ME=0.5110034D-3,MMU=0.10565943D0,MTAU=1.7842D0,         DIFM0 49
     .          MU=0.04145D0,MD=0.04146D0,MS=0.150D0,MC=1.5D0,MB=4.5D0) DIFM0 50
*HOLC2 ALFAS HAS BEEN REMOVED                                           DIFM0 51
      PARAMETER(MPI=0.140D0)                                            DIFM0 52
      PARAMETER(EPS=1.D-3)                                              DIFM0 53
      SAVE                                                              DIFM0 54
      DATA ICOUNT /0/                                                   DIFM0 55
*                                                                       DIFM0 56
* The following block-if is executed when DIFMU  is called for the firstDIFM0 57
* time.  From then on, this block-if  is only executed when the mass    DIFM0 58
* parameters have changed with respect to the previous call.  As a largeDIFM0 59
* part of the calculation of DIFMU  is independent of s, this saves     DIFM0 60
* much computertime                                                     DIFM0 61
      IF(ICOUNT.EQ.0 .OR. ABS(MZ-XMZ).GT.EPS .OR. ABS(MH-XMH).GT.EPS    DIFM0 62
     .   .OR. ABS(MT-XMT).GT.EPS                             ) THEN     ZW910121
*        WRITE(5,'('' INITIALISING... '')')                             DIFM0 64
         ICOUNT=ICOUNT+1                                                DIFM0 65
         IF (KEYGSW.GT.1) THEN                                          DIFM0 66
C        =====================                                          DIFM0 67
         MZ=XMZ                                                         DIFM0 68
         MH=XMH                                                         DIFM0 69
         MT=XMT                                                         DIFM0 70
*        ALFAS=XALFAS                                                   DIFM0 71
*                                                                       DIFM0 72
* Iterative determination of SW and MW from MZ,MH and MT                DIFM0 73
* SW is sin**2 theta weak.  Start with approximate value.               DIFM0 74
         SQ=DSQRT(1.D0-4.D0*A0/MZ**2/(1.D0-.07D0))                      DIFM0 75
         SWOLD=(1.D0-SQ)/2.D0                                           DIFM0 76
         MW=MZ*SQRT(1.D0-SWOLD)                                         DIFM0 77
         CALL RNORM(MZ,MW,MH,MT)                                        DIFM0 78
* RNORM calculates the Common/RENORM/ which contains DELTAR and the re- DIFM0 79
* normalisation constants RESZZ, SUBZZ (needed later in the calculation DIFM0 80
* of the real part of the Z self energy) and RESGZ (for the Z photon    DIFM0 81
* mixing).  Also the coupling constants in Common/COUPL/ are calculated.DIFM0 82
         DO 1 I=1,10                                                    DIFM0 83
           SQ=DSQRT(1.D0-4.D0*A0/MZ**2/(1.D0-DELTAR))                   DIFM0 84
           SW=(1.D0-SQ)/2.D0                                            DIFM0 85
           MW=MZ*SQRT(1.D0-SW)                                          DIFM0 86
           CALL RNORM(MZ,MW,MH,MT)                                      DIFM0 87
           IF(ABS(SW-SWOLD).LT.3D-6) GOTO 2                             DIFM0 88
           SWOLD= SW                                                    DIFM0 89
   1     CONTINUE                                                       DIFM0 90
         WRITE(6,'('' NO SUFFICIENT CONVERGENCE FOR SW IN 10 STEPS'')') DIFM0 91
   2     CONTINUE                                                       DIFM0 92
         ELSE                                                           DIFM0 93
C        ====                                                           DIFM0 94
           SW=SWSQ                                                      DIFM0 95
           CW=1.D0-SW                                                   DIFM0 96
          SW1= SQRT(SW)                                                 DIFM0 97
          CW1= SQRT(CW)                                                 DIFM0 98
           MZ=AMZ                                                       DIFM0 99
         ENDIF                                                          DIFM0100
C        =====                                                          DIFM0101
*  couplings and  charges:                                              DIFM0102
         GAE = -1D0/(4D0*SW1*CW1)                                       DIFM0103
         GVE = -(1D0-4D0*SW)/(4.D0*SW1*CW1)                             DIFM0104
         QE = -1.D0                                                     DIFM0105
         GAF= GAE                                                       DIFM0106
         GVF= GVE                                                       DIFM0107
         QF = -1.D0                                                     DIFM0108
*uu      GAF= -GAE                                                      DIFM0109
*uu      GVF= (1.D0-8.D0*SW/3.D0)/(2.D0*SW1*CW1)                        DIFM0110
*uu      QF = 2.D0/3.D0                                                 DIFM0111
*dd      GAF=  GAE                                                      DIFM0112
*dd      GVF= (4.D0*SW/3.D0-1.D0)/(2.D0*SW1*CW1)                        DIFM0113
*dd      QF =-1.D0/3.D0                                                 DIFM0114
*                                                                       DIFM0115
*  threshold and final state corrections for quarks                     DIFM0116
         SMIN  = 4.D0*MMU**2                                            DIFM0117
         RQUARK= 1.D0                                                   DIFM0118
*qq      SMIN  = 4.D0*MPI**2                                            DIFM0119
*qq      RQUARK= 3. * (1.+ALFAS*(1.+ALFAS*(1.98-5.*0.115)/PI)/PI)       DIFM0120
*                                                                       DIFM0121
*  DELIMZ()/(1+PIZZ) is the correction to the Z widt                    DIFM0122
*                                                                       DIFM0123
         AL4PI = 1.D0/(4.D0*PI*ALFINV)                                  DIFM0124
      IF (KEYGSW.GT.1) THEN                                             DIFM0125
      WDTH0=IMSZ(MZ**2)                                                 DIFM0126
      ELSE                                                              DIFM0127
      WDTH0=AMZ*GAMMZ                                                   DIFM0128
      ENDIF                                                             DIFM0129
*        WRITE(6,'(''+              ...FINISHED'')')                    DIFM0130
      ENDIF                                                             DIFM0131
*                                                                       DIFM0132
* Begin of the   S dependent part.                                      DIFM0133
* N is a normalisation factor to convert the cross section into nbarn   DIFM0134
      N     = 0.D0                                                      DIFM0135
      IF(S.GT.SMIN)                                                     DIFM0136
     .  N   = RQUARK*389385.7D0*4.D0*PI/(3.D0*ALFINV**2*S)              DIFM0137
     .        * SQRT(1.D0-SMIN/S)*(1.D0+0.5D0*SMIN/S)                   DIFM0138
*  The Born cross section                                               DIFM0139
      CHI0 = S/DCMPLX(S-MZ**2,S/MZ**2*WDTH0)                            DIFM0140
      CHI1 = DREAL(CHI0)                                                DIFM0141
      CHI2 = DREAL(CHI0*DCONJG(CHI0))                                   DIFM0142
      G10  = 1D0+2D0*GVE**2*CHI1+(GVE**2+GAE**2)**2*CHI2                DIFM0143
      G30  =     2D0*GAE**2*CHI1+4D0*GVE**2*GAE**2*CHI2                 DIFM0144
      H0   =     2D0*GVE*GAE*(CHI1+(GVE**2+GAE**2)*CHI2)                DIFM0145
      SY0 = (1D0-S1*S2)*(1-S3*S4)*G10                                   DIFM0146
     .     +(S2-S1)*(S4-S3) *G30                                        DIFM0147
     .     +(S2-S1)*(1D0-S3*S4)*H0                                      DIFM0148
     .     +(1D0-S1*S2)*(S4-S3)*H0                                      DIFM0149
      AS0 = (1D0-S1*S2)*(1-S3*S4)*G30                                   DIFM0150
     .     +(S2-S1)*(S4-S3) *G10                                        DIFM0151
     .     +(S2-S1)*(1D0-S3*S4)*H0                                      DIFM0152
     .     +(1D0-S1*S2)*(S4-S3)*H0                                      DIFM0153
      SIG0 = SY0*(1D0+CT*CT) + AS0*2D0*CT                               DIFM0154
*                                                                       DIFM0155
*  QED corrections                                                      DIFM0156
      END                                                               DIFM0157
      FUNCTION BORNH(MODE,SVAR,COSTHE,TA,TB)
C======================================================================
C============ROUTINES TO DETACH SECOND ELECTROWEAK LIBRARY=============
C======================================================================
      IMPLICIT REAL*8(A-H,O-Z)
      PRINT *, 'SORRY, SECOND ELECTROWEAK LIBRARY IS NOT INTERFACED'
      BORNH=5.
      STOP
      END
      SUBROUTINE PRMHOL(ZMASS,GAMZ0,GAMMZ,WMASS,GAMW0,GAMW,SIN2W)
      IMPLICIT REAL*8(A-H,O-Z)
      PRINT *, 'SORRY, SECOND ELECTROWEAK LIBRARY IS NOT INTERFACED'
      STOP
      END
      SUBROUTINE HOLSTA(IDF,KEYGSW,YMZ,YMH,YMT)
      IMPLICIT REAL*8(A-H,O-Z)
      PRINT *, 'SORRY, SECOND ELECTROWEAK LIBRARY IS NOT INTERFACED'
      STOP
      END
