      SUBROUTINE EXPAND(MODE,XPAR,NPAR)     
C     ****************************************     
C  !!!!! LOGBOOK OF CORRECTIONS starting Nov. 91 !!!
C  R1 and R2 in KINEKR undefined
C  BREMKF, VVDIST moved to yfs3mod.f
C  VVDIST replaced with VVRHO from YFSFIG
C  VESK8A replaced by VESK1W
C  FUNSKO replaced by RHOSKO (change of name)
C  GAUSS replaced by GAUSJD
C  CMSENE shiftet to XPAR !!! 3 first entries in XPAR changed
C  CHBIN2 replaced by CHBIN1
C  XPAR(10,12) in output are swapped (to bhlumi convention)
*  Initialization of GLIBK in the generator
*  Bug with parameter(pi=...) corrected
C=======================================================================
C=======================================================================
C=============================YFS3======================================
C=====================FERMION PAIR PRODUCTION===========================
C===============INITIAL AND FINAL STATE EXPONENTIATION==================
C=======================================================================
C=======================================================================
C=======================YFS VERSION 3.3.0===============================
C=======================================================================
C=========================FEBRUARY  1993================================
C=======================================================================
C AUTHORS: 
C    S. JADACH, JAGELLONIAN UNIVERSITY, CRACOW, POLAND      
C    B.F.L. WARD, UNIVERSITY OF TENNESSEE, KNOXVILLE, TENNESSEE        
C=======================================================================
C          
C SOME CONTROLL HISTOGRAMING STILL IN PROGRAM      
C          
C generator of yennie-frautschi-suura type         
C with exponentiated single bremsstrahlung         
C********* input    
C mode =-1/0/1/2 defines       
C       initialization/generation/give-xsection/final-report  
C cmsene   = centre of mass energy (gev)  
C npar(1)=keyrad=1000001 initial state only        
C         keyrad=1000010 final state only          
C         keyrad=1000011 initial + final state     
C         keyrad=1000000 born without any bremss.  
C         keyrad=100n001 fixed initial state multiplicity (tests)      
C         keyrad=10k0010 fixed final   state multiplicity (tests)      
C npar(2)=keyred=0,1,2   three different reduction procedures          
C npar(3)=keywgt=0,1   unweighted/weighted events  
C xpar(1)=cmsene  =  mass of z0  
C xpar(2)=amaz    =  mass of z0  
C xpar(3)=sinw2   =  sin(thetaweinberg)**2  
C xpar(4)=gammz   =  width of z0 
C xpar(5)=amfin   =  mass of final fermion  
C xpar(6)=vvmin   =  minimum v-variable (dimesionless) =epsilon 
C xpar(7)=vvmax   =  maximum v-variable   
C********* output   
C fourmomenta and photon multiplicity in /momset/  
C xpar(10)=xsecnb = cross section in nanobarns        
C xpar(11)=errel  = relative error (dimensionless)  
C xpar(12)=xsmc   = cross section in r-units   
C npar(10)=nevacc = number of generated events      
C**************************    
C For advanced users only:     
C (1) One may use KEYRAD < 0  for running at fixed v-variable,         
C in this case all events have  v=VMAX precisely.  
C (2) For KEYWGT=1 weighted events are generated and the user should   
C use the weight WTMOD from the common block /WGTALL/.      
C WTMOD is the actual model weight depending on other input params.    
C The other interesting possibility is to use      
C     WT=WTCRU1*WTCRU2*WTSET(i) where   
C     WTSET(71) =   zero-th order initial+final    
C     WTSET(72) =   first order   initial+final    
C     WTSET(73) =   second order  initial+final    
C and the following provide the corresponding components of x-section. 
C     WTSET(80) =   First order, beta0 contribution alone   
C     WTSET(81) =   First order, beta1 contribution alone   
C     WTSET(90) =   Second order, beta0 contribution alone  
C     WTSET(91) =   Second order, beta1 contribution alone  
C     WTSET(92) =   Second order, beta2 contribution alone  
C furthermore, for the initial state alone we provide       
C     WTSET( 1) =   zero-th order initial          
C     WTSET( 2) =   first order   initial          
C     WTSET( 3) =   second order  initial          
C and the corresponding components      
C     WTSET(20) =   First order, beta0 contribution alone   
C     WTSET(21) =   First order, beta1 contribution alone   
C     WTSET(30) =   Second order, beta0 contribution alone  
C     WTSET(31) =   Second order, beta1 contribution alone  
C     WTSET(32) =   Second order, beta2 contribution alone  
C N.B. WTMOD=WTCRU1*WTCRU2*WTSET(71)    
C     ************************ 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)          
      PARAMETER(PI=3.1415926535897932D0,ALFINV=137.03604D0) 
      DIMENSION  XPAR( *),NPAR( *)      
      COMMON / CGLIB / BLIBK(20000)
      SAVE   / CGLIB / 
      COMMON / CMONIT/ AVERWT,ERRELA,NEVTOT,NEVACC,NEVNEG,NEVOVE,NEVZER
      COMMON / MOMSET / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT      
      COMMON / MOMINI / XF1(4),XF2(4),XPHUM(4),XPHOT(100,4),NPHOX      
      COMMON / MOMFIN / YF1(4),YF2(4),YPHUM(4),YPHOT(100,4),NPHOY      
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF    
      COMMON / WGTALL / WTMOD,WTCRU1,WTCRU2,WTSET(100)      
      COMMON / KEYYFS / KEYZET,KEYBRM,KEYFIX,KEYRED,KEYWGT  
      COMMON / INOUT  / NINP,NOUT   
      COMMON / BXFMTS / BXOPE,BXCLO,BXTXT,BXL1I,BXL1F,BXL2F,BXL1G,BXL2G 
      CHARACTER*80      BXOPE,BXCLO,BXTXT,BXL1I,BXL1F,BXL2F,BXL1G,BXL2G 
      DIMENSION XXF(4)
      SAVE   / CMONIT /,/ MOMSET /,/ MOMINI /,/ MOMFIN /,/ WEKING /
      SAVE   / WGTALL /,/ KEYYFS /,/ INOUT  /,/ BXFMTS /
      SAVE   NEVGEN,KEYBIN,KEYBFI,CMSENE
      SAVE   IDYFS, WTMAX
      IF(MODE.EQ.-1) THEN      
C     ==================================================================
C     =====================INITIALIZATION===============================
C     ==================================================================

 6900 FORMAT('1',10(/,10X,A)) 
      WRITE(NOUT,6900)  
     $'  *************************************************************',
     $'  *  ****   ****  **********    *******          ***********  *',
     $'  *  ****   ****  **********  **********         **********   *',
     $'  *   **** ****   ****        *****                 ******    *',
     $'  *    ******     ********      ******    *****    ******     *',
     $'  *     ****      ********         *****  *****      ******   *',
     $'  *     ****      ****        **********         ***********  *',
     $'  *     ****      ****         *******           **********   *',
     $'  *************************************************************',
     $' '   

* ==========================================================
* Initialization of internal histogramming package GLIBK
* Let us keep for YFS3 the GLIBK ID-ent range from 2 to 1000 
* ==========================================================
      CALL GLIMIT(20000)
      CALL GOUTPU(NOUT)  

      CALL FILEXP(XPAR,NPAR)     
      IDYFS = 0
      CALL GBOOK1(IDYFS +5,'WT EXPAND  NPHOT.NE.0  $', 60 ,-1D0, 5D0)
      CALL GBOOK1(IDYFS +6,'WT EXPAND  NPHOT.NE.0  $', 60 ,-1D0, 0D0)
      CALL GBOOK1(IDYFS+11,'PHOTON MULTIPLICITY    $', 50,  0D0,50D0)
C GMONIT MONITORS WEIGHTS       
      CALL GMONIT(-1,IDYFS+71,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+72,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+73,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+74,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+75,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+78,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+79,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+70,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+80,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+81,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+90,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+91,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+92,0D0,1D0,1D0)  
      CMSENE = 2D0*ENE
      KEYBIN = MOD(KEYBRM,10)   
      KEYBFI = MOD(KEYBRM,100)/10       
      IF(KEYBIN.EQ.1) CALL KARLUD(-1,DUM1,DUM2)     
      IF(KEYBFI.EQ.1) CALL KARFIN(-1, XXF,DUMM1,DUMM2)      
      CALL  MODEL(-1,DUM1,DUM2) 
      NEVGEN=0      
      ELSEIF(MODE.EQ.0) THEN    
C     ==================================================================
C     =====================GENERATION===================================
C     ==================================================================
      NEVGEN=NEVGEN+1   
  100 CONTINUE      
C ===================   
C ...Initial state YFS2 type generator  
         IF(KEYBIN.EQ.1) THEN   
            CALL KARLUD( 0,WTKARL,DUM2)     
         ELSE       
            CALL GIBEA(CMSENE,AMFIN,XF1,XF2)        
            WTKARL = 1D0        
            NPHOX  = 0  
         ENDIF      
C ...Four-momentum of virtual Z 
         DO 27 K=1,4    
  27     XXF(K) = XF1(K)+XF2(K)         
C ===================   
C ...Final state momenta in the Z frame     
         IF(KEYBFI.EQ.1) THEN   
            CALL KARFIN(0, XXF,AMFIN,WTCFIN)        
         ELSE       
C ...No final state bremss, fermion momenta defined in Z frame  
            CALL KINF2( XXF,AMFIN,YF1,YF2)  
            WTCFIN = 1D0        
            NPHOY  = 0  
         ENDIF      
C ...Merging momenta and transform to CMS frame     
         CALL MERGIF    
C =================== All kinematics is fixed at this point =======     
         WTCRU1 = WTKARL        
         WTCRU2 = WTCFIN        
         WTCRUD = WTKARL*WTCFIN 
C =================== All weights are fixed at this point =========     
CCCC     IF(NEVGEN.LE.5) CALL DUMPI(NOUT)   
CCCC     IF(NEVGEN.LE.5) CALL DUMPF(NOUT)   
C ...Model weight   
         CALL MODEL(0,WTMAX,WTMDL)      
C ...principal model weight for WT=1 events (after rejection)   
         WT     = WTCRUD*WTMDL  
C ...Weigt monitoring   
         CALL GMONIT(0,IDYFS+73,WTCRUD*WTSET(73),WTMAX,0D0)       
         CALL GMONIT(0,IDYFS+72,WTCRUD*WTSET(72),WTMAX,0D0)       
         CALL GMONIT(0,IDYFS+71,WTCRUD*WTSET(71),WTMAX,0D0)       
         CALL GMONIT(0,IDYFS+75,WTCRUD*(WTSET(73)-WTSET(72)),WTMAX,0D0)
         CALL GMONIT(0,IDYFS+74,WTCRUD*(WTSET(72)-WTSET(71)),WTMAX,0D0)
         CALL GMONIT(0,IDYFS+80,WTCRUD*WTSET(80),WTMAX,0D0)       
         CALL GMONIT(0,IDYFS+81,WTCRUD*WTSET(81),WTMAX,0D0)       
         CALL GMONIT(0,IDYFS+90,WTCRUD*WTSET(90),WTMAX,0D0)       
         CALL GMONIT(0,IDYFS+91,WTCRUD*WTSET(91),WTMAX,0D0)       
         CALL GMONIT(0,IDYFS+92,WTCRUD*WTSET(92),WTMAX,0D0)       
C ...test histograms    
         XMULT=FLOAT(NPHOT)+.1D0        
         CALL GF1(IDYFS+11,XMULT,1D0)     
         IF(NPHOT.GE.0) CALL GF1(IDYFS+5,WT,1D0)  
         IF(WT.LT.0.)   CALL GF1(IDYFS+6,WT,1D0)  
C ...Rejection according to principal weight  
         IF(KEYWGT.EQ.0) THEN    
C ...unweihgted events with WT=1 
            CALL VARRAN(RN,1)
            CALL GMONIT(0,IDYFS+79,WT ,WTMAX,RN) 
            IF(WT.LT.0D0) THEN
              RWT=-WT
            ELSEIF(WT.LT.WTMAX) THEN
              RWT=0.0
            ELSE
              RWT=WT-WTMAX
            ENDIF    
            CALL GMONIT(0,IDYFS+70,RWT ,WTMAX,RN)    
            IF(RN.GT.WT/WTMAX) GOTO 100       
            WTMOD=1.D0    
C ...WTCRU1,2  weights are RESET to one 
            WTCRU1=1D0    
            WTCRU2=1D0    
         ELSE       
C ...weighted events      
            WTMOD  = WTCRUD*WTMDL       
            CALL GMONIT(0,IDYFS+79,WT     ,WTMAX,0D0)      
            CALL GMONIT(0,IDYFS+78,WTCRUD ,WTMAX,0D0)      
         ENDIF      
      ELSEIF(MODE.EQ.1.OR.MODE.EQ.2) THEN     
C     ==================================================================
C     =====================FINAL WEIGHT ANALYSIS========================
C     ==================================================================
      GNANOB=389.385D-30*1.D33   
      SIG0NB =  4D0*PI/(ALFINV**2*3D0*CMSENE**2)*GNANOB     
      XBORNB =  BORNY(CMSENE**2)*SIG0NB       
      IF(KEYBIN.EQ.1) THEN       
         CALL KARLUD(MODE,XKARL,ERKARL)       
      ELSE   
         XKARL  = BORNY(CMSENE**2)      
         ERKARL = 0D0     
      ENDIF  
      IF(KEYBFI.EQ.1) CALL KARFIN(MODE,XXF,DUMM1,DUMM2)     
C     
      CALL GMONIT(1,IDYFS+79,DUMM1,DUMM2,DUMM3)     
      NPAR(10)= NEVGEN    
      XSMC   =  XKARL*AVERWT     
      EREL   =  SQRT(ERKARL**2+ERRELA**2)     
      ERABS  =  XSMC*EREL        
      XSMCNB =  XSMC*SIG0NB      
      ERABS2 =  XSMCNB*EREL      
      XPAR(10)= XSMCNB
      XPAR(11)= EREL      
      XPAR(12)= XSMC             
      IF(KEYWGT.EQ.0) THEN              
C ...Weighted events, normal option     
         XPAR(20)=XSMCNB            
         XPAR(21)=EREL                  
         XPAR(22)=XSMC
      ELSE          
C ...Weighted events, additional information on x-sections  
         CALL GMONIT(1,IDYFS+78,DUMM1,DUMM2,DUMM3)                
         XPAR(20)= XKARL*SIG0NB     
         XPAR(21)= ERRELA               
         XPAR(22)= XKARL                
      ENDIF         
C NO PRINTOUT FOR MODE =1               
      IF(MODE.EQ.1) RETURN              
cc    CALL GPRINT(IDYFS+11)                 
      CALL GPRINT(IDYFS+ 5)                 
      CALL GPRINT(IDYFS+ 6)                 
      WRITE(NOUT,BXOPE)         
      WRITE(NOUT,BXTXT) 'EXPAND output - window A'              
      WRITE(NOUT,BXL1F) CMSENE,     'CMS energy total   ','CMSENE','A0'
      WRITE(NOUT,BXL2F) XSMC,ERABS, 'xs_tot MC R-units  ','XSMC  ','A1'
      WRITE(NOUT,BXL1F) XSMCNB,     'xs_tot    nanob.   ','XSMCNB','A3'
      WRITE(NOUT,BXL1F) ERABS2,     'absolute error     ','ERABS2','A4'
      WRITE(NOUT,BXL1F) EREL,       'relative error     ','EREL  ','A5'
      WRITE(NOUT,BXL1I) NEVTOT,     'total no of events ','NEVTOT','A6'
      WRITE(NOUT,BXL1I) NEVACC,     'accepted    events ','NEVACC','A7'
      WRITE(NOUT,BXL1I) NEVNEG,     'WT<0        events ','NEVNEG','A8'
      WRITE(NOUT,BXL1I) NEVOVE,     'WT>WTMAX    events ','NEVOVE','A9'
      WRITE(NOUT,BXL1F) WTMAX ,     'WTMAX              ','WTMAX ','A10'
      WRITE(NOUT,BXL1F) XBORNB,     'xs_Born   nanob.   ','XBORNB','A11'
      WRITE(NOUT,BXCLO)        
      IF ( (NEVNEG+NEVOVE) .GT. NEVACC/4000) THEN
        WRITE(NOUT,BXOPE)                 
        WRITE(NOUT,BXTXT) ' possible loss of precision !!!!!! '
        WRITE(NOUT,BXTXT) ' VVMAX too close to 1D0 ? '
        WRITE(NOUT,BXTXT) ' reduce VVMAX in KORALZ parameters!'
        WRITE(NOUT,BXTXT) ' it will faster program also !'
        WRITE(NOUT,BXTXT) ' WTMAX too small ?                 '
        WRITE(NOUT,BXTXT) ' Increase it in SUBROURTINE MODEL! ' 
        WRITE(NOUT,BXTXT) ' MANY events of negative weights?  ' 
        WRITE(NOUT,BXTXT) ' Contact JADACH at CERNVM,         ' 
        WRITE(NOUT,BXTXT) ' But check folowing weights first  ' 
        WRITE(NOUT,BXCLO)
        WRITE(NOUT,BXOPE)                 
        WRITE(NOUT,BXTXT) ' Rejection weight of YFS3               '
        WRITE(NOUT,BXCLO)
         CALL GMONIT(2,IDYFS+79,DUMM1,DUMM2,DUMM3)             
        WRITE(NOUT,BXOPE)                 
        WRITE(NOUT,BXTXT) ' contribution of over and underflows    '
        WRITE(NOUT,BXCLO)   
         CALL GMONIT(2,IDYFS+70,DUMM1,DUMM2,DUMM3)
        WRITE(NOUT,BXOPE)                   
        WRITE(NOUT,BXTXT) ' ratio averwt(id=70)/averwt(id=79)      '
        WRITE(NOUT,BXTXT) ' measures severity of error             '
        WRITE(NOUT,BXCLO)
      ENDIF 
C     ==================================================================
C     =============SUPPL. FINAL WEIGHT ANALYSIS=========================
C     ==================================================================
      WRITE(NOUT,BXOPE)                 
      WRITE(NOUT,BXTXT) '        EXPAND output - window B ' 
      WRITE(NOUT,BXTXT) '           X-sections in R-units ' 
      CALL GMONIT(1,IDYFS+73,DUMM1,DUMM2,DUMM3)                   
      XS03   =  XKARL*AVERWT            
      DXS03  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)      
      CALL GMONIT(1,IDYFS+72,DUMM1,DUMM2,DUMM3)                   
      XS02   =  XKARL*AVERWT            
      DXS02  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)      
      CALL GMONIT(1,IDYFS+71,DUMM1,DUMM2,DUMM3)                   
      XS01   =  XKARL*AVERWT            
      DXS01  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)      
      CALL GMONIT(1,IDYFS+75,DUMM1,DUMM2,DUMM3)                   
      XS05   =  XKARL*AVERWT            
      DXS05  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)      
      CALL GMONIT(1,IDYFS+74,DUMM1,DUMM2,DUMM3)                   
      XS04   =  XKARL*AVERWT            
      DXS04  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)      
      WRITE(NOUT,BXL2F) XS03,DXS03,'X-section','O(alf2)',  'B1'
      WRITE(NOUT,BXL2F) XS02,DXS02,'X-section','O(alf1)',  'B2'
      WRITE(NOUT,BXL2F) XS01,DXS01,'X-section','O(alf0)',  'B3'
      IF(XS02.NE.0D0) WRITE(NOUT,BXL2F)                     
     $ XS05/XS02,DXS05/XS02,'(O(alf2)-O(alf1))','/O(alf1)','B4'
      IF(XS01.NE.0D0) WRITE(NOUT,BXL2F)                     
     $ XS04/XS01,DXS04/XS01,'(O(alf1)-O(alf0))','/O(alf0)','B5'
      WRITE(NOUT,BXCLO)                 
C -------------     
      WTCRU1 = XKARL                    
      WTCRU2 = ERKARL                   
      CALL  MODEL(MODE,DUMM1,DUMM2)     
C -------------     
      ELSE          
C     ====          
      WRITE(NOUT,*) '===>EXPAND: WRONG MODE'                
      STOP          
      ENDIF         
C     =====         
      END                 
      SUBROUTINE MERGIF   
C     *****************   
C Merging two commons all photons together  
C Transformation to common (CMS) trame is supposed to be already done  
C     ************************************  
      IMPLICIT DOUBLE PRECISION  (A-H,O-Z)  
      COMMON / MOMSET / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT  
      COMMON / MOMINI / XF1(4),XF2(4),XPHUM(4),XPHOT(100,4),NPHOX 
      COMMON / MOMFIN / YF1(4),YF2(4),YPHUM(4),YPHOT(100,4),NPHOY 
C ...Photons              
      NPHOT  = 0          
      DO 130 I=1,NPHOX    
        NPHOT  =NPHOT+1   
        DO 130 K=1,4      
  130   SPHOT(NPHOT,K)=XPHOT(I,K)           
      DO 140 I=1,NPHOY    
        NPHOT  =NPHOT+1   
        DO 140 K=1,4      
  140   SPHOT(NPHOT,K)=YPHOT(I,K)           
C ...Final state fermions                   
      DO 145 K=1,4        
        QF1(K)= YF1(K)    
  145   QF2(K)= YF2(K)    
C ...Axiliary             
      DO 150 K=1,4        
  150    SPHUM(K)= XPHUM(K)+YPHUM(K)        
      END                 
      SUBROUTINE FILEXP(XPAR,NPAR)   
C     ***********************************   
C TRANSFERS AND DEFINES INPUT PARAMS, PRINTS INPUT PARAMETERS 
      IMPLICIT DOUBLE PRECISION  (A-H,O-Z)  
      DIMENSION  XPAR( *),NPAR( *)          
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF  
      COMMON / KEYYFS / KEYZET,KEYBRM,KEYFIX,KEYRED,KEYWGT    
      COMMON / SPISET / POLAR1,POLAR2,POLFI1,POLFI2           
      COMMON / UUREC  / UU,EPS,DELTA        
      COMMON / VVREC  / VVMIN,VVMAX,VV,BETI                   
      COMMON / INOUT  / NINP,NOUT     
      COMMON / BXFMTS / BXOPE,BXCLO,BXTXT,BXL1I,BXL1F,BXL2F,BXL1G,BXL2G 
      CHARACTER*80      BXOPE,BXCLO,BXTXT,BXL1I,BXL1F,BXL2F,BXL1G,BXL2G       
      COMMON / RANPAR / KEYRND
      SAVE / WEKING /,/ KEYYFS /,/ SPISET /,/ UUREC  /,/ VVREC  /
      SAVE / INOUT  /,/ BXFMTS /,/ RANPAR /

C ...BX-formats for nice and flexible outbuts                 
      BXOPE =  '(//1X,15(5H*****)    )'     
      BXTXT =  '(1X,1H*,                  A48,25X,    1H*)'   
      BXL1I =  '(1X,1H*,I17,                 16X, A20,A12,A7, 1X,1H*)'
      BXL1F =  '(1X,1H*,F17.8,               16X, A20,A12,A7, 1X,1H*)' 
      BXL2F =  '(1X,1H*,F17.8, 4H  +-, F11.8, 1X, A20,A12,A7, 1X,1H*)'
      BXL1G =  '(1X,1H*,G17.8,               16X, A20,A12,A7, 1X,1H*)'
      BXL2G =  '(1X,1H*,G17.8, 4H  +-, F11.8, 1X, A20,A12,A7, 1X,1H*)'
      BXCLO =  '(1X,15(5H*****)/   )'       

C  type of the RANDOM NUMBER GENERATOR RANMAR                   
      KEYRND = 1
C----------               
      KEYBRM= ABS(NPAR(1))                  
      KEYFIX= 0           
      IF(NPAR(1).LT.0) KEYFIX=1             
      KEYRED= NPAR(2)     
      KEYWGT= NPAR(3)     
      KEYZET= NPAR(4)     
      CMSENE = XPAR(1)      
      AMAZ   = XPAR(2)      
      SINW2  = XPAR(3)      
      GAMMZ  = XPAR(4)      
      AMFIN  = XPAR(5)      
      VVMIN  = XPAR(6)      
      VVMAX  = XPAR(7)      
      ENE    = CMSENE/2D0      
      VVMAX  = MIN(VVMAX,1D0-(AMFIN/ENE)**2)                   
      EPS    = VVMIN       
      DELTA  = EPS*1D-3    
      POLAR1 = 0D0          
      POLAR2 = 0D0          
      POLFI1 = 0D0          
      POLFI2 = 0D0          
      AMEL   = 0.5111D-3   
      IDE=2               
      IDF=2               
      XK0=3.D-3           
C
      WRITE(NOUT,BXOPE)         
      WRITE(NOUT,BXTXT) '    YFS VERSION 3.30   FEBR.  93        '
      WRITE(NOUT,BXL1F) CMSENE,     'CMS energy total   ','CMSENE','A0'
      WRITE(NOUT,BXL1I) KEYBRM,     'general QED switch ','KEYBRM','A1'
      WRITE(NOUT,BXL1F) AMFIN,      'final fermionmass  ','AMFIN ','A2'
      WRITE(NOUT,BXL1F) AMAZ,       'Z mass   [GeV]     ','AMAZ  ','A3'
      WRITE(NOUT,BXL1F) GAMMZ,      'Z width  [GeV]     ','GAMMZ ','A4'
      WRITE(NOUT,BXL1F) SINW2,      'sin(theta_W)**2    ','SINW2 ','A5'
      WRITE(NOUT,BXL1F) VVMIN,      'dummy infrared cut ','VVMIN ','A6'
      WRITE(NOUT,BXL1F) VVMAX,      'v_max ( =1 )       ','VVMAX ','A7'
      WRITE(NOUT,BXL1I) KEYRED,     'reduction  switch  ','KEYRED','A8'
      WRITE(NOUT,BXL1I) KEYWGT,     'weighting  switch  ','KEYWGT','A9'
      WRITE(NOUT,BXL1I) KEYZET,     'elect_weak switch  ','KEYZET','A10'
      WRITE(NOUT,BXCLO)         
      END                 
      SUBROUTINE KARLUD(MODE,PAR1,PAR2)     
C     *********************************     
C LOW LEVEL  MONTE-CARLO GENERATOR          
C ADMINISTRATES DIRECTLY GENERATION OF V-VARIABLE             
C AND INDIRECTLY OF ALL OTHER VARIABLES.    
C     ************************              
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
      PARAMETER (PI=3.1415926535897932D0,ALFINV= 137.03604D0)      
      PARAMETER (CEULER =0.57721566D0)                  
      PARAMETER (NMAX= 40)   
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF 
      COMMON / KEYYFS / KEYZET,KEYBRM,KEYFIX,KEYRED,KEYWGT    
C COMMUNICATES WITH VESKO/RHOSKO            
      COMMON / VVREC  / VVMIN,VVMAX,VV,BETI                   
      COMMON / INOUT  / NINP,NOUT     
C COMMUNICATES WITH GMONIT                  
      COMMON / CMONIT/ AVERWT,ERRELA,NEVTOT,NEVACC,NEVNEG,NEVOVE,NEVZER 
      COMMON / BXFMTS / BXOPE,BXCLO,BXTXT,BXL1I,BXL1F,BXL2F,BXL1G,BXL2G
      CHARACTER*80      BXOPE,BXCLO,BXTXT,BXL1I,BXL1F,BXL2F,BXL1G,BXL2G
      SAVE / WEKING /,/ KEYYFS /,/ VVREC  /,/ INOUT  /
      SAVE / CMONIT /,/ BXFMTS /
      SAVE SVAR,BETI2,GAMFAP,GAMFAC,GAMFA2,PREC,XCGAUS,XDEL,XCVESK
      SAVE IDYFS
      EXTERNAL RHOSKO
C MAXIMUM PHOTON MULTIPLICITY               
C       
      IF(MODE.EQ.-1) THEN                   
C     ==================================================================
C     ===================INITIALIZATION=================================
C     ==================================================================
      WRITE(NOUT,BXOPE)         
      WRITE(NOUT,BXTXT) 'Initialize KARLUD  start'              
      SVAR = 4D0*ENE**2
      BETI = 2D0/ALFINV/PI*(DLOG(4D0*ENE**2/AMEL**2)-1D0)     
      BETI2= 2D0/ALFINV/PI* DLOG(4D0*ENE**2/AMEL**2)          
      GAMFAP =1D0-PI**2*BETI**2/12D0        
      GAMFAC =EXP(-CEULER*BETI)/DPGAMM(1D0+BETI)               
      GAMFA2 =EXP(-CEULER*BETI2)/DPGAMM(1D0+BETI2)             
      IDYFS = 0
      CALL GBOOK1(IDYFS+ 7,'WT IN KARLUD         $', 50 , 0D0,5D0)
      CALL GMONIT(-1,IDYFS+51,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+52,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+53,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+54,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+55,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+56,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+59,0D0,1D0,1D0)  
      CALL VESK1W(-1,RHOSKO,XCVESK,DUM1,DUM2)             
      PREC = 1D-6
      XCGAUS =BREMKF(1,PREC)   
      XDEL = XCVESK/XCGAUS-1
      WRITE(NOUT,BXL1F) XCVESK,     'xs_crude  VESKO    ','XCVESK','  '
      WRITE(NOUT,BXL1F) XCGAUS,     'xs_crude  GAUSS    ','XCGAUS','  '
      WRITE(NOUT,BXL1F) XDEL       ,'XCVESK/XCGAUS-1    ','      ','  '
      WRITE(NOUT,BXTXT) 'Initialize KARLUD  end  '              
      WRITE(NOUT,BXCLO)         
      ELSEIF(MODE.EQ.0) THEN                
C     ==================================================================
C     ====================GENERATION====================================
C     ==================================================================
   30 CONTINUE            
C GENERATE VV             
      IF(KEYFIX.EQ.0) THEN                  
        CALL VESK1W( 0,RHOSKO,DUM1,DUM2,WTVES)           
      ELSE                
        WTVES=1D0
        VV=VVMAX          
      ENDIF               
C LOW-LEVEL MULTIPHOTON GENERATOR           
      CALL YFSGEN(VV,VVMIN,NMAX,WT1,WT2,WT3)                  
C--------------TESTS ON INTERNAL WEIGHTS    
C--------------DOES NOT INTERFERE WITH THE EVENT GENERATION !!! 
      REF  = VVRHO(50,SVAR,AMEL,VV,VVMIN)                   
      WTR  = REF/VVRHO(1,SVAR,AMEL,VV,VVMIN)                
      CALL VARRAN(RN,1)
      CALL GMONIT(0,IDYFS+56,WTR,1D0,RN)          
C PSEUDOREJECTION IN ORDER TO INTRODUCE REFERENCE XSECTION
      IF(KEYFIX.EQ.0 .AND. RN.GT.WTR) GOTO 110                
      WF1  = WT1*VVRHO(51,SVAR,AMEL,VV,VVMIN)/REF           
      WF2  = WT2*VVRHO(52,SVAR,AMEL,VV,VVMIN)/REF           
      WF3  = WT3          
      WF13 = WF1*WF3      
      WF123= WF1*WF2*WF3                    
      CALL GMONIT(0,IDYFS+51,WF1,  1D0,1D0)       
      CALL GMONIT(0,IDYFS+52,WF2,  1D0,1D0)       
      CALL GMONIT(0,IDYFS+53,WF3,  1D0,1D0)       
      CALL GMONIT(0,IDYFS+54,WF13, 1D0,1D0)       
      CALL GMONIT(0,IDYFS+55,WF123,1D0,1D0)       
  110 CONTINUE            
C--------------           
      WT=WTVES*WT1*WT2*WT3
      WTKARL=WT           
      CALL GMONIT(0,IDYFS+59,WT,  1D0,1D0)        
      CALL GF1(IDYFS+ 7,WT,1D0)           
      PAR1=WT             
      ELSE                
C     ==================================================================
C     ====================FINAL WEIGHT ANALYSIS=========================
C     ==================================================================
      CALL GPRINT(IDYFS+ 7)   
      CALL GMONIT(1,IDYFS+59,DUMM1,DUMM2,DUMM3)   
      WTKARL = AVERWT      
      ERKRL  = ERRELA 
      PREC   = 1D-6
      XSGS   = BREMKF(1,PREC)
      ERGS   = XSGS*PREC
      CALL VESK1W( 1,RHOSKO,XSVE,ERELVE,XCVESK)
      ERVE   = XSVE*ERELVE       
      IF(KEYFIX.EQ.1)  XCVESK=XCGAUS     
C Note that since VESK1W produces weighted events we are sending
C up the crude x-section (from VESK1W) to the calling program
      PAR1   = XCVESK         
      PAR2   = 0D0         
C NO PRINTOUT FOR MODE = 2                  
      IF(MODE.EQ.1) RETURN                  
      DDV    = XSVE/XSGS-1D0
      DDR    = ERELVE + 1D-6
      XSKR   = XCVESK*WTKARL
      ERKR   = XSKR*ERKRL
      WRITE(NOUT,BXOPE)         
      WRITE(NOUT,BXTXT) '     KARLUD  FINAL  REPORT     '
      WRITE(NOUT,BXTXT) '         window A              '
      WRITE(NOUT,BXL1I) NEVTOT,     'total no of events ','NEVTOT','A0'
      WRITE(NOUT,BXL1I) NEVNEG,     'WT<0        events ','NEVNEG','A1'
      WRITE(NOUT,BXL1F) XCVESK,     'xs_cru VESKO  [R]  ','XCVESK','A2'
      WRITE(NOUT,BXL2F) XSVE,ERVE,  'xs_est VESKO  [R]  ','XSVE  ','A3'
      WRITE(NOUT,BXL2F) XSGS,ERGS,  'xs_est Gauss  [R]  ','XSGS  ','A4'
      WRITE(NOUT,BXL2F) DDV,DDR,    'XCVE/XCGS-1        ','      ','A5'
      WRITE(NOUT,BXL2F) WTKARL,ERKRL,'   <WT>           ','WTKARL','A6'
      WRITE(NOUT,BXL2F) XSKR,ERKR,  'sigma_prim    [R]  ','XSKARL','A7'
      WRITE(NOUT,BXCLO)         
C     ==================================================================
C     =============SUPPL. FINAL WEIGHT ANALYSIS=========================
C     ==================================================================
      CALL GMONIT(1,IDYFS+51,DUMM1,DUMM2,DUMM3)   
      DEL1   = AVERWT-1D0                   
      DWT1   = ERRELA     
      CALL GMONIT(1,IDYFS+52,DUMM1,DUMM2,DUMM3)   
      AWF2   = AVERWT     
      DWT2   = ERRELA     
      CALL GMONIT(1,IDYFS+53,DUMM1,DUMM2,DUMM3)   
      AWF3   = AVERWT     
      DEL3   = AVERWT-GAMFA2                
      DWT3   = ERRELA     
      CALL GMONIT(1,IDYFS+54,DUMM1,DUMM2,DUMM3)   
      AWF4   = AVERWT     
      DEL4   = AVERWT-GAMFAC                
      DWT4   = ERRELA     
      WRITE(NOUT,BXOPE)         
      WRITE(NOUT,BXTXT) '     KARLUD  FINAL  REPORT     '
      WRITE(NOUT,BXTXT) '         window B              '
      WRITE(NOUT,BXL2F) DEL1,DWT1,  '<WF1>-1  mass wt   ','DEL1  ','B1'
      WRITE(NOUT,BXL2F) AWF2,DWT2,  '<WF2> dilat. weight','AWF2  ','B2'
      WRITE(NOUT,BXL2F) AWF3,DWT3,  '<WF3> dilat. weight','AWF3  ','B3'
      WRITE(NOUT,BXL2F) DEL3,DWT3,  '<WF3>-YGF(BETI2)   ','DEL3  ','B4'
      WRITE(NOUT,BXL2F) AWF4,DWT4,  '<WF1*WF3>          ','AWF4  ','B5'
      WRITE(NOUT,BXL2F) DEL4,DWT4,  '<WF1*WF3>-YGF(BETI)','DEL4  ','B6'
      WRITE(NOUT,BXCLO)         
C     ==================================================================
      CALL GMONIT(1,IDYFS+55,DUMM1,DUMM2,DUMM3)   
      AWF5   = AVERWT     
      DEL5   = AVERWT-GAMFAC                
      DWT5   = ERRELA     
      CALL GMONIT(1,IDYFS+56,DUMM1,DUMM2,DUMM3)   
      AWF6   = AVERWT     
      PREC = 1D-6
      XREFER = BREMKF(50,PREC)                   
      DELKAR = XREFER*AWF5/XSKR  -1D0       
      DELREF = XCVESK*AWF6/XREFER-1D0       
      WRITE(NOUT,BXOPE)         
      WRITE(NOUT,BXTXT) '     KARLUD  FINAL  REPORT CONT.   '
      WRITE(NOUT,BXTXT) '         WINDOW C                  '
      WRITE(NOUT,BXTXT) 'BETI= 2*ALFA/PI*(LOG(S/MEL**2)-1)       '
      WRITE(NOUT,BXTXT) 'GAMFAP= 1-PI**2*BETI**2/12              '
      WRITE(NOUT,BXTXT) 'GAMFAC=EXP(-CEULER*BETI)/GAMMA(1+BETI)  '
      WRITE(NOUT,BXTXT) 'GAMFA2=EXP(-CEULER*BETI2)/GAMMA(1+BETI2)'
      WRITE(NOUT,BXL1F)  BETI,        '                =','BETI  ','C1'
      WRITE(NOUT,BXL1F)  GAMFAP,      '                =','GAMFAP','C2'
      WRITE(NOUT,BXL1F)  GAMFAC,      '                =','GAMFAC','C3'
      WRITE(NOUT,BXL1F)  GAMFA2,      '                =','GAMFA2','C4'
      WRITE(NOUT,BXL2F) AWF5,DWT5, ' <WF1*WF3*WF4>      ','AWF5  ','C5'
      WRITE(NOUT,BXL2F) DEL5,DWT5, ' <WF1*WF3>-YGF(BETI)','DEL5  ','C6'
      WRITE(NOUT,BXTXT) 'DELKAR=XREFER*AVER(WF1*WF1*WF3)/XSKARL-1'
      WRITE(NOUT,BXTXT) 'DELREF=XCRUDE*AVER(WTR)/XREFER-1        '
      WRITE(NOUT,BXL1F) XREFER,    'reference x_sect.   ','XREFER','C7'
      WRITE(NOUT,BXL1F) DELKAR,    'XREFER*AWF5/XSKR  -1','DELKAR','C8'
      WRITE(NOUT,BXL1F) DELREF,    'XCVESK*AWF6/XREFER-1','DELREF','C9'
      WRITE(NOUT,BXCLO)         
      ENDIF               
C     =====               
      END                 
      FUNCTION RHOSKO(R)                    
C     ********************                  
C CALLED IN VESK1W        
C PROVIDES V OR K DISTRIBUTION TO BE GENERATED                
C     ********************                  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
      PARAMETER (FLEPS = 1D-35)
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF
      COMMON / KEYYFS / KEYZET,KEYBRM,KEYFIX,KEYRED,KEYWGT     
      COMMON / VVREC  / VVMIN,VVMAX,VV,BETI                   
C MAPPING  R => VV CHANGE  TO IMPROVE ON EFFICIENCY
C Note that the replacement below makes program more precise
C and bulet-proof with respect numerical instabilities close to VV=0    
      X = MAX(R,FLEPS**BETI)                
      BBT = -0.5D0        
      CALL CHBIN1(X,BETI,BBT,VVMAX,VV,RJAC)               
C BORN XSECTION           
C NOTE 1/(1-VV) FACTOR BECAUSE BORNY IS IN R-UNITS            
      SVAR   = 4D0*ENE**2
      SVAR1  = SVAR*(1D0-VV)                 
      XBORN  = BORNY(SVAR1)/(1D0-VV)         
C constant x-section for tests 
      IF(KEYZET.EQ.-2) XBORN = XBORN * (1D0-VV)
      RHOSKO = RJAC*XBORN* VVRHO(1,SVAR,AMEL,VV,VVMIN)
      END                 

      SUBROUTINE YFSGEN(VV,VMIN,NMAX,WT1,WT2,WT3)               
C     *******************************************               
C======================================================================
C================== Y F S G E N =======================================
C======================================================================
C*********INPUT                 
C VV    = V VARIABLE            
C VMIN  = MINIMUM V VARIABLE (INFRARED CUTOFF)  
C NMAX  = MAXIMUM PHOTON MULTIPLICITY           
C*********OUTPUT                
C WT1  = WEIGHT DUE TO NEGLECTED MASS TERMS     
C WT2  = WEIGHT DUE TO DILATATION OF PHOTON MOMENTA             
C WT3  = ANOTHER DILATATION WEIGHT              
C OTHER OUTPUT RESULTS IN /MOMINI/              
C*****************************                  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)       
      PARAMETER( PI=3.1415926535897932D0,ALFINV= 137.03604D0)
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF
      COMMON / MOMINI / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT 
      COMMON / KEYYFS / KEYZET,KEYBRM,KEYFIX,KEYRED,KEYWGT   
      SAVE / WEKING /,/ MOMINI /,/ KEYYFS /
      DIMENSION XPH(100),RR(100)                
C               
C HERE BETI2 MUST BE USED INSTEAD OF BETI (MASS TERM NEGLECTED) 
      BETI2 = 2D0/ALFINV/PI*DLOG(4D0*ENE**2/AMEL**2)            
      AM2=(AMEL/ENE)**2         
      DO 10 I=1,NMAX            
      XPH(I)=0D0                
      DO 10 J=1,4               
   10 SPHOT(I,J)=0D0            
      IF(VV.LE.VMIN) THEN       
C NO PHOTON ABOVE DETECTABILITY THRESHOLD       
         WT1=1D0                
         WT2=1D0                
         WT3=1D0                
         NPHOT=0                
      ELSE      
C ONE OR MORE PHOTONS, GENERATE PHOTON MULTIPLICITY             
C NPHOT = POISSON(WITH AVERAGE = AVERG) + 1     
         AVERG=BETI2*DLOG(VV/VMIN)              
  100    CALL POISSG(AVERG,NMAX,MULTP,RR)       
         NPHOT = MULTP+1        
C This is for tests of program at fixed multiplicity (for adv. users)
         NPHFIX =  MOD(KEYBRM,10000)/1000       
         IF(NPHFIX.NE.0.AND.NPHOT.NE.NPHFIX) GOTO 100           
         IF(NPHOT.EQ.1) THEN    
            XPH(1)=VV           
            CALL BREMUL(XPH,AM2,WT1)            
            DJAC0=(1D0+1D0/SQRT(1D0-VV))/2D0    
            WT2  = 1D0/DJAC0    
            WT3  = 1D0          
         ELSE                   
            XPH(1)=VV           
            DO 200 I=2,NPHOT    
  200       XPH(I)=VV*(VMIN/VV)**RR(I-1)        
            CALL BREMUL(XPH,AM2,WT1)            
            CALL RESOLH(VV,EXPY,DJAC)           
            DJAC0=(1D0+1D0/SQRT(1D0-VV))/2D0    
            WT2  = DJAC/DJAC0   
            WT3  = 1D0          
C SCALE DOWN PHOTON ENERGIES AND MOMENTA        
            DO 300 I=1,NPHOT    
            DO 300 K=1,4        
  300       SPHOT(I,K)=SPHOT(I,K)/EXPY          
C CHECK ON LOWER ENERGY CUT-OFF                 
            IF(SPHOT(NPHOT,4).LT.VMIN) WT3 =0D0                 
         ENDIF                  
      ENDIF     
C PHOTON MOMENTA IN GEV UNITS   
      DO 420 J=1,4              
  420 SPHUM(J)=0D0              
      DO 480 I=1,NPHOT          
      DO 480 J=1,4              
      SPHOT(I,J)=SPHOT(I,J)*ENE                 
  480 SPHUM(J)=SPHUM(J)+SPHOT(I,J)              
C DEFINE FERMION MOMENTA        
      CALL KINEKR               
      END       
      SUBROUTINE RESOLH(VV,EXPY,DJAC)           
C     *******************************           
C THIS SOLVES CONSTRAINT EQUATION ON PHOTON MOMENTA             
C ALSO CALCULATES CORRESPONDING JACOBIAN FACTOR                 
C INPUT:  VV    = COSTRAINT PARAMETER V         
C OUTPUT  EXPY  = RESCALING FACTOR - A SOLUTION OF THE EQUATION 
C         DJAC  = JACOBIAN FACTOR               
C     ************************                  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)       
      DIMENSION PP(4),PK(4)     
      COMMON / MOMINI / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT
      SAVE   / MOMINI /
C               
      DO 210 K=1,4              
      PK(K)=0D0                 
  210 PP(K)=0D0                 
      PP(4)=2D0                 
      DO 215 I=1,NPHOT          
      DO 215 K=1,4              
  215 PK(K)=PK(K)+SPHOT(I,K)    
      PPDPP=PP(4)**2-PP(3)**2-PP(2)**2-PP(1)**2                 
      PKDPK=PK(4)**2-PK(3)**2-PK(2)**2-PK(1)**2                 
      PPDPK=PP(4)*PK(4)-PP(3)*PK(3)-PP(2)*PK(2)-PP(1)*PK(1)     
      AA=PPDPP*PKDPK/(PPDPK)**2                 
      EXPY=2D0*PPDPK/PPDPP/VV   
C SOLUTION FOR CONSTRAINT ON PHOTON FOUR MOMENTA                
      EXPY=EXPY*.5D0*(1D0+SQRT(1D0-VV*AA))      
C JACOBIAN FACTOR               
      DJAC=(1D0+1D0/SQRT(1D0-VV*AA))/2D0        
      END       
      SUBROUTINE BREMUL(XPH,AM2,WT)             
C     *****************************             
C PROVIDES PHOTON FOURMOMENTA   
C INPUT  : XPH    = LIST OF PHOTON ENERGIES     
C OUTPUT : SPHOT  = LIST OF PHPTON FOUR-MOMENTA                 
C          WT     = WEIGHT DUE TO MASS TERMS    
C     ************************                  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)       
      PARAMETER( PI =3.1415926535897932D0)           
      COMMON / MOMINI / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT
      SAVE   / MOMINI /
      DIMENSION XPH(*)          

      WT=1D0    
      DO 100 I=1,NPHOT          
      XK=XPH(I)                 
      CALL VARRAN(RN,1)
      CALL ANGBRE(RN,AM2,CG,SG,DIST0,DIST1)     
      WTM   =DIST1/DIST0        
      WT    =WT*WTM             
      CALL VARRAN(RNUMB,1)
      PHI=2D0*PI*RNUMB          
      SPHOT(I,1)=XK*SG*COS(PHI)                 
      SPHOT(I,2)=XK*SG*SIN(PHI)                 
      SPHOT(I,3)=XK*CG          
      SPHOT(I,4)=XK             
  100 CONTINUE                  
      END       
      SUBROUTINE KINEKR         
C     *****************         
C CALLED IN YFSGEN              
C DEFINES FINAL STATE FERMION FOUR MOMENTA      
C     ************************                  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)       
      PARAMETER( PI =3.1415926535897932D0)           
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF
      COMMON / MOMINI / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT 
      SAVE   / WEKING /,/ MOMINI /
      DIMENSION QSU(4),DRVEC(10)          
C               
C QSU IS FOURMOMENTUM OF FINAL STATE FERMION PAIR               
      DO 10 K=1,4               
   10 QSU(K)=-SPHUM(K)          
      QSU(4)=QSU(4)+2D0*ENE     
      QSM =SQRT(QSU(4)**2-QSU(3)**2-QSU(2)**2-QSU(1)**2)        
C GENERATE MOMENTA OF FERMIONS IN THEIR REST FRAME WITH FLAT DISTR.
      QF1(4)=QSM/2D0            
      QF2(4)=QSM/2D0            
      QMD=SQRT(QF1(4)**2-AMFIN**2)              
      CALL VARRAN(DRVEC,2)
      R1 = DRVEC(1)
      R2 = DRVEC(2)
      COSTH=-1D0+2D0*R1         
      SINTH=SQRT(1D0-COSTH**2)                  
      QF1(1)=QMD*SINTH*COS(2D0*PI*R2)           
      QF1(2)=QMD*SINTH*SIN(2D0*PI*R2)           
      QF1(3)=QMD*COSTH          
      DO 30 K=1,3               
   30 QF2(K)=-QF1(K)            
C TRANSFORM BACK TO CMS         
      IF(NPHOT.GE.1) THEN       
        CALL BOSTDQ(-1,QSU,QF1,QF1)             
        CALL BOSTDQ(-1,QSU,QF2,QF2)             
      ENDIF     
C======================================================================
C==================END OF YFSGEN=======================================
C======================================================================
      END       
      SUBROUTINE KARFIN(MODE, XXF,AMFIN,WT)     
C     ***************************************   
C ======================================================================
C ... Low level Monte Carlo for final state multibremsstrahlung 
C ======================================================================
C Input:        
C         XXF    = CMS four momentum of the entire final state  
C  system i.e. fermions + photons               
C         AMFIN  = mass of final state fermion  
C Hidden input:  EPS, DELTA in /VVREC/, formats in /BXFMTS/     
C Output:       
C            WT  = crude MC weight              
C         Momenta in /MOMFIN/   
C     ***********************************       
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)       
      DIMENSION XXF(4)          
      COMMON / MOMFIN / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT
      COMMON / UUREC  / UU,EPS,DELTA            
C COMMUNICATES WITH GMONIT      
      COMMON / CMONIT/ AVERWT,ERRELA,NEVTOT,NEVACC,NEVNEG,NEVOVE,NEVZER
      COMMON / INOUT  / NINP,NOUT         
      DIMENSION  MK(100), WTMAS(100)            
      COMMON / BXFMTS / BXOPE,BXCLO,BXTXT,BXL1I,BXL1F,BXL2F,BXL1G,BXL2G
      CHARACTER*80      BXOPE,BXCLO,BXTXT,BXL1I,BXL1F,BXL2F,BXL1G,BXL2G
      SAVE / MOMFIN /,/ UUREC  /,/ CMONIT/,/ INOUT  /,/ BXFMTS /
      SAVE NEVGEN,MARTOT,IDYFS
C               
      IF(MODE.EQ.-1) THEN       
C     ===================       
      WRITE(NOUT,BXOPE)         
      WRITE(NOUT,BXTXT) 'Initialize KARFIN  start'              
      IDYFS = 0
      CALL GBOOK1(IDYFS+20,'KARFIN: log10(k/eps) marked $',50, 0D0, 5D0)
C ...Additional check on WTCTRL, plot of its u-dependence       
      CALL GBOOK1(IDYFS+31,'KARFIN:     U  WTCTRL       $',27,.1D0, 1D0)
      CALL GBOOK1(IDYFS+32,'KARFIN:     U  WT=1         $',27,.1D0, 1D0)
      CALL GMONIT(-1,IDYFS+60,0D0,1D0,1D0)      
      CALL GMONIT(-1,IDYFS+61,0D0,1D0,1D0)      
      CALL GMONIT(-1,IDYFS+62,0D0,1D0,1D0)      
      CALL GMONIT(-1,IDYFS+63,0D0,1D0,1D0)      
      CALL GMONIT(-1,IDYFS+64,0D0,1D0,1D0)      
      CALL GMONIT(-1,IDYFS+65,0D0,1D0,1D0)      
      CALL GMONIT(-1,IDYFS+66,0D0,1D0,1D0)      
      CALL GMONIT(-1,IDYFS+69,0D0,1D0,1D0)      
      NEVGEN=0                  
      MARTOT=0                  
      WRITE(NOUT,BXTXT) 'Initialize KARFIN  end  '              
      WRITE(NOUT,BXCLO)         
      ELSEIF(MODE.EQ.0) THEN    
C     ======================    
      NEVGEN=NEVGEN+1           
      SVAR = XXF(4)**2-XXF(3)**2-XXF(2)**2-XXF(1)**2            
      CMSENE = SQRT(SVAR)       
      EMIN = EPS*CMSENE/2       
      CALL MBREF(SVAR,AMFIN,DELTA,              
     $           UU,NPHOT,SPHOT,SPHUM,MK,QF1,QF2,WT1,WT2,WTMAS) 
      CALL KINF1(XXF,QF1,QF2,NPHOT,SPHOT,SPHUM)                 
      WT3=1D0                   
      WCTRL=1D0                 
      WTREM=1D0                 
      IF(WT1.NE.0.D0) THEN      
C ...optionally remove photons below epsilon from the record    
C ...and reorganize mass weights                
         CALL PIATEK(AMFIN,EMIN,DELTA,WTMAS,WTREM,WT3,WCTRL)    
      ENDIF     
      XMUL= NPHOT               
      CALL GMONIT(0,IDYFS+64,XMUL,20D0,0D0)           
      CALL GMONIT(0,IDYFS+65,WCTRL,1D0,0D0)           
      CALL GF1(IDYFS+31, UU  ,WCTRL)          
      CALL GF1(IDYFS+32, UU  ,  1D0)          
      CALL GMONIT(0,IDYFS+66,WTREM,1D0,0D0)           
C ...Monitoring weights         
      XML = NPHOT               
      CALL GMONIT(0,IDYFS+60,XML,20D0,0D0)            
      CALL GMONIT(0,IDYFS+61,WT1,1D0,0D0)             
      CALL GMONIT(0,IDYFS+62,WT2,1D0,0D0)             
      CALL GMONIT(0,IDYFS+63,WT3,1D0,0D0)             
C ...marked photons             
      IF(NPHOT.GE.1) THEN       
         DO 60 I=1,NPHOT        
         XK= SPHOT(I,4)/EMIN    
         UL= LOG10(XK)          
         IF(MK(I).EQ.1)   CALL GF1(IDYFS+20,   UL,1.D0)       
         IF(MK(I).EQ.1)   MARTOT=MARTOT+1       
   60    CONTINUE               
      ENDIF     
C ...Main weight                
      WT = WT1*WT2*WT3          
      CALL GMONIT(0,IDYFS+69,WT ,1D0,0D0)             
      ELSE      
C     ====      
C ...no printout for MODE=1     
      IF(MODE.EQ.1) RETURN      
C-----------------------------------------------------------------------
C.........................Output window A...............................
      CALL GMONIT(1,IDYFS+60,AVMULT,DUMM2,DUMM3)      
      CALL GMONIT(1,IDYFS+61,AWT61,DWT61,DUMM3)       
      CALL GMONIT(1,IDYFS+62,AWT62,DWT62,DUMM3)       
      CALL GMONIT(1,IDYFS+63,AWT63,DWT63,DUMM3)       
      CALL GMONIT(1,IDYFS+69,AWT69,DWT69,DUMM3)       
C ...General information on weights             
      WRITE(NOUT,BXOPE)         
      WRITE(NOUT,BXTXT) 'KARFIN output - window A'              
      WRITE(NOUT,BXTXT) '    Weight Statistics   '              
      WRITE(NOUT,BXL2F) AWT69,DWT69,' general weight    ','WT    ','A1'
      WRITE(NOUT,BXL1I) NEVGEN,     ' generated events  ','NEVGEN','A2'
      WRITE(NOUT,BXL1F) AVMULT,     ' aver. ph. multi.  ','AVMULT','A3'
      WRITE(NOUT,BXL1I) MARTOT,     ' Marked photons    ','MARTOT','A4'
      WRITE(NOUT,BXL2F) AWT61,DWT61,' Kinematics, smin  ','WT1   ','A5'
      WRITE(NOUT,BXL2F) AWT62,DWT62,' Jacobian          ','WT2   ','A6'
      WRITE(NOUT,BXL2F) AWT63,DWT63,' Photon ang. dist. ','WT3   ','A7'
      WRITE(NOUT,BXCLO)         
C ...Specific details on mass weight rearrangenment, and rejection
      CALL GMONIT(1,IDYFS+64,AVMLT,DWT65,DUMM3)       
      CALL GMONIT(1,IDYFS+65,AWT65,DWT65,DUMM3)       
      CALL GMONIT(1,IDYFS+66,AWT66,DWT66,DUMM3)       
      NZER66 = NEVZER           
      NTOT66 = NEVTOT           
      WRITE(NOUT,BXOPE)         
      WRITE(NOUT,BXTXT) 'KARFIN output - window B'              
      WRITE(NOUT,BXTXT) '    on mass weights     '              
      WRITE(NOUT,BXL2F) AWT66,DWT66,' removal wgt WTREM ','WT6 ','B1'
      WRITE(NOUT,BXL1I) NTOT66,     ' no. of raw events ','    ','B2'
      WRITE(NOUT,BXL1I) NZER66,     ' WT6=0      events ','    ','B3'
      WRITE(NOUT,BXL1F) AVMLT,      ' raw ph. multipl.  ','    ','B4'
      WRITE(NOUT,BXL2F) AWT65,DWT65,' control wgt WCTRL ','WT5 ','B5'
      WRITE(NOUT,BXL1G) EPS,        ' epsilon           ','    ','B6'
      WRITE(NOUT,BXL1G) DELTA,      ' delta             ','    ','B7'
      WRITE(NOUT,BXCLO)         
C ...Histograms                 
cc      CALL GPRINT(IDYFS+20)         
cc      CALL GOPERA(IDYFS+31,'/',IDYFS+32,IDYFS+33,1D0,1D0)   
cc      CALL GPRINT(IDYFS+33)         
      ENDIF     
C     =====     
      END       
      SUBROUTINE PIATEK(AMFIN,EMIN,DELTA,WTMAS,WTREM,WTM3A,WCTRL)
C     ***********************************************************
C Written CERN piatek 22 sept. 89  (S.J.)       
C Note the action of this routine is not Loretnz invariant !!!! 
C         KEYPIA   =0,1 REMOVAL OF PHOTONS BELOW EMIN OFF/ON    
C INPUT:  momenta in / MOMFIN /                 
C         AMFIN    = fermion mass (GEV)         
C         EMIN     = Emin minimum energy of photons to be left (GEV)
C         DELTA    = infrared cut-off in generation (dimrnsionless)
C         WTMAS    = list of mass weights for all photons       
C OUTPUT: WTREJ    = 1 for KEYPIA=0             
C  = mass weight of removed photons for KEYPIA=1                
C         WTM3T    = mass weight for all photons, see comments below
C         WCTRL    = control weight for remowed photons         
C     ***********************************       
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)       
      PARAMETER(PI=3.1415926535897932D0,ALFINV=137.03604D0)     
      DIMENSION  WTMAS(100)     
      COMMON / MOMFIN / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT
      COMMON / KEYYFS / KEYZET,KEYBRM,KEYFIX,KEYRED,KEYWGT      
      COMMON / INOUT  / NINP,NOUT  
      SAVE / MOMFIN /,/ KEYYFS /,/ INOUT  /
      DIMENSION QQ(4),PP(4)

      KEYPIA = KEYRED           
      DO 10 K=1,4               
      PP(K) = QF1(K)+QF2(K) +SPHUM(K)           
  10  QQ(K) = QF1(K)+QF2(K)     
      SVAR = PP(4)**2-PP(3)**2 -PP(2)**2 -PP(1)**2              
      SPRIM= QQ(4)**2-QQ(3)**2 -QQ(2)**2 -QQ(1)**2              
      WTM1=1D0                  
      WTM2=1D0                  
C ...mass weight below and above epsilon calculated separately  
      DO 40 I=1,NPHOT           
      IF(SPHOT(I,4).LT.EMIN) THEN               
         WTM1=WTM1*WTMAS(I)     
         IF(WTM1.LE.1D-30) WTM1=0D0             
      ELSE      
         WTM2=WTM2*WTMAS(I)     
         IF(WTM2.LE.1D-30) WTM2=0D0             
      ENDIF     
   40 CONTINUE                  
C ...All sort of weights        
      ALF1  =  1/PI/ALFINV      
      QQK  = QQ(4)*SPHUM(4)-QQ(3)*SPHUM(3)-QQ(2)*SPHUM(2)-QQ(1)*SPHUM(1)
C ...delt1 and eps1 are cutoffs which sit in YFS formfactor     
      DELT1 =  DELTA*(1+ 2*QQK/SPRIM)           
      EPS1  =  SQRT(EMIN**2/QF1(4)/QF2(4))      
C ...YFS formfactor cut-off dependend part: delt1 = 2Emin/sqrt(s')
C ...where Emin is infrared cut-off in QMS      
      FYFS  = -2*ALF1*(DLOG(SPRIM/AMFIN**2)-1)*DLOG(1/DELT1)    
C ...The total phase space integral for crude x-section,        
C ...Note that delta is a lower limit on y-variables used in generation
      FPHS  =  2*ALF1* DLOG(SVAR/AMFIN**2) *DLOG(1/DELTA)       
      DELB  =  FYFS + FPHS      
C ...The average mass weight for removed photon = EXP(DELB2)    
C ...Can be calculated analyticaly as a  ratio of YFS formfactors
C ...On the other hand it is checked by MC, see control weight WTCTRL
      DELB2 = -2*ALF1*(DLOG(SVAR/SPRIM)+1) *DLOG(EPS1/DELT1)    
C ...Control weight - its average should be precisely one       
      WCTRL =WTM1*EXP(-DELB2)   
      IF(KEYPIA.EQ.0) THEN      
         IF(ABS(DELB).GT.100D0 ) WRITE(NOUT,*) ' DELB= ',DELB  
         IF(ABS(DELB).GT.100D0 ) WRITE(   6,*) ' DELB= ',DELB  
         WTREM = 1D0            
         WTM3A = WTM1*WTM2*EXP(DELB)            
      ELSE      
C ...Optional removal of photons below epsilon from the record  
C ...in such a case WTM3A includes exp(BELB2)= <WT3> for removed ph.
         NPH=NPHOT              
         DO 100 J=NPHOT,1,-1    
         IF(SPHOT(J,4).LT.EMIN) THEN            
            DO 60 I=J+1,NPH     
            DO 60 K=1,4         
   60       SPHOT(I-1,K)=SPHOT(I,K)             
            NPH=NPH-1           
         ENDIF                  
  100    CONTINUE               
         NPHOT=NPH              
C ...WTMAS includes here average weight of removed photons exp(DELB2)
         WTREM = WTM1           
         WTM3A = WTM2*EXP(DELB+DELB2)           
      ENDIF     
      END       
      SUBROUTINE WFORM(CMSENE,Q1,Q2,AMF,DELTA,EPS,DYFS)         
C     *************************************************         
C Not used, kept for some future tests          
C Yennie-Fraytschi-Suura Formfactors for the final state ferm. pair
C     ***********************************       
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)       
      PARAMETER(PI=3.1415926535897932D0,ALFINV=137.03604D0)     
      PARAMETER(ALF1=1/ALFINV/PI)         
      DIMENSION Q1(4),Q2(4)     

      SVAR  = CMSENE**2         
      ENE= CMSENE/2             
C ...Momenta q1,q2 should be in CMS             
      E1 = Q1(4)                
      E2 = Q2(4)                
      BETF2 = 2*ALF1* DLOG(SVAR /AMF**2)        
      DELB  = BETF2*DLOG(ENE/SQRT(E1*E2)*EPS/DELTA)             
      EP    = E1+E2             
      EM    = E1-E2             
      Q1Q2  = Q1(4)*Q2(4)-Q1(3)*Q2(3)-Q1(2)*Q2(2)-Q1(1)*Q2(1)   
      DL    = SQRT( 2*Q1Q2 +EM**2 )             
      REMN  = PI**2/2           
     $        -0.50*DLOG(E1/E2)**2              
     $        -0.25*DLOG((DL+EM)**2/(4*E1*E2))**2               
     $        -0.25*DLOG((DL-EM)**2/(4*E1*E2))**2               
     $        - DILOGY((DL+EP)/(DL+EM)) -DILOGY((DL-EP)/(DL-EM))  
     $        - DILOGY((DL-EP)/(DL+EM)) -DILOGY((DL+EP)/(DL-EM))  
      DYFS  = EXP( DELB +ALF1*REMN )            
      END       
      SUBROUTINE MBREF(SVAR,AMFIN,DELTA,        
     $                 UU,NPHOT,PHOT,PHSU,MK,Q1,Q2,WT1,WT2,WTM) 
C     *****************************************************************
C SIMULATES FINAL STATE BREMSSTRAHLUNG (11 MARCH 1989)         
C INPUT  : SVAR   = S VARIABLE  (GEV)         
C          AMFIN  = MASS OF FINAL FERMION     
C          DELTA  = LOWER ENERGY BOUND (DIMENSIONLESS)         
C OUTPUT : UU     = 1-s'/s   
C          NPHOT  = PHOTON MULTIPLICITY       
C          PHOT   = PHOTON FOUR MOMENTA (GEV) IN CMS           
C          PHSU   = SUM OF PHOTON MOMENTA     
C          MK     = MARKS ON PHOTONS CLOSE TO LOWER ENERGY BOUND 
C          Q1     = FINAL FERMION FOUR MOMENTUM (GEV)          
C          Q2     = FINAL FERMION FOUR MOMENTUM                
C          WT1    = THE WEIGHT - PHASE SPACE LIMITS FOR VERY HARD PHOT.
C          WT2    = THE WEIGHT - TRANSLATION JACOBIAN.         
C          WTM    = The list of mass weights.                  
C     **************************************  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)     
      PARAMETER(PI=3.1415926535897932D0,ALFINV=137.03604D0)    
      DIMENSION PHOT(100,4),PHSU(4),MK(100),WTM(100),Q1(4),Q2(4)
      DIMENSION RR(100),XK(100),CGX(100),SGX(100)              
      COMMON / INOUT  / NINP,NOUT       
      COMMON / KEYYFS / KEYZET,KEYBRM,KEYFIX,KEYRED,KEYWGT
      SAVE / INOUT  /,/ KEYYFS /

C KEYCMS =0 INHIBITS TRANSFORMATION TO CMS    
C INITIALIZATIONS            
      UU= -1D0               
      WT1=1.D0               
      WT2=1.D0               
      AM2= 4.D0*AMFIN**2/SVAR                 
      DO 10 I=1,100          
      RR(I)=0.D0             
   10 MK(I)=0                
      DO 20 K=1,4            
      PHSU(K)=0.D0           
      Q1(K)=0.D0             
   20 Q2(K)=0.D0             
      DO 21 I=1,100          
      DO 21 K=1,4            
   21 PHOT(I,K)=0.D0         
C GENERATE PHOTON MULTIPLICITY, AVERG = AVERAGE MULTIPLICITY (CRUDE)
      BETF2 = 2/PI/ALFINV*DLOG(SVAR/AMFIN**2)                  
      AVERG = BETF2*DLOG(1/DELTA)             
      NMAX=50                
    5 CONTINUE               
      CALL POISSG(AVERG,NMAX,NPHOT,RR)        
C This is for tests of program at fixed multiplicity (for adv. users)
      NPHFIX =  MOD(KEYBRM,100000)/10000      
      IF(NPHFIX.NE.0.AND.NPHOT.NE.NPHFIX) GOTO 5               
      IF(NPHOT.EQ.0) THEN    
          SPRIM=SVAR         
      ELSE                   
C BEGIN WITH PHOTON ENERGY   
          XSUM=0.D0          
          DO  50 I=1,NPHOT   
          XK(I)=DELTA**RR(I)                  
          IF(XK(I).LT.SQRT(10.D0)*DELTA) MK(I)=1               
   50     XSUM=XSUM+XK(I)    
          IF(XSUM.GE.1.D0) GOTO 900           
          DO 60 I=1,NPHOT    
   60     XK(I)=XK(I)/(1.D0-XSUM)             
          DO 100 I=1,NPHOT   
C ...Photons close to low energy boundry marked for further control
          CALL VARRAN(RN1,1)
          CALL VARRAN(RN2,1)
C ...Simplified photon angular distribution,  
C ...s'->s and m**2/(kp)**2 dropped           
C ...CG=cos(theta) and SG=sin(theta) memorized to avoid rounding err.
          CALL ANGBRE(RN1,AM2,CG,SG,WTM(I),DIS1)               
          PHI=2.D0*PI*RN2    
C ...Define photon mementa (in units of sqrt(s')/2 )           
          PHOT(I,1)=XK(I)*SG*COS(PHI)         
          PHOT(I,2)=XK(I)*SG*SIN(PHI)         
          PHOT(I,3)=XK(I)*CG                  
          PHOT(I,4)=XK(I)    
          DO 70 K=1,4        
   70     PHSU(K)=PHSU(K)+PHOT(I,K)           
          CGX(I)=CG          
          SGX(I)=SG          
  100     CONTINUE           
C ...Determine rescaling factor and s', WT2 is dilatation Jacobian 
          XMK2 = PHSU(4)**2-PHSU(3)**2-PHSU(2)**2-PHSU(1)**2   
          YY   = 1.D0/(1.D0 +PHSU(4) +XMK2/4.D0 )              
          WT2  = YY*(1.D0+PHSU(4))            
          SPRIM= SVAR*YY     
C ...reject events with too hard photons      
          SMINI= 4*AMFIN**2                   
          IF(SPRIM.LT.SMINI) GOTO 900         
C ...recsale properly all photon momenta      
          ENER = SQRT(SPRIM)/2.D0             
          DO 120 K=1,4       
          PHSU(K)= PHSU(K)*ENER               
          DO 120 I=1,NPHOT   
  120     PHOT(I,K)=PHOT(I,K)*ENER            
C-----------Mass weight---------------------  
C ...This weight compensates for s->s' and droping terms -m**2/(k.q)**2 
C ...care is taken of machine rounding errors                  
          AMF= 4.D0*AMFIN**2/SPRIM            
          BTF =SQRT(1.D0-AMF)                 
          DO 200 I=1,NPHOT   
          IF( CGX(I).GT.0.D0 ) THEN           
              DEL2=1.D0+BTF*CGX(I)            
              DEL1= (SGX(I)**2 + AMF*CGX(I)**2)/DEL2           
          ELSE               
              DEL1=1.D0-BTF*CGX(I)            
              DEL2= (SGX(I)**2 + AMF*CGX(I)**2)/DEL1           
          ENDIF              
          DIST1=1/DEL1/DEL2                   
     $            -AMF/(1.D0+BTF )/2.D0*(1.D0/DEL1**2+1.D0/DEL2**2)
          IF(DIST1.LT.0.D0) THEN              
              DIST1=0D0      
              WRITE(NOUT,*) ' +++++++ MBREF: NEGATIVE WTMAS =',DIST1
              WRITE(   6,*) ' +++++++ MBREF: NEGATIVE WTMAS =',DIST1
          ENDIF              
          WTM(I)= DIST1/WTM(I)                
          IF(WTM(I).LT. 1.D-20) WTM(I)= 0.D0  
  200     CONTINUE           
      ENDIF                  
      UU   = 1 - SPRIM/SVAR                   
      ENER= SQRT(SPRIM)/2.D0                  
C FINAL FERMION MOMENTA      
      Q1(4)=ENER             
      Q1(3)=SQRT(ENER**2-AMFIN**2)            
      Q2(4)=ENER             
      Q2(3)=-Q1(3)           
      RETURN                 
C EVENT OUTSIDE PHASE SPACE                   
  900 WT1=0.D0               
      WT2=1.D0               
      NPHOT=-1               
      END                    
      SUBROUTINE KINF1(XXF,Q1,Q2,NPHOT,PHOT,PHSU)              
C     *******************************************              
C Transforms to CMS: PHOT, PHSU, Q1,Q2        
C with random Euler rotation in XXF frame (Z frame)            
C     ***********************************     
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)     
      PARAMETER( PI = 3.1415926535897932D0)               
      DIMENSION XXF(4),PHOT(100,4),PHSU(4),Q1(4),Q2(4)         
      DIMENSION PH(4),PP(4),DRVEC(10)                   

      IF(NPHOT.EQ.-1) RETURN                  
      CALL VARRAN(DRVEC,2)
      RN1 = DRVEC(1)
      RN2 = DRVEC(2)
      CTH= 1.D0 -2.D0*RN1    
      THE= ACOS(CTH)         
      PHI= 2.D0*PI*RN2       
      DO 210 K=1,4           
  210 PP(K)=Q1(K)+Q2(K)+PHSU(K)               
      DO 230 I=1,NPHOT       
          DO 220 K=1,4       
  220     PH(K)=PHOT(I,K)    
          CALL BOSTDQ(  1, PP,PH,PH)          
          CALL ROTEUL(THE,PHI,PH,PH)          
          CALL BOSTDQ( -1,XXF,PH,PH)          
          DO 225 K=1,4       
  225     PHOT(I,K)= PH(K)   
  230 CONTINUE               
      CALL BOSTDQ(  1, PP,Q1,Q1)              
      CALL ROTEUL(THE,PHI,Q1,Q1)              
      CALL BOSTDQ( -1,XXF,Q1,Q1)              
      CALL BOSTDQ(  1, PP,Q2,Q2)              
      CALL ROTEUL(THE,PHI,Q2,Q2)              
      CALL BOSTDQ( -1,XXF,Q2,Q2)              
      CALL BOSTDQ(  1, PP,PHSU,PHSU)          
      CALL ROTEUL(THE,PHI,PHSU,PHSU)          
      CALL BOSTDQ( -1,XXF,PHSU,PHSU)          
      END                    
      SUBROUTINE ROTEUL(THE,PHI,PVEC,QVEC)    
C     ************************************    
C EULER ROTATION             
      IMPLICIT REAL*8(A-H,O-Z)                
      REAL*8 PVEC(4),QVEC(4)                  
      CALL ROTOD1(THE,PVEC,QVEC)              
      CALL ROTOD3(PHI,QVEC,QVEC)              
      END                    
      SUBROUTINE GIBEA(CMSENE,AMEL,P1,P2)     
C     ***********************************     
C GIVEN CMS ENERGY (CMSENE) DEFINES BEAM MOMENTA IN CMS        
C     ***********************************     
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)     
      DIMENSION P1(*),P2(*)                   
      BETEL=SQRT(1D0-4D0*AMEL**2/CMSENE**2)   
      P1(1)=  0D0            
      P1(2)=  0D0            
      P1(3)=  CMSENE/2D0*BETEL                
      P1(4)=  CMSENE/2D0     
      P2(1)=  0D0            
      P2(2)=  0D0            
      P2(3)= -CMSENE/2D0*BETEL                
      P2(4)=  CMSENE/2D0     
      END                    
      SUBROUTINE KINF2(XXF,AMFIN,Q1,Q2)       
C     ************************************    
C ...Generates two body phase space with uniform spherical density 
C ...For pure Born case (no bremss.)          
C     ***********************************     
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)     
      PARAMETER( PI = 3.1415926535897932D0)               
      DIMENSION XXF(*),Q1(*),Q2(*),DRVEC(10)            

      CMSENE= SQRT(XXF(4)**2-XXF(3)**2-XXF(2)**2-XXF(1)**2)    
      CALL VARRAN(DRVEC,2)
      RN1 = DRVEC(1)
      RN2 = DRVEC(2)
      CTH= 1.D0 -2.D0*RN1    
      THE= ACOS(CTH)         
      PHI= 2.D0*PI*RN2       
      CALL GIBEA(CMSENE,AMFIN,Q1,Q2)          
      CALL ROTEUL(THE,PHI,Q1,Q1)              
      CALL BOSTDQ( -1,XXF,Q1,Q1)              
      CALL ROTEUL(THE,PHI,Q2,Q2)              
      CALL BOSTDQ( -1,XXF,Q2,Q2)              
C======================================================================
C=====================End of KARFIN part===============================
C======================================================================
      END                    
      SUBROUTINE POISSG(AVERG,NMAX,MULT,RR)
C     ************************************** 
C Last corr. Nov. 91              
C This generates photon multipl. NPHOT according to Poisson distr. 
C INPUT:  AVERG = AVERAGE MULTIPLICITY   
C         NMAX  = MAXIMUM MULTIPLICITY   
C OUTPUT: MULT = GENERATED MULTIPLICITY 
C         RR(1:100) LIST OF ORDERED UNIFORM RANDOM NUMBERS, 
C         A BYPRODUCT RESULT, TO BE EVENTUALLY USED FOR SOME FURTHER
C         PURPOSE (I.E.  GENERATION OF PHOTON ENERGIES). 
C     ************************           
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION RR(*)                    
      COMMON / INOUT  / NINP,NOUT  
      SAVE   / INOUT  /
      SAVE NFAIL
      DATA NFAIL/0/                      
   50 NN=0                               
      SUM=0D0                            
      DO 100 IT=1,NMAX                   
      CALL VARRAN(RN,1)
      Y= LOG(RN)                         
      SUM=SUM+Y                          
      NN=NN+1                            
      RR(NN)=SUM/(-AVERG)                
      IF(SUM.LT.-AVERG) GOTO 130         
  100 CONTINUE                           
      NFAIL=NFAIL+1                      
      IF(NFAIL.GT.100) GOTO 900          
      GOTO 50                            
  130 MULT=NN-1                         
      RETURN                             
  900 WRITE(NOUT,*) ' POISSG: TO SMALL NMAX'
      STOP                               
      END                                

      SUBROUTINE ANGBRE(RN1,AM2,COSTHG,SINTHG,DIST0,DIST1)
C     **************************************************** 
C THIS ROUTINE GENERATES PHOTON ANGULAR DISTRIBUTION 
C IN THE REST FRAME OF THE FERMION PAIR. 
C THE DISTRIBUTION IS TAKEN IN THE INFRARED LIMIT.
C GENERATES WEIGHTED EVENTS              
C INPUT:  AM2 = 4*MASSF**2/S WHERE MASSF IS FERMION MASS
C         AND S IS FERMION PAIR EFFECTIVE MASS.
C OUTPUT: COSTHG, SINTHG, COS AND SIN OF THE PHOTON 
C         ANGLE WITH RESPECT TO FERMIONS DIRECTION 
C         DIST0 = distribution  generated without m**2/(kp)**2 terms
C         DIST1 = distribution  with m**2/(kp)**2 terms 
C     *************************************** 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      BETA=SQRT(1.D0-AM2)                
      EPS=AM2/(1.D0+SQRT(1.D0-AM2))      
      DEL1=(2.D0-EPS)*(EPS/(2.D0-EPS))**RN1 
      DEL2=2.D0-DEL1                     
C SYMMETRIZATION                         
      CALL VARRAN(RN2,1)
      IF(RN2.LE.0.5D0) THEN              
        A=DEL1                           
        DEL1=DEL2                        
        DEL2=A                           
      ENDIF                              
      DIST0=1D0/DEL1/DEL2                
      DIST1=DIST0-EPS/2.D0*(1D0/DEL1**2+1D0/DEL2**2)
C CALCULATION OF SIN AND COS THETA FROM INTERNAL VARIABLES 
      COSTHG=(1.D0-DEL1)/BETA            
      SINTHG=SQRT(DEL1*DEL2-AM2)/BETA    
      END                                

      SUBROUTINE DUMPS(NOUT)                 
C     **********************                 
C THIS PRINTS OUT FOUR MOMENTA OF PHOTONS    
C ON UNIT NO. NOUT                           
C     **********************                 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)    
      COMMON / MOMSET / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT  
      SAVE   / MOMSET /
      DIMENSION SUM(4)                       
      WRITE(NOUT,*) '=====================DUMPS===================='
      WRITE(NOUT,3100) 'QF1',(  QF1(  K),K=1,4) 
      WRITE(NOUT,3100) 'QF2',(  QF2(  K),K=1,4) 
      DO 100 I=1,NPHOT                       
  100 WRITE(NOUT,3100) 'PHO',(SPHOT(I,K),K=1,4) 
      DO 200 K=1,4                           
  200 SUM(K)=QF1(K)+QF2(K)                   
      DO 210 I=1,NPHOT                       
      DO 210 K=1,4                           
  210 SUM(K)=SUM(K)+SPHOT(I,K)               
      WRITE(NOUT,3100) 'SUM',(  SUM(  K),K=1,4) 
 3100 FORMAT(1X,A3,1X,5F18.14)               
      END                                    

      SUBROUTINE DUMPF(NOUT)                 
C     **********************                 
C THIS PRINTS OUT FOUR MOMENTA OF PHOTONS    
C ON UNIT NO. NOUT                           
C     **********************                 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)    
      COMMON / MOMFIN / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT
      SAVE   / MOMFIN /
      DIMENSION SUM(4)                       
      WRITE(NOUT,*) '=====================DUMPF====================' 
      WRITE(NOUT,3100) 'QF1',(  QF1(  K),K=1,4) 
      WRITE(NOUT,3100) 'QF2',(  QF2(  K),K=1,4)  
      DO 100 I=1,NPHOT                       
  100 WRITE(NOUT,3100) 'PHO',(SPHOT(I,K),K=1,4) 
      DO 200 K=1,4                           
  200 SUM(K)=QF1(K)+QF2(K)                   
      DO 210 I=1,NPHOT                       
      DO 210 K=1,4                           
  210 SUM(K)=SUM(K)+SPHOT(I,K)               
      WRITE(NOUT,3100) 'SUM',(  SUM(  K),K=1,4) 
 3100 FORMAT(1X,A3,1X,5F18.14)               
      END                                    

      SUBROUTINE DUMPI(NOUT)                 
C     **********************                 
C THIS PRINTS OUT FOUR MOMENTA OF PHOTONS    
C ON UNIT NO. NOUT                           
C     **********************                 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)    
      COMMON / MOMINI / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT 
      SAVE   / MOMINI /
      DIMENSION SUM(4)                       
      WRITE(NOUT,*) '=====================DUMPI===================='
      WRITE(NOUT,3100) 'QF1',(  QF1(  K),K=1,4) 
      WRITE(NOUT,3100) 'QF2',(  QF2(  K),K=1,4) 
      DO 100 I=1,NPHOT                       
  100 WRITE(NOUT,3100) 'PHO',(SPHOT(I,K),K=1,4) 
      DO 200 K=1,4                           
  200 SUM(K)=QF1(K)+QF2(K)                   
      DO 210 I=1,NPHOT                       
      DO 210 K=1,4                           
  210 SUM(K)=SUM(K)+SPHOT(I,K)               
      WRITE(NOUT,3100) 'SUM',(  SUM(  K),K=1,4) 
 3100 FORMAT(1X,A3,1X,5F18.14)               
      END                                    

      SUBROUTINE DUMPN(NOUT,IEV)                 
C     **************************                 
C THIS PRINTS OUT FOUR MOMENTA OF final state     
C and the serial number of event IEV on unit NOUT
C     **********************                 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)    
      COMMON / MOMINI / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT 
      SAVE   / MOMINI /
      DIMENSION SUM(4)                       
      WRITE(NOUT,*) '=============DUMPNEW====================>',IEV
      WRITE(NOUT,3100) 'QF1',(  QF1(  K),K=1,4) 
      WRITE(NOUT,3100) 'QF2',(  QF2(  K),K=1,4) 
      DO 100 I=1,NPHOT                       
  100 WRITE(NOUT,3100) 'PHO',(SPHOT(I,K),K=1,4) 
      DO 200 K=1,4                           
  200 SUM(K)=QF1(K)+QF2(K)                   
      DO 210 I=1,NPHOT                       
      DO 210 K=1,4                           
  210 SUM(K)=SUM(K)+SPHOT(I,K)               
      WRITE(NOUT,3100) 'SUM',(  SUM(  K),K=1,4) 
 3100 FORMAT(1X,A3,1X,5F18.14)               
      END   

