C new version january 1992
C VERSION FEBRUARY 1990  
C VERSION FROM CERN 28 NOV 89             
C FYFS CORRECTED         
C BETA1 FOR FINA STATE TO BE CORRECTED, NO MODIFICATIONS DUE E.W. 
C.... XXKARL NOT A MODEL PARAMETER ANY MORE   
C.....monitoring weight shifted to MONIN  
C COSMETIC CHANGE IN GIFYFS               
C !!!!!!!  LOGBOOK of correction !!!!
*** PRAMETER an IMPLICIT interchanged in UURHO 
*** VVRHO and UURHO are made to be exactly the same as in YFSFIG
    
C----------------------------------------------------------------------
C---------------Model for initial + final------------------------------
C----------------------------------------------------------------------
      SUBROUTINE MODEL(MODE,PAR1,PAR2)    
C     ********************************    
C THIS ROUTINE DEFINES WEIGHT FOR A MODEL TO BE IMPLEMENTED    
C ON TOP OF BASIC DISTRIBUTION FROM KARLUD    
C Above VLIM1/2 the contribution from beta1/2 is not calculated,  
C This saves time, for precision 1D-4 use VLIM1=1.D-4 and VLIM2=0.04
C              and for precision 1D-3 use VLIM1=1.D-3 and VLIM2=0.12
C     **********************************  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      PARAMETER(NPMX=25) 
      PARAMETER(VLIM1= 1.D-9, VLIM2= 1.D-9)   
      COMMON / MOMINI / XF1(4),XF2(4),XPHUM(4),XPHOT(100,4),NPHOX 
      COMMON / MOMFIN / QF1(4),QF2(4),YPHUM(4),YPHOT(100,4),NPHOY
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF
      COMMON / KEYYFS / KEYZET,KEYBRM,KEYFIX,KEYRED,KEYWGT     
      COMMON / WGTALL / WTMOD,WTCRU1,WTCRU2,WTSET(100)         
      COMMON / INOUT  / NINP,NOUT   
      SAVE / MOMINI /,/ MOMFIN /,/ WEKING /,/ KEYYFS /
      SAVE / WGTALL /,/ INOUT  /
C Spying on weights.........              
      COMMON / BETSPY / BETA00,BETA01,BETA02,BETI01,BETI02,    
     $  BETA10(NPMX),BETA11(NPMX),BETA20(NPMX,NPMX),           
     $  SFACX(NPMX),SFACY(NPMX),          
     $  BETX10(NPMX),BETX11(NPMX),BETY10(NPMX),BETY11(NPMX),   
     $  BETXX20(NPMX,NPMX),BETXY20(NPMX,NPMX),BETYY20(NPMX,NPMX),
     $  BETI10(NPMX),BETI11(NPMX),BETI20(NPMX,NPMX),            
     $  BETF10(NPMX),BETF11(NPMX),BETF20(NPMX,NPMX)  
      SAVE / BETSPY /
C ...........            
      DIMENSION P1(4),P2(4),QQ(4),PP(4),XX(4),XPH1(4),XPH2(4)  
      SAVE KEYBIN,KEYBFI,ICONT,ICLIM,ICLIM2
C   
      IF(MODE.EQ.-1) THEN                 
C     =================================================================
C     =====================INITIALIZATION==============================
C     =================================================================
C ...Initial/final state bremsstrahlung switches               
      KEYBIN  = MOD(KEYBRM,10)            
      KEYBFI  = MOD(KEYBRM,100)/10        
      IF(KEYBIN.EQ.1) CALL MONIN(-1)      
      ICONT =  0         
      ICLIM =  0         
      ICLIM2=  50
      ELSEIF(MODE.EQ.0) THEN              
C     =================================================================
C     ===================MODEL X-SECTION===============================
C     =================================================================
      ICONT=ICONT+1      
      WTMAX=3.5D0        
      WTMDL=1D0          
      DO 10 I=1,100      
   10 WTSET(I)=0D0       
C ...Return for events outside phase space    
      IF(WTCRU1*WTCRU2.EQ.0D0) GOTO 770   
      CMSENE=2D0*ENE     
C define beam momenta    
      CALL GIBEA(CMSENE,AMEL,P1,P2)       
C define 4-mometum XX of (virtual) Z      
      DO 20 K=1,4        
      PP(K)= P1(K)+ P2(K)                 
      QQ(K)=QF1(K)+QF2(K)                 
   20 XX(K)=XF1(K)+XF2(K)                 
      SVAR  = PP(4)**2-PP(3)**2-PP(2)**2-PP(1)**2              
      SVAR1 = XX(4)**2-XX(3)**2-XX(2)**2-XX(1)**2              
      SVAR2 = QQ(4)**2-QQ(3)**2-QQ(2)**2-QQ(1)**2              
      VV = 1D0 -SVAR1/SVAR                
      UU = 1D0 -SVAR2/SVAR1               
C ...Crude distribution  
      CALL NCRUDE(XX,DISCRU)              
C ...Beta0, up to first order             
      CALL NDIST0(XX,P1,P2,QF1,QF2,ANDIS,DELI1,DELI2,DELF1,DELF2)
C ...Various versions of Beta0, initial+final                
      BETA02 = ANDIS*(1D0+DELI1+DELI2)*(1D0+DELF1+DELF2)      
      BETA01 = ANDIS*(1D0+DELI1)*(1D0+DELF1)     
      BETA00 = ANDIS    
C ...Initial only      
      BETI02 = ANDIS*(1D0+DELI1+DELI2)     
      BETI01 = ANDIS*(1D0+DELI1)           
      BETF01 = ANDIS*(1D0+DELF1)           
      IF(ICONT.LE.ICLIM) CALL NTEST0(XX,P1,P2,QF1,QF2)         
    
C ...BETA1...BETA1...BETA1...BETA1...     
C ...Contributions from beta1 (divided by S-factors)           
C ...First INITIAL state radiation        
      SUMX10=0D0         
      SUMX11=0D0         
      SUMI11=0D0         
      IF(KEYBIN.EQ.1 .AND. VV.GT.VLIM1) THEN  
      DO  80 JPH=1,NPHOX 
        DO 50 K=1,4      
   50   XPH1(K)=XPHOT(JPH,K)              
        CALL SFACH0(P1,P2,XPH1,SFACJ)     
        SFACX(JPH) = SFACJ                
        CALL NDIST1(XX,P1,P2,QF1,QF2,XPH1,DIST,DXLI1)
        DIST11=  DIST*(1D0+DXLI1)*(1+DELF1)     
        DIST10=  DIST
        DISI11=  DIST*(1D0+DXLI1)           
        IF(ICONT.LE.ICLIM) CALL NTEST1(XX,P1,P2,QF1,QF2,XPH1)  
C ...BETX contains virtual final state corr. while BETI does not
c;;;; in O(alf1) factor 1+defl1 helps factorization
        BETX10(JPH) = (DIST10 -BETA00*SFACJ )*(1+DELF1)
        BETX11(JPH) =  DIST11 -BETA01*SFACJ
        SUMX10      =  SUMX10 +BETX10(JPH) /SFACJ              
        SUMX11      =  SUMX11 +BETX11(JPH) /SFACJ              
        BETI10(JPH) =  DIST10 -BETA00*SFACJ
        BETI11(JPH) =  DISI11 -BETI01*SFACJ   
        SUMI11      =  SUMI11 +BETI11(JPH) /SFACJ              
   80   CONTINUE         
      ELSE               
        DO 90 JPH=1,NPHOX                 
        SFACX(JPH)  = -1D0                
        BETX10(JPH) =  0D0                
        BETX11(JPH) =  0D0                
        BETI10(JPH) =  0D0                
        BETI11(JPH) =  0D0                
   90   CONTINUE         
      ENDIF              
C ...FINAL state - beta1 
      SUMY10=0D0         
      SUMY11=0D0         
      IF(KEYBFI.EQ.1 .AND. UU.GT.VLIM1) THEN  
      DO 120 JPH=1,NPHOY 
        DO 115 K=1,4     
C note minus sign here!!!!                
  115   XPH1(K)=-YPHOT(JPH,K)             
        CALL SFACH0(QF1,QF2,XPH1,SFACJ)   
        SFACY(JPH) = SFACJ                
        CALL FDIST1(XX,P1,P2,QF1,QF2,XPH1,DIST,DYLF1)       
        DIST11=  DIST*(1D0+DYLF1)*(1+DELI1)     
        DIST10=  DIST    
        IF(ICONT.LE.ICLIM) CALL NTEST1(XX,QF1,QF2,P1,P2,XPH1)  
C ...BETY comprises initial state virtual corrections!         
ccc;;; in O(alf1) factor 1+deli1 helps factorization
        BETY10(JPH) = (DIST10 -BETA00*SFACJ  )*(1D0+DELI1)
        BETY11(JPH) =  DIST11 -BETA01*SFACJ   
        SUMY10      =  SUMY10 +BETY10(JPH) /SFACJ              
        SUMY11      =  SUMY11 +BETY11(JPH) /SFACJ              
        BETF10(JPH) =  DIST10 -BETA00*SFACJ
        BETF11(JPH) =  DISI11 -BETF01*SFACJ   
  120   CONTINUE         
      ELSE               
        DO 125 JPH=1,NPHOY                
        SFACY(JPH)  = -1D0                
        BETY10(JPH) =  0D0                
        BETY11(JPH) =  0D0                
  125   CONTINUE         
      ENDIF              
    
C ...BETA2...BETA2...BETA2...BETA2...     
C contributions from beta2, pure INITIAL state                 
      SUMXX2=0D0         
      IF(KEYBIN.EQ.1 .AND. VV.GT.VLIM2) THEN  
      DO 200 JPH2=2,NPHOX                 
      DO 200 JPH1=1,JPH2-1                
         DO 150 K=1,4    
            XPH1(K)=XPHOT(JPH1,K)         
  150       XPH2(K)=XPHOT(JPH2,K)         
         CALL NDIST2(XX,P1,P2,QF1,QF2,XPH1,XPH2,DIST2)         
         IF(ICONT.LE.ICLIM) CALL NTEST2(XX,P1,P2,QF1,QF2,XPH1,XPH2) 
         BETA2 = DIST2 -BETA00*SFACX(JPH1)*SFACX(JPH2)         
ccc  $          -BETX10(JPH1)*SFACX(JPH2) -BETX10(JPH2)*SFACX(JPH1)
     $          -BETI10(JPH1)*SFACX(JPH2) -BETI10(JPH2)*SFACX(JPH1)
         SUMXX2=SUMXX2 +BETA2 /SFACX(JPH1)/SFACX(JPH2)         
         BETXX20(JPH1,JPH2)=BETA2         
  200    CONTINUE        
      ELSE               
      DO 205 JPH2=2,NPHOX                 
      DO 205 JPH1=1,NPHOX                 
         BETXX20(JPH1,JPH2)= 0D0          
  205 CONTINUE           
      ENDIF              
C   
C contributions from beta2, pure FINAL state  
      SUMYY2=0D0         
      IF(KEYBFI.EQ.1 .AND. UU.GT.VLIM2) THEN  
      DO 220 JPH2=2,NPHOY                 
      DO 220 JPH1=1,JPH2-1                
         DO 218 K=1,4    
C note minus sign here!!!!                
            XPH1(K)=-YPHOT(JPH1,K)        
  218       XPH2(K)=-YPHOT(JPH2,K)        
         CALL FDIST2(XX,P1,P2,QF1,QF2,XPH1,XPH2,DIST2)         
         IF(ICONT.LE.ICLIM) CALL NTEST2(XX,P1,P2,QF1,QF2,XPH1,XPH2)
         BETA2 = DIST2 -BETA00*SFACY(JPH1)*SFACY(JPH2)
ccc  $          -BETY10(JPH1)*SFACY(JPH2) -BETY10(JPH2)*SFACY(JPH1)
     $          -BETF10(JPH1)*SFACY(JPH2) -BETF10(JPH2)*SFACY(JPH1)
         SUMYY2=SUMYY2 +BETA2 /SFACY(JPH1)/SFACY(JPH2)
         BETYY20(JPH1,JPH2)=BETA2
  220    CONTINUE        
      ELSE               
      DO 222 JPH2=2,NPHOY                 
      DO 222 JPH1=1,NPHOY                 
         BETYY20(JPH1,JPH2)= 0D0          
  222 CONTINUE           
      ENDIF              
C contributions from beta2, INITIAL/FINAL state
C or in other terminology beta1_init*beta1_final
      SUMXY2=0D0         
      IF(KEYBIN*KEYBFI.EQ.1 .AND. VV.GT.VLIM1.AND.UU.GT.VLIM1) THEN 
      DO 240 JPH1=1,NPHOX                 
      DO 240 JPH2=1,NPHOY                 
         DO 230 K=1,4    
            XPH1(K)= XPHOT(JPH1,K)        
C note minus sign here!!!!                
  230       XPH2(K)=-YPHOT(JPH2,K)        
         CALL NFDIST(XX,P1,P2,QF1,QF2,XPH1,XPH2,DIST2)         
         BETA2 = DIST2 -BETA00*SFACX(JPH1)*SFACY(JPH2)         
ccc  $          -BETX10(JPH1)*SFACY(JPH2) -BETY10(JPH2)*SFACX(JPH1) 
     $          -BETI10(JPH1)*SFACY(JPH2) -BETF10(JPH2)*SFACX(JPH1) 
         SUMXY2=SUMXY2 +BETA2 /SFACX(JPH1)/SFACY(JPH2)         
         BETXY20(JPH1,JPH2)=BETA2         
  240    CONTINUE        
      ELSE               
      DO 245 JPH1=1,NPHOX                 
      DO 245 JPH2=1,NPHOY                 
         BETXY20(JPH1,JPH2)= 0D0          
  245 CONTINUE           
      ENDIF              
C   
C ...Remnant of the YFS formfactor for the final/final state   
      CALL GIFYFS( P1, P2,FORINI)         
      CALL GIFYFS(QF1,QF2,FORFIN)         
      IF(KEYBIN.EQ.0) FORINI=1D0          
      IF(KEYBFI.EQ.0) FORFIN=1D0          
      FYFS = FORINI*FORFIN                
C   
C ...And the rejection weights = (new.distr/crude.distr)       
C ========== INITIAL + FINAL =================                 
C All beta's ---------------------------------                 
      WTSET(71) =   FYFS*BETA00/DISCRU    
      WTSET(72) =   FYFS*(BETA01+SUMX10+SUMY10+SUMXY2)/DISCRU
      WTSET(73) =   FYFS*                 
     &    (BETA02+SUMX11+SUMY11+SUMXX2 +SUMXY2 +SUMYY2 )/DISCRU 
C First order, individual beta's -------------                 
      WTSET(80) =   FYFS*BETA01/DISCRU    
      WTSET(81) =   FYFS*(SUMX10+SUMY10)/DISCRU                
      WTSET(82) =   FYFS*(SUMX10)/DISCRU                
      WTSET(83) =   FYFS*(SUMY10)/DISCRU                
      WTSET(84) =   FYFS*(SUMXY2)/DISCRU                
C Second order, individual beta's ------------                 
      WTSET(90) =   FYFS*BETA02/DISCRU    
      WTSET(91) =   FYFS*(SUMX11+SUMY11)/DISCRU                
      WTSET(92) =   FYFS*(SUMXX2+SUMXY2+SUMYY2)/DISCRU
      WTSET(93) =   FYFS*(SUMX11)/DISCRU
      WTSET(94) =   FYFS*(SUMY11)/DISCRU
      WTSET(95) =   FYFS*(SUMXX2)/DISCRU
      WTSET(96) =   FYFS*(SUMXY2)/DISCRU
      WTSET(97) =   FYFS*(SUMYY2)/DISCRU
C ========= INITIAL STATE ALONE ==============                 
C All beta's ---------------------------------                 
      WTSET( 1) =   FORINI*BETA00/DISCRU  
      WTSET( 2) =   FORINI*(BETI01+SUMX10)/DISCRU              
      WTSET( 3) =   FORINI*(BETI02+SUMI11+SUMXX2)/DISCRU       
C First order, individual beta's -------------                 
      WTSET(10) =   FORINI*BETI01/DISCRU  
      WTSET(11) =   FORINI*SUMX10/DISCRU  
C Second order, individual beta's ------------                 
      WTSET(20) =   FORINI*BETI02/DISCRU  
      WTSET(21) =   FORINI*SUMI11/DISCRU  
      WTSET(22) =   FORINI*SUMXX2/DISCRU  
C     ============================================             
C ...Model weight (the best)              
      WTMDL     =   WTSET(73)             
C ...tests on weights    
CC    IF(ICONT.LE.ICLIM2) CALL DUMPBT(NOUT)   
CC    IF(ICONT.LE.ICLIM2) CALL DUMPBT(   6)   
c      IF(ICONT.LE.ICLIM2.AND.NPHOY.GT.3) CALL DUMPBT(NOUT)     
c      IF(ICONT.LE.ICLIM2.AND.NPHOY.GT.3) CALL DUMPBT(   6)     
  770 CONTINUE           
      IF(KEYBIN.EQ.1) CALL MONIN(0)       
      PAR1  = WTMAX      
      PAR2  = WTMDL      
      ELSE               
C     =================================================================
C     =====================FINAL WEIGHT REPORT=========================
C     =================================================================
      IF(KEYBIN.EQ.1) CALL MONIN(1)       
      IF(KEYBIN.EQ.0.AND.KEYBFI.EQ.1) CALL MONIF               
      ENDIF              
C     =====              
      END                
      SUBROUTINE MONIF   
C     ****************   
C  Monitornig weights and x-sections for the FINAL state bremss.
C  Second, first and zero order X-sections    
C     *********************************** 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      COMMON / CMONIT/ AVERWT,ERRELA,NEVTOT,NEVACC,NEVNEG,NEVOVE,NEVZER
      COMMON / WGTALL / WTMOD,WTCRU1,WTCRU2,WTSET(100)         
      COMMON / INOUT  / NINP,NOUT   
      COMMON / BXFMTS / BXOPE,BXCLO,BXTXT,BXL1I,BXL1F,BXL2F,BXL1G,BXL2G
      CHARACTER*80      BXOPE,BXCLO,BXTXT,BXL1I,BXL1F,BXL2F,BXL1G,BXL2G
      SAVE / CMONIT/,/ WGTALL /,/ INOUT  /,/ BXFMTS /
      SAVE IDYFS
C --------------------------------------------------------------------
C X-sctions in Born units (for the moment)    
      XKARL = 1            
      ERKARL= 0  
      IDYFS = 0         
      CALL GMONIT(1,IDYFS+73,DUMM1,DUMM2,DUMM3) 
      XS03   =  XKARL*AVERWT              
      DXS03  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)         
      CALL GMONIT(1,IDYFS+72,DUMM1,DUMM2,DUMM3) 
      XS02   =  XKARL*AVERWT              
      DXS02  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)         
      CALL GMONIT(1,IDYFS+71,DUMM1,DUMM2,DUMM3) 
      XS01   =  XKARL*AVERWT              
      DXS01  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)         
      CALL GMONIT(1,IDYFS+75,DUMM1,DUMM2,DUMM3) 
      XS05   =  XKARL*AVERWT              
      DXS05  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)         
      CALL GMONIT(1,IDYFS+74,DUMM1,DUMM2,DUMM3) 
      XS04   =  XKARL*AVERWT              
      DXS04  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)         
C ...BETA CONTRIBUTIONS  
      CALL GMONIT(1,IDYFS+90,DUMM1,DUMM2,DUMM3) 
      XS20   =  XKARL*AVERWT              
      DXS20  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)         
      CALL GMONIT(1,IDYFS+91,DUMM1,DUMM2,DUMM3) 
      XS21   =  XKARL*AVERWT              
      DXS21  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)         
      CALL GMONIT(1,IDYFS+92,DUMM1,DUMM2,DUMM3) 
      XS22   =  XKARL*AVERWT              
      DXS22  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)         
      CALL GMONIT(1,IDYFS+80,DUMM1,DUMM2,DUMM3) 
      XS10   =  XKARL*AVERWT              
      DXS10  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)         
      CALL GMONIT(1,IDYFS+81,DUMM1,DUMM2,DUMM3) 
      XS11   =  XKARL*AVERWT              
      DXS11  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)         
C ......................Output window B...............................
      WRITE(NOUT,BXOPE)  
      WRITE(NOUT,BXTXT) '          MODEL  output - window B'   
      WRITE(NOUT,BXTXT) '          FINAL   state only      '   
      WRITE(NOUT,BXTXT) 'Analytical estimates of X-sections'   
      WRITE(NOUT,BXTXT) 'Units of Born X-section           '   
      PREC = 1D-5
      YS00 =      BREFKF( 300,PREC)            
      YS01 =      BREFKF( 301,PREC)            
      YS02 =      BREFKF( 302,PREC)            
      WRITE(NOUT,BXL1F) YS02,'X-section','O(alf2)','B1'        
      WRITE(NOUT,BXL1F) YS01,'X-section','O(alf1)','B2'        
      WRITE(NOUT,BXL1F) YS00,'X-section','O(alf0)','B3'        
      WRITE(NOUT,BXL1F) YS02-YS01,'(O(alf2)-O(alf1))','/O(alf1)','B4'
      WRITE(NOUT,BXL1F) YS01-YS00,'(O(alf1)-O(alf0))','/O(alf0)','B5'
      YS20 = BREFKF( 320,PREC)                 
      YS21 = BREFKF( 321,PREC)                 
      YS22 = BREFKF( 322,PREC)                 
      YS10 = BREFKF( 310,PREC)                 
      YS11 = BREFKF( 311,PREC)                 
      WRITE(NOUT,BXL1F) YS20,'Beta0          ','O(alf2)','B06' 
      WRITE(NOUT,BXL1F) YS21,'     Beta1     ','       ','B07' 
      WRITE(NOUT,BXL1F) YS22,'          Beta2','       ','B08' 
      WRITE(NOUT,BXL1F) YS10,'Beta0          ','O(alf1)','B09' 
      WRITE(NOUT,BXL1F) YS11,'     Beta1     ','       ','B10' 
      WRITE(NOUT,BXCLO)  
C --------------------------------------------------------------------
C ......................Output window C...............................
      WRITE(NOUT,BXOPE)  
      WRITE(NOUT,BXTXT) '             MODEL  output - window C' 
      WRITE(NOUT,BXTXT) ' FINAL   State  only'                 
      WRITE(NOUT,BXTXT) 'Comparison of MC and Analytical calc.' 
      WRITE(NOUT,BXTXT) '(MonteCarlo  - Analytical)/Analytical'
      RS01 = XS01/YS00 -1                 
      RS02 = XS02/YS01 -1                 
      RS03 = XS03/YS02 -1                 
      WRITE(NOUT,BXL2F) RS03,DXS03/YS02,'X-section','O(alf2)','C1'
      WRITE(NOUT,BXL2F) RS02,DXS02/YS01,'X-section','O(alf1)','C2'
      WRITE(NOUT,BXL2F) RS01,DXS01/YS00,'X-section','O(alf0)','C3'
      WRITE(NOUT,BXTXT) 'Beta contributions'  
      RS20 = XS20/YS20 -1                 
      RS21 = XS21/YS21 -1                 
      RS22 = XS22/YS22 -1                 
      RS10 = XS10/YS10 -1                 
      RS11 = XS11/YS11 -1                 
      DRS20 = DXS20/YS20 
      DRS21 = DXS21/YS21 
      DRS22 = DXS22/YS22 
      DRS10 = DXS10/YS10 
      DRS11 = DXS11/YS11 
      WRITE(NOUT,BXL2F) RS20,DRS20,'Beta0          ','O(alf2)','C04'
      WRITE(NOUT,BXL2F) RS21,DRS21,'     Beta1     ','       ','C05'
      WRITE(NOUT,BXL2F) RS22,DRS22,'          Beta2','       ','C06' 
      WRITE(NOUT,BXL2F) RS10,DRS10,'Beta0          ','O(alf1)','C07'
      WRITE(NOUT,BXL2F) RS11,DRS11,'     Beta1     ','       ','C08'
      WRITE(NOUT,BXCLO)  
C ...the end of the FINAL-state report..............................
      END                

    
      SUBROUTINE MONIN(MODE)              
C     **********************              
C  Monitornig weights and x-sections for the initial state bremss.
C  Auxiliary weights on INITIAL STATE ONLY        
C  Second, first and zero order X-sections        
C     *********************************** 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      COMMON / CMONIT/ AVERWT,ERRELA,NEVTOT,NEVACC,NEVNEG,NEVOVE,NEVZER
      COMMON / WGTALL / WTMOD,WTCRU1,WTCRU2,WTSET(100)           
      COMMON / INOUT  / NINP,NOUT   
      COMMON / BXFMTS / BXOPE,BXCLO,BXTXT,BXL1I,BXL1F,BXL2F,BXL1G,BXL2G
      CHARACTER*80      BXOPE,BXCLO,BXTXT,BXL1I,BXL1F,BXL2F,BXL1G,BXL2G
      SAVE / CMONIT/,/ WGTALL /,/ INOUT  /,/ BXFMTS /
      SAVE IDYFS

      IF(MODE.EQ.-1) THEN  
C     ===================  
      IDYFS = 0
      CALL GMONIT(-1,IDYFS+ 1,0D0,1D0,1D0)        
      CALL GMONIT(-1,IDYFS+ 2,0D0,1D0,1D0)        
      CALL GMONIT(-1,IDYFS+ 3,0D0,1D0,1D0)        
      CALL GMONIT(-1,IDYFS+ 4,0D0,1D0,1D0)        
      CALL GMONIT(-1,IDYFS+ 5,0D0,1D0,1D0)        
      CALL GMONIT(-1,IDYFS+10,0D0,1D0,1D0)        
      CALL GMONIT(-1,IDYFS+11,0D0,1D0,1D0)        
      CALL GMONIT(-1,IDYFS+20,0D0,1D0,1D0)        
      CALL GMONIT(-1,IDYFS+21,0D0,1D0,1D0)        
      CALL GMONIT(-1,IDYFS+22,0D0,1D0,1D0)        
      ELSEIF(MODE.EQ.0) THEN              
C     ======================              
      WTMAX=2.5D0          
      WTCRUD = WTCRU1*WTCRU2              
      CALL GMONIT(0,IDYFS+ 3,WTCRUD*WTSET( 3),WTMAX,0D0)               
      CALL GMONIT(0,IDYFS+ 2,WTCRUD*WTSET( 2),WTMAX,0D0)               
      CALL GMONIT(0,IDYFS+ 1,WTCRUD*WTSET( 1),WTMAX,0D0)               
C ...and differences       
      CALL GMONIT(0,IDYFS+ 5,WTCRUD*(WTSET(3)-WTSET(2)),WTMAX,0D0)     
      CALL GMONIT(0,IDYFS+ 4,WTCRUD*(WTSET(2)-WTSET(1)),WTMAX,0D0)     
C ...Second order beta0,1,2               
      CALL GMONIT(0,IDYFS+20,WTCRUD*WTSET(20),WTMAX,0D0)               
      CALL GMONIT(0,IDYFS+21,WTCRUD*WTSET(21),WTMAX,0D0)               
      CALL GMONIT(0,IDYFS+22,WTCRUD*WTSET(22),WTMAX,0D0)               
C ...First order beta0,1   
      CALL GMONIT(0,IDYFS+10,WTCRUD*WTSET(10),WTMAX,0D0)               
      CALL GMONIT(0,IDYFS+11,WTCRUD*WTSET(11),WTMAX,0D0)               
      ELSEIF(MODE.EQ.1) THEN              
C     ======================              
      XKARL  = WTCRU1      
      ERKARL = WTCRU2      
C ........................Output window A...............................
      WRITE(NOUT,BXOPE)    
      WRITE(NOUT,BXTXT) '        MODEL  output - window A '      
      WRITE(NOUT,BXTXT) '  Monte Carlo INITIAL state ONLY '      
      WRITE(NOUT,BXTXT) '           X-sections in R-units '      
      CALL GMONIT(1,IDYFS+ 3,DUMM1,DUMM2,DUMM3) 
C)))))CALL GMONIT(2,IDYFS+ 3,DUMM1,DUMM2,DUMM3) 
C     WRITE(2,*) ' YFSMOD, XKARL,AVERWT',XKARL,AVERWT            
C))))))))   
      XS03   =  XKARL*AVERWT              
      DXS03  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)           
      CALL GMONIT(1,IDYFS+ 2,DUMM1,DUMM2,DUMM3) 
      XS02   =  XKARL*AVERWT              
      DXS02  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)           
      CALL GMONIT(1,IDYFS+ 1,DUMM1,DUMM2,DUMM3) 
      XS01   =  XKARL*AVERWT              
      DXS01  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)           
      CALL GMONIT(1,IDYFS+ 5,DUMM1,DUMM2,DUMM3) 
      XS05   =  XKARL*AVERWT              
      DXS05  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)           
      CALL GMONIT(1,IDYFS+ 4,DUMM1,DUMM2,DUMM3) 
      XS04   =  XKARL*AVERWT              
      DXS04  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)           
      WRITE(NOUT,BXL2F) XS03,DXS03,'X-section','O(alf2)',  'A01' 
      WRITE(NOUT,BXL2F) XS02,DXS02,'X-section','O(alf1)',  'A02' 
      WRITE(NOUT,BXL2F) XS01,DXS01,'X-section','O(alf0)',  'A03' 
      IF(XS02.NE.0D0) WRITE(NOUT,BXL2F)   
     $ XS05/XS02,DXS05/XS02,'(O(alf2)-O(alf1))','/O(alf1)','A04' 
      IF(XS01.NE.0D0) WRITE(NOUT,BXL2F)   
     $ XS04/XS01,DXS04/XS01,'(O(alf1)-O(alf0))','/O(alf0)','A05' 
C ...Beta contributions absolute          
      CALL GMONIT(1,IDYFS+20,DUMM1,DUMM2,DUMM3) 
      XS20   =  XKARL*AVERWT              
      DXS20  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)           
      CALL GMONIT(1,IDYFS+21,DUMM1,DUMM2,DUMM3) 
      XS21   =  XKARL*AVERWT              
      DXS21  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)           
      CALL GMONIT(1,IDYFS+22,DUMM1,DUMM2,DUMM3) 
      XS22   =  XKARL*AVERWT              
      DXS22  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)           
      CALL GMONIT(1,IDYFS+10,DUMM1,DUMM2,DUMM3) 
      XS10   =  XKARL*AVERWT              
      DXS10  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)           
      CALL GMONIT(1,IDYFS+11,DUMM1,DUMM2,DUMM3) 
      XS11   =  XKARL*AVERWT              
      DXS11  =  XKARL*AVERWT*SQRT(ERKARL**2+ERRELA**2)           
      WRITE(NOUT,BXTXT) 'Beta contributions in R-units'          
      WRITE(NOUT,BXL2F) XS20,DXS20,'Beta0          ','O(alf2)','A06'
      WRITE(NOUT,BXL2F) XS21,DXS21,'     Beta1     ','       ','A07'
      WRITE(NOUT,BXL2F) XS22,DXS22,'          Beta2','       ','A08'
      WRITE(NOUT,BXL2F) XS10,DXS10,'Beta0          ','O(alf1)','A09'
      WRITE(NOUT,BXL2F) XS11,DXS11,'     Beta1     ','       ','A10'
      WRITE(NOUT,BXL2F) XS01,DXS01,'Beta0          ','O(alf0)','A11'
C ...Beta contributions relative          
      WRITE(NOUT,BXTXT) 'Beta contributions - relative'          
      IF(XS03.NE.0D0) WRITE(NOUT,BXL2F)   
     $ XS20/XS03,DXS20/XS03,'Bet0/(Bet0+1+2)','O(alf2)','A12'    
      IF(XS03.NE.0D0) WRITE(NOUT,BXL2F)   
     $ XS21/XS03,DXS21/XS03,'Bet1/(Bet0+1+2)','       ','A13'    
      IF(XS03.NE.0D0) WRITE(NOUT,BXL2F)   
     $ XS22/XS03,DXS22/XS03,'Bet2/(Bet0+1+2)','       ','A14'    
      IF(XS02.NE.0D0) WRITE(NOUT,BXL2F)   
     $ XS10/XS02,DXS10/XS02,'Bet0/(Bet0+1)','O(alf1)'  ,'A15'    
      IF(XS02.NE.0D0) WRITE(NOUT,BXL2F)   
     $ XS11/XS02,DXS11/XS02,'Bet1/(Bet0+1)','       '  ,'A16'    
      WRITE(NOUT,BXCLO)    
C --------------------------------------------------------------------
C ......................Output window B...............................
      WRITE(NOUT,BXOPE)    
      WRITE(NOUT,BXTXT) '          MODEL  output - window B'     
      WRITE(NOUT,BXTXT) '          INITIAL state only cont.'     
      WRITE(NOUT,BXTXT) 'Analytical estimates of X-sections'     
      PREC = 1D-5
      YS00 =      BREMKF( 300,PREC)            
      YS01 =      BREMKF( 301,PREC)            
      YS02 =      BREMKF( 302,PREC)            
      WRITE(NOUT,BXL1F) YS02,'X-section','O(alf2)','B1'          
      WRITE(NOUT,BXL1F) YS01,'X-section','O(alf1)','B2'          
      WRITE(NOUT,BXL1F) YS00,'X-section','O(alf0)','B3'          
      WRITE(NOUT,BXL1F) YS02-YS01,'(O(alf2)-O(alf1))','/O(alf1)','B4'
      WRITE(NOUT,BXL1F) YS01-YS00,'(O(alf1)-O(alf0))','/O(alf0)','B5'
      YS20 = BREMKF( 320,PREC)  
      YS21 = BREMKF( 321,PREC)  
      YS22 = BREMKF( 322,PREC)  
      YS10 = BREMKF( 310,PREC)  
      YS11 = BREMKF( 311,PREC)  
      WRITE(NOUT,BXL1F) YS20,'Beta0          ','O(alf2)','B06'   
      WRITE(NOUT,BXL1F) YS21,'     Beta1     ','       ','B07'   
      WRITE(NOUT,BXL1F) YS22,'          Beta2','       ','B08'   
      WRITE(NOUT,BXL1F) YS10,'Beta0          ','O(alf1)','B09'   
      WRITE(NOUT,BXL1F) YS11,'     Beta1     ','       ','B10'   
      WRITE(NOUT,BXCLO)    
C --------------------------------------------------------------------
C ......................Output window C...............................
      WRITE(NOUT,BXOPE)    
      WRITE(NOUT,BXTXT) '             MODEL  output - window C'
      WRITE(NOUT,BXTXT) '                  Initial State  only'
      WRITE(NOUT,BXTXT) 'Comparison of MC and Analytical calc.'
      WRITE(NOUT,BXTXT) '(MonteCarlo  - Analytical)/Analytical'
      RS01 = XS01/YS00 -1                 
      RS02 = XS02/YS01 -1                 
      RS03 = XS03/YS02 -1                 
      WRITE(NOUT,BXL2F) RS03,DXS03/YS02,'X-section','O(alf2)','C1'
      WRITE(NOUT,BXL2F) RS02,DXS02/YS01,'X-section','O(alf1)','C2'
      WRITE(NOUT,BXL2F) RS01,DXS01/YS00,'X-section','O(alf0)','C3'
      WRITE(NOUT,BXTXT) 'Beta contributions'                 
      RS20 = XS20/YS20 -1                 
      RS21 = XS21/YS21 -1                 
      RS22 = XS22/YS22 -1                 
      RS10 = XS10/YS10 -1                 
      RS11 = XS11/YS11 -1                 
      DRS20 = DXS20/YS20                  
      DRS21 = DXS21/YS21                  
      DRS22 = DXS22/YS22                  
      DRS10 = DXS10/YS10                  
      DRS11 = DXS11/YS11                  
      WRITE(NOUT,BXL2F) RS20,DRS20,'Beta0          ','O(alf2)','C04'
      WRITE(NOUT,BXL2F) RS21,DRS21,'     Beta1     ','       ','C05'
      WRITE(NOUT,BXL2F) RS22,DRS22,'          Beta2','       ','C06'
      WRITE(NOUT,BXL2F) RS10,DRS10,'Beta0          ','O(alf1)','C07'
      WRITE(NOUT,BXL2F) RS11,DRS11,'     Beta1     ','       ','C08'
      WRITE(NOUT,BXCLO)                   
C ...the end of the initial-state report..............................
      ELSE             
      WRITE(NOUT,*) ' +++++ WRONG MODE IN MONIN'             
      ENDIF            
C     =====            
      END              
      SUBROUTINE DUMPBT(NOUT)             
C     ***********************             
C     Prints out information on beta's    
C     *********************************** 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      PARAMETER(NPMX=25)                  
C Spying on weights.........              
      COMMON / BETSPY / BETA00,BETA01,BETA02,BETI01,BETI02,  
     $  BETA10(NPMX),BETA11(NPMX),BETA20(NPMX,NPMX),         
     $  SFACX(NPMX),SFACY(NPMX),          
     $  BETX10(NPMX),BETX11(NPMX),BETY10(NPMX),BETY11(NPMX), 
     $  BETXX20(NPMX,NPMX),BETXY20(NPMX,NPMX),BETYY20(NPMX,NPMX),
     $  BETI10(NPMX),BETI11(NPMX),BETI20(NPMX,NPMX),          
     $  BETF10(NPMX),BETF11(NPMX),BETF20(NPMX,NPMX)            
      SAVE / BETSPY /
C ...........          
      COMMON / MOMINI / XF1(4),XF2(4),XPHUM(4),XPHOT(100,4),NPHOX 
      COMMON / MOMFIN / QF1(4),QF2(4),YPHUM(4),YPHOT(100,4),NPHOY
      SAVE / MOMINI /,/ MOMFIN /
    
      WRITE(NOUT,*) '--------------------<DUMBT>----------------------'
 2000 FORMAT(A30,3F15.8/(5F15.8))         
C ...Beta0             
      WRITE(NOUT,2000) ' Beta00, Beta01/Beta00, Beta02/Beta00'
     & ,BETA00,BETA01/BETA00,BETA02/BETA00                   
C ...SFACI(i)          
 2002 FORMAT(A16,4E16.7/(5E16.7))         
      IF(NPHOX.GT.0) WRITE(NOUT,2002) ' SFACX(i) ',(SFACX(I),I=1,NPHOX)
      IF(NPHOY.GT.0) WRITE(NOUT,2002) ' SFACY(i) ',(SFACY(I),I=1,NPHOY)
C ...Beta1   INITIAL state ...............                   
      IF(NPHOX.GT.0) WRITE(NOUT,2000) ' Init. BetX10(i)/Beta00 ',
     $  ( BETX10(I)/SFACX(I)/BETA00  ,I=1,NPHOX)             
      IF(NPHOX.GT.0) WRITE(NOUT,2000) ' Init. BetX11(i)/Beta00 ',
     $  ( BETX11(I)/SFACX(I)/BETA00  ,I=1,NPHOX)             
    
C ...Beta1   final state ...............  
      IF(NPHOY.GT.0) WRITE(NOUT,2000) ' Fin.  BetY10(i)/Beta00 ',
     $  ( BETY10(I)/SFACY(I)/BETA00  ,I=1,NPHOY)             
      IF(NPHOY.GT.0) WRITE(NOUT,2000) ' Fin.  BetY11(i)/Beta00 ',
     $  ( BETY11(I)/SFACY(I)/BETA00  ,I=1,NPHOY)             
    
C ...Beta2 pure initial                   
      IF(NPHOX.GE.2) THEN                 
      WRITE(NOUT,*) ' Init. state BetXX20(i,j)'              
      DO 100 J=2,NPHOX 
      WRITE(NOUT,'(  8F12.8)')            
     $ (BETXX20(I,J)/SFACX(I)/SFACX(J)/BETA00,I=1,J-1)       
  100 CONTINUE         
      ENDIF            
C ...Beta2 pure final  
      IF(NPHOY.GE.2) THEN                 
      WRITE(NOUT,*) ' Final state BetYY20(i,j)'              
      DO 110 J=2,NPHOY 
      WRITE(NOUT,'(  8F20.16)')           
     $ (BETYY20(I,J)/SFACY(I)/SFACY(J)/BETA00,I=1,J-1)       
  110 CONTINUE         
      ENDIF            
C ...Beta2 initial/final                  
      IF(NPHOX.GE.1 .AND. NPHOY.GE.1) THEN                   
      WRITE(NOUT,*) ' In/fi state BetXY20(i,j)'              
      DO 120 J=1,NPHOY 
      WRITE(NOUT,'(  8F12.8)')            
     $ (BETXY20(I,J)/SFACX(I)/SFACY(J)/BETA00,I=1,NPHOX)     
  120 CONTINUE         
      ENDIF            
      END              
      SUBROUTINE NTEST0(QQ,P1,P2,Q1,Q2)   
C     *********************************   
C ...Testing redustion for Beta0          
C     *********************************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      COMMON / INOUT  / NINP,NOUT   
      SAVE   / INOUT  /
      DIMENSION QQ(*),P1(*),P2(*),Q1(*),Q2(*)                
      DIMENSION PR1(4),PR2(4),QR1(4),QR2(4)                  
      DIMENSION PPR(4),QQR(4),QQ1(4)      
C   
      WRITE(NOUT,*) '-----------NTEST0---------==========='  
      CALL REDUZ0(QQ,Q1,Q2,QR1,QR2)       
      CALL REDUZ0(QQ,P1,P2,PR1,PR2)       
      CALL BOSTDQ(1,QQ,QQ,QQ1)            
      DO 10 K=1,4      
      PPR(K)=PR1(K)+PR2(K)-QQ1(K)         
  10  QQR(K)=QR1(K)+QR2(K)-QQ1(K)         
      call dumpt(2,' PPR    ',PPR)        
      call dumpt(2,' QQR    ',QQR)        
      call dumpt(2,'  PR1   ',PR1)        
      call dumpt(2,'  PR2   ',PR2)        
      call dumpt(2,'  QR1   ',QR1)        
      call dumpt(2,'  QR2   ',QR2)        
      CALL GTHET0(PR1,QR1,COSTH )         
      WRITE(NOUT,'(A,3F20.12)') ' COSTH= ',COSTH             
      END              
      SUBROUTINE NTEST1(QQ,P1,P2,Q1,Q2,PH)                   
C     ************************************                   
C ...Testing reduction for beta1          
C     ************************************                   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      COMMON / INOUT  / NINP,NOUT   
      SAVE   / INOUT  /
      DIMENSION QQ(*),P1(*),P2(*),Q1(*),Q2(*),PH(*)          
      DIMENSION PR1(4),PR2(4),QR1(4),QR2(4),PHR(4)           
      DIMENSION PPR(4),QQR(4),PX1(4),PX2(4),QQ1(4),PPX(4)    
C   
      WRITE(NOUT,*) '-----------NTEST1---------<<<<<<<<<<<'  
      CALL REDUZ0(QQ,Q1,Q2,QR1,QR2)       
      CALL REDUZ1(QQ,P1,P2,PH,PR1,PR2,PHR)                   
      CALL REDUZ0(QQ,P1,P2,PX1,PX2)       
      CALL BOSTDQ(1,QQ,QQ,QQ1)            
      DO 10 K=1,4      
      PPX(K)=PX1(K)+PX2(K)        -QQ1(K) 
      PPR(K)=PR1(K)+PR2(K)-PHR(K) -QQ1(K) 
  10  QQR(K)=QR1(K)+QR2(K)        -QQ1(K) 
      call dumpt(2,' PPX    ',PPX)        
      call dumpt(2,' PPR    ',PPR)        
      call dumpt(2,' QQR    ',QQR)        
      call dumpt(2,'  PR1   ',PR1)        
      call dumpt(2,'  PR2   ',PR2)        
      call dumpt(2,'  PX1   ',PX1)        
      call dumpt(2,'  PX2   ',PX2)        
      call dumpt(2,'  QR1   ',QR1)        
      call dumpt(2,'  QR2   ',QR2)        
C Single bremsstrahlung Xsection          
      CALL GSOFA1(P1,P2,PH,GF1,GF2)       
      CALL GTHET1(PR1,PR2,QR1,COSTH1,COSTH2)                 
      CALL SFACH0(P1,P2, PH ,SFACJ)       
      CALL GTHET0(PX1,QR1,COSTH)          
      WRITE(NOUT,'(A,3F20.12)') ' PH(4)= ',PH(4)             
      WRITE(NOUT,'(A,3F20.12)') ' COSTH= ',COSTH1-COSTH,COSTH2-COSTH
      WRITE(NOUT,'(A,3F20.12)') ' GF/SF= ',(GF1+GF2)/SFACJ   
      END              
      SUBROUTINE NTEST2(QQ,P1,P2,Q1,Q2,PH1,PH2)              
C     *****************************************              
C ...Testing reduction for beta2          
C     ************************************                   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      COMMON / INOUT  / NINP,NOUT   
      SAVE   / INOUT  /
      DIMENSION QQ(*),P1(*),P2(*),Q1(*),Q2(*),PH1(*),PH2(*)  
      DIMENSION PR1(4),PR2(4),QR1(4),QR2(4),PH1R(4),PH2R(4)  
      DIMENSION PPR(4),QQR(4),PX1(4),PX2(4),QQ1(4)           
C   
      WRITE(NOUT,*) '-----------NTEST2---------<<<<<<<<<<<'  
      CALL REDUZ0(QQ,Q1,Q2,QR1,QR2)       
      CALL REDUZ2(QQ,P1,P2,PH1,PH2,PR1,PR2,PH1R,PH2R)        
      CALL BOSTDQ(1,QQ,QQ,QQ1)            
      DO 10 K=1,4      
      PPR(K)=PR1(K)+PR2(K)-PH1R(K)-PH2R(K) -QQ1(K)           
  10  QQR(K)=QR1(K)+QR2(K)                 -QQ1(K)           
      call dumpt(2,' PPR    ',PPR)        
      call dumpt(2,' QQR    ',QQR)        
      call dumpt(2,'  PR1   ',PR1)        
      call dumpt(2,'  PR2   ',PR2)        
      call dumpt(2,'  QR1   ',QR1)        
      call dumpt(2,'  QR2   ',QR2)        
C Single bremsstrahlung Xsection          
      CALL GSOFA2(P1,P2,PH1,PH2,GF1,GF2)  
      CALL GTHET1(PR1,PR2,QR1,COSTH1,COSTH2)                 
      CALL SFACH0(P1,P2, PH1,SFAC1)       
      CALL SFACH0(P1,P2, PH2,SFAC2)       
      CALL REDUZ0(QQ,P1,P2,PX1,PX2)       
      CALL GTHET0(PX1,QR1,COSTH)          
      WRITE(NOUT,'(A,3F20.12)') 'PHi(4)= ',PH1(4),PH2(4)     
      WRITE(NOUT,'(A,3F20.12)') ' COSTH= ',COSTH1-COSTH,COSTH2-COSTH
      WRITE(NOUT,'(A,3F20.12)') ' GF/SF= ',(GF1+GF2)/SFAC1/SFAC2
      END              
      SUBROUTINE GIFYFS(P1,P2,FYFS)       
C     *****************************       
C YFS formfactor       
C     *****************************       
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION P1(*),P2(*)               
      PARAMETER( PI=3.1415926535897932D0, ALFINV=137.03604D0)
      PARAMETER( ALF1=1D0/ALFINV/PI)
                  
      SVAR   = (P1(4)+P2(4))**2-(P1(3)+P2(3))**2             
     $        -(P1(2)+P2(2))**2-(P1(1)+P2(1))**2             
      AMS    = P1(4)**2-P1(3)**2-P1(2)**2-P1(1)**2           
      BILG  =  DLOG(SVAR/AMS)             
      BETA  =  2*ALF1*(BILG-1)            
      DELB  =  BETA/4 + ALF1*( -.5D0  +PI**2/3D0)            
      FYFS  =  EXP(DELB)                  
      END              
      SUBROUTINE NCRUDE(QQ,DISCRU)        
C     ****************************        
C provides crude distribution generated in KARLUD            
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION QQ(4)  
      SVAR1  =  QQ(4)**2-QQ(3)**2-QQ(2)**2-QQ(1)**2          
C---      DISCRU =  BORNV(SVAR1,0D0)*4D0/3D0  
      DISCRU =  BORNY(SVAR1)*4D0/3D0  
      END              
      SUBROUTINE NDIST0(XX,P1,P2,Q1,Q2,ANDIS,DELI1,DELI2,DELF1,DELF2)
C     ***************************************************************
C Provides elements of beta0,             
C for transparency reasons the full reduction of momenta is done.
C     *********************************** 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      COMMON / KEYYFS / KEYZET,KEYBRM,KEYFIX,KEYRED,KEYWGT   
      SAVE   / KEYYFS /
      DIMENSION XX(*),P1(*),P2(*),Q1(*),Q2(*)                
      DIMENSION PR1(4),PR2(4),QR1(4),QR2(4)                  
C   
      CALL REDUZ0(XX,P1,P2,PR1,PR2)       
      CALL REDUZ0(XX,Q1,Q2,QR1,QR2)       
      CALL GTHET0(PR1,QR1,COSTH1)         
      COSTH  = (PR1(1)*QR1(1) +PR1(2)*QR1(2) +PR1(3)*QR1(3)) 
     $            /SQRT((QR1(1)**2 +QR1(2)**2 +QR1(3)**2)    
     $                 *(PR1(1)**2 +PR1(2)**2 +PR1(3)**2))   
      SVAR1  = XX(4)**2-XX(3)**2-XX(2)**2-XX(1)**2
C ZW 03.03.97 here was bug 
C      SVAR1  = XX(4)**2-XX(3)**2-XX(2)-XX(1)**2              
      ANDIS  = BORNV (SVAR1,COSTH )       
      CALL BVIRT0(P1,P2,DELI1,DELI2)      
      CALL BVIRT0(Q1,Q2,DELF1,DELF2)      
C ...Initial/final state bremsstrahlung switches             
      KEYBIN  = MOD(KEYBRM,10)            
      KEYBFI  = MOD(KEYBRM,100)/10        
      DELI1   = DELI1*KEYBIN              
      DELI2   = DELI2*KEYBIN              
      DELF1   = DELF1*KEYBFI              
      DELF2   = DELF2*KEYBFI              
      END              
      SUBROUTINE NDIST1(QQ,P1,P2,Q1,Q2,PH,DIST,DELI1)
C     *********************************** ***********
C Provides single bremsstrahlung distribution, INITIAL STATE 
C INPUT:  P1,P2,Q1,Q2,PH, four momenta    
C OUTPUT: 
C         DIST           is first order result, exact.               
C         DISI*(1+DELI1) is second erder LL+NLL result      
C     *********************************** 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      COMMON / KEYYFS / KEYZET,KEYBRM,KEYFIX,KEYRED,KEYWGT   
      SAVE   / KEYYFS /
      DIMENSION QQ(*),P1(*),P2(*),Q1(*),Q2(*),PH(*)          
      DIMENSION PR1(4),PR2(4),QR1(4),QR2(4),PHR(4)           
C   
      CALL REDUZ1(QQ,P1,P2,PH,PR1,PR2,PHR)                   
      CALL REDUZ0(QQ,Q1,Q2,QR1,QR2)       
C Single bremsstrahlung Xsection          
      CALL GSOFA1(P1,P2,PH,GF1,GF2)       
      CALL GTHET1(PR1,PR2,QR1,COSTH1,COSTH2)                 
      SVAR1 = QQ(4)**2-QQ(3)**2-QQ(2)**2-QQ(1)**2            
      ANDI11= BORNV(SVAR1,COSTH1)         
      ANDI12= BORNV(SVAR1,COSTH2)         
      DIST  =  GF1*ANDI11+ GF2*ANDI12     
C Virtual correction in the second order case (K-factor style)
      CALL BVIRT1(P1,P2,PH,DELI1)         
C ...Initial/final state bremsstrahlung switches             
      KEYBIN  = MOD(KEYBRM,10)            
      DELI1   = DELI1*KEYBIN              
      END              
      SUBROUTINE FDIST1(QQ,P1,P2,Q1,Q2,PH,DIST,DELF1)     
C     ***********************************************     
C Provides FIRST ORDER single FINAL state bremsstrahlung distribution
C INPUT:  QQ,P1,P2,Q1,Q2,PH, four momenta 
C OUTPUT:              
C         DIST           is first order result, exact.               
C         DIST*(1+DELF1) is scond order result, LL + NLL              
C     *********************************** 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION QQ(*),P1(*),P2(*),Q1(*),Q2(*),PH(*)          
      COMMON / KEYYFS / KEYZET,KEYBRM,KEYFIX,KEYRED,KEYWGT   
      SAVE   / KEYYFS /
      DIMENSION PR1(4),PR2(4),QR1(4),QR2(4),PHR(4)           
C   
      CALL REDUZ1(QQ,Q1,Q2,PH,QR1,QR2,PHR)                   
      CALL REDUZ0(QQ,P1,P2,PR1,PR2)       
      SVAR1 = QQ(4)**2-QQ(3)**2-QQ(2)**2-QQ(1)**2            
C Infrared factor from reduced momenta    
C Single bremsstrahlung Xsection          
      CALL GSFIN1(Q1,Q2,PH,GF1,GF2)       
      CALL GTHET1(QR1,QR2,PR1,COSTH1,COSTH2)                 
      ANDI11= BORNV(SVAR1,COSTH1)         
      ANDI12= BORNV(SVAR1,COSTH2)         
      DIST  = GF1*ANDI11+ GF2*ANDI12      
C Virtual correction in the second order case (K-factor style)
      CALL BVIRF1(Q1,Q2,PH,DELF1)         
C ...Initial/final state bremsstrahlung switches             
      KEYBFI  = MOD(KEYBRM,100)/10        
      DELF1   = DELF1*KEYBFI              
      END              
      SUBROUTINE GSFIN1(P1,P2,PH,F1,F2)   
C     *********************************   
C Final state now! but P <=> replacement kept                
C CALCULATES INGREDIENTS FOR REAL SINGLE PHOTON DIFF. XSECTION 
C     *****************************************              
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION PH(*),P1(*),P2(*)         
      AM2= P1(4)**2-P1(1)**2-P1(2)**2-P1(3)**2               
      PK1= P1(4)*PH(4)-P1(1)*PH(1)-P1(2)*PH(2)-P1(3)*PH(3)   
      PK2= P2(4)*PH(4)-P2(1)*PH(1)-P2(2)*PH(2)-P2(3)*PH(3)   
      PP = P1(4)*P2(4)-P1(1)*P2(1)-P1(2)*P2(2)-P1(3)*P2(3)   
C   
      BB =  ABS(PK2)/PP                   
      AA =  ABS(PK1)/PP                   
      A  = AA/(1 +AA+BB)                  
      B  = BB/(1 +AA+BB)                  
      SFAC1  =  2D0*PP/PK1/PK2            
      AM = AM2/(2D0*PP)                   
      WWM= 1D0-AM*2D0*(1D0-A)*(1D0-B)/((1D0-A)**2+(1D0-B)**2)*(A/B+B/A)
      F1   = 0.5D0*(1D0-A)**2*WWM *SFAC1  
      F2   = 0.5D0*(1D0-B)**2*WWM *SFAC1  
      END              
      SUBROUTINE NDIST2(QQ,P1,P2,Q1,Q2,PH1,PH2,DIST2)        
C     ***********************************************        
C Provides double bremsstrahlung distribution - INITIAL state brem.
C INPUT:  P1,P2,Q1,Q2,PH1,PH2, four momenta                  
C OUTPUT: DIST2     double bremsstrahlung distribution       
C     *********************************** 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION QQ(*),P1(*),P2(*),Q1(*),Q2(*),PH1(*),PH2(*)  
      DIMENSION PR1(4),PR2(4),PH1R(4),PH2R(4),QR1(4),QR2(4)  
    
      CALL REDUZ2(QQ,P1,P2,PH1,PH2,PR1,PR2,PH1R,PH2R)        
      CALL REDUZ0(QQ,Q1,Q2,QR1,QR2)       
      SVAR1 = QQ(4)**2-QQ(3)**2-QQ(2)**2-QQ(1)**2            
C infrared factors from reduced momenta   
C double bremsstrahlung Xsect in next-to-leading log approx. 
      CALL GSOFA2(P1,P2,PH1,PH2,GF1,GF2)  
      CALL GTHET1(PR1,PR2,QR1,COSTH1,COSTH2)                 
      ANDI11= BORNV(SVAR1,COSTH1)         
      ANDI12= BORNV(SVAR1,COSTH2)         
      DIST2 =   GF1*ANDI11+   GF2*ANDI12  
      END              
      SUBROUTINE HSOFA2(P1,P2,PH1,PH2,F1,F2)                 
C     **************************************                 
C OLD VERSION          
C CALCULATES INGREDIENTS FOR REAL DOUBLE PHOTON DIFF. XSECTION 
C     *****************************************              
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION PH1(*),PH2(*),P1(*),P2(*) 
C   
      WM (A  )=     (1D0-A)**2            
      WMS(A,B)=     ((1D0-A)**2+(1D0-B)**2)                  
      WWM(A,B)=        
     $   1D0-AM*2D0*(1D0-A)*(1D0-B)/((1D0-A)**2+(1D0-B)**2)*(A/B+B/A)
C   
      PP = P1(4)*P2(4)-P1(1)*P2(1)-P1(2)*P2(2)-P1(3)*P2(3)   
      AM2= P1(4)**2-P1(1)**2-P1(2)**2-P1(3)**2               
      AM = AM2/(2D0*PP)                   
      B1 = (P2(4)*PH1(4)-P2(1)*PH1(1)-P2(2)*PH1(2)-P2(3)*PH1(3))/PP
      A1 = (P1(4)*PH1(4)-P1(1)*PH1(1)-P1(2)*PH1(2)-P1(3)*PH1(3))/PP
      B2 = (P2(4)*PH2(4)-P2(1)*PH2(1)-P2(2)*PH2(2)-P2(3)*PH2(3))/PP
      A2 = (P1(4)*PH2(4)-P1(1)*PH2(1)-P1(2)*PH2(2)-P1(3)*PH2(3))/PP
      SFAC1  =  2D0/(PP*A1*B1)*WWM(A1,B1) 
      SFAC2  =  2D0/(PP*A2*B2)*WWM(A2,B2) 
      A1P= A1/(1D0-A2) 
      B1P= B1/(1D0-B2) 
      A2P= A2/(1D0-A1) 
      B2P= B2/(1D0-B1) 
      IF((A1+B1).GT.(A2+B2)) THEN         
        X1=WM (A1   )*WMS(A2P,B2P) +WM (A1P    )*WMS(A2,B2)  
        X2=WM (   B1)*WMS(A2P,B2P) +WM (    B1P)*WMS(A2,B2)  
      ELSE             
        X1=WM (A2   )*WMS(A1P,B1P) +WM (A2P    )*WMS(A1,B1)  
        X2=WM (   B2)*WMS(A1P,B1P) +WM (    B2P)*WMS(A1,B1)  
      ENDIF            
      F1 = X1*SFAC1*SFAC2/8D0             
      F2 = X2*SFAC1*SFAC2/8D0             
      END              
      SUBROUTINE GSOFA2(P1,P2,PH1,PH2,F1,F2)                 
C     **************************************                 
C NEW VERSION BY ELA WAS                  
C CALCULATES INGREDIENTS FOR REAL DOUBLE PHOTON DIFF. XSECTION
C     *****************************************              
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION PH1(*),PH2(*),P1(*),P2(*) 
C   
      WM (A  )=     (1D0-A)**2            
      WMS(A,B)=     ((1D0-A)**2+(1D0-B)**2)                  
      WWM(A,B)=        
     $   1D0-AM*2D0*(1D0-A)*(1D0-B)/((1D0-A)**2+(1D0-B)**2)*(A/B+B/A)
C   
      PP = P1(4)*P2(4)-P1(1)*P2(1)-P1(2)*P2(2)-P1(3)*P2(3)   
      AM2= P1(4)**2-P1(1)**2-P1(2)**2-P1(3)**2               
      AM = AM2/(2D0*PP)                   
      B1 = (P2(4)*PH1(4)-P2(1)*PH1(1)-P2(2)*PH1(2)-P2(3)*PH1(3))/PP
      A1 = (P1(4)*PH1(4)-P1(1)*PH1(1)-P1(2)*PH1(2)-P1(3)*PH1(3))/PP
      B2 = (P2(4)*PH2(4)-P2(1)*PH2(1)-P2(2)*PH2(2)-P2(3)*PH2(3))/PP
      A2 = (P1(4)*PH2(4)-P1(1)*PH2(1)-P1(2)*PH2(2)-P1(3)*PH2(3))/PP
      SFAC1  =  2D0/(PP*A1*B1)*WWM(A1,B1) 
      SFAC2  =  2D0/(PP*A2*B2)*WWM(A2,B2) 
      A1P= A1/(1D0-A2) 
      B1P= B1/(1D0-B2) 
      A2P= A2/(1D0-A1) 
      B2P= B2/(1D0-B1) 
      IF((A1+B1).GT.(A2+B2)) THEN         
        X1=WM (A1   )*WMS(A2P,B2P) +WM (A1P    )*WMS(A2,B2)  
        X2=WM (   B1)*WMS(A2P,B2P) +WM (    B1P)*WMS(A2,B2)  
      ELSE             
        X1=WM (A2   )*WMS(A1P,B1P) +WM (A2P    )*WMS(A1,B1)  
        X2=WM (   B2)*WMS(A1P,B1P) +WM (    B2P)*WMS(A1,B1)  
      ENDIF            
      F1 = X1*SFAC1*SFAC2/8D0             
      F2 = X2*SFAC1*SFAC2/8D0             
C.. correction ELA WAS november 1989................................
C.. this correction reconstructs properly double collinear limit  
C.. and affects below photon-fermion angle  <0.1 amel/ene    
      SFAC1  =  2D0/(PP*A1*B1)            
      SFAC2  =  2D0/(PP*A2*B2)            
      WWM1=1D0-WWM(A1,B1)                 
      WWM2=1D0-WWM(A2,B2)                 
      DELT=(B2**2*A1**2+A2**2*B1**2)/(X1+X2)*2D0*            
     #  ( 1D0/(A1+A2)**2+1D0/(B1+B2)**2)  
      WMINF=1D0-WWM1-WWM2+WWM1*WWM2*(1D0+DELT)               
      F1 = X1*SFAC1*SFAC2/8D0*WMINF       
      F2 = X2*SFAC1*SFAC2/8D0*WMINF       
C...end of correction............................................
      END              
      SUBROUTINE FDIST2(QQ,P1,P2,Q1,Q2,PH1,PH2,DIST2)        
C     ***********************************************        
C Provides double bremsstrahlung distribution - FINAL state brem.
C INPUT:  P1,P2,Q1,Q2,PH1,PH2, four momenta                  
C OUTPUT: DIST2     double bremsstrahlung distribution       
C     *********************************** 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION QQ(*),P1(*),P2(*),Q1(*),Q2(*),PH1(*),PH2(*)  
      DIMENSION PR1(4),PR2(4),PH1R(4),PH2R(4),QR1(4),QR2(4)  
    
      CALL REDUZ2(QQ,Q1,Q2,PH1,PH2,QR1,QR2,PH1R,PH2R)        
      CALL REDUZ0(QQ,P1,P2,PR1,PR2)       
      SVAR1 = QQ(4)**2-QQ(3)**2-QQ(2)**2-QQ(1)**2            
C infrared factors from reduced momenta   
C double bremsstrahlung Xsect in next-to-leading log approx. 
      CALL GSFIN2(Q1,Q2,PH1,PH2,GF1,GF2)  
      CALL GTHET1(QR1,QR2,PR1,COSTH1,COSTH2)                 
      ANDI11= BORNV(SVAR1,COSTH1)         
      ANDI12= BORNV(SVAR1,COSTH2)         
      DIST2 =   GF1*ANDI11+   GF2*ANDI12  
      END              
      SUBROUTINE GSFIN2(P1,P2,PH1,PH2,F1,F2)                 
C     **************************************                 
C CALCULATES INGREDIENTS FOR REAL DOUBLE PHOTON DIFF. XSECTION
C     *****************************************              
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION PH1(*),PH2(*),P1(*),P2(*) 
C   
      WM (A  )=     (1D0-A)**2            
      WMS(A,B)=     ((1D0-A)**2+(1D0-B)**2)                  
      WWM(A,B)=        
     $   1D0-AM*2D0*(1D0-A)*(1D0-B)/((1D0-A)**2+(1D0-B)**2)*(A/B+B/A)
C   
      PP = P1(4)*P2(4)-P1(1)*P2(1)-P1(2)*P2(2)-P1(3)*P2(3)   
      AM2= P1(4)**2-P1(1)**2-P1(2)**2-P1(3)**2               
      AM = AM2/(2D0*PP)                   
      BB1=ABS(P2(4)*PH1(4)-P2(1)*PH1(1)-P2(2)*PH1(2)-P2(3)*PH1(3))/PP
      AA1=ABS(P1(4)*PH1(4)-P1(1)*PH1(1)-P1(2)*PH1(2)-P1(3)*PH1(3))/PP
      BB2=ABS(P2(4)*PH2(4)-P2(1)*PH2(1)-P2(2)*PH2(2)-P2(3)*PH2(3))/PP
      AA2=ABS(P1(4)*PH2(4)-P1(1)*PH2(1)-P1(2)*PH2(2)-P1(3)*PH2(3))/PP
      AA1P= AA1/(1D0+AA2)                 
      BB1P= BB1/(1D0+BB2)                 
      AA2P= AA2/(1D0+AA1)                 
      BB2P= BB2/(1D0+BB1)                 
      A1  = AA1/(1+AA1+BB1)               
      A2  = AA2/(1+AA2+BB2)               
      B1  = BB1/(1+AA1+BB1)               
      B2  = BB2/(1+AA2+BB2)               
      A1P = AA1P/(1+AA1P+BB1P)            
      A2P = AA2P/(1+AA2P+BB2P)            
      B1P = BB1P/(1+AA1P+BB1P)            
      B2P = BB2P/(1+AA2P+BB2P)            
      SFAC1  =  2D0/(PP*AA1*BB1)*WWM(A1,B1)                  
      SFAC2  =  2D0/(PP*AA2*BB2)*WWM(A2,B2)                  
      IF((A1+B1).GT.(A2+B2)) THEN         
        X1=WM (A1   )*WMS(A2P,B2P) +WM (A1P    )*WMS(A2,B2)  
        X2=WM (   B1)*WMS(A2P,B2P) +WM (    B1P)*WMS(A2,B2)  
      ELSE             
        X1=WM (A2   )*WMS(A1P,B1P) +WM (A2P    )*WMS(A1,B1)  
        X2=WM (   B2)*WMS(A1P,B1P) +WM (    B2P)*WMS(A1,B1)  
      ENDIF            
      F1 = X1*SFAC1*SFAC2/8D0             
      F2 = X2*SFAC1*SFAC2/8D0             
      END              
      SUBROUTINE NFDIST(QQ,P1,P2,Q1,Q2,PH1,PH2,DIST2)        
C     ***********************************************        
C Provides distribution for simultaneous initial and final state
C single bremsstrahlung.                  
C INPUT:  P1,P2,Q1,Q2,PH1,PH2 four momenta                   
C OUTPUT: DIST2 is second order result, leading+subleading log. appr.
C     *********************************** 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION QQ(*),P1(*),P2(*),Q1(*),Q2(*),PH1(*),PH2(*)  
      DIMENSION PR1(4),PR2(4),QR1(4),QR2(4),PHR1(4),PHR2(4)  
C   
      CALL REDUZ1(QQ,P1,P2,PH1,PR1,PR2,PHR1)                 
      CALL REDUZ1(QQ,Q1,Q2,PH2,QR1,QR2,PHR2)                 
C Single bremsstrahlung Xsection          
c;;
ccc      CALL BVIRT1(P1,P2,PH1,DELI1)         
ccc      CALL BVIRF1(Q1,Q2,PH2,DELF1)         
      CALL GSOFA1(P1,P2,PH1,GI1,GI2)      
      CALL GSFIN1(Q1,Q2,PH2,GF1,GF2)      
      CALL GTHET3(PR1,PR2,QR1,QR2,CTH11,CTH12,CTH21,CTH22)   
      SVAR1 = QQ(4)**2-QQ(3)**2-QQ(2)**2-QQ(1)**2            
      ANDI11= BORNV(SVAR1,CTH11)          
      ANDI12= BORNV(SVAR1,CTH12)          
      ANDI21= BORNV(SVAR1,CTH21)          
      ANDI22= BORNV(SVAR1,CTH22)          
      DIST2 =  GI1*GF1*ANDI11+ GI1*GF2*ANDI12                
     &        +GI2*GF1*ANDI21+ GI2*GF2*ANDI22                
      END              
      SUBROUTINE BVIRT0(P1,P2,DELS1,DELS2)                   
C     ************************************                   
C Virtual corrections to beta0            
C beta0 is equal Born*(1+DELS1+DELS2)     
C     *********************************** 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION P1(*),P2(*)               
      PARAMETER(PI=3.1415926535897932D0, ALFINV=137.03604D0)
      PARAMETER(ZET2= PI**2/6D0)  
      PARAMETER(ZET3= 1.2020569031595942854D0)       
      PARAMETER(ALF1=1D0/ALFINV/PI)                  
      SVAR   = (P1(4)+P2(4))**2-(P1(3)+P2(3))**2             
     $        -(P1(2)+P2(2))**2-(P1(1)+P2(1))**2             
      AMEL2  = P1(4)**2-P1(3)**2-P1(2)**2-P1(1)**2 
      BILG  =  DLOG(SVAR/AMEL2)           
      DELS1 =  ALF1*(BILG-1D0)            
      DELS2 =  ALF1**2 *0.5D0*BILG**2     
C Subleading terms     
      DELS2 =  DELS2 + ALF1**2*(          
     $            -(13D0/16D0 +1.5D0*ZET2 -3D0*ZET3)*BILG    
     $            -16D0/5D0*ZET2*ZET2 +51D0/8D0*ZET2 +13D0/4D0 
     $            -4.5D0*ZET3 -6D0*ZET2*LOG(2D0) )           
      END
      SUBROUTINE BVIRT1(P1,P2,PH,DELS1)   
C     *********************************   
C VIRTUAL CORRECTION TO BETA1             
C     *********************************** 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION P1(*),P2(*),PH(*),PP(4)   
      PARAMETER(PI=3.1415926535897932D0, ALFINV=137.03604D0)
      PARAMETER(ALF1=1D0/ALFINV/PI)                  
C   
      DO 20 K=1,4      
  20  PP(K)=P1(K)+P2(K)                   
      SVAR= PP(4)**2-PP(3)**2-PP(2)**2-PP(1)**2              
      XK= 2*(PH(4)*PP(4)-PH(3)*PP(3)-PH(2)*PP(2)-PH(1)*PP(1))/SVAR
      AMEL2  = P1(4)**2-P1(3)**2-P1(2)**2-P1(1)**2           
      BILG  =  DLOG(SVAR/AMEL2)           
      DELS1 =  ALF1*(BILG-1D0)*(1D0-0.5D0*DLOG(1D0-XK))      
      END              
      SUBROUTINE BVIRF1(P1,P2,PH,DELS1)   
C     *********************************   
C VIRTUAL CORRECTION TO BETA1             
C     *********************************** 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION P1(*),P2(*),PH(*),PP(4)   
      PARAMETER(PI=3.1415926535897932D0, ALFINV=137.03604D0)
      PARAMETER(ALF1=1D0/ALFINV/PI)                  
C   
      DO 20 K=1,4      
  20  PP(K)=P1(K)+P2(K)                   
      SVAR= PP(4)**2-PP(3)**2-PP(2)**2-PP(1)**2              
      XK= 2*(PH(4)*PP(4)-PH(3)*PP(3)-PH(2)*PP(2)-PH(1)*PP(1))/SVAR
      XK=ABS(XK)/(1+ABS(XK))              
      AMEL2  = P1(4)**2-P1(3)**2-P1(2)**2-P1(1)**2           
      BILG  =  DLOG(SVAR/AMEL2)           
      DELS1 =  ALF1*(BILG-1D0)*(1D0+0.5D0*DLOG(1D0-XK))      
      END              
      SUBROUTINE GSOFA1(P1,P2,PH,F1,F2)   
C     *********************************   
C CALCULATES INGREDIENTS FOR REAL SINGLE PHOTON DIFF. XSECTION 
C     *****************************************              
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION PH(*),P1(*),P2(*)         
      AM2= P1(4)**2-P1(1)**2-P1(2)**2-P1(3)**2               
      PK1= P1(4)*PH(4)-P1(1)*PH(1)-P1(2)*PH(2)-P1(3)*PH(3)   
      PK2= P2(4)*PH(4)-P2(1)*PH(1)-P2(2)*PH(2)-P2(3)*PH(3)   
      PP = P1(4)*P2(4)-P1(1)*P2(1)-P1(2)*P2(2)-P1(3)*P2(3)   
      B  =  PK2/PP     
      A  =  PK1/PP     
      SFAC1  =  2D0*PP/PK1/PK2            
      AM = AM2/(2D0*PP)                   
      WWM= 1D0-AM*2D0*(1D0-A)*(1D0-B)/((1D0-A)**2+(1D0-B)**2)*(A/B+B/A)
      F1   = 0.5D0*(1D0-A)**2*WWM *SFAC1  
      F2   = 0.5D0*(1D0-B)**2*WWM *SFAC1  
      END              
      SUBROUTINE SFACH0(P1,P2,PH,SFAC0)   
C     *********************************   
C CALCULATES SOFT FACTOR FOR REAL SOFT PHOTON.               
C     *********************************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION PH(4),P1(4),P2(4)         
      AM2= P1(4)**2-P1(1)**2-P1(2)**2-P1(3)**2               
      PK1= P1(4)*PH(4)-P1(1)*PH(1)-P1(2)*PH(2)-P1(3)*PH(3)   
      PK2= P2(4)*PH(4)-P2(1)*PH(1)-P2(2)*PH(2)-P2(3)*PH(3)   
      PP = P1(4)*P2(4)-P1(1)*P2(1)-P1(2)*P2(2)-P1(3)*P2(3)   
      SFAC0  =  2D0*PP/PK1/PK2 -AM2/PK1**2 -AM2/PK2**2       
      END              
      SUBROUTINE GTHET0(P1,Q1,COSTH)      
C     ******************************      
C Calculates CosTh between BEAM and FINAL fermion            
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION P1(*),Q1(*)               
      COSTH  = (P1(1)*Q1(1) +P1(2)*Q1(2) +P1(3)*Q1(3))       
     $            /SQRT((Q1(1)**2 +Q1(2)**2 +Q1(3)**2)       
     $                 *(P1(1)**2 +P1(2)**2 +P1(3)**2))      
      END              
      SUBROUTINE GTHET1(P1,P2,Q1,COSTH1,COSTH2)              
C     *****************************************              
C Calculates CosTh1 and CosTh2 between BEAM amd FINAL        
C fermion momenta in final fermion rest frame Q1(4)+Q2(4)=0  
C     *********************************** 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION P1(*),P2(*),Q1(*)         
      COSTH1 = (P1(1)*Q1(1) +P1(2)*Q1(2) +P1(3)*Q1(3))       
     $            /SQRT((Q1(1)**2 +Q1(2)**2 +Q1(3)**2)       
     $                 *(P1(1)**2 +P1(2)**2 +P1(3)**2))      
      COSTH2 =-(P2(1)*Q1(1) +P2(2)*Q1(2) +P2(3)*Q1(3))       
     $            /SQRT((Q1(1)**2 +Q1(2)**2 +Q1(3)**2)       
     $                 *(P2(1)**2 +P2(2)**2 +P2(3)**2))      
      END              
      SUBROUTINE GTHET3(P1,P2,Q1,Q2,CTH11,CTH12,CTH21,CTH22) 
C     ***************************************************    
C Calculates CosTh1 and CosTh2 between BEAM amd FINAL        
C fermion momenta in Z RESONANCE rest frame Q1(4)+Q2(4)=0    
C     *********************************** 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION P1(*),P2(*),Q1(*),Q2(*)   
      Q1D=        SQRT(Q1(1)**2 +Q1(2)**2 +Q1(3)**2)         
      Q2D=        SQRT(Q2(1)**2 +Q2(2)**2 +Q2(3)**2)         
      P1D=        SQRT(P1(1)**2 +P1(2)**2 +P1(3)**2)         
      P2D=        SQRT(P2(1)**2 +P2(2)**2 +P2(3)**2)         
      CTH11 = (Q1(1)*P1(1) +Q1(2)*P1(2) +Q1(3)*P1(3))/Q1D/P1D 
      CTH12 =-(Q1(1)*P2(1) +Q1(2)*P2(2) +Q1(3)*P2(3))/Q1D/P2D
      CTH21 =-(Q2(1)*P1(1) +Q2(2)*P1(2) +Q2(3)*P1(3))/Q2D/P1D 
      CTH22 = (Q2(1)*P2(1) +Q2(2)*P2(2) +Q2(3)*P2(3))/Q2D/P2D
      END              
      SUBROUTINE TRALQQ(MODE,Q,P,R)       
C     *****************************       
C BOOST ALONG Z AXIS TO A FRAME WHERE QQ(3)=0                
C AND NEXT ALONG TRANSVERSE DIRECTION OF QQ,                 
C FORTH (MODE = 1) OR BACK (MODE = -1).   
C Q MUST BE A TIMELIKE, P MAY BE ARBITRARY.                  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION Q(*),P(*),R(*)            
      DIMENSION QL(4),QT(4)               
      QL(4)=Q(4)       
      QL(3)=Q(3)       
      QL(2)=0D0        
      QL(1)=0D0        
      CALL BOSTDQ(1,QL,Q,QT)              
      IF(MODE.EQ.1) THEN                  
        CALL BOSTDQ( 1,QL,P,R)            
        CALL BOSTDQ( 1,QT,R,R)            
      ELSE             
        CALL BOSTDQ(-1,QT,P,R)            
        CALL BOSTDQ(-1,QL,R,R)            
      ENDIF            
      END              
      SUBROUTINE REDUZ0(QQ,P1,P2,PR1,PR2) 
C     *********************************** 
C reduction of momenta for beta0, second one                 
C I.E. WE MAPP:   P1,P2 ==> PR1,PR2       
C such that  PR1+PR2 = QQ                 
C Resulting PRi QRi are in QQ rest frame. 
C     *********************************** 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      PARAMETER( EPS1 =1D-15)                  
      DIMENSION QQ(4),P1(4),P2(4),PR1(4),PR2(4)              
      DIMENSION PP(4),PX1(4),PX2(4),PPX(4)                   
C   
      DO 20 K=1,4      
 20   PP(K)=P1(K)+P2(K)                   
      IF((PP(1)**2+PP(2)**2+PP(3)**2)/PP(4)**2 .GT. EPS1) THEN 
C transform all momenta to QQ rest-frame  
         CALL BOSTDQ( 1,QQ,P1 ,PX1)       
         CALL BOSTDQ( 1,QQ,P2 ,PX2)       
         CALL BOSTDQ( 1,QQ,PP ,PPX)       
C transform all momenta to PP rest-frame  
         CALL BOSTDQ( 1,PPX,PX1,PX1)      
         CALL BOSTDQ( 1,PPX,PX2,PX2)      
      ELSE             
C do nothing if we are already in PP rest-frame              
         DO 23 K=1,4   
            PX1(K)=P1(K)                  
   23       PX2(K)=P2(K)                  
      ENDIF            
C construct reduced beam momenta PR1,PR2  
C note: they are understood to be in QQ rest-frame           
      SVAR1 = QQ(4)**2-QQ(3)**2-QQ(2)**2-QQ(1)**2            
      SVAR  = PP(4)**2-PP(3)**2-PP(2)**2-PP(1)**2            
      VV    = 1D0 -SVAR1/SVAR             
      IF(ABS(VV).GT. EPS1) THEN           
         AMEL2=  P1(4)**2-P1(3)**2-P1(2)**2-P1(1)**2         
         PR1(4)= SQRT(SVAR1)/2D0          
         PR2(4)= PR1(4)                   
         PXMOD = SQRT(PX1(1)**2+PX1(2)**2+PX1(3)**2)         
         PRMOD = SQRT(PR1(4)**2-AMEL2)    
         DO 30 K=1,3   
         PR1(K)= PX1(K)/PXMOD*PRMOD       
 30      PR2(K)= PX2(K)/PXMOD*PRMOD       
      ELSE             
         DO 40 K=1,4   
         PR1(K)= PX1(K)                   
 40      PR2(K)= PX2(K)                   
      ENDIF            
      END              
      SUBROUTINE REDUZ1(QQ,P1,P2,PH,PR1,PR2,PHR)             
C     ******************************************             
C reduction of 4-momenta for beta1        
C           P1,P2,PH ==--> PR1,PR2,PHR    
C such that  PR1+PR2 = QQ+PHR             
C     *********************************** 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      PARAMETER( EPS1 =1D-15)                   
      COMMON / INOUT  / NINP,NOUT   
      SAVE   / INOUT  /
      DIMENSION QQ(4), P1(4), P2(4), PH(4), PR1(4),PR2(4),PHR(4)
      DIMENSION PP(4),QQK(4),PPX(4), PPK(4)                  
      DIMENSION PX1(4),PX2(4),PHX(4)      
C   
      DO 20 K=1,4      
      PP(K)   = P1(K)+P2(K)               
      PPK(K)  = P1(K)+P2(K)-PH(K)         
 20   QQK(K)  = QQ(K)+PH(K)               
      SVAR  =  PP(4)**2 -PP(3)**2 -PP(2)**2 -PP(1)**2        
      SVAR1 =  QQ(4)**2 -QQ(3)**2 -QQ(2)**2 -QQ(1)**2        
      SS1   = PPK(4)**2-PPK(3)**2-PPK(2)**2-PPK(1)**2        
      SS2   = QQK(4)**2-QQK(3)**2-QQK(2)**2-QQK(1)**2        
      IF((PP(1)**2+PP(2)**2+PP(3)**2)/PP(4)**2 .GT. EPS1) THEN
C transform all momenta to QQ rest-frame  
         CALL BOSTDQ( 1,QQ,P1 ,PX1)       
         CALL BOSTDQ( 1,QQ,P2 ,PX2)       
         CALL BOSTDQ( 1,QQ,PH ,PHX)       
         CALL BOSTDQ( 1,QQ,PP ,PPX)       
C transform all momenta to PP rest-frame  
         CALL BOSTDQ( 1,PPX,PX1,PX1)      
         CALL BOSTDQ( 1,PPX,PX2,PX2)      
         CALL BOSTDQ( 1,PPX,PHX,PHX)      
      ELSE             
C do nothing if we are already in PP rest-frame              
         DO 23 K=1,4   
            PHX(K)=PH(K)                  
            PX1(K)=P1(K)                  
   23       PX2(K)=P2(K)                  
      ENDIF            
C construct reduced beam momenta PR1,PR2  
C note: they are understood to be in QQ rest-frame           
      VV2   = 1D0 - SS2/SVAR              
      IF(ABS(VV2).GT. EPS1) THEN          
         PK    =  (PX1(4)+PX2(4))*PHX(4)  
CCCCC    XLAM= SQRT(SVAR1/SVAR+(PK/SVAR)**2)+PK/SVAR         
         XLAM= SQRT(SVAR1/SS1)            
         AMEL2=  P1(4)**2-P1(3)**2-P1(2)**2-P1(1)**2         
         PXMOD = SQRT(PX1(1)**2+PX1(2)**2+PX1(3)**2)         
         PX1(4)= PX1(4)*XLAM              
         PX2(4)= PX2(4)*XLAM              
CCC      PRMOD = SQRT(PX1(4)**2-AMEL2)    
         PRMOD =      PX1(4)**2-AMEL2     
         IF(PRMOD.LE.0D0) WRITE(NOUT,*) ' REDUZ1: PRMOD=', PRMOD
         IF(PRMOD.LE.0D0) WRITE(   6,*) ' REDUZ1: PRMOD=', PRMOD
         PRMOD = SQRT(ABS(PRMOD))         
         DO 30 K=1,3   
         PX1(K)= PX1(K)/PXMOD*PRMOD       
 30      PX2(K)= PX2(K)/PXMOD*PRMOD       
         DO 31 K=1,4   
 31      PHX(K)= PHX(K)*XLAM              
      ENDIF            
C then, boost away the three-vector part of P1+P2-PH         
C that is transform to QQ rest frame      
      DO 35 K=1,4      
 35   PP(K)= PX1(K)+PX2(K)-PHX(K)         
      CALL BOSTDQ( 1,PP,PX1,PR1)          
      CALL BOSTDQ( 1,PP,PX2,PR2)          
      CALL BOSTDQ( 1,PP,PHX,PHR)          
      END              
      SUBROUTINE REDUZ2(QQ,P1,P2,PH1,PH2,PR1,PR2,PH1R,PH2R)  
C     *****************************************************  
C Reduction for beta2  
C           P1,P2,PH1,PH2 ==--> PR1,PR2,PH1R,PH2R            
C such that  PR1+PR2 = PH1R+PH2R+QQ       
C Input:  QQ,P1,P2,PH1,PH2                
C Output: PR1,PR2,PH1R,PH2R               
C     *********************************** 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      PARAMETER( EPS1 =1D-15)                   
      COMMON / INOUT  / NINP,NOUT   
      SAVE   / INOUT  /
      DIMENSION QQ(*), P1(*),  P2(*),  PH1(*),  PH2(*)       
      DIMENSION        PR1(*), PR2(*), PH1R(*), PH2R(*)      
      DIMENSION PP(4),QQK(4),PPK(4),PPX(4)       
      DIMENSION PX1(4),PX2(4),PH1X(4),PH2X(4),SPH(4)         
C   
      DO 20 K=1,4      
      PP(K)   = P1(K)+P2(K)               
      PPK(K)  = P1(K)+P2(K)-PH1(K)-PH2(K) 
 20   QQK(K)  = QQ(K)+PH1(K)+PH2(K)       
      SVAR  =  PP(4)**2 -PP(3)**2 -PP(2)**2 -PP(1)**2        
      SVAR1 =  QQ(4)**2 -QQ(3)**2 -QQ(2)**2 -QQ(1)**2        
      SS1   = PPK(4)**2-PPK(3)**2-PPK(2)**2-PPK(1)**2        
      SS2   = QQK(4)**2-QQK(3)**2-QQK(2)**2-QQK(1)**2        
      IF((PP(1)**2+PP(2)**2+PP(3)**2)/PP(4)**2 .GT. EPS1) THEN 
C transform all momenta to QQ rest-frame  
         CALL BOSTDQ( 1,QQ,P1 ,PX1)       
         CALL BOSTDQ( 1,QQ,P2 ,PX2)       
         CALL BOSTDQ( 1,QQ,PH1,PH1X)      
         CALL BOSTDQ( 1,QQ,PH2,PH2X)      
         CALL BOSTDQ( 1,QQ,PP ,PPX)       
C transform all momenta to PP rest-frame  
         CALL BOSTDQ( 1,PPX,PX1,PX1)      
         CALL BOSTDQ( 1,PPX,PX2,PX2)      
         CALL BOSTDQ( 1,PPX,PH1X,PH1X)    
         CALL BOSTDQ( 1,PPX,PH2X,PH2X)    
      ELSE             
C do nothing if we are already in PP rest-frame              
         DO 23 K=1,4   
            PH1X(K)=PH1(K)                
            PH2X(K)=PH2(K)                
            PX1(K)=P1(K)                  
   23       PX2(K)=P2(K)                  
      ENDIF            
C construct reduced beam momenta PR1,PR2  
C note: they are understood to be in QQ rest-frame           
      VV2   = 1D0 - SS2/SVAR              
      IF(ABS(VV2).GT.1D-6) THEN           
C construct reduced beam momenta PR1,PR2  
C start with dilatation of beams          
         DO 24 K=1,4   
         PP(K)  =  PX1(K)+PX2(K)          
  24     SPH(K) =  PH1(K)+PH2(K)          
         PK     =  PP(4)*SPH(4)           
         SK2    =  SPH(4)**2 -SPH(3)**2 -SPH(2)**2 -SPH(1)**2
CCCC     XLAM   =  SQRT((SVAR1-SK2)/SVAR+(PK/SVAR)**2)+PK/SVAR
         XLAM   =  SQRT(SVAR1/SS1)        
         AMEL2  =  P1(4)**2-P1(3)**2-P1(2)**2-P1(1)**2       
         PXMOD  =  SQRT(PX1(1)**2+PX1(2)**2+PX1(3)**2)       
         PX1(4) =  PX1(4)*XLAM            
         PX2(4) =  PX2(4)*XLAM            
CCCC     PRMOD  =  SQRT(PX1(4)**2-AMEL2)  
         PRMOD  =      PX1(4)**2-AMEL2    
         IF(PRMOD.LE.0D0) WRITE(NOUT,*) ' REDUZ2: PRMOD=', PRMOD
         IF(PRMOD.LE.0D0) WRITE(   6,*) ' REDUZ2: PRMOD=', PRMOD 
         PRMOD  = SQRT(ABS(PRMOD))        
         DO 30 K=1,3   
         PX1(K) = PX1(K)/PXMOD*PRMOD      
 30      PX2(K) = PX2(K)/PXMOD*PRMOD      
         DO 31 K=1,4   
         PH1X(K)= PH1X(K)*XLAM            
 31      PH2X(K)= PH2X(K)*XLAM            
      ENDIF            
C then, boost away the three-vector part of P1+P2-PH1-PH2    
C that is transform to QQ rest frame      
      DO 35 K=1,4      
 35   PP(K)= PX1(K)+PX2(K)-PH1X(K)-PH2X(K)                   
      CALL BOSTDQ( 1,PP,PX1,PR1)          
      CALL BOSTDQ( 1,PP,PX2,PR2)          
      CALL BOSTDQ( 1,PP,PH1X,PH1R)        
      CALL BOSTDQ( 1,PP,PH2X,PH2R)        
      END                        

      FUNCTION BREMKF(KEY,EREL)                  
C     *************************         
C NON-MONTECARLO INTEGRATION OF THE V-DISTRIBUTION            
C GAUSS METHOD, CHANGE OF VARIABLES WITH HELP OF CHBIN1       
C SEE VVDISB              
C KEY= 1,2,3,...FOR VARIOUS DISTRIBUTIONS   
C KEY= 3 FOR MC GENERATION, OTHER FOR TESTS                   
C FOR KEYFIX=1, EXEPTIONALLY, IT PROVIDES INTEGRAND AT VV=VVMAX 
C WITH BORN OMITTED       
C     ************************              
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
      COMMON / KEYYFS / KEYZET,KEYBRM,KEYFIX,KEYRED,KEYWGT    
C COMMON KEYDST COMMUNICATES ONLY WITH VVDISB - INTEGRAND FUNCTION 
      COMMON / KEYDST / KEYDIS              
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF 
      COMMON / VVREC  / VVMIN,VVMAX,VV,BETI                   
      SAVE / KEYYFS /,/ KEYDST /,/ WEKING /,/ VVREC  /
      EXTERNAL VVDISB     
C       
      KEYDIS=KEY          
      IF(KEYFIX.EQ.0) THEN                  
         XBORN  =BORNY(4D0*ENE**2)          
         PREC=  XBORN*EREL                  
         XA= 0D0          
         XB= 1D0
         CALL GAUSJD(VVDISB,XA,XB,PREC,RESULT)
         BREMKF=RESULT          
      ELSE                
         SVAR  = 4D0*ENE**2
         BREMKF= VVRHO(KEYDIS,SVAR,AMEL,VVMAX,VVMIN)
     $          /VVRHO(     9,SVAR,AMEL,VVMAX,VVMIN)          
      ENDIF               
      END                 
      FUNCTION VVDISB(R)                    
C     ******************                    
C INTEGRAND FOR BREMKF    
C MAPPING XX => VV CHANGE  TO IMPROVE ON EFFICIENCY           
C     ************************              
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
      PARAMETER( FLEPS =1D-35)              
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF
      COMMON / VVREC  / VVMIN,VVMAX,VV,BETI                   
      COMMON / KEYDST / KEYDIS              
      SAVE / WEKING /,/ VVREC  /,/ KEYDST /
C       
      KEYD=KEYDIS         
      X = MAX(R,FLEPS**BETI)                
      ALF=  BETI          
      BET=  1D0           
C ...SPECIAL CASES        
C ...Monte Carlo crude distr                
      IF    (KEYD.EQ.1)  THEN               
        BET=  -0.5D0      
C ...YFS exponentiation beta0,1,2 contribs  
      ELSEIF(KEYD.EQ.310)  THEN              
        ALF=  BETI        
      ELSEIF(KEYD.EQ.311)  THEN             
        ALF=  BETI +1     
      ELSEIF(KEYD.EQ.320)  THEN              
        ALF=  BETI        
      ELSEIF(KEYD.EQ.321)  THEN             
        ALF=  BETI +1     
      ELSEIF(KEYD.EQ.322)  THEN             
        ALF=  BETI +2     
C ...Reference distr including dilatation factor DAMEL        
      ELSEIF(KEYD.EQ.12) THEN               
        BET=  -0.5        
      ENDIF               
      CALL CHBIN1(X,ALF,BET,VVMAX,VV,RJAC)                
C BORN XSECTION           
C NOTE 1/(1-VV) FACTOR BECAUSE BORNY IS IN R-UNITS            
      SVAR   = 4D0*ENE**2
      SVAR1  = SVAR*(1D0-VV)                 
      XBORN  = BORNY(SVAR1)/(1D0-VV)         
      VVDISB = VVRHO(KEYD,SVAR,AMEL,VV,VVMIN) *RJAC*XBORN          
      END                 
      FUNCTION VVRHO(KEYDIS,SVAR,AMEL,VV,VVMIN) 
C     *****************************************
C-------------------------------------------------------------
C Convention for KEYDIS      
C Pedagogical exercises
C     KEYDIS   =  1      crude distribution for initial state MC
C     KEYDIS   =  9      reference distr.  of YFS2 CPC paper 
C     KEYDIS   =  50-52  obsolete test distr. for YFS2 CPC paper 
C     KEYDIS   =  101    soft part YFS       First  Order
C     KEYDIS   =  102    soft part YFS       Second Order
C     KEYDIS   =  105    hard non-exp.       First  Order
C     KEYDIS   =  106    hard non-exp.       Second Order
C Total results
C     KEYDIS   =  0 + R*100                  Zero   Order     
C     KEYDIS   =  1 + R*100                  First  Order     
C     KEYDIS   =  2 + R*100                  Second Order     
C     KEYDIS   = 15     reference distr. of YFS paper
C Beta contributions
C     KEYDIS   = 10 + R*100      Beta0       Zero   Order        
C     KEYDIS   = 11 + R*100      Beta0       First  Order        
C     KEYDIS   = 12 + R*100      Beta1            
C     KEYDIS   = 20 + R*100      Beta0       Second Order        
C     KEYDIS   = 21 + R*100      Beta1            
C     KEYDIS   = 22 + R*100      Beta2        
C     R = 200 Kuraev-Fadin   
C     R = 300 YFS (pragmatic)           
C     R = 400 YFS single electron LL str. funct.          
C-------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER(PI= 3.1415926535897932D0, ALFINV=137.03604D0) 
      PARAMETER(ALF1   = 1D0/PI/ALFINV)
      PARAMETER(CEULER =0.57721566D0)       
      COMMON / INOUT  / NINP,NOUT     
      SAVE   / INOUT  /
C           
      KEYD = KEYDIS           
      BILG   = DLOG(SVAR/AMEL**2)           
      BETI   = 2D0*ALF1*(BILG-1D0)          
C===================================================================
C ---------------------- KEYD = 1 ----------------------------------
C ---- Crude distribution in YFS2 initial state Monte Carlo --------
C ------------------------------------------------------------------
c dilat is related to dilatation jacobian in yfsgen                
c damel is responsible for modification of photon ang. distribution
c see also weight wt=wt1 in   angbre                               
      IF(KEYD.GE.1.AND.KEYD.LT.100) THEN
         DILAT=1D0           
         IF(VV.GT.VVMIN) DILAT=(1D0+1D0/SQRT(1D0-VV))/2D0        
         BETI2  = 2D0*ALF1*BILG                
         DAMEL=1D0           
         IF(VV.GT.VVMIN) DAMEL=BETI2/BETI*(VV/VVMIN)**(BETI2-BETI)
C---------
         IF    (KEYD.EQ.1)  THEN               
            DISTR= BETI*VV**(BETI-1D0)*DILAT*DAMEL       
C ...Reference distribution used in YFS2 paper --------------------
         ELSEIF(KEYD.EQ. 9)  THEN   
            DISTR= BETI*VV**(BETI-1D0)*(1+(1-VV)**2)/2               
C basic reference distribution  xrefer=sigma-ref                
         ELSEIF(KEYD.EQ.50) THEN   
            DISTR= BETI*VV**(BETI-1D0)             
C XREFER TIMES DAMEL            
         ELSEIF(KEYD.EQ.51) THEN   
            DISTR= BETI*VV**(BETI-1D0)*DAMEL       
C XREFER TIMES DILATATION FACTOR DILAT          
         ELSEIF(KEYD.EQ.52) THEN   
            DISTR= BETI*VV**(BETI-1D0)*DILAT
         ENDIF       
C ------------------------------------------------------------
C ------------- Soft part only  -- YFS exponentiation         
C ------------------------------------------------------------
      ELSEIF(KEYD.GE. 101.AND.KEYD.LE.102) THEN     
         DELB   = ALF1*(0.5D0*BILG -1D0  +PI**2/3D0)          
         GAMFAC =EXP(-CEULER*BETI)/DPGAMM(1D0+BETI)           
C ....first order             
         IF(KEYD  .EQ. 101) THEN              
            DELS = ALF1*(BILG-1D0)          
C ....Second Order            
         ELSEIF(KEYD  .EQ. 102) THEN          
            DELS = ALF1*(BILG-1D0) +0.5D0*(ALF1*BILG)**2      
         ENDIF                
         DISTR=  GAMFAC*EXP(DELB)*BETI*VV**(BETI-1D0)*( 1D0+DELS)
C ---------------------------------------------------------------
C ------------- Hard part only - no exponentiation              
C ---------------------------------------------------------------
      ELSEIF(KEYD.GE. 105.AND.KEYD.LE.106 ) THEN   
         Z=1D0-VV                
C ....First  Order               
         IF(KEYD  .EQ. 105) THEN   
            DISTR =  BETI*(1D0 +Z**2)/2D0/VV   
C ....Second Order               
         ELSEIF(KEYD  .EQ. 106) THEN             
            DIST1 =  BETI*(1D0 +Z**2)/2D0/VV   
            DELH2 =  (ALF1*BILG)**2*(          
     $             -(1D0+Z*Z)/VV*DLOG(Z)       
     $              +(1D0+Z)*(0.5D0*DLOG(Z)-2D0*DLOG(VV))        
     $              -2.5D0-0.5D0*Z  )          
            DIST2 =  (ALF1*BILG)**2*( 3 +4*DLOG(VV))/VV +DELH2   
            DISTR =  DIST1+DIST2 
         ENDIF 
C ---------------------------------------------------------------
C ---------------------------------------------------------------
C ----- exponentiation following Kuraiev Fadin prescription 
C ---------------------------------------------------------------
      ELSEIF(KEYD.GE.201.AND.KEYD.LE.202) THEN 
C First Order  from Gerrit Burgers (POLARIZATION BOOK)           
         DZ2 = PI**2/6D0         
         Z=1D0-VV                
         IF(KEYD  .EQ.201) THEN  
            DELVS= ALF1*(1.5D0*BILG +2D0*DZ2-2D0)                
            DELH=  -ALF1*(1D0+Z)*(BILG-1D0)    
         ELSEIF(KEYD  .EQ.202) THEN            
            DELVS= ALF1*(1.5D0*BILG +2D0*DZ2-2D0)                
     $            +ALF1**2*(9D0/8D0-2D0*DZ2)*BILG**2             
            DELH=  -ALF1*(1D0+Z)*(BILG-1D0)    
     $      +ALF1**2*( -(1D0+Z*Z)/VV     *DLOG(Z)                
     $              +(1D0+Z)*(0.5D0*DLOG(Z)-2D0*DLOG(VV))        
     $              -2.5D0-0.5D0*Z)*BILG**2    
         ENDIF 
         DISTR=  BETI*VV**(BETI-1D0)*( 1D0+DELVS) +DELH          
C ---------------------------------------------------------------
C ------------- YFS ad-hoc exponentiation -----------------------
C ---------------------------------------------------------------
      ELSEIF(KEYD.GE.300.AND.KEYD.LE.302) THEN 
         DELB   = ALF1*(0.5D0*BILG -1D0  +PI**2/3D0)             
         GAMFAC =EXP(-CEULER*BETI)/DPGAMM(1D0+BETI)              
C ....Zero   Order               
         IF(KEYD  .EQ.300)  THEN 
            DELS = 0D0           
            DELH = -BETI/4 *LOG(1-VV)          
C ....First  Order               
         ELSEIF(KEYD  .EQ.301)  THEN           
            DELS = BETI/2        
            DELH = VV*(-1 +VV/2) 
     $      -BETI/2*VV**2 - BETI/4*(1-VV)**2*LOG(1-VV)           
C ....Second Order               
         ELSEIF(KEYD  .EQ.302)  THEN           
            DELS = ALF1*(BILG-1D0) +0.5D0*(ALF1*BILG)**2         
            DELH = VV*(-1D0+VV/2D0)            
     $      +ALF1*BILG*(-0.25D0*(4D0-6D0*VV+3D0*VV**2)*DLOG(1D0-VV) -VV)
         ENDIF        
         DISTR= GAMFAC*EXP(DELB)*BETI*VV**(BETI-1D0)*(1 +DELS + DELH )  
C----------------------------------------------------------------   
C-------------- YFS ad-hoc exponentiation -----------------------
C-------------Contributions  from various beta's ---------------- 
C---------------------------------------------------------------- 
      ELSEIF(KEYD.GE.310.AND.KEYD.LE.322)  THEN       
         DELB   = ALF1*(0.5D0*BILG -1D0  +PI**2/3D0)  
         GAMFAC = EXP(-CEULER*BETI)/DPGAMM(1D0+BETI)  
         SOFT   = 0D0 
         DELH   = 0D0 
C ...Beta0 First  Order                 
         IF(KEYD.EQ.310) THEN           
            SOFT = 1 + BETI/2           
            DELH = -BETI/4 *LOG(1-VV)   
C ...Beta1 First  Order                 
         ELSEIF(KEYD.EQ. 311)  THEN     
            DELH =    
     $      VV*(-1D0+VV/2/(1+BETI))*(1-0.5*BETI*LOG(1-VV)) 
C ...Beta0 Second Order                 
         ELSEIF(KEYD.EQ.320) THEN       
            SOFT = 1 + BETI/2  +BETI**2/8             
            DELH = -BETI/4 *LOG(1-VV)   
C ...Beta1 Second Order                 
         ELSEIF(KEYD.EQ. 321)  THEN     
            DELH = VV*(-1+VV/2)         
     $      -BETI*VV/2 -BETI*VV**2/4 +BETI/8*(-2+6*VV-3*VV**2)*LOG(1-VV)
C ...Beta2 Second Order                 
         ELSEIF(KEYD.EQ. 322)  THEN     
            DELH =    BETI*  VV**2/4D0  
         ENDIF        
         DISTR=  GAMFAC*EXP(DELB)*BETI*VV**(BETI-1D0)*(SOFT+DELH)       
C -------------------------------------------------------------------   
C -------------------YFS formula-------------------------------------   
C -------------Single fermion LL fragmentation ----------------------   
C -------------------------------------------------------------------   
      ELSEIF(KEYD.GE.400.AND.KEYD.LE.402)  THEN       
C&&&&&&  DELB   = BETI/4                
         DELB   = BETI/4  +ALF1*(-0.5D0  +PI**2/3D0)  
         GAMFAC = EXP(-CEULER*BETI)/DPGAMM(1D0+BETI)  
         SOFT   = 0D0 
         DELH   = 0D0 
C ...Zero   Order     
         IF(KEYD.EQ.400) THEN           
            SOFT = 1  
C ...First  Order     
         ELSEIF(KEYD.EQ.401) THEN       
            SOFT = 1 + BETI/2           
            DELH =    
     $      VV*(-1D0+VV/2/(1+BETI))     
C ...Second Order     
         ELSEIF(KEYD.EQ.402) THEN       
            SOFT = 1 + BETI/2  +BETI**2/8             
C           DELH =    
C    $      VV*(1+0.5*BETI)*(-1D0+VV/2/(1+BETI))      
C    $      -0.50*BETI*LOG(1-VV)*0.5*(1+(1-VV)**2)    
C    $      + BETI/4D0*VV*(VV +(1-VV/2)*DLOG(1D0-VV)) 
            DELH =    
     $      VV*(-1D0+VV/2)              
     $      + BETI*(-VV/2 -(1+3*(1-VV)**2)/8*DLOG(1D0-VV))              
         ENDIF  
         DISTR=  GAMFAC*EXP(DELB)*BETI*VV**(BETI-1D0)*(SOFT+DELH)       
C -------------------------------------------------------------------   
C -------------Single fermion LL fragmentation ----------------------   
C -------------Contributions  from various beta's -------------------   
C -------------------------------------------------------------------   
      ELSEIF(KEYD.GE.400.AND.KEYD.LE.422)  THEN       
C&&&&&   DELB   = BETI/4                
         DELB   = BETI/4  +ALF1*(-0.5D0  +PI**2/3D0)  
         GAMFAC = EXP(-CEULER*BETI)/DPGAMM(1D0+BETI)  
         SOFT   = 0D0 
         DELH   = 0D0 
C ...Beta0 zero   Order                 
         IF(KEYD.EQ.400) THEN           
            SOFT = 1  
C ...Beta0 First  Order                 
         ELSEIF(KEYD.EQ.410) THEN       
            SOFT = 1 + BETI/2           
C ...Beta1 First  Order                 
         ELSEIF(KEYD.EQ. 411)  THEN     
            DELH =    
     $      VV*(-1D0+VV/2/(1+BETI))     
C ...Beta0 Second Order                 
         ELSEIF(KEYD.EQ.420) THEN       
            SOFT = 1 + BETI/2  +BETI**2/8             
C ...Beta1 Second Order                 
         ELSEIF(KEYD.EQ. 421)  THEN     
            DELH =    
     $      VV*(1+0.5*BETI)*(-1D0+VV/2/(1+BETI))      
     $      -0.50*BETI*LOG(1-VV)*0.5*(1+(1-VV)**2)    
C ...Beta2 Second Order                 
         ELSEIF(KEYD.EQ. 422)  THEN     
            DELH = BETI/4D0*VV*(VV +(1-VV/2)*DLOG(1D0-VV))              
         ELSE   
            GOTO 900          
         ENDIF  
         DISTR=  GAMFAC*EXP(DELB)*BETI*VV**(BETI-1D0)*(SOFT+DELH) 
C ----------------------------------------------------------------
C -------------Single fermion LL fragmentation -------------------
C -------------I N F I N I T E   O R D E R -----------------------
C ----------------------------------------------------------------
      ELSEIF(KEYD.EQ.502)  THEN   
         DELB   = BETI*0.75D0     
         GAMFAC = EXP(-CEULER*BETI)/DPGAMM(1D0+BETI)               
         SOFT   = 1           
         DELH =  
     $   VV*(-1D0+VV/2)            
     $   + BETI*(-VV**2/4 -(1+3*(1-VV)**2)/8*DLOG(1D0-VV))         
         DISTR=  GAMFAC*EXP(DELB)*BETI*VV**(BETI-1D0)*(SOFT+DELH)  
      ELSE       
         GOTO 900             
      ENDIF      
      VVRHO = DISTR                
      RETURN    
 900  WRITE(6,*) ' ===--->  WRONG KEYDIS IN VVRHO',KEYD 
      STOP       
      END        


      FUNCTION BREFKF(KEY,EREL)                
C     *************************                
C Non-MonteCarlo integration of the u-distribution FINAL st.bremss.
C Gauss method, change of variables with help of CHBIN1        
C     ************************            
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
C COMMON KEYDST COMMUNICATES ONLY UUDISB - INTEGRAND FUNCTION  
      COMMON / KEYDST / KEYDIS            
      SAVE   / KEYDST /
      EXTERNAL UUDISB    
C   
      KEYDIS=KEY         
      PREC= DABS( EREL)        
      XA= 0D0            
      XB= 1D0            
      CALL GAUSJD(UUDISB,XA,XB,PREC,RESULT)
      BREFKF=RESULT 
      END                
      FUNCTION UUDISB(R) 
C     ****************** 
C INTEGRAND FOR BREFKF   
C MAPPING XX => UU CHANGE  TO IMPROVE ON EFFICIENCY            
C     ************************            
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      PARAMETER( FLEPS =1D-35)            
      PARAMETER( PI=3.1415926535897932D0,ALFINV= 137.03604D0)
      PARAMETER( ALF1=1D0/ALFINV/PI) 
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF
      COMMON / VVREC  / VVMIN,VVMAX,VV,BETI   
      COMMON / KEYDST / KEYDIS            
      SAVE / WEKING /,/ VVREC  /,/ KEYDST /
C   
      KEYD=KEYDIS        
      BETF= 2/ALFINV/PI*(DLOG(4*ENE**2/AMFIN**2)-1)            
      X = MAX(R,FLEPS**BETF)              
      ALF=  BETF         
      BET=  1D0          
C ...YFS exponentiation beta0,1,2 contribs    
      IF(KEYD.EQ.310) THEN                
        ALF=  BETF       
      ELSEIF(KEYD.EQ.311)  THEN           
        ALF=  BETF +1    
      ELSEIF(KEYD.EQ.320) THEN            
        ALF=  BETF       
      ELSEIF(KEYD.EQ.321)  THEN           
        ALF=  BETF +1    
      ELSEIF(KEYD.EQ.322)  THEN           
        ALF=  BETF +2    
      ENDIF              
      CALL CHBIN1(X,ALF,BET,VVMAX,UU,RJAC)                 
      SVAR   = 4D0*ENE**2  
      UUDISB=UURHO(KEYD,SVAR,AMFIN,UU)*RJAC
      END                
      FUNCTION UURHO(KEYDIS,SVAR,AMFIN,UU) 
C     ******************************************
C--------------------------------------------------------------
C The parametrization of the final state bremss. as in YFS3    
C Various types of the rho(u) distribution                     
C--------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER(PI= 3.1415926535897932D0, ALFINV=137.03604D0)   
      PARAMETER(CEULER =0.57721566D0)       
      COMMON / INOUT  / NINP,NOUT     
      SAVE   / INOUT  /
C       
      KEYD   = KEYDIS         
      ALF1   = 1D0/PI/ALFINV                
      SPRIM  = SVAR*(1-UU)  
      BILG   = DLOG(SPRIM/AMFIN**2)         
      BETF   = 2D0*ALF1*(BILG-1D0)          
C -------------YFS formula ------------------------------------------
      IF(KEYD.GE.300.AND.KEYD.LE.302) THEN    
         DELB   = ALF1*(0.5D0*BILG -1D0  +PI**2/3D0)            
         DELB   = DELB -BETF/2 *DLOG(1-UU)  
         GAMFAC =EXP(-CEULER*BETF)/DPGAMM(1D0+BETF)              
C ....Zero   Order          
         IF(KEYD  .EQ.300)  THEN             
            DELS = 0D0      
            DELH = -BETF/4 *LOG(1-UU)       
C ....First  Order          
         ELSEIF(KEYD  .EQ.301)  THEN         
            DELS = BETF/2   
            DELH = UU*(-1 +UU/2)            
     $       +BETF*(-UU**2/2 - 0.25D0*(1-UU)**2*LOG(1-UU) )     
C final state specific contr.
     $       +BETF*UU/2*(1-UU/2)*LOG(1-UU)  
C ....Second Order          
         ELSEIF(KEYD  .EQ.302)  THEN         
            DELS  = BETF/2D0 +BETF**2/8D0   
            DELH  = UU*(-1D0+UU/2D0)        
     $        +BETF*( -UU/2  +(2*UU-UU**2)/8*LOG(1-UU) )        
         ENDIF              
         DISTR= GAMFAC*EXP(DELB)*BETF*UU**(BETF-1D0)*(1 +DELS +DELH )
C ------------------------------------------------------------------- 
C -------------Contributions  from various beta's -------------------
      ELSEIF(KEYD.GE.310.AND.KEYD.LE.322)  THEN                 
         DELB   = ALF1*(0.5D0*BILG -1D0  +PI**2/3D0)            
         DELB   = DELB -BETF/2 *DLOG(1-UU)  
         GAMFAC = EXP(-CEULER*BETF)/DPGAMM(1D0+BETF)             
         SOFT   = 0D0       
         DELH   = 0D0       
C ...Beta0 First  Order     
         IF(KEYD.EQ.310) THEN               
            SOFT = 1 + BETF/2               
            DELH = -BETF/4 *LOG(1-UU)       
C ...Beta1 First  Order     
         ELSEIF(KEYD.EQ. 311)  THEN         
            DELH =          
     $      UU*(-1D0+UU/2/(1+BETF))*(1-0.5*BETF*LOG(1-UU))      
     $       -BETF*UU/2*(-1+UU/2)*LOG(1-UU) 
C ...Beta0 Second Order     
         ELSEIF(KEYD.EQ.320) THEN           
            SOFT = 1 + BETF/2  +BETF**2/8   
            DELH = -BETF/4 *LOG(1-UU)       
C ...Beta1 Second Order     
         ELSEIF(KEYD.EQ. 321)  THEN         
            DELH =          
     $      UU*(1+0.5*BETF)*(-1D0+UU/2/(1+BETF))*(1-0.5*BETF*LOG(1-UU))
     $       +0.25*BETF*LOG(1-UU)*0.5*(1+(1-UU)**2)             
C final state specific contrib.
     $       +BETF*UU/2*(1-UU/2)*LOG(1-UU)  
C           DELH = UU*(-1D0+UU/2D0)         
C    $       +BETF*(-UU/2 -UU**2/4 +(2+2*UU-UU**2)/8D0*LOG(1-UU))  
C ...Beta2 Second Order     
         ELSEIF(KEYD.EQ. 322)  THEN         
            DELH =    BETF*UU/2*( UU/2  -(1-UU/2)*LOG(1-UU) )   
         ENDIF              
         DISTR=  GAMFAC*EXP(DELB)*BETF*UU**(BETF-1D0)*(SOFT+DELH) 
      ELSE  
         WRITE(NOUT,*) ' ===--->  WRONG KEYDIS IN UURHO'        
         STOP               
      ENDIF                 
      UURHO = DISTR         
      END   
C----------------------------------------------------------------------
C----------------------------------------------------------------------
C----------------------------------------------------------------------



