      SUBROUTINE MASET(AMZ,AMH,AMT)
C======================================================================
C============WE START WITH ROUTINES RENAMING ENTRIES===================
C======================================================================
C
      IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL BANNER
      BANNER=.TRUE.
      IF(BANNER)WRITE(6,1000)
      IF(BANNER)WRITE(6,1001)
1000  FORMAT(
     C32X,56H********************************************************,/,
     C32X,56H********************************************************,/,
     C32X,56H***                                                  ***,/,
     C32X,56H***                 PROGRAM Z0POLE                   ***,/,
     C32X,56H***                                                  ***,/,
     C32X,56H***                     AUTHOR                       ***,/,
     C32X,56H***                 ROBIN G. STUART                  ***,/,
     C32X,56H***                      CERN                        ***,/,
     C32X,56H***                                                  ***,/,
     C32X,56H***                 QCD CORRECTIONS                  ***,/,
     C32X,56H***                 BERND A. KNIEHL                  ***
     C      )
1001  FORMAT(
     C32X,56H***                      DESY                        ***,/,
     C32X,56H***                                                  ***,/,
     C32X,56H***          LAST UPDATE : JUNE, 1992                ***,/,
     C32X,56H***                                                  ***,/,
     C32X,56H***                                                  ***,/,
     C32X,56H********************************************************,/,
     C32X,56H***                                                  ***,/,
     C32X,56H***          LAST UPDATE OF INTERFACE:               ***,/,
     C32X,56H***              MARCH 7,    1995                    ***,/,
     C32X,56H***                                                  ***,/,
     C32X,56H********************************************************,/,
     C32X,56H********************************************************,
     C///)

      CALL ROBINI(AMZ,AMH,AMT)
      END
      SUBROUTINE CINT
      END
      SUBROUTINE ROBINI(AMZ,AMH,AMT)
C**********************
C  CALCULATES CROSS SECTIONS IN NANOBARNS FOR E+E- -> F F-BAR
C    INCLUDING HIGHER ORDER ELECTROWEAK CORRECTIONS WITHOUT QED
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER NSCHEM
      REAL*8 ALPHA,MF,MHIGGS,MINT,MTOP,MZ,NBARN,NCOL,NCOLF,PI,
     .       QE,QF,
     .       SIN2W,T3E,T3F,
     .       WMASS,XSCALE,ZMASS
      REAL*8 AMZ,AMH,AMT
      COMPLEX*16 POLE
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8            ENE ,AMIN,AMFIN
      COMMON/FERMAS/NLPT,NQRK,XLPT,XQRK
      INTEGER NLPT,NQRK
      REAL*8 XLPT(40,2),XQRK(40,2)
      COMMON / IDFC  / IDFF
      COMMON / INOUT / INUT,IOUT
      REAL*8 DSIGMA
      EXTERNAL DSIGMA
      PI=4.D0*DATAN(1.D0)
      NBARN  =  3.893796623D5
C-----------------------------------------------------------------------
C  MZ IS THE Z0 BOSON MASS IN THE ON-SHELL RENORMALIZATION SCHEME
C     MHIGGS AND  MTOP ARE INPUT VALUES OF HIGGS AND TOP QUARK MASS
C     NCOL IS THE NUMBER OF QUARK COLOURS
C-----------------------------------------------------------------------
      MZ     =  AMZ
      MHIGGS =  AMH
      MTOP   =  AMT
      NCOL   =   3.D0
C-----------------------------------------------------------------------
C  INPUT PARAMETERS OF THE INITIAL AND FINAL STATES
C     T3E, QE IS THE ELECTRIC CHARGE AND ISOSPIN OF THE INCOMING FERMION
C     T3F, QF IS THE ELECTRIC CHARGE AND ISOSPIN OF THE OUTGOING FERMION
C     NCOLF IS THE NUMBER OF COLOURS IN THE FINAL STATE (NO QCD CORRS)
C     MF IS THE MASS OF THE OUTGOING FERMION
C     MINT IS THE MASS OF THE ISOSPIN PARTNER OF THE OUTGOING FERMION
C-----------------------------------------------------------------------
        CALL GIVIZO( IDE, 1,AIZOR,QINI,KDUMM)
        CALL GIVIZO( IDE,-1,AIZOL,QINI,KDUMM)
        T3E    = AIZOL+AIZOR
        CALL GIVIZO( IDF, 1,AIZOR,QFIN,KOLOR)
        CALL GIVIZO( IDF,-1,AIZOL,QFIN,KOLOR)
        T3M    =  AIZOL+AIZOR
      T3E    =  T3E
      QE     =  QINI
      T3F    =  T3M
      QF     =  QFIN
      NCOLF  =  KOLOR
      MF     =  AMFIN
C mass of the isispin partner.
           CALL FMASET(AMT)
           IDEK=ABS(IDFF)
           IF (ABS(IDF).EQ.1) THEN      
             MINT=AMFIN
           ELSEIF (ABS(IDF).EQ.2) THEN      
             MINT=0.0
           ELSE
             MINT=XQRK(IDEK,1)
           ENDIF
C-----------------------------------------------------------------------
C  RENORMALIZATION SCHEME AND SCALE FOR THE CALCULATION
C     NSCHEM = 1, ON SHELL SCHEME AND XSCALE ARBITRARY
C     NSCHEM = 2, MS-BAR SCHEME AND XSCALE IS THE 'T HOOFT MASS
C-----------------------------------------------------------------------
      NSCHEM = 2
      XSCALE = MZ**2
C-----------------------------------------------------------------------
C  INITIALIZE STANDARD MODEL PARAMETERS
C-----------------------------------------------------------------------
      CALL GSWINT(NSCHEM,XSCALE,NCOL,MHIGGS,MTOP,MZ)
C===================================================
C-----------------------------------------------------------------------
C  EXTRACT AND PRINT THE RENORMALIZED PARAMETERS AND POLE POSITION
C-----------------------------------------------------------------------
      CALL PRMZ0P(ALPHA,SIN2W,WMASS,ZMASS,POLE)
C==============================================
      WRITE(6,1000)MZ,MHIGGS,MTOP
      IF(NSCHEM.EQ.1)THEN
          WRITE(6,1001)
      ELSE IF(NSCHEM.EQ.2)THEN
          WRITE(6,1002)DSQRT(XSCALE)
      ELSE
          WRITE(6,1003)
          STOP
          END IF
      WRITE(6,1004)1.D0/ALPHA,SIN2W,WMASS,ZMASS
      WRITE(6,1005)DREAL(POLE),-DIMAG(POLE),
     .             DSQRT(DREAL(POLE)),-DIMAG(POLE)/DSQRT(DREAL(POLE)),
     .             DREAL(CDSQRT(POLE)),-2.D0*DIMAG(CDSQRT(POLE))
C-----------------------------------------------------------------------
C  PRINT THE INITIAL AND FINAL STATE PARAMETERS
C-----------------------------------------------------------------------
      WRITE(6,1006)T3E,T3F,QE,QF,MF,MINT,NCOLF
      RETURN
1000  FORMAT(1H ,5X,'INPUT PARAMETERS;    ON-SHELL SCHEME Z0 MASS  = ',
     .       F9.4,/,
     .       1H ,5X,'                     HIGGS MASS               = ',
     .       F9.4,/,
     .       1H ,5X,'                     TOP QUARK MASS           = ',
     .       F9.4,//)
1001  FORMAT(1H ,5X,'NSCHEM = 1 HAS BEEN SELECTED; THE ON-SHELL RENORMAL
     .IZATION SCHEME WILL BE USED.',//,
     .       1H ,5X,'IN THE ON-SHELL SCHEME THE RENORMALIZED PARAMETERS
     .ARE...',/)
1002  FORMAT(1H ,5X,'NSCHEM = 2 HAS BEEN SELECTED; THE MS-BAR RENORMALIZ
     .ATION SCHEME WILL BE USED.',//,
     .       1H ,5X,'                     T HOOFT MASS             = ',
     .       F9.4,//,
     .       1H ,5X,'IN THE MS-BAR SCHEME THE RENORMALIZED PARAMETERS AR
     .E...',/)
1003  FORMAT(1H ,'INVALID RENORMALIZATION SCHEME SELECTED',/,
     .       1H ,'  VALID CHOICES ARE NSCHEM = 1, ON-SHELL SCHEME',/,
     .       1H ,'                           = 2, MS-BAR SCHEME')
1004  FORMAT(1H ,5X,'                         1/ALPHA              = ',
     .       F13.8,/,
     .       1H ,5X,'                         SIN**2 W             = ',
     .       F13.8,/,
     .       1H ,5X,'                         W MASS               = ',
     .       F13.8,/,
     .       1H ,5X,'                         Z MASS               = ',
     .       F13.8,/,
     .       /)
1005  FORMAT(1H ,5X,'POSITION OF THE POLE ON THE COMPLEX S-PLANE;',//,
     .       1H ,5X,'                         S POLE       = ',
     .       F11.6,  '     - I * ',F12.6,/,
     .       1H ,5X,'                                      = ',
     .       F11.6,' **2 - I * M * ',F8.6,/,
     .       1H ,5X,'                                      = ',
     .       '(',F10.6,'     - I / 2 * ',F8.6,' )**2',//)
1006  FORMAT(1H ,5X,'EXTERNAL FERMIONS:   INITIAL  STATE',28X,
     .                                   'FINAL STATE',//,
     .       1H ,5X,'                     T3 = ',F10.6,27X,
     .                                   'T3 = ',F10.6,/,
     .       1H ,5X,'                     Q  = ',F10.6,27X,
     .                                   'Q  = ',F10.6,/,
     .       1H ,66X,'MASS = ',F8.4,/,
     .       1H ,47X,'MASS OF ISOSPIN PARTNER = ',F8.4,/,
     .       1H ,44X,'NO. OF FINAL STATE COLOURS = ',F6.2,//)
      END
      FUNCTION BORNR (MODE,SVAR,COSTHE,TA,TB)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8            ENE ,AMIN,AMFIN
      COMMON / KEYSET / KEYGSW,KEYRAD,KEYTAB
      DATA PI /3.141592653589793238462643D0/
C
      BORNR=   BORNZP(MODE,SVAR,COSTHE,TA,TB)
C
      IF ((ABS(IDF) .GE. 3).AND.(KEYGSW.GT.1)) THEN
C       QCD correction for quarks 
C       note that there is no SVAR dependence !!!
        CORQCD=1.D0+ALPHAS(4.D0*ENE*ENE)/PI
     +             +ALPHAS(4.D0*ENE*ENE)**2/PI**2*(1.98D0-0.115D0*5.D0)
        BORNR = BORNR*CORQCD
      END IF
      END
      SUBROUTINE PRMROB(ZMASS,GAMZ0,GAMZ,WMASS,GAMW0,GAMW,SIN2W)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 POLE
      CALL PRMZ0P(ALPHA,SW2,WMAS,ZMAS,POLE)
      ZMASS=ZMAS
      GAMZ0=-DIMAG(POLE)/ZMAS
      GAMZ =-DIMAG(POLE)/ZMAS
      WMASS=WMAS
      GAMW0=0.0
      GAMW =0.0
      SIN2W=SW2
      END
      FUNCTION BORNZP(MODE,SVAR,COSTHE,TA,TB)
C ----------------------------------------------------------------------
C THIS ROUTINE PROVIDES BORN CROSS SECTION. IT HAS THE SAME         *
C STRUCTURE AS FUNTIS AND FUNTIH, THUS CAN BE USED AS SIMPLER       *
C EXAMPLE OF THE METHOD APPLIED THERE                               *
C 18.04. IT IS NOT SO SIMPLE NOW THERE ARE 2 MODES SIMPLE OLD ONE   *
C AND THE NEW ONE WHERE ALSO ELECTROWEAK CORRECTIONS ARE ADDED      *
C
C     called by : BORNY, BORAS, BORNV, WAGA, WEIGHT
C ----------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8            ENE ,AMIN,AMFIN
      COMMON / IDFC  / IDFF
      COMMON / GAUSPM /SS,POLN,T3E,QE,T3F,QF
     &                ,XUPGI   ,XUPZI   ,XUPGF   ,XUPZF
     &                ,NDIAG0,NDIAGA,KEYA,KEYZ
     &                ,ITCE,JTCE,ITCF,JTCF,KOLOR
      REAL*8           SS,POLN,T3E,QE,T3F,QF
     &                ,XUPGI(2),XUPZI(2),XUPGF(2),XUPZF(2)
      COMMON / QEDPRM /ALFINV,ALFPI,XK0
      REAL*8           ALFINV,ALFPI,XK0
      COMMON / INSPIN / SEPS1,SEPS2
      REAL*8            SEPS1,SEPS2
      COMMON/FERMAS/NLPT,NQRK,XLPT,XQRK
      INTEGER NLPT,NQRK
      COMMON/SPEEDY/BCALL1,RCALL1
      LOGICAL BCALL1,RCALL1 
      REAL*8 XLPT(40,2),XQRK(40,2)
C=====================================================================
      COMMON / GSWPRM /SWSQ,AMW,AMZ,AMH,AMTOP,GAMMZ
      REAL*8           SWSQ,AMW,AMZ,AMH,AMTOP,GAMMZ
C     SWSQ        = sin2 (theta Weinberg)
C     AMW,AMZ     = W & Z boson masses respectively
C     AMH         = the Higgs mass
C     AMTOP       = the top mass
C     GAMMZ       = Z0 width
      COMMON / KEYSET / KEYGSW,KEYRAD,KEYTAB
      COMMON /NEWMOD/  AMNEUT,NNEUT
      REAL*8           AMNEUT

      COMPLEX*16 ABORN(2,2),APHOT(2,2),AZETT(2,2)
      COMPLEX*16 XUPZFP(2),XUPZIP(2)
      COMPLEX*16 ABORNM(2,2),APHOTM(2,2),AZETTM(2,2)
      COMPLEX*16 PROPA,PROPZ
      COMPLEX*16 XR,XI,PROPW,AW(2,2)
      COMPLEX*16 XUPF,XUPI
      COMPLEX*16 XTHING
      COMPLEX*16 HAMP(2,2),HAMPI(2,2)
      REAL*8 XM2,XP2,MINT
      DATA AW/4*(0.D0,0.D0)/,XI/(0.D0,1.D0)/,XR/(1.D0,0.D0)/
      DATA XGW/2.5D0/
      DATA MODE0 /-5/
      DATA SVAR0,COST0 /-5.D0,-6.D0/
      DATA PI /3.141592653589793238462643D0/
C    
C MEMORIZATION =========================================================
      IF ( MODE.NE.MODE0.OR.SVAR.NE.SVAR0.OR.COSTHE.NE.COST0) THEN
      IF (SVAR.NE.SVAR0) THEN
        RCALL1=.TRUE.
        BCALL1=.TRUE.
      ENDIF
C ** PROPAGATORS
        MODE0=MODE
        SVAR0=SVAR
        COST0=COSTHE
        SINTHE=SQRT(1.D0-COSTHE**2)
        BETA=SQRT(MAX(0D0,(1D0-4D0*AMFIN**2/SVAR)))
C I MULTIPLY AXIAL COUPLING BY BETA FACTOR.
        XUPZFP(1)=0.5D0*(XUPZF(1)+XUPZF(2))+0.5*BETA*(XUPZF(1)-XUPZF(2))
        XUPZFP(2)=0.5D0*(XUPZF(1)+XUPZF(2))-0.5*BETA*(XUPZF(1)-XUPZF(2))
        XUPZIP(1)=0.5D0*(XUPZI(1)+XUPZI(2))+0.5*(XUPZI(1)-XUPZI(2))
        XUPZIP(2)=0.5D0*(XUPZI(1)+XUPZI(2))-0.5*(XUPZI(1)-XUPZI(2))
C FINAL STATE VECTOR COUPLING
        XUPF     =0.5D0*(XUPZF(1)+XUPZF(2))
        XUPI     =0.5D0*(XUPZI(1)+XUPZI(2))
      IF (MODE.GT.0.AND.KEYGSW.GT.1) THEN
C I MULTIPLY AXIAL COUPLING BY BETA FACTOR.
C I ADD ALSO FORMFACTORS
*********************************************************
*
* INITIALISATION OF SPIN AMPLITUDES HAMP(2,2)
* KEYTAB is dummy at the moment
*
*********************************************************
           IF (KEYTAB.EQ.0) THEN
             SV=SVAR/2D0
             T=-0.5D0*SVAR*(1.D0-COSTHE)
C mass of the isispin partner.
           IDEK=ABS(IDFF)
           IF (ABS(IDF).EQ.1) THEN      
             MINT=AMFIN
           ELSEIF (ABS(IDF).EQ.2) THEN      
             MINT=0.0
           ELSE
             MINT=XQRK(IDEK,1)
           ENDIF
      CALL HELAMP(DCMPLX(SVAR),DCMPLX(T),T3E,QE,T3F,QF,DCMPLX(MINT**2),
     .            HAMP(1,1),HAMP(1,2),HAMP(2,1),HAMP(2,2))
C
           CORRF= 3D0*PI*16D0
           CORRF=SQRT(ALFINV**2*3/PI/CORRF)
           HAMP(1,1)=HAMP(1,1)*CORRF
           HAMP(1,2)=HAMP(1,2)*CORRF
           HAMP(2,1)=HAMP(2,1)*CORRF
           HAMP(2,2)=HAMP(2,2)*CORRF
           ELSEIF (KEYTAB.EQ.1) THEN
             T=-0.5D0*SVAR*(1.D0-COSTHE)
C mass of the isispin partner.     
           IDEK=ABS(IDFF)
           IF (ABS(IDF).EQ.1) THEN      
             MINT=AMFIN
           ELSEIF (ABS(IDF).EQ.2) THEN      
             MINT=0.0
           ELSE
             MINT=XQRK(IDEK,1)
           ENDIF
      CALL HELAMP(DCMPLX(SVAR),DCMPLX(T),T3E,QE,T3F,QF,DCMPLX(MINT**2),
     .            HAMP(1,1),HAMP(1,2),HAMP(2,1),HAMP(2,2))
           CORRF= 3D0*PI*16D0
           CORRF=SQRT(ALFINV**2*3/PI/CORRF)
           HAMP(1,1)=HAMP(1,1)*CORRF
           HAMP(1,2)=HAMP(1,2)*CORRF
           HAMP(2,1)=HAMP(2,1)*CORRF
           HAMP(2,2)=HAMP(2,2)*CORRF
           ELSE
             PRINT *, 'STOP IN BORNZP: UNDEFINED KEYTAB, KEYTAB=',KEYTAB
             STOP
           ENDIF
C Z0pole reacts on particle antip replacement and we got used that not.
           IF (IDE.GT.0) THEN
             XTHING=HAMP(1,2)
             HAMP(1,2)=HAMP(2,1)
             HAMP(2,1)=XTHING
             XTHING=HAMP(1,1)
             HAMP(1,1)=HAMP(2,2)
             HAMP(2,2)=XTHING
           ENDIF
*
           DO I=1,2
             HAMPI(I,1)=0.5D0*     (HAMP(I,1)+HAMP(I,2))
     $                 +0.5D0*BETA*(HAMP(I,1)-HAMP(I,2))
             HAMPI(I,2)=0.5D0*     (HAMP(I,1)+HAMP(I,2))
     $                 -0.5D0*BETA*(HAMP(I,1)-HAMP(I,2))
           ENDDO
********************************************************
        PROPA =1D0/SVAR
        PROPZ =1D0/DCMPLX(SVAR-AMZ**2,SVAR/AMZ*GAMMZ)
C I REPLACE BORN NORMALIZATION OF Z PROPAGATOR BY THE BETTER ONE
        GMU  = 1.16637D-5
        DEL1 =GMU*AMZ**2*ALFINV/(DSQRT(2.D0)*8.D0*PI)
        DEL0 =1./(SWSQ*(1.-SWSQ))/16.
        PROPZ = PROPZ*DEL1/DEL0
      ELSE
        PROPA =1D0/SVAR
        IF (KEYGSW.EQ.0) PROPA=0.D0
        PROPZ =1D0/DCMPLX(SVAR-AMZ**2,SVAR/AMZ*GAMMZ)
      ENDIF
      IF (IABS(IDF).EQ.1) THEN
C*** NUNUB SPECIAL : W PROPAGATOR IN t-CHANNEL
      DO 15 I=1,2
      DO 15 J=1,2
      AW(I,J)=(0.D0,0.D0)
  15  CONTINUE
        IF(MODE.NE.1) THEN
        XMW=AMZ*DSQRT(1D0-SWSQ)
        XCOUP=1.D0/2.D0/SWSQ
         IF (IDE.LT.0) THEN
           AW(2,1)=- DCMPLX(XCOUP*(1.D0-COSTHE))/XMW/XMW
         ELSE
           AW(1,2)=- DCMPLX(XCOUP*(1.D0-COSTHE))/XMW/XMW
         ENDIF
        ELSE
        XMW=AMZ*DSQRT(1D0-SWSQ)
        XP2=(SVAR*(1.D0+COSTHE)/2.+XMW*XMW)**2+(XMW*XGW)**2
        PROPW=DCMPLX(-(SVAR*(1.D0+COSTHE)/2+XMW*XMW)/XP2)
        PROPW=PROPW-XI*DCMPLX(XMW*XGW/XP2)
        XCOUP=1.D0/2.D0/SWSQ
          IF (IDE.LT.0) THEN
           AW(2,1)= PROPW*DCMPLX(XCOUP*(1.D0-COSTHE))
          ELSE
           AW(1,2)= PROPW*DCMPLX(XCOUP*(1.D0-COSTHE))
          ENDIF
C disputable lines .....
C          IF(KEYGSW.GT.1) THEN
C           AW(1,2)=AW(1,2)*DEL1/DEL0
C           AW(2,1)=AW(2,1)*DEL1/DEL0
C          ENDIF
C end of disputable lines
        ENDIF
      ENDIF
      DO 50 I=1,2
      DO 50 J=1,2
       REGULA= (3-2*I)*(3-2*J) + COSTHE
       REGULM=-(3-2*I)*(3-2*J) * SINTHE *2.D0*AMFIN/SQRT(SVAR)
       IF (MODE.GT.0.AND.KEYGSW.GT.1) THEN
        APHOT(I,J)=0.0
        AZETT(I,J)=HAMPI(I,J)*REGULA
        ABORN(I,J)=AZETT(I,J)+AW(I,J)
        APHOTM(I,J)=0.D0
        AZETTM(I,J)=DCMPLX(0D0,1D0)*0.5D0*(HAMP(I,1)+HAMP(I,2))*REGULM
        ABORNM(I,J)=APHOTM(I,J)+AZETTM(I,J)
       ELSE
        APHOT(I,J)=PROPA*(XUPGI(I)*XUPGF(J)*REGULA)
        AZETT(I,J)=PROPZ*(XUPZIP(I)*XUPZFP(J))*REGULA
        ABORN(I,J)=APHOT(I,J)+AZETT(I,J)+AW(I,J)
        APHOTM(I,J)=PROPA*DCMPLX(0D0,1D0)*XUPGI(I)*XUPGF(J)*REGULM
        AZETTM(I,J)=PROPZ*DCMPLX(0D0,1D0)*(XUPZIP(I)*XUPF)*REGULM
        ABORNM(I,J)=APHOTM(I,J)+AZETTM(I,J)
       ENDIF
   50 CONTINUE
      ENDIF
C
C******************
C* IN CALCULATING CROSS SECTION ONLY DIAGONAL ELEMENTS
C* OF THE SPIN DENSITY MATRICES ENTER (LONGITUD. POL. ONLY.)
C* HELICITY CONSERVATION EXPLICITLY OBEYED
      POLAR1=  (SEPS1)
      POLAR2= (-SEPS2)
      BORN=0D0
      DO 150 I=1,2
      HELIC= 3-2*I
      DO 150 J=1,2
      HELIT=3-2*J
      FACTOR=KOLOR*(1D0+HELIC*POLAR1)*(1D0-HELIC*POLAR2)/4D0
      FACTOM=FACTOR*(1+HELIT*TA)*(1-HELIT*TB)
      FACTOR=FACTOR*(1+HELIT*TA)*(1+HELIT*TB)
      IF(IABS(IDF).NE.1) THEN
      BORN=BORN+CDABS(ABORN(I,J))**2*FACTOR
C MASS TERM IN BORN
       IF (MODE.GT.0) THEN
C mass terms included in BORN. Is it better ?
C--       IF (MODE.GE.5) THEN
       BORN=BORN+CDABS(ABORNM(I,J))**2*FACTOM
      ENDIF
      ELSE
        XM2=CDABS(ABORN(I,J))**2+(NNEUT-1)*CDABS(AZETT(I,J))**2
        XM3=CDABS(ABORNM(I,J))**2+(NNEUT-1)*CDABS(AZETTM(I,J))**2
        BORN=BORN+(XM2+XM3)*FACTOR
      ENDIF
  150 CONTINUE
C************
      FUNT=BORN
      IF(FUNT.LT.0.D0)  FUNT=BORN
C
      IF (SVAR.GT.4D0*AMFIN**2) THEN
C PHASE SPACE THRESHOLD FACTOR
        THRESH=SQRT(1-4D0*AMFIN**2/SVAR)
        BORNZP= FUNT*SVAR**2*THRESH
      ELSE
        THRESH=0.D0
        BORNZP=0.D0
      ENDIF
C ZW HERE WAS AN ERROR 19. 05. 1989

      IF (IBOX.EQ.1.AND.KEYGSW.GT.1.AND.MODE.GT.0.AND.IDF**2.NE.1) THEN
        BOXY=0.0
        BORNZP=BORNZP+BOXY
      ENDIF
      END
      FUNCTION BORNH(MODE,SVAR,COSTHE,TA,TB)
C======================================================================
C============ROUTINES TO DETACH SECOND ELECTROWEAK LIBRARY=============
C======================================================================
      IMPLICIT REAL*8(A-H,O-Z)
      PRINT *, 'SORRY, SECOND ELECTROWEAK LIBRARY IS NOT INTERFACED'
      BORNH=5.
      STOP
      END
      SUBROUTINE PRMHOL(ZMASS,GAMZ0,GAMMZ,WMASS,GAMW0,GAMW,SIN2W)
      IMPLICIT REAL*8(A-H,O-Z)
      PRINT *, 'SORRY, SECOND ELECTROWEAK LIBRARY IS NOT INTERFACED'
      STOP
      END
      SUBROUTINE HOLSTA(IDF,KEYGSW,YMZ,YMH,YMT)
      IMPLICIT REAL*8(A-H,O-Z)
      PRINT *, 'SORRY, SECOND ELECTROWEAK LIBRARY IS NOT INTERFACED'
      STOP
      END
